//
// Copyright (c) 1997, 2013, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_x86_32.hpp"
#include "adfiles/ad_x86_32.hpp"
#include "memory/allocation.inline.hpp"
#include "asm/macroAssembler.inline.hpp"
#include "code/compiledIC.hpp"
#include "code/vmreg.hpp"
#include "gc_interface/collectedHeap.inline.hpp"
#include "oops/compiledICHolder.hpp"
#include "oops/markOop.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "oops/oop.inline2.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/biasedLocking.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "nativeInst_x86.hpp"
#include "vmreg_x86.inline.hpp"

//SourceForm

#line 197 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

#define   RELOC_IMM32    Assembler::imm_operand
#define   RELOC_DISP32   Assembler::disp32_operand

#define __ _masm.

// How to find the high register of a Long pair, given the low register
#define   HIGH_FROM_LOW(x) ((x)+2)

// These masks are used to provide 128-bit aligned bitmasks to the XMM
// instructions, to allow sign-masking or sign-bit flipping.  They allow
// fast versions of NegF/NegD and AbsF/AbsD.

// Note: 'double' and 'long long' have 32-bits alignment on x86.
static jlong* double_quadword(jlong *adr, jlong lo, jlong hi) {
  // Use the expression (adr)&(~0xF) to provide 128-bits aligned address
  // of 128-bits operands for SSE instructions.
  jlong *operand = (jlong*)(((uintptr_t)adr)&((uintptr_t)(~0xF)));
  // Store the value to a 128-bits operand.
  operand[0] = lo;
  operand[1] = hi;
  return operand;
}

// Buffer for 128-bits masks used by SSE instructions.
static jlong fp_signmask_pool[(4+1)*2]; // 4*128bits(data) + 128bits(alignment)

// Static initialization during VM startup.
static jlong *float_signmask_pool  = double_quadword(&fp_signmask_pool[1*2], CONST64(0x7FFFFFFF7FFFFFFF), CONST64(0x7FFFFFFF7FFFFFFF));
static jlong *double_signmask_pool = double_quadword(&fp_signmask_pool[2*2], CONST64(0x7FFFFFFFFFFFFFFF), CONST64(0x7FFFFFFFFFFFFFFF));
static jlong *float_signflip_pool  = double_quadword(&fp_signmask_pool[3*2], CONST64(0x8000000080000000), CONST64(0x8000000080000000));
static jlong *double_signflip_pool = double_quadword(&fp_signmask_pool[4*2], CONST64(0x8000000000000000), CONST64(0x8000000000000000));

// Offset hacking within calls.
static int pre_call_resets_size() {
  int size = 0;
  Compile* C = Compile::current();
  if (C->in_24_bit_fp_mode()) {
    size += 6; // fldcw
  }
  if (C->max_vector_size() > 16) {
    size += 3; // vzeroupper
  }
  return size;
}

static int preserve_SP_size() {
  return 2;  // op, rm(reg/reg)
}

// !!!!! Special hack to get all type of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.
int MachCallStaticJavaNode::ret_addr_offset() {
  int offset = 5 + pre_call_resets_size();  // 5 bytes from start of call to where return address points
  if (_method_handle_invoke)
    offset += preserve_SP_size();
  return offset;
}

int MachCallDynamicJavaNode::ret_addr_offset() {
  return 10 + pre_call_resets_size();  // 10 bytes from start of call to where return address points
}

static int sizeof_FFree_Float_Stack_All = -1;

int MachCallRuntimeNode::ret_addr_offset() {
  assert(sizeof_FFree_Float_Stack_All != -1, "must have been emitted already");
  return sizeof_FFree_Float_Stack_All + 5 + pre_call_resets_size();
}

// Indicate if the safepoint node needs the polling page as an input.
// Since x86 does have absolute addressing, it doesn't.
bool SafePointNode::needs_polling_address_input() {
  return false;
}

//
// Compute padding required for nodes which need alignment
//

// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallStaticJavaDirectNode::compute_padding(int current_offset) const {
  current_offset += pre_call_resets_size();  // skip fldcw, if any
  current_offset += 1;      // skip call opcode byte
  return round_to(current_offset, alignment_required()) - current_offset;
}

// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallStaticJavaHandleNode::compute_padding(int current_offset) const {
  current_offset += pre_call_resets_size();  // skip fldcw, if any
  current_offset += preserve_SP_size();   // skip mov rbp, rsp
  current_offset += 1;      // skip call opcode byte
  return round_to(current_offset, alignment_required()) - current_offset;
}

// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallDynamicJavaDirectNode::compute_padding(int current_offset) const {
  current_offset += pre_call_resets_size();  // skip fldcw, if any
  current_offset += 5;      // skip MOV instruction
  current_offset += 1;      // skip call opcode byte
  return round_to(current_offset, alignment_required()) - current_offset;
}

// EMIT_RM()
void emit_rm(CodeBuffer &cbuf, int f1, int f2, int f3) {
  unsigned char c = (unsigned char)((f1 << 6) | (f2 << 3) | f3);
  cbuf.insts()->emit_int8(c);
}

// EMIT_CC()
void emit_cc(CodeBuffer &cbuf, int f1, int f2) {
  unsigned char c = (unsigned char)( f1 | f2 );
  cbuf.insts()->emit_int8(c);
}

// EMIT_OPCODE()
void emit_opcode(CodeBuffer &cbuf, int code) {
  cbuf.insts()->emit_int8((unsigned char) code);
}

// EMIT_OPCODE() w/ relocation information
void emit_opcode(CodeBuffer &cbuf, int code, relocInfo::relocType reloc, int offset = 0) {
  cbuf.relocate(cbuf.insts_mark() + offset, reloc);
  emit_opcode(cbuf, code);
}

// EMIT_D8()
void emit_d8(CodeBuffer &cbuf, int d8) {
  cbuf.insts()->emit_int8((unsigned char) d8);
}

// EMIT_D16()
void emit_d16(CodeBuffer &cbuf, int d16) {
  cbuf.insts()->emit_int16(d16);
}

// EMIT_D32()
void emit_d32(CodeBuffer &cbuf, int d32) {
  cbuf.insts()->emit_int32(d32);
}

// emit 32 bit value and construct relocation entry from relocInfo::relocType
void emit_d32_reloc(CodeBuffer &cbuf, int d32, relocInfo::relocType reloc,
        int format) {
  cbuf.relocate(cbuf.insts_mark(), reloc, format);
  cbuf.insts()->emit_int32(d32);
}

// emit 32 bit value and construct relocation entry from RelocationHolder
void emit_d32_reloc(CodeBuffer &cbuf, int d32, RelocationHolder const& rspec,
        int format) {
#ifdef ASSERT
  if (rspec.reloc()->type() == relocInfo::oop_type && d32 != 0 && d32 != (int)Universe::non_oop_word()) {
    assert(cast_to_oop(d32)->is_oop() && (ScavengeRootsInCode || !cast_to_oop(d32)->is_scavengable()), "cannot embed scavengable oops in code");
  }
#endif
  cbuf.relocate(cbuf.insts_mark(), rspec, format);
  cbuf.insts()->emit_int32(d32);
}

// Access stack slot for load or store
void store_to_stackslot(CodeBuffer &cbuf, int opcode, int rm_field, int disp) {
  emit_opcode( cbuf, opcode );               // (e.g., FILD   [ESP+src])
  if( -128 <= disp && disp <= 127 ) {
    emit_rm( cbuf, 0x01, rm_field, ESP_enc );  // R/M byte
    emit_rm( cbuf, 0x00, ESP_enc, ESP_enc);    // SIB byte
    emit_d8 (cbuf, disp);     // Displacement  // R/M byte
  } else {
    emit_rm( cbuf, 0x02, rm_field, ESP_enc );  // R/M byte
    emit_rm( cbuf, 0x00, ESP_enc, ESP_enc);    // SIB byte
    emit_d32(cbuf, disp);     // Displacement  // R/M byte
  }
}

   // rRegI ereg, memory mem) %{    // emit_reg_mem
void encode_RegMem( CodeBuffer &cbuf, int reg_encoding, int base, int index, int scale, int displace, relocInfo::relocType disp_reloc ) {
  // There is no index & no scale, use form without SIB byte
  if ((index == 0x4) &&
      (scale == 0) && (base != ESP_enc)) {
    // If no displacement, mode is 0x0; unless base is [EBP]
    if ( (displace == 0) && (base != EBP_enc) ) {
      emit_rm(cbuf, 0x0, reg_encoding, base);
    }
    else {                    // If 8-bit displacement, mode 0x1
      if ((displace >= -128) && (displace <= 127)
          && (disp_reloc == relocInfo::none) ) {
        emit_rm(cbuf, 0x1, reg_encoding, base);
        emit_d8(cbuf, displace);
      }
      else {                  // If 32-bit displacement
        if (base == -1) { // Special flag for absolute address
          emit_rm(cbuf, 0x0, reg_encoding, 0x5);
          // (manual lies; no SIB needed here)
          if ( disp_reloc != relocInfo::none ) {
            emit_d32_reloc(cbuf, displace, disp_reloc, 1);
          } else {
            emit_d32      (cbuf, displace);
          }
        }
        else {                // Normal base + offset
          emit_rm(cbuf, 0x2, reg_encoding, base);
          if ( disp_reloc != relocInfo::none ) {
            emit_d32_reloc(cbuf, displace, disp_reloc, 1);
          } else {
            emit_d32      (cbuf, displace);
          }
        }
      }
    }
  }
  else {                      // Else, encode with the SIB byte
    // If no displacement, mode is 0x0; unless base is [EBP]
    if (displace == 0 && (base != EBP_enc)) {  // If no displacement
      emit_rm(cbuf, 0x0, reg_encoding, 0x4);
      emit_rm(cbuf, scale, index, base);
    }
    else {                    // If 8-bit displacement, mode 0x1
      if ((displace >= -128) && (displace <= 127)
          && (disp_reloc == relocInfo::none) ) {
        emit_rm(cbuf, 0x1, reg_encoding, 0x4);
        emit_rm(cbuf, scale, index, base);
        emit_d8(cbuf, displace);
      }
      else {                  // If 32-bit displacement
        if (base == 0x04 ) {
          emit_rm(cbuf, 0x2, reg_encoding, 0x4);
          emit_rm(cbuf, scale, index, 0x04);
        } else {
          emit_rm(cbuf, 0x2, reg_encoding, 0x4);
          emit_rm(cbuf, scale, index, base);
        }
        if ( disp_reloc != relocInfo::none ) {
          emit_d32_reloc(cbuf, displace, disp_reloc, 1);
        } else {
          emit_d32      (cbuf, displace);
        }
      }
    }
  }
}


void encode_Copy( CodeBuffer &cbuf, int dst_encoding, int src_encoding ) {
  if( dst_encoding == src_encoding ) {
    // reg-reg copy, use an empty encoding
  } else {
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, dst_encoding, src_encoding );
  }
}

void emit_cmpfp_fixup(MacroAssembler& _masm) {
  Label exit;
  __ jccb(Assembler::noParity, exit);
  __ pushf();
  //
  // comiss/ucomiss instructions set ZF,PF,CF flags and
  // zero OF,AF,SF for NaN values.
  // Fixup flags by zeroing ZF,PF so that compare of NaN
  // values returns 'less than' result (CF is set).
  // Leave the rest of flags unchanged.
  //
  //    7 6 5 4 3 2 1 0
  //   |S|Z|r|A|r|P|r|C|  (r - reserved bit)
  //    0 0 1 0 1 0 1 1   (0x2B)
  //
  __ andl(Address(rsp, 0), 0xffffff2b);
  __ popf();
  __ bind(exit);
}

void emit_cmpfp3(MacroAssembler& _masm, Register dst) {
  Label done;
  __ movl(dst, -1);
  __ jcc(Assembler::parity, done);
  __ jcc(Assembler::below, done);
  __ setb(Assembler::notEqual, dst);
  __ movzbl(dst, dst);
  __ bind(done);
}


//=============================================================================
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

int Compile::ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  st->print("# MachConstantBaseNode (empty encoding)");
}
#endif


//=============================================================================
#ifndef PRODUCT
void MachPrologNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  Compile* C = ra_->C;

  int framesize = C->frame_size_in_bytes();
  int bangsize = C->bang_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove wordSize for return addr which is already pushed.
  framesize -= wordSize;

  if (C->need_stack_bang(bangsize)) {
    framesize -= wordSize;
    st->print("# stack bang (%d bytes)", bangsize);
    st->print("\n\t");
    st->print("PUSH   EBP\t# Save EBP");
    if (framesize) {
      st->print("\n\t");
      st->print("SUB    ESP, #%d\t# Create frame",framesize);
    }
  } else {
    st->print("SUB    ESP, #%d\t# Create frame",framesize);
    st->print("\n\t");
    framesize -= wordSize;
    st->print("MOV    [ESP + #%d], EBP\t# Save EBP",framesize);
  }

  if (VerifyStackAtCalls) {
    st->print("\n\t");
    framesize -= wordSize;
    st->print("MOV    [ESP + #%d], 0xBADB100D\t# Majik cookie for stack depth check",framesize);
  }

  if( C->in_24_bit_fp_mode() ) {
    st->print("\n\t");
    st->print("FLDCW  \t# load 24 bit fpu control word");
  }
  if (UseSSE >= 2 && VerifyFPU) {
    st->print("\n\t");
    st->print("# verify FPU stack (must be clean on entry)");
  }

#ifdef ASSERT
  if (VerifyStackAtCalls) {
    st->print("\n\t");
    st->print("# stack alignment check");
  }
#endif
  st->cr();
}
#endif


void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  MacroAssembler _masm(&cbuf);

  int framesize = C->frame_size_in_bytes();
  int bangsize = C->bang_size_in_bytes();

  __ verified_entry(framesize, C->need_stack_bang(bangsize)?bangsize:0, C->in_24_bit_fp_mode());

  C->set_frame_complete(cbuf.insts_size());

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    Compile::ConstantTable& constant_table = C->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}

uint MachPrologNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_); // too many variables; just compute it the hard way
}

int MachPrologNode::reloc() const {
  return 0; // a large enough number
}

//=============================================================================
#ifndef PRODUCT
void MachEpilogNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  Compile *C = ra_->C;
  int framesize = C->frame_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove two words for return addr and rbp,
  framesize -= 2*wordSize;

  if (C->max_vector_size() > 16) {
    st->print("VZEROUPPER");
    st->cr(); st->print("\t");
  }
  if (C->in_24_bit_fp_mode()) {
    st->print("FLDCW  standard control word");
    st->cr(); st->print("\t");
  }
  if (framesize) {
    st->print("ADD    ESP,%d\t# Destroy frame",framesize);
    st->cr(); st->print("\t");
  }
  st->print_cr("POPL   EBP"); st->print("\t");
  if (do_polling() && C->is_method_compilation()) {
    st->print("TEST   PollPage,EAX\t! Poll Safepoint");
    st->cr(); st->print("\t");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile *C = ra_->C;

  if (C->max_vector_size() > 16) {
    // Clear upper bits of YMM registers when current compiled code uses
    // wide vectors to avoid AVX <-> SSE transition penalty during call.
    MacroAssembler masm(&cbuf);
    masm.vzeroupper();
  }
  // If method set FPU control word, restore to standard control word
  if (C->in_24_bit_fp_mode()) {
    MacroAssembler masm(&cbuf);
    masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
  }

  int framesize = C->frame_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove two words for return addr and rbp,
  framesize -= 2*wordSize;

  // Note that VerifyStackAtCalls' Majik cookie does not change the frame size popped here

  if (framesize >= 128) {
    emit_opcode(cbuf, 0x81); // add  SP, #framesize
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d32(cbuf, framesize);
  } else if (framesize) {
    emit_opcode(cbuf, 0x83); // add  SP, #framesize
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, framesize);
  }

  emit_opcode(cbuf, 0x58 | EBP_enc);

  if (do_polling() && C->is_method_compilation()) {
    cbuf.relocate(cbuf.insts_end(), relocInfo::poll_return_type, 0);
    emit_opcode(cbuf,0x85);
    emit_rm(cbuf, 0x0, EAX_enc, 0x5); // EAX
    emit_d32(cbuf, (intptr_t)os::get_polling_page());
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  Compile *C = ra_->C;
  // If method set FPU control word, restore to standard control word
  int size = C->in_24_bit_fp_mode() ? 6 : 0;
  if (C->max_vector_size() > 16) size += 3; // vzeroupper
  if (do_polling() && C->is_method_compilation()) size += 6;

  int framesize = C->frame_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove two words for return addr and rbp,
  framesize -= 2*wordSize;

  size++; // popl rbp,

  if (framesize >= 128) {
    size += 6;
  } else {
    size += framesize ? 3 : 0;
  }
  return size;
}

int MachEpilogNode::reloc() const {
  return 0; // a large enough number
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

int MachEpilogNode::safepoint_offset() const { return 0; }

//=============================================================================

enum RC { rc_bad, rc_int, rc_float, rc_xmm, rc_stack };
static enum RC rc_class( OptoReg::Name reg ) {

  if( !OptoReg::is_valid(reg)  ) return rc_bad;
  if (OptoReg::is_stack(reg)) return rc_stack;

  VMReg r = OptoReg::as_VMReg(reg);
  if (r->is_Register()) return rc_int;
  if (r->is_FloatRegister()) {
    assert(UseSSE < 2, "shouldn't be used in SSE2+ mode");
    return rc_float;
  }
  assert(r->is_XMMRegister(), "must be");
  return rc_xmm;
}

static int impl_helper( CodeBuffer *cbuf, bool do_size, bool is_load, int offset, int reg,
                        int opcode, const char *op_str, int size, outputStream* st ) {
  if( cbuf ) {
    emit_opcode  (*cbuf, opcode );
    encode_RegMem(*cbuf, Matcher::_regEncode[reg], ESP_enc, 0x4, 0, offset, relocInfo::none);
#ifndef PRODUCT
  } else if( !do_size ) {
    if( size != 0 ) st->print("\n\t");
    if( opcode == 0x8B || opcode == 0x89 ) { // MOV
      if( is_load ) st->print("%s   %s,[ESP + #%d]",op_str,Matcher::regName[reg],offset);
      else          st->print("%s   [ESP + #%d],%s",op_str,offset,Matcher::regName[reg]);
    } else { // FLD, FST, PUSH, POP
      st->print("%s [ESP + #%d]",op_str,offset);
    }
#endif
  }
  int offset_size = (offset == 0) ? 0 : ((offset <= 127) ? 1 : 4);
  return size+3+offset_size;
}

// Helper for XMM registers.  Extra opcode bits, limited syntax.
static int impl_x_helper( CodeBuffer *cbuf, bool do_size, bool is_load,
                         int offset, int reg_lo, int reg_hi, int size, outputStream* st ) {
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    if (reg_lo+1 == reg_hi) { // double move?
      if (is_load) {
        __ movdbl(as_XMMRegister(Matcher::_regEncode[reg_lo]), Address(rsp, offset));
      } else {
        __ movdbl(Address(rsp, offset), as_XMMRegister(Matcher::_regEncode[reg_lo]));
      }
    } else {
      if (is_load) {
        __ movflt(as_XMMRegister(Matcher::_regEncode[reg_lo]), Address(rsp, offset));
      } else {
        __ movflt(Address(rsp, offset), as_XMMRegister(Matcher::_regEncode[reg_lo]));
      }
    }
#ifndef PRODUCT
  } else if (!do_size) {
    if (size != 0) st->print("\n\t");
    if (reg_lo+1 == reg_hi) { // double move?
      if (is_load) st->print("%s %s,[ESP + #%d]",
                              UseXmmLoadAndClearUpper ? "MOVSD " : "MOVLPD",
                              Matcher::regName[reg_lo], offset);
      else         st->print("MOVSD  [ESP + #%d],%s",
                              offset, Matcher::regName[reg_lo]);
    } else {
      if (is_load) st->print("MOVSS  %s,[ESP + #%d]",
                              Matcher::regName[reg_lo], offset);
      else         st->print("MOVSS  [ESP + #%d],%s",
                              offset, Matcher::regName[reg_lo]);
    }
#endif
  }
  int offset_size = (offset == 0) ? 0 : ((offset <= 127) ? 1 : 4);
  // VEX_2bytes prefix is used if UseAVX > 0, so it takes the same 2 bytes as SIMD prefix.
  return size+5+offset_size;
}


static int impl_movx_helper( CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                            int src_hi, int dst_hi, int size, outputStream* st ) {
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    if (src_lo+1 == src_hi && dst_lo+1 == dst_hi) { // double move?
      __ movdbl(as_XMMRegister(Matcher::_regEncode[dst_lo]),
                as_XMMRegister(Matcher::_regEncode[src_lo]));
    } else {
      __ movflt(as_XMMRegister(Matcher::_regEncode[dst_lo]),
                as_XMMRegister(Matcher::_regEncode[src_lo]));
    }
#ifndef PRODUCT
  } else if (!do_size) {
    if (size != 0) st->print("\n\t");
    if (UseXmmRegToRegMoveAll) {//Use movaps,movapd to move between xmm registers
      if (src_lo+1 == src_hi && dst_lo+1 == dst_hi) { // double move?
        st->print("MOVAPD %s,%s",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      } else {
        st->print("MOVAPS %s,%s",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      }
    } else {
      if( src_lo+1 == src_hi && dst_lo+1 == dst_hi ) { // double move?
        st->print("MOVSD  %s,%s",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      } else {
        st->print("MOVSS  %s,%s",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      }
    }
#endif
  }
  // VEX_2bytes prefix is used if UseAVX > 0, and it takes the same 2 bytes as SIMD prefix.
  // Only MOVAPS SSE prefix uses 1 byte.
  int sz = 4;
  if (!(src_lo+1 == src_hi && dst_lo+1 == dst_hi) &&
      UseXmmRegToRegMoveAll && (UseAVX == 0)) sz = 3;
  return size + sz;
}

static int impl_movgpr2x_helper( CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                            int src_hi, int dst_hi, int size, outputStream* st ) {
  // 32-bit
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    __ movdl(as_XMMRegister(Matcher::_regEncode[dst_lo]),
             as_Register(Matcher::_regEncode[src_lo]));
#ifndef PRODUCT
  } else if (!do_size) {
    st->print("movdl   %s, %s\t# spill", Matcher::regName[dst_lo], Matcher::regName[src_lo]);
#endif
  }
  return 4;
}


static int impl_movx2gpr_helper( CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                                 int src_hi, int dst_hi, int size, outputStream* st ) {
  // 32-bit
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    __ movdl(as_Register(Matcher::_regEncode[dst_lo]),
             as_XMMRegister(Matcher::_regEncode[src_lo]));
#ifndef PRODUCT
  } else if (!do_size) {
    st->print("movdl   %s, %s\t# spill", Matcher::regName[dst_lo], Matcher::regName[src_lo]);
#endif
  }
  return 4;
}

static int impl_mov_helper( CodeBuffer *cbuf, bool do_size, int src, int dst, int size, outputStream* st ) {
  if( cbuf ) {
    emit_opcode(*cbuf, 0x8B );
    emit_rm    (*cbuf, 0x3, Matcher::_regEncode[dst], Matcher::_regEncode[src] );
#ifndef PRODUCT
  } else if( !do_size ) {
    if( size != 0 ) st->print("\n\t");
    st->print("MOV    %s,%s",Matcher::regName[dst],Matcher::regName[src]);
#endif
  }
  return size+2;
}

static int impl_fp_store_helper( CodeBuffer *cbuf, bool do_size, int src_lo, int src_hi, int dst_lo, int dst_hi,
                                 int offset, int size, outputStream* st ) {
  if( src_lo != FPR1L_num ) {      // Move value to top of FP stack, if not already there
    if( cbuf ) {
      emit_opcode( *cbuf, 0xD9 );  // FLD (i.e., push it)
      emit_d8( *cbuf, 0xC0-1+Matcher::_regEncode[src_lo] );
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      st->print("FLD    %s",Matcher::regName[src_lo]);
#endif
    }
    size += 2;
  }

  int st_op = (src_lo != FPR1L_num) ? EBX_num /*store & pop*/ : EDX_num /*store no pop*/;
  const char *op_str;
  int op;
  if( src_lo+1 == src_hi && dst_lo+1 == dst_hi ) { // double store?
    op_str = (src_lo != FPR1L_num) ? "FSTP_D" : "FST_D ";
    op = 0xDD;
  } else {                   // 32-bit store
    op_str = (src_lo != FPR1L_num) ? "FSTP_S" : "FST_S ";
    op = 0xD9;
    assert( !OptoReg::is_valid(src_hi) && !OptoReg::is_valid(dst_hi), "no non-adjacent float-stores" );
  }

  return impl_helper(cbuf,do_size,false,offset,st_op,op,op_str,size, st);
}

// Next two methods are shared by 32- and 64-bit VM. They are defined in x86.ad.
static int vec_mov_helper(CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                          int src_hi, int dst_hi, uint ireg, outputStream* st);

static int vec_spill_helper(CodeBuffer *cbuf, bool do_size, bool is_load,
                            int stack_offset, int reg, uint ireg, outputStream* st);

static int vec_stack_to_stack_helper(CodeBuffer *cbuf, bool do_size, int src_offset,
                                     int dst_offset, uint ireg, outputStream* st) {
  int calc_size = 0;
  int src_offset_size = (src_offset == 0) ? 0 : ((src_offset < 0x80) ? 1 : 4);
  int dst_offset_size = (dst_offset == 0) ? 0 : ((dst_offset < 0x80) ? 1 : 4);
  switch (ireg) {
  case Op_VecS:
    calc_size = 3+src_offset_size + 3+dst_offset_size;
    break;
  case Op_VecD:
    calc_size = 3+src_offset_size + 3+dst_offset_size;
    src_offset += 4;
    dst_offset += 4;
    src_offset_size = (src_offset == 0) ? 0 : ((src_offset < 0x80) ? 1 : 4);
    dst_offset_size = (dst_offset == 0) ? 0 : ((dst_offset < 0x80) ? 1 : 4);
    calc_size += 3+src_offset_size + 3+dst_offset_size;
    break;
  case Op_VecX:
    calc_size = 6 + 6 + 5+src_offset_size + 5+dst_offset_size;
    break;
  case Op_VecY:
    calc_size = 6 + 6 + 5+src_offset_size + 5+dst_offset_size;
    break;
  default:
    ShouldNotReachHere();
  }
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    int offset = __ offset();
    switch (ireg) {
    case Op_VecS:
      __ pushl(Address(rsp, src_offset));
      __ popl (Address(rsp, dst_offset));
      break;
    case Op_VecD:
      __ pushl(Address(rsp, src_offset));
      __ popl (Address(rsp, dst_offset));
      __ pushl(Address(rsp, src_offset+4));
      __ popl (Address(rsp, dst_offset+4));
      break;
    case Op_VecX:
      __ movdqu(Address(rsp, -16), xmm0);
      __ movdqu(xmm0, Address(rsp, src_offset));
      __ movdqu(Address(rsp, dst_offset), xmm0);
      __ movdqu(xmm0, Address(rsp, -16));
      break;
    case Op_VecY:
      __ vmovdqu(Address(rsp, -32), xmm0);
      __ vmovdqu(xmm0, Address(rsp, src_offset));
      __ vmovdqu(Address(rsp, dst_offset), xmm0);
      __ vmovdqu(xmm0, Address(rsp, -32));
      break;
    default:
      ShouldNotReachHere();
    }
    int size = __ offset() - offset;
    assert(size == calc_size, "incorrect size calculattion");
    return size;
#ifndef PRODUCT
  } else if (!do_size) {
    switch (ireg) {
    case Op_VecS:
      st->print("pushl   [rsp + #%d]\t# 32-bit mem-mem spill\n\t"
                "popl    [rsp + #%d]",
                src_offset, dst_offset);
      break;
    case Op_VecD:
      st->print("pushl   [rsp + #%d]\t# 64-bit mem-mem spill\n\t"
                "popq    [rsp + #%d]\n\t"
                "pushl   [rsp + #%d]\n\t"
                "popq    [rsp + #%d]",
                src_offset, dst_offset, src_offset+4, dst_offset+4);
      break;
     case Op_VecX:
      st->print("movdqu  [rsp - #16], xmm0\t# 128-bit mem-mem spill\n\t"
                "movdqu  xmm0, [rsp + #%d]\n\t"
                "movdqu  [rsp + #%d], xmm0\n\t"
                "movdqu  xmm0, [rsp - #16]",
                src_offset, dst_offset);
      break;
    case Op_VecY:
      st->print("vmovdqu [rsp - #32], xmm0\t# 256-bit mem-mem spill\n\t"
                "vmovdqu xmm0, [rsp + #%d]\n\t"
                "vmovdqu [rsp + #%d], xmm0\n\t"
                "vmovdqu xmm0, [rsp - #32]",
                src_offset, dst_offset);
      break;
    default:
      ShouldNotReachHere();
    }
#endif
  }
  return calc_size;
}

uint MachSpillCopyNode::implementation( CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream* st ) const {
  // Get registers to move
  OptoReg::Name src_second = ra_->get_reg_second(in(1));
  OptoReg::Name src_first = ra_->get_reg_first(in(1));
  OptoReg::Name dst_second = ra_->get_reg_second(this );
  OptoReg::Name dst_first = ra_->get_reg_first(this );

  enum RC src_second_rc = rc_class(src_second);
  enum RC src_first_rc = rc_class(src_first);
  enum RC dst_second_rc = rc_class(dst_second);
  enum RC dst_first_rc = rc_class(dst_first);

  assert( OptoReg::is_valid(src_first) && OptoReg::is_valid(dst_first), "must move at least 1 register" );

  // Generate spill code!
  int size = 0;

  if( src_first == dst_first && src_second == dst_second )
    return size;            // Self copy, no move

  if (bottom_type()->isa_vect() != NULL) {
    uint ireg = ideal_reg();
    assert((src_first_rc != rc_int && dst_first_rc != rc_int), "sanity");
    assert((src_first_rc != rc_float && dst_first_rc != rc_float), "sanity");
    assert((ireg == Op_VecS || ireg == Op_VecD || ireg == Op_VecX || ireg == Op_VecY), "sanity");
    if( src_first_rc == rc_stack && dst_first_rc == rc_stack ) {
      // mem -> mem
      int src_offset = ra_->reg2offset(src_first);
      int dst_offset = ra_->reg2offset(dst_first);
      return vec_stack_to_stack_helper(cbuf, do_size, src_offset, dst_offset, ireg, st);
    } else if (src_first_rc == rc_xmm && dst_first_rc == rc_xmm ) {
      return vec_mov_helper(cbuf, do_size, src_first, dst_first, src_second, dst_second, ireg, st);
    } else if (src_first_rc == rc_xmm && dst_first_rc == rc_stack ) {
      int stack_offset = ra_->reg2offset(dst_first);
      return vec_spill_helper(cbuf, do_size, false, stack_offset, src_first, ireg, st);
    } else if (src_first_rc == rc_stack && dst_first_rc == rc_xmm ) {
      int stack_offset = ra_->reg2offset(src_first);
      return vec_spill_helper(cbuf, do_size, true,  stack_offset, dst_first, ireg, st);
    } else {
      ShouldNotReachHere();
    }
  }

  // --------------------------------------
  // Check for mem-mem move.  push/pop to move.
  if( src_first_rc == rc_stack && dst_first_rc == rc_stack ) {
    if( src_second == dst_first ) { // overlapping stack copy ranges
      assert( src_second_rc == rc_stack && dst_second_rc == rc_stack, "we only expect a stk-stk copy here" );
      size = impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_second),ESI_num,0xFF,"PUSH  ",size, st);
      size = impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_second),EAX_num,0x8F,"POP   ",size, st);
      src_second_rc = dst_second_rc = rc_bad;  // flag as already moved the second bits
    }
    // move low bits
    size = impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_first),ESI_num,0xFF,"PUSH  ",size, st);
    size = impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_first),EAX_num,0x8F,"POP   ",size, st);
    if( src_second_rc == rc_stack && dst_second_rc == rc_stack ) { // mov second bits
      size = impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_second),ESI_num,0xFF,"PUSH  ",size, st);
      size = impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_second),EAX_num,0x8F,"POP   ",size, st);
    }
    return size;
  }

  // --------------------------------------
  // Check for integer reg-reg copy
  if( src_first_rc == rc_int && dst_first_rc == rc_int )
    size = impl_mov_helper(cbuf,do_size,src_first,dst_first,size, st);

  // Check for integer store
  if( src_first_rc == rc_int && dst_first_rc == rc_stack )
    size = impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_first),src_first,0x89,"MOV ",size, st);

  // Check for integer load
  if( dst_first_rc == rc_int && src_first_rc == rc_stack )
    size = impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_first),dst_first,0x8B,"MOV ",size, st);

  // Check for integer reg-xmm reg copy
  if( src_first_rc == rc_int && dst_first_rc == rc_xmm ) {
    assert( (src_second_rc == rc_bad && dst_second_rc == rc_bad),
            "no 64 bit integer-float reg moves" );
    return impl_movgpr2x_helper(cbuf,do_size,src_first,dst_first,src_second, dst_second, size, st);
  }
  // --------------------------------------
  // Check for float reg-reg copy
  if( src_first_rc == rc_float && dst_first_rc == rc_float ) {
    assert( (src_second_rc == rc_bad && dst_second_rc == rc_bad) ||
            (src_first+1 == src_second && dst_first+1 == dst_second), "no non-adjacent float-moves" );
    if( cbuf ) {

      // Note the mucking with the register encode to compensate for the 0/1
      // indexing issue mentioned in a comment in the reg_def sections
      // for FPR registers many lines above here.

      if( src_first != FPR1L_num ) {
        emit_opcode  (*cbuf, 0xD9 );           // FLD    ST(i)
        emit_d8      (*cbuf, 0xC0+Matcher::_regEncode[src_first]-1 );
        emit_opcode  (*cbuf, 0xDD );           // FSTP   ST(i)
        emit_d8      (*cbuf, 0xD8+Matcher::_regEncode[dst_first] );
     } else {
        emit_opcode  (*cbuf, 0xDD );           // FST    ST(i)
        emit_d8      (*cbuf, 0xD0+Matcher::_regEncode[dst_first]-1 );
     }
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      if( src_first != FPR1L_num ) st->print("FLD    %s\n\tFSTP   %s",Matcher::regName[src_first],Matcher::regName[dst_first]);
      else                      st->print(             "FST    %s",                            Matcher::regName[dst_first]);
#endif
    }
    return size + ((src_first != FPR1L_num) ? 2+2 : 2);
  }

  // Check for float store
  if( src_first_rc == rc_float && dst_first_rc == rc_stack ) {
    return impl_fp_store_helper(cbuf,do_size,src_first,src_second,dst_first,dst_second,ra_->reg2offset(dst_first),size, st);
  }

  // Check for float load
  if( dst_first_rc == rc_float && src_first_rc == rc_stack ) {
    int offset = ra_->reg2offset(src_first);
    const char *op_str;
    int op;
    if( src_first+1 == src_second && dst_first+1 == dst_second ) { // double load?
      op_str = "FLD_D";
      op = 0xDD;
    } else {                   // 32-bit load
      op_str = "FLD_S";
      op = 0xD9;
      assert( src_second_rc == rc_bad && dst_second_rc == rc_bad, "no non-adjacent float-loads" );
    }
    if( cbuf ) {
      emit_opcode  (*cbuf, op );
      encode_RegMem(*cbuf, 0x0, ESP_enc, 0x4, 0, offset, relocInfo::none);
      emit_opcode  (*cbuf, 0xDD );           // FSTP   ST(i)
      emit_d8      (*cbuf, 0xD8+Matcher::_regEncode[dst_first] );
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      st->print("%s  ST,[ESP + #%d]\n\tFSTP   %s",op_str, offset,Matcher::regName[dst_first]);
#endif
    }
    int offset_size = (offset == 0) ? 0 : ((offset <= 127) ? 1 : 4);
    return size + 3+offset_size+2;
  }

  // Check for xmm reg-reg copy
  if( src_first_rc == rc_xmm && dst_first_rc == rc_xmm ) {
    assert( (src_second_rc == rc_bad && dst_second_rc == rc_bad) ||
            (src_first+1 == src_second && dst_first+1 == dst_second),
            "no non-adjacent float-moves" );
    return impl_movx_helper(cbuf,do_size,src_first,dst_first,src_second, dst_second, size, st);
  }

  // Check for xmm reg-integer reg copy
  if( src_first_rc == rc_xmm && dst_first_rc == rc_int ) {
    assert( (src_second_rc == rc_bad && dst_second_rc == rc_bad),
            "no 64 bit float-integer reg moves" );
    return impl_movx2gpr_helper(cbuf,do_size,src_first,dst_first,src_second, dst_second, size, st);
  }

  // Check for xmm store
  if( src_first_rc == rc_xmm && dst_first_rc == rc_stack ) {
    return impl_x_helper(cbuf,do_size,false,ra_->reg2offset(dst_first),src_first, src_second, size, st);
  }

  // Check for float xmm load
  if( dst_first_rc == rc_xmm && src_first_rc == rc_stack ) {
    return impl_x_helper(cbuf,do_size,true ,ra_->reg2offset(src_first),dst_first, dst_second, size, st);
  }

  // Copy from float reg to xmm reg
  if( dst_first_rc == rc_xmm && src_first_rc == rc_float ) {
    // copy to the top of stack from floating point reg
    // and use LEA to preserve flags
    if( cbuf ) {
      emit_opcode(*cbuf,0x8D);  // LEA  ESP,[ESP-8]
      emit_rm(*cbuf, 0x1, ESP_enc, 0x04);
      emit_rm(*cbuf, 0x0, 0x04, ESP_enc);
      emit_d8(*cbuf,0xF8);
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      st->print("LEA    ESP,[ESP-8]");
#endif
    }
    size += 4;

    size = impl_fp_store_helper(cbuf,do_size,src_first,src_second,dst_first,dst_second,0,size, st);

    // Copy from the temp memory to the xmm reg.
    size = impl_x_helper(cbuf,do_size,true ,0,dst_first, dst_second, size, st);

    if( cbuf ) {
      emit_opcode(*cbuf,0x8D);  // LEA  ESP,[ESP+8]
      emit_rm(*cbuf, 0x1, ESP_enc, 0x04);
      emit_rm(*cbuf, 0x0, 0x04, ESP_enc);
      emit_d8(*cbuf,0x08);
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      st->print("LEA    ESP,[ESP+8]");
#endif
    }
    size += 4;
    return size;
  }

  assert( size > 0, "missed a case" );

  // --------------------------------------------------------------------
  // Check for second bits still needing moving.
  if( src_second == dst_second )
    return size;               // Self copy; no move
  assert( src_second_rc != rc_bad && dst_second_rc != rc_bad, "src_second & dst_second cannot be Bad" );

  // Check for second word int-int move
  if( src_second_rc == rc_int && dst_second_rc == rc_int )
    return impl_mov_helper(cbuf,do_size,src_second,dst_second,size, st);

  // Check for second word integer store
  if( src_second_rc == rc_int && dst_second_rc == rc_stack )
    return impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_second),src_second,0x89,"MOV ",size, st);

  // Check for second word integer load
  if( dst_second_rc == rc_int && src_second_rc == rc_stack )
    return impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_second),dst_second,0x8B,"MOV ",size, st);


  Unimplemented();
}

#ifndef PRODUCT
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream* st) const {
  implementation( NULL, ra_, false, st );
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation( &cbuf, ra_, false, NULL );
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return implementation( NULL, ra_, true, NULL );
}


//=============================================================================
#ifndef PRODUCT
void BoxLockNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("LEA    %s,[ESP + #%d]",Matcher::regName[reg],offset);
}
#endif

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_encode(this);
  if( offset >= 128 ) {
    emit_opcode(cbuf, 0x8D);      // LEA  reg,[SP+offset]
    emit_rm(cbuf, 0x2, reg, 0x04);
    emit_rm(cbuf, 0x0, 0x04, ESP_enc);
    emit_d32(cbuf, offset);
  }
  else {
    emit_opcode(cbuf, 0x8D);      // LEA  reg,[SP+offset]
    emit_rm(cbuf, 0x1, reg, 0x04);
    emit_rm(cbuf, 0x0, 0x04, ESP_enc);
    emit_d8(cbuf, offset);
  }
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  if( offset >= 128 ) {
    return 7;
  }
  else {
    return 4;
  }
}

//=============================================================================
#ifndef PRODUCT
void MachUEPNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  st->print_cr(  "CMP    EAX,[ECX+4]\t# Inline cache check");
  st->print_cr("\tJNE    SharedRuntime::handle_ic_miss_stub");
  st->print_cr("\tNOP");
  st->print_cr("\tNOP");
  if( !OptoBreakpoint )
    st->print_cr("\tNOP");
}
#endif

void MachUEPNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler masm(&cbuf);
#ifdef ASSERT
  uint insts_size = cbuf.insts_size();
#endif
  masm.cmpptr(rax, Address(rcx, oopDesc::klass_offset_in_bytes()));
  masm.jump_cc(Assembler::notEqual,
               RuntimeAddress(SharedRuntime::get_ic_miss_stub()));
  /* WARNING these NOPs are critical so that verified entry point is properly
     aligned for patching by NativeJump::patch_verified_entry() */
  int nops_cnt = 2;
  if( !OptoBreakpoint ) // Leave space for int3
     nops_cnt += 1;
  masm.nop(nops_cnt);

  assert(cbuf.insts_size() - insts_size == size(ra_), "checking code size of inline cache node");
}

uint MachUEPNode::size(PhaseRegAlloc *ra_) const {
  return OptoBreakpoint ? 11 : 12;
}


//=============================================================================

int Matcher::regnum_to_fpu_offset(int regnum) {
  return regnum - 32; // The FP registers are in the second chunk
}

// This is UltraSparc specific, true just means we have fast l2f conversion
const bool Matcher::convL2FSupported(void) {
  return true;
}

// Is this branch offset short enough that a short branch can be used?
//
// NOTE: If the platform does not provide any short branch variants, then
//       this method should return false for offset 0.
bool Matcher::is_short_branch_offset(int rule, int br_size, int offset) {
  // The passed offset is relative to address of the branch.
  // On 86 a branch displacement is calculated relative to address
  // of a next instruction.
  offset -= br_size;

  // the short version of jmpConUCF2 contains multiple branches,
  // making the reach slightly less
  if (rule == jmpConUCF2_rule)
    return (-126 <= offset && offset <= 125);
  return (-128 <= offset && offset <= 127);
}

const bool Matcher::isSimpleConstant64(jlong value) {
  // Will one (StoreL ConL) be cheaper than two (StoreI ConI)?.
  return false;
}

// The ecx parameter to rep stos for the ClearArray node is in dwords.
const bool Matcher::init_array_count_is_in_bytes = false;

// Threshold size for cleararray.
const int Matcher::init_array_short_size = 8 * BytesPerLong;

// Needs 2 CMOV's for longs.
const int Matcher::long_cmove_cost() { return 1; }

// No CMOVF/CMOVD with SSE/SSE2
const int Matcher::float_cmove_cost() { return (UseSSE>=1) ? ConditionalMoveLimit : 0; }

// Does the CPU require late expand (see block.cpp for description of late expand)?
const bool Matcher::require_postalloc_expand = false;

// Should the Matcher clone shifts on addressing modes, expecting them to
// be subsumed into complex addressing expressions or compute them into
// registers?  True for Intel but false for most RISCs
const bool Matcher::clone_shift_expressions = true;

// Do we need to mask the count passed to shift instructions or does
// the cpu only look at the lower 5/6 bits anyway?
const bool Matcher::need_masked_shift_count = false;

bool Matcher::narrow_oop_use_complex_address() {
  ShouldNotCallThis();
  return true;
}

bool Matcher::narrow_klass_use_complex_address() {
  ShouldNotCallThis();
  return true;
}


// Is it better to copy float constants, or load them directly from memory?
// Intel can load a float constant from a direct address, requiring no
// extra registers.  Most RISCs will have to materialize an address into a
// register first, so they would do better to copy the constant from stack.
const bool Matcher::rematerialize_float_constants = true;

// If CPU can load and store mis-aligned doubles directly then no fixup is
// needed.  Else we split the double into 2 integer pieces and move it
// piece-by-piece.  Only happens when passing doubles into C code as the
// Java calling convention forces doubles to be aligned.
const bool Matcher::misaligned_doubles_ok = true;


void Matcher::pd_implicit_null_fixup(MachNode *node, uint idx) {
  // Get the memory operand from the node
  uint numopnds = node->num_opnds();        // Virtual call for number of operands
  uint skipped  = node->oper_input_base();  // Sum of leaves skipped so far
  assert( idx >= skipped, "idx too low in pd_implicit_null_fixup" );
  uint opcnt     = 1;                 // First operand
  uint num_edges = node->_opnds[1]->num_edges(); // leaves for first operand
  while( idx >= skipped+num_edges ) {
    skipped += num_edges;
    opcnt++;                          // Bump operand count
    assert( opcnt < numopnds, "Accessing non-existent operand" );
    num_edges = node->_opnds[opcnt]->num_edges(); // leaves for next operand
  }

  MachOper *memory = node->_opnds[opcnt];
  MachOper *new_memory = NULL;
  switch (memory->opcode()) {
  case DIRECT:
  case INDOFFSET32X:
    // No transformation necessary.
    return;
  case INDIRECT:
    new_memory = new (C) indirect_win95_safeOper( );
    break;
  case INDOFFSET8:
    new_memory = new (C) indOffset8_win95_safeOper(memory->disp(NULL, NULL, 0));
    break;
  case INDOFFSET32:
    new_memory = new (C) indOffset32_win95_safeOper(memory->disp(NULL, NULL, 0));
    break;
  case INDINDEXOFFSET:
    new_memory = new (C) indIndexOffset_win95_safeOper(memory->disp(NULL, NULL, 0));
    break;
  case INDINDEXSCALE:
    new_memory = new (C) indIndexScale_win95_safeOper(memory->scale());
    break;
  case INDINDEXSCALEOFFSET:
    new_memory = new (C) indIndexScaleOffset_win95_safeOper(memory->scale(), memory->disp(NULL, NULL, 0));
    break;
  case LOAD_LONG_INDIRECT:
  case LOAD_LONG_INDOFFSET32:
    // Does not use EBP as address register, use { EDX, EBX, EDI, ESI}
    return;
  default:
    assert(false, "unexpected memory operand in pd_implicit_null_fixup()");
    return;
  }
  node->_opnds[opcnt] = new_memory;
}

// Advertise here if the CPU requires explicit rounding operations
// to implement the UseStrictFP mode.
const bool Matcher::strict_fp_requires_explicit_rounding = true;

// Are floats conerted to double when stored to stack during deoptimization?
// On x32 it is stored with convertion only when FPU is used for floats.
bool Matcher::float_in_double() { return (UseSSE == 0); }

// Do ints take an entire long register or just half?
const bool Matcher::int_in_long = false;

// Return whether or not this register is ever used as an argument.  This
// function is used on startup to build the trampoline stubs in generateOptoStub.
// Registers not mentioned will be killed by the VM call in the trampoline, and
// arguments in those registers not be available to the callee.
bool Matcher::can_be_java_arg( int reg ) {
  if(  reg == ECX_num   || reg == EDX_num   ) return true;
  if( (reg == XMM0_num  || reg == XMM1_num ) && UseSSE>=1 ) return true;
  if( (reg == XMM0b_num || reg == XMM1b_num) && UseSSE>=2 ) return true;
  return false;
}

bool Matcher::is_spillable_arg( int reg ) {
  return can_be_java_arg(reg);
}

bool Matcher::use_asm_for_ldiv_by_con( jlong divisor ) {
  // Use hardware integer DIV instruction when
  // it is faster than a code which use multiply.
  // Only when constant divisor fits into 32 bit
  // (min_jint is excluded to get only correct
  // positive 32 bit values from negative).
  return VM_Version::has_fast_idiv() &&
         (divisor == (int)divisor && divisor != min_jint);
}

// Register for DIVI projection of divmodI
RegMask Matcher::divI_proj_mask() {
  return EAX_REG_mask();
}

// Register for MODI projection of divmodI
RegMask Matcher::modI_proj_mask() {
  return EDX_REG_mask();
}

// Register for DIVL projection of divmodL
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODL projection of divmodL
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return EBP_REG_mask();
}

// Returns true if the high 32 bits of the value is known to be zero.
bool is_operand_hi32_zero(Node* n) {
  int opc = n->Opcode();
  if (opc == Op_AndL) {
    Node* o2 = n->in(2);
    if (o2->is_Con() && (o2->get_long() & 0xFFFFFFFF00000000LL) == 0LL) {
      return true;
    }
  }
  if (opc == Op_ConL && (n->get_long() & 0xFFFFFFFF00000000LL) == 0LL) {
    return true;
  }
  return false;
}


#line 1370 "../generated/adfiles/ad_x86_32.cpp"


//SourceForm

#line 543 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"


// Emit exception handler code.
// Stuff framesize into a register and call a VM stub routine.
int HandlerImpl::emit_exception_handler(CodeBuffer& cbuf) {

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_exception_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();
  __ jump(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(CodeBuffer& cbuf) {

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_deopt_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();

#ifdef _LP64
  address the_pc = (address) __ pc();
  Label next;
  // push a "the_pc" on the stack without destroying any registers
  // as they all may be live.

  // push address of "next"
  __ call(next, relocInfo::none); // reloc none is fine since it is a disp32
  __ bind(next);
  // adjust it so it matches "the_pc"
  __ subptr(Address(rsp, 0), __ offset() - offset);
#else
  InternalAddress here(__ pc());
  __ pushptr(here.addr());
#endif

  __ jump(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));
  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}


//=============================================================================

  // Float masks come from different places depending on platform.
#ifdef _LP64
  static address float_signmask()  { return StubRoutines::x86::float_sign_mask(); }
  static address float_signflip()  { return StubRoutines::x86::float_sign_flip(); }
  static address double_signmask() { return StubRoutines::x86::double_sign_mask(); }
  static address double_signflip() { return StubRoutines::x86::double_sign_flip(); }
#else
  static address float_signmask()  { return (address)float_signmask_pool; }
  static address float_signflip()  { return (address)float_signflip_pool; }
  static address double_signmask() { return (address)double_signmask_pool; }
  static address double_signflip() { return (address)double_signflip_pool; }
#endif


const bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode))
    return false;

  switch (opcode) {
    case Op_PopCountI:
    case Op_PopCountL:
      if (!UsePopCountInstruction)
        return false;
    break;
    case Op_MulVI:
      if ((UseSSE < 4) && (UseAVX < 1)) // only with SSE4_1 or AVX
        return false;
    break;
    case Op_CompareAndSwapL:
#ifdef _LP64
    case Op_CompareAndSwapP:
#endif
      if (!VM_Version::supports_cx8())
        return false;
    break;
  }

  return true;  // Per default match rules are supported.
}

// Max vector size in bytes. 0 if not supported.
const int Matcher::vector_width_in_bytes(BasicType bt) {
  assert(is_java_primitive(bt), "only primitive type vectors");
  if (UseSSE < 2) return 0;
  // SSE2 supports 128bit vectors for all types.
  // AVX2 supports 256bit vectors for all types.
  int size = (UseAVX > 1) ? 32 : 16;
  // AVX1 supports 256bit vectors only for FLOAT and DOUBLE.
  if (UseAVX > 0 && (bt == T_FLOAT || bt == T_DOUBLE))
    size = 32;
  // Use flag to limit vector size.
  size = MIN2(size,(int)MaxVectorSize);
  // Minimum 2 values in vector (or 4 for bytes).
  switch (bt) {
  case T_DOUBLE:
  case T_LONG:
    if (size < 16) return 0;
  case T_FLOAT:
  case T_INT:
    if (size < 8) return 0;
  case T_BOOLEAN:
  case T_BYTE:
  case T_CHAR:
  case T_SHORT:
    if (size < 4) return 0;
    break;
  default:
    ShouldNotReachHere();
  }
  return size;
}

// Limits on vector size (number of elements) loaded into vector.
const int Matcher::max_vector_size(const BasicType bt) {
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}
const int Matcher::min_vector_size(const BasicType bt) {
  int max_size = max_vector_size(bt);
  // Min size which can be loaded into vector is 4 bytes.
  int size = (type2aelembytes(bt) == 1) ? 4 : 2;
  return MIN2(size,max_size);
}

// Vector ideal reg corresponding to specidied size in bytes
const int Matcher::vector_ideal_reg(int size) {
  assert(MaxVectorSize >= size, "");
  switch(size) {
    case  4: return Op_VecS;
    case  8: return Op_VecD;
    case 16: return Op_VecX;
    case 32: return Op_VecY;
  }
  ShouldNotReachHere();
  return 0;
}

// Only lowest bits of xmm reg are used for vector shift count.
const int Matcher::vector_shift_count_ideal_reg(int size) {
  return Op_VecS;
}

// x86 supports misaligned vectors store/load.
const bool Matcher::misaligned_vectors_ok() {
  return !AlignVector; // can be changed by flag
}

// x86 AES instructions are compatible with SunJCE expanded
// keys, hence we do not need to pass the original key to stubs
const bool Matcher::pass_original_key_for_aes() {
  return false;
}

// Helper methods for MachSpillCopyNode::implementation().
static int vec_mov_helper(CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                          int src_hi, int dst_hi, uint ireg, outputStream* st) {
  // In 64-bit VM size calculation is very complex. Emitting instructions
  // into scratch buffer is used to get size in 64-bit VM.
  LP64_ONLY( assert(!do_size, "this method calculates size only for 32-bit VM"); )
  assert(ireg == Op_VecS || // 32bit vector
         (src_lo & 1) == 0 && (src_lo + 1) == src_hi &&
         (dst_lo & 1) == 0 && (dst_lo + 1) == dst_hi,
         "no non-adjacent vector moves" );
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    int offset = __ offset();
    switch (ireg) {
    case Op_VecS: // copy whole register
    case Op_VecD:
    case Op_VecX:
      __ movdqu(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]));
      break;
    case Op_VecY:
      __ vmovdqu(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]));
      break;
    default:
      ShouldNotReachHere();
    }
    int size = __ offset() - offset;
#ifdef ASSERT
    // VEX_2bytes prefix is used if UseAVX > 0, so it takes the same 2 bytes as SIMD prefix.
    assert(!do_size || size == 4, "incorrect size calculattion");
#endif
    return size;
#ifndef PRODUCT
  } else if (!do_size) {
    switch (ireg) {
    case Op_VecS:
    case Op_VecD:
    case Op_VecX:
      st->print("movdqu  %s,%s\t# spill",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      break;
    case Op_VecY:
      st->print("vmovdqu %s,%s\t# spill",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      break;
    default:
      ShouldNotReachHere();
    }
#endif
  }
  // VEX_2bytes prefix is used if UseAVX > 0, and it takes the same 2 bytes as SIMD prefix.
  return 4;
}

static int vec_spill_helper(CodeBuffer *cbuf, bool do_size, bool is_load,
                            int stack_offset, int reg, uint ireg, outputStream* st) {
  // In 64-bit VM size calculation is very complex. Emitting instructions
  // into scratch buffer is used to get size in 64-bit VM.
  LP64_ONLY( assert(!do_size, "this method calculates size only for 32-bit VM"); )
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    int offset = __ offset();
    if (is_load) {
      switch (ireg) {
      case Op_VecS:
        __ movdl(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
        break;
      case Op_VecD:
        __ movq(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
        break;
      case Op_VecX:
        __ movdqu(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
        break;
      case Op_VecY:
        __ vmovdqu(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
        break;
      default:
        ShouldNotReachHere();
      }
    } else { // store
      switch (ireg) {
      case Op_VecS:
        __ movdl(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
        break;
      case Op_VecD:
        __ movq(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
        break;
      case Op_VecX:
        __ movdqu(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
        break;
      case Op_VecY:
        __ vmovdqu(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
        break;
      default:
        ShouldNotReachHere();
      }
    }
    int size = __ offset() - offset;
#ifdef ASSERT
    int offset_size = (stack_offset == 0) ? 0 : ((stack_offset < 0x80) ? 1 : 4);
    // VEX_2bytes prefix is used if UseAVX > 0, so it takes the same 2 bytes as SIMD prefix.
    assert(!do_size || size == (5+offset_size), "incorrect size calculattion");
#endif
    return size;
#ifndef PRODUCT
  } else if (!do_size) {
    if (is_load) {
      switch (ireg) {
      case Op_VecS:
        st->print("movd    %s,[rsp + %d]\t# spill", Matcher::regName[reg], stack_offset);
        break;
      case Op_VecD:
        st->print("movq    %s,[rsp + %d]\t# spill", Matcher::regName[reg], stack_offset);
        break;
       case Op_VecX:
        st->print("movdqu  %s,[rsp + %d]\t# spill", Matcher::regName[reg], stack_offset);
        break;
      case Op_VecY:
        st->print("vmovdqu %s,[rsp + %d]\t# spill", Matcher::regName[reg], stack_offset);
        break;
      default:
        ShouldNotReachHere();
      }
    } else { // store
      switch (ireg) {
      case Op_VecS:
        st->print("movd    [rsp + %d],%s\t# spill", stack_offset, Matcher::regName[reg]);
        break;
      case Op_VecD:
        st->print("movq    [rsp + %d],%s\t# spill", stack_offset, Matcher::regName[reg]);
        break;
       case Op_VecX:
        st->print("movdqu  [rsp + %d],%s\t# spill", stack_offset, Matcher::regName[reg]);
        break;
      case Op_VecY:
        st->print("vmovdqu [rsp + %d],%s\t# spill", stack_offset, Matcher::regName[reg]);
        break;
      default:
        ShouldNotReachHere();
      }
    }
#endif
  }
  int offset_size = (stack_offset == 0) ? 0 : ((stack_offset < 0x80) ? 1 : 4);
  // VEX_2bytes prefix is used if UseAVX > 0, so it takes the same 2 bytes as SIMD prefix.
  return 5+offset_size;
}

static inline jfloat replicate4_imm(int con, int width) {
  // Load a constant of "width" (in bytes) and replicate it to fill 32bit.
  assert(width == 1 || width == 2, "only byte or short types here");
  int bit_width = width * 8;
  jint val = con;
  val &= (1 << bit_width) - 1;  // mask off sign bits
  while(bit_width < 32) {
    val |= (val << bit_width);
    bit_width <<= 1;
  }
  jfloat fval = *((jfloat*) &val);  // coerce to float type
  return fval;
}

static inline jdouble replicate8_imm(int con, int width) {
  // Load a constant of "width" (in bytes) and replicate it to fill 64bit.
  assert(width == 1 || width == 2 || width == 4, "only byte, short or int types here");
  int bit_width = width * 8;
  jlong val = con;
  val &= (((jlong) 1) << bit_width) - 1;  // mask off sign bits
  while(bit_width < 64) {
    val |= (val << bit_width);
    bit_width <<= 1;
  }
  jdouble dval = *((jdouble*) &val);  // coerce to double type
  return dval;
}

#ifndef PRODUCT
  void MachNopNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("nop \t# %d bytes pad for loops and calls", _count);
  }
#endif

  void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc*) const {
    MacroAssembler _masm(&cbuf);
    __ nop(_count);
  }

  uint MachNopNode::size(PhaseRegAlloc*) const {
    return _count;
  }

#ifndef PRODUCT
  void MachBreakpointNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("# breakpoint");
  }
#endif

  void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc* ra_) const {
    MacroAssembler _masm(&cbuf);
    __ int3();
  }

  uint MachBreakpointNode::size(PhaseRegAlloc* ra_) const {
    return MachNode::size(ra_);
  }


#line 1745 "../generated/adfiles/ad_x86_32.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // ECX
  'C', // EBX
  'N', // EBP
  'C', // EDI
  'C', // EAX
  'C', // EDX
  'C', // ESI
  'N', // ESP
  'C', // FPR0L
  'C', // FPR0H
  'C', // FPR1L
  'C', // FPR1H
  'C', // FPR2L
  'C', // FPR2H
  'C', // FPR3L
  'C', // FPR3H
  'C', // FPR4L
  'C', // FPR4H
  'C', // FPR5L
  'C', // FPR5H
  'C', // FPR6L
  'C', // FPR6H
  'C', // FPR7L
  'C', // FPR7H
  'C', // XMM0
  'C', // XMM0b
  'C', // XMM0c
  'C', // XMM0d
  'C', // XMM0e
  'C', // XMM0f
  'C', // XMM0g
  'C', // XMM0h
  'C', // XMM1
  'C', // XMM1b
  'C', // XMM1c
  'C', // XMM1d
  'C', // XMM1e
  'C', // XMM1f
  'C', // XMM1g
  'C', // XMM1h
  'C', // XMM2
  'C', // XMM2b
  'C', // XMM2c
  'C', // XMM2d
  'C', // XMM2e
  'C', // XMM2f
  'C', // XMM2g
  'C', // XMM2h
  'C', // XMM3
  'C', // XMM3b
  'C', // XMM3c
  'C', // XMM3d
  'C', // XMM3e
  'C', // XMM3f
  'C', // XMM3g
  'C', // XMM3h
  'C', // XMM4
  'C', // XMM4b
  'C', // XMM4c
  'C', // XMM4d
  'C', // XMM4e
  'C', // XMM4f
  'C', // XMM4g
  'C', // XMM4h
  'C', // XMM5
  'C', // XMM5b
  'C', // XMM5c
  'C', // XMM5d
  'C', // XMM5e
  'C', // XMM5f
  'C', // XMM5g
  'C', // XMM5h
  'C', // XMM6
  'C', // XMM6b
  'C', // XMM6c
  'C', // XMM6d
  'C', // XMM6e
  'C', // XMM6f
  'C', // XMM6g
  'C', // XMM6h
  'C', // XMM7
  'C', // XMM7b
  'C', // XMM7c
  'C', // XMM7d
  'C', // XMM7e
  'C', // XMM7f
  'C', // XMM7g
  'C', // XMM7h
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C', // ECX
  'E', // EBX
  'E', // EBP
  'E', // EDI
  'C', // EAX
  'C', // EDX
  'E', // ESI
  'N', // ESP
  'C', // FPR0L
  'C', // FPR0H
  'C', // FPR1L
  'C', // FPR1H
  'C', // FPR2L
  'C', // FPR2H
  'C', // FPR3L
  'C', // FPR3H
  'C', // FPR4L
  'C', // FPR4H
  'C', // FPR5L
  'C', // FPR5H
  'C', // FPR6L
  'C', // FPR6H
  'C', // FPR7L
  'C', // FPR7H
  'C', // XMM0
  'C', // XMM0b
  'C', // XMM0c
  'C', // XMM0d
  'C', // XMM0e
  'C', // XMM0f
  'C', // XMM0g
  'C', // XMM0h
  'C', // XMM1
  'C', // XMM1b
  'C', // XMM1c
  'C', // XMM1d
  'C', // XMM1e
  'C', // XMM1f
  'C', // XMM1g
  'C', // XMM1h
  'C', // XMM2
  'C', // XMM2b
  'C', // XMM2c
  'C', // XMM2d
  'C', // XMM2e
  'C', // XMM2f
  'C', // XMM2g
  'C', // XMM2h
  'C', // XMM3
  'C', // XMM3b
  'C', // XMM3c
  'C', // XMM3d
  'C', // XMM3e
  'C', // XMM3f
  'C', // XMM3g
  'C', // XMM3h
  'C', // XMM4
  'C', // XMM4b
  'C', // XMM4c
  'C', // XMM4d
  'C', // XMM4e
  'C', // XMM4f
  'C', // XMM4g
  'C', // XMM4h
  'C', // XMM5
  'C', // XMM5b
  'C', // XMM5c
  'C', // XMM5d
  'C', // XMM5e
  'C', // XMM5f
  'C', // XMM5g
  'C', // XMM5h
  'C', // XMM6
  'C', // XMM6b
  'C', // XMM6c
  'C', // XMM6d
  'C', // XMM6e
  'C', // XMM6f
  'C', // XMM6g
  'C', // XMM6h
  'C', // XMM7
  'C', // XMM7b
  'C', // XMM7c
  'C', // XMM7d
  'C', // XMM7e
  'C', // XMM7f
  'C', // XMM7g
  'C', // XMM7h
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  0 // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immI_rule,
  /*    9 */  immI0_rule,
  /*   10 */  immI1_rule,
  /*   11 */  immI_M1_rule,
  /*   12 */  immI2_rule,
  /*   13 */  immI8_rule,
  /*   14 */  immI16_rule,
  /*   15 */  immU31_rule,
  /*   16 */  immI_32_rule,
  /*   17 */  immI_1_31_rule,
  /*   18 */  immI_32_63_rule,
  /*   19 */  immI_1_rule,
  /*   20 */  immI_2_rule,
  /*   21 */  immI_3_rule,
  /*   22 */  immP_rule,
  /*   23 */  immP0_rule,
  /*   24 */  immL_rule,
  /*   25 */  immL0_rule,
  /*   26 */  immL_M1_rule,
  /*   27 */  immL_127_rule,
  /*   28 */  immL_32bits_rule,
  /*   29 */  immL32_rule,
  /*   30 */  immDPR0_rule,
  /*   31 */  immDPR1_rule,
  /*   32 */  immDPR_rule,
  /*   33 */  immD_rule,
  /*   34 */  immD0_rule,
  /*   35 */  immFPR0_rule,
  /*   36 */  immFPR1_rule,
  /*   37 */  immFPR_rule,
  /*   38 */  immF_rule,
  /*   39 */  immF0_rule,
  /*   40 */  immI_16_rule,
  /*   41 */  immI_24_rule,
  /*   42 */  immI_255_rule,
  /*   43 */  immI_65535_rule,
  /*   44 */  rRegI_rule,
  /*   45 */  xRegI_rule,
  /*   46 */  eAXRegI_rule,
  /*   47 */  eBXRegI_rule,
  /*   48 */  eCXRegI_rule,
  /*   49 */  eDXRegI_rule,
  /*   50 */  eDIRegI_rule,
  /*   51 */  naxRegI_rule,
  /*   52 */  nadxRegI_rule,
  /*   53 */  ncxRegI_rule,
  /*   54 */  eSIRegI_rule,
  /*   55 */  anyRegP_rule,
  /*   56 */  eRegP_rule,
  /*   57 */  eRegP_no_EBP_rule,
  /*   58 */  naxRegP_rule,
  /*   59 */  nabxRegP_rule,
  /*   60 */  pRegP_rule,
  /*   61 */  eAXRegP_rule,
  /*   62 */  eBXRegP_rule,
  /*   63 */  eCXRegP_rule,
  /*   64 */  eSIRegP_rule,
  /*   65 */  eDIRegP_rule,
  /*   66 */  eBPRegP_rule,
  /*   67 */  eRegL_rule,
  /*   68 */  eADXRegL_rule,
  /*   69 */  eBCXRegL_rule,
  /*   70 */  eADXRegL_low_only_rule,
  /*   71 */  eFlagsReg_rule,
  /*   72 */  eFlagsRegU_rule,
  /*   73 */  eFlagsRegUCF_rule,
  /*   74 */  flagsReg_long_LTGE_rule,
  /*   75 */  flagsReg_long_EQNE_rule,
  /*   76 */  flagsReg_long_LEGT_rule,
  /*   77 */  regDPR_rule,
  /*   78 */  regDPR1_rule,
  /*   79 */  regDPR2_rule,
  /*   80 */  regnotDPR1_rule,
  /*   81 */  regFPR_rule,
  /*   82 */  regFPR1_rule,
  /*   83 */  regF_rule,
  /*   84 */  regD_rule,
  /*   85 */  direct_rule,
  /*   86 */  indirect_rule,
  /*   87 */  indOffset8_rule,
  /*   88 */  indOffset32_rule,
  /*   89 */  indOffset32X_rule,
  /*   90 */  indIndexOffset_rule,
  /*   91 */  indIndex_rule,
  /*   92 */  indIndexScale_rule,
  /*   93 */  indIndexScaleOffset_rule,
  /*   94 */  load_long_RegP_rule,
  /*   95 */  load_long_indirect_rule,
  /*   96 */  load_long_indOffset32_rule,
  /*   97 */  stackSlotP_rule,
  /*   98 */  stackSlotI_rule,
  /*   99 */  stackSlotF_rule,
  /*  100 */  stackSlotD_rule,
  /*  101 */  stackSlotL_rule,
  /*  102 */  indirect_win95_safe_rule,
  /*  103 */  indOffset8_win95_safe_rule,
  /*  104 */  indOffset32_win95_safe_rule,
  /*  105 */  indIndexOffset_win95_safe_rule,
  /*  106 */  indIndexScale_win95_safe_rule,
  /*  107 */  indIndexScaleOffset_win95_safe_rule,
  /*  108 */  cmpOp_rule,
  /*  109 */  cmpOpU_rule,
  /*  110 */  cmpOpUCF_rule,
  /*  111 */  cmpOpUCF2_rule,
  /*  112 */  cmpOp_fcmov_rule,
  /*  113 */  cmpOp_commute_rule,
  /*  114 */  vecS_rule,
  /*  115 */  vecD_rule,
  /*  116 */  vecX_rule,
  /*  117 */  vecY_rule,
  // last operand
  /*  118 */  load_long_memory_rule,
  /*  119 */  memory_rule,
  /*  120 */  long_memory_rule,
  // last operand class
  /*  121 */  _AddP_eRegP_rRegI_rule,
  /*  122 */  _LShiftI_rRegI_immI2_rule,
  /*  123 */  _AddP_eRegP__LShiftI_rRegI_immI2_rule,
  /*  124 */  _AddP_eRegP_no_EBP_rRegI_rule,
  /*  125 */  _AddP_eRegP_no_EBP__LShiftI_rRegI_immI2_rule,
  /*  126 */  _LoadI_memory__rule,
  /*  127 */  _LoadL_memory__rule,
  /*  128 */  _LoadB_memory__rule,
  /*  129 */  _LoadUB_memory__rule,
  /*  130 */  _AndI__LoadUB_memory__immI8_rule,
  /*  131 */  _LoadS_memory__rule,
  /*  132 */  _LShiftI__LoadS_memory__immI_24_rule,
  /*  133 */  _LoadUS_memory__rule,
  /*  134 */  _LShiftI__LoadUS_memory__immI_24_rule,
  /*  135 */  _AndI__LoadUS_memory__immI_255_rule,
  /*  136 */  _AndI__LoadUS_memory__immI16_rule,
  /*  137 */  _LShiftI__LoadI_memory__immI_24_rule,
  /*  138 */  _LShiftI__LoadI_memory__immI_16_rule,
  /*  139 */  _AndI__LoadI_memory__immI_255_rule,
  /*  140 */  _AndI__LoadI_memory__immI_65535_rule,
  /*  141 */  _AndI__LoadI_memory__immU31_rule,
  /*  142 */  _ConvI2L__LoadI_memory___rule,
  /*  143 */  _ConvL2I_eRegL__rule,
  /*  144 */  _RoundDouble_regDPR1__rule,
  /*  145 */  _RoundFloat_regFPR1__rule,
  /*  146 */  _ConvD2F_regDPR1__rule,
  /*  147 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  148 */  _Binary_rRegI_rRegI_rule,
  /*  149 */  _Binary_cmpOpU_eFlagsRegU_rule,
  /*  150 */  _Binary_cmpOpUCF_eFlagsRegUCF_rule,
  /*  151 */  _Binary_rRegI__LoadI_memory__rule,
  /*  152 */  _Binary_eRegP_eRegP_rule,
  /*  153 */  _Binary_cmpOp_fcmov_eFlagsRegU_rule,
  /*  154 */  _Binary_regDPR1_regDPR_rule,
  /*  155 */  _Binary_regFPR1_regFPR_rule,
  /*  156 */  _Binary_regDPR_regDPR_rule,
  /*  157 */  _Binary_regFPR_regFPR_rule,
  /*  158 */  _Binary_regF_regF_rule,
  /*  159 */  _Binary_regD_regD_rule,
  /*  160 */  _Binary_eRegL_eRegL_rule,
  /*  161 */  _AddI__LoadI_memory__rRegI_rule,
  /*  162 */  _AddI_rRegI__LoadI_memory__rule,
  /*  163 */  _AddI__LoadI_memory__immI_rule,
  /*  164 */  _AddI__LoadI_memory__immI1_rule,
  /*  165 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  166 */  _Binary_eAXRegP_eRegP_rule,
  /*  167 */  _Binary_eAXRegI_rRegI_rule,
  /*  168 */  _Binary_eADXRegL_eBCXRegL_rule,
  /*  169 */  _Binary_eAXRegP_eCXRegP_rule,
  /*  170 */  _Binary_eAXRegI_eCXRegI_rule,
  /*  171 */  _SubI__LoadI_memory__rRegI_rule,
  /*  172 */  _SubI_immI0_rRegI_rule,
  /*  173 */  _ConvI2L_nadxRegI__rule,
  /*  174 */  _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule,
  /*  175 */  _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_rule,
  /*  176 */  _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule,
  /*  177 */  _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_rule,
  /*  178 */  _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63_rule,
  /*  179 */  _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63_rule,
  /*  180 */  _ConvI2L_eAXRegI__rule,
  /*  181 */  _AndL__ConvI2L_eAXRegI__immL_32bits_rule,
  /*  182 */  _AndL__ConvI2L_nadxRegI__immL_32bits_rule,
  /*  183 */  _RShiftI__LoadI_memory__immI1_rule,
  /*  184 */  _RShiftI__LoadI_memory__immI8_rule,
  /*  185 */  _LShiftI_xRegI_immI_24_rule,
  /*  186 */  _LShiftI_xRegI_immI_16_rule,
  /*  187 */  _AndI__LoadI_memory__rRegI_rule,
  /*  188 */  _AndI_rRegI__LoadI_memory__rule,
  /*  189 */  _AndI__LoadI_memory__immI_rule,
  /*  190 */  _XorI_rRegI_immI_M1_rule,
  /*  191 */  _SubI_immI0__LoadI_memory__rule,
  /*  192 */  _AddI_rRegI_immI_M1_rule,
  /*  193 */  _CastP2X_eRegP__rule,
  /*  194 */  _OrI__LoadI_memory__rRegI_rule,
  /*  195 */  _OrI_rRegI__LoadI_memory__rule,
  /*  196 */  _OrI__LoadI_memory__immI_rule,
  /*  197 */  _LShiftI_rRegI_immI1_rule,
  /*  198 */  _URShiftI_rRegI_immI_M1_rule,
  /*  199 */  _LShiftI_rRegI_immI8_rule,
  /*  200 */  _URShiftI_rRegI_immI8_rule,
  /*  201 */  _LShiftI_ncxRegI_eCXRegI_rule,
  /*  202 */  _SubI_immI0_eCXRegI_rule,
  /*  203 */  _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule,
  /*  204 */  _SubI_immI_32_eCXRegI_rule,
  /*  205 */  _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule,
  /*  206 */  _URShiftI_rRegI_immI1_rule,
  /*  207 */  _LShiftI_rRegI_immI_M1_rule,
  /*  208 */  _URShiftI_ncxRegI_eCXRegI_rule,
  /*  209 */  _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule,
  /*  210 */  _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule,
  /*  211 */  _XorI__LoadI_memory__rRegI_rule,
  /*  212 */  _XorI_rRegI__LoadI_memory__rule,
  /*  213 */  _XorI__LoadI_memory__immI_rule,
  /*  214 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  215 */  _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule,
  /*  216 */  _SubI_rRegI_rRegI_rule,
  /*  217 */  _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule,
  /*  218 */  _LoadL_load_long_memory__rule,
  /*  219 */  _XorL_eRegL_immL_M1_rule,
  /*  220 */  _SubL_immL0_eRegL_rule,
  /*  221 */  _SubL_immL0__LoadL_memory__rule,
  /*  222 */  _AddL_eRegL_immL_M1_rule,
  /*  223 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  224 */  _LoadD_memory__rule,
  /*  225 */  _SubD_regDPR_regDPR_rule,
  /*  226 */  _AddD_regDPR_regDPR_rule,
  /*  227 */  _AddD__LoadD_memory__regDPR_rule,
  /*  228 */  _RoundDouble__AddD__LoadD_memory__regDPR__rule,
  /*  229 */  _AddD_regDPR__LoadD_memory__rule,
  /*  230 */  _RoundDouble__AddD_regDPR__LoadD_memory___rule,
  /*  231 */  _AddD_regDPR_immDPR_rule,
  /*  232 */  _MulD_regDPR_regDPR_rule,
  /*  233 */  _DivD_regDPR_regDPR_rule,
  /*  234 */  _LoadF_memory__rule,
  /*  235 */  _MulF__LoadF_memory__regFPR_rule,
  /*  236 */  _MulF_regFPR__LoadF_memory__rule,
  /*  237 */  _MulF_regFPR_regFPR_rule,
  /*  238 */  _SubF_regFPR_regFPR_rule,
  /*  239 */  _ConvI2L_rRegI__rule,
  /*  240 */  _Binary_eDIRegP_eCXRegI_rule,
  /*  241 */  _Binary_eSIRegP_eDXRegI_rule,
  /*  242 */  _Binary_eDIRegP_eSIRegP_rule,
  /*  243 */  _Binary_eDIRegP_eDXRegI_rule,
  /*  244 */  _Binary_eSIRegP_immI_rule,
  /*  245 */  _Binary_eSIRegP_eAXRegI_rule,
  /*  246 */  _AndI_rRegI_immI_rule,
  /*  247 */  _AndI_rRegI_memory_rule,
  /*  248 */  _LoadP_memory__rule,
  /*  249 */  _Binary_nadxRegI_eAXRegI_rule,
  /*  250 */  _PartialSubtypeCheck_eSIRegP_eAXRegP_rule,
  /*  251 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  252 */  _Binary_eRegL__LoadL_load_long_memory__rule,
  /*  253 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  254 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  255 */  _ConvF2D_regF__rule,
  /*  256 */  _SqrtD__ConvF2D_regF___rule,
  /*  257 */  _ConvF2D__LoadF_memory___rule,
  /*  258 */  _SqrtD__ConvF2D__LoadF_memory____rule,
  /*  259 */  _ConvF2D_immF__rule,
  /*  260 */  _SqrtD__ConvF2D_immF___rule,
  /*  261 */  _LoadVector_memory__rule,
  // last internally defined operand
  /*  262 */  stackSlotI_rule,
  /*  263 */  stackSlotP_rule,
  /*  264 */  stackSlotL_rule,
  /*  265 */  eRegP_rule,
  /*  266 */  eRegP_rule,
  /*  267 */  eRegP_rule,
  /*  268 */  eRegP_rule,
  /*  269 */  eRegP_rule,
  /*  270 */  rRegI_rule,
  /*  271 */  rRegI_rule,
  /*  272 */  eRegP_rule,
  /*  273 */  eRegL_rule,
  /*  274 */  eRegL_rule,
  /*  275 */  regFPR_rule,
  /*  276 */  regFPR_rule,
  /*  277 */  regFPR_rule,
  /*  278 */  regF_rule,
  /*  279 */  regF_rule,
  /*  280 */  regDPR_rule,
  /*  281 */  regDPR_rule,
  /*  282 */  regDPR_rule,
  /*  283 */  regD_rule,
  /*  284 */  regD_rule,
  /*  285 */  rRegI_rule,
  /*  286 */  eRegL_rule,
  /*  287 */  eRegP_rule,
  /*  288 */  regFPR_rule,
  /*  289 */  regDPR_rule,
  /*  290 */  eADXRegL_low_only_rule,
  /*  291 */  Universe_rule,
  /*  292 */  eAXRegP_rule,
  /*  293 */  rRegI_rule,
  /*  294 */  eRegP_rule,
  /*  295 */  eRegP_rule,
  /*  296 */  rRegI_rule,
  /*  297 */  eFlagsReg_rule,
  /*  298 */  eFlagsReg_rule,
  /*  299 */  eFlagsReg_rule,
  /*  300 */  0,
  /*  301 */  0,
  /*  302 */  eFlagsReg_rule,
  /*  303 */  eFlagsReg_rule,
  /*  304 */  eFlagsReg_rule,
  /*  305 */  eFlagsReg_rule,
  /*  306 */  eFlagsReg_rule,
  /*  307 */  eFlagsReg_rule,
  /*  308 */  eFlagsReg_rule,
  /*  309 */  eFlagsRegU_rule,
  /*  310 */  eFlagsRegUCF_rule,
  /*  311 */  eFlagsRegU_rule,
  /*  312 */  eFlagsRegU_rule,
  /*  313 */  eFlagsRegUCF_rule,
  /*  314 */  eFlagsRegU_rule,
  /*  315 */  eFlagsRegUCF_rule,
  /*  316 */  regDPR1_rule,
  /*  317 */  regDPR1_rule,
  /*  318 */  eFlagsRegU_rule,
  /*  319 */  eFlagsRegUCF_rule,
  /*  320 */  eFlagsRegU_rule,
  /*  321 */  eFlagsRegU_rule,
  /*  322 */  eFlagsRegUCF_rule,
  /*  323 */  eFlagsRegU_rule,
  /*  324 */  eFlagsRegUCF_rule,
  /*  325 */  regFPR1_rule,
  /*  326 */  regFPR1_rule,
  /*  327 */  rRegI_rule,
  /*  328 */  rRegI_rule,
  /*  329 */  regFPR_rule,
  /*  330 */  regF_rule,
  /*  331 */  regF_rule,
  /*  332 */  eRegL_rule,
  /*  333 */  regDPR_rule,
  /*  334 */  regD_rule,
  /*  335 */  regD_rule,
  /*  336 */  eFlagsReg_rule,
  /*  337 */  eFlagsReg_rule,
  /*  338 */  eFlagsReg_rule,
  /*  339 */  eFlagsReg_rule,
  /*  340 */  eFlagsReg_rule,
  /*  341 */  eFlagsReg_rule,
  /*  342 */  eFlagsRegU_rule,
  /*  343 */  eFlagsRegU_rule,
  /*  344 */  eFlagsRegU_rule,
  /*  345 */  eFlagsRegU_rule,
  /*  346 */  eFlagsRegU_rule,
  /*  347 */  eFlagsRegU_rule,
  /*  348 */  eFlagsRegU_rule,
  /*  349 */  eFlagsRegU_rule,
  /*  350 */  eFlagsReg_rule,
  /*  351 */  eFlagsReg_rule,
  /*  352 */  eFlagsReg_rule,
  /*  353 */  flagsReg_long_LTGE_rule,
  /*  354 */  flagsReg_long_LTGE_rule,
  /*  355 */  flagsReg_long_EQNE_rule,
  /*  356 */  flagsReg_long_EQNE_rule,
  /*  357 */  flagsReg_long_LEGT_rule,
  /*  358 */  flagsReg_long_LEGT_rule,
  /*  359 */  eFlagsReg_rule,
  /*  360 */  eFlagsReg_rule,
  /*  361 */  eFlagsReg_rule,
  /*  362 */  Universe_rule,
  /*  363 */  regF_rule,
  /*  364 */  regF_rule,
  /*  365 */  regD_rule,
  /*  366 */  regD_rule,
  /*  367 */  regF_rule,
  /*  368 */  regF_rule,
  /*  369 */  regD_rule,
  /*  370 */  regD_rule,
  /*  371 */  vecS_rule,
  /*  372 */  vecS_rule,
  /*  373 */  rRegI_rule,
  /*  374 */  eRegL_rule,
  /*  375 */  rRegI_rule,
  /*  376 */  rRegI_rule,
  /*  377 */  rRegI_rule,
  /*  378 */  rRegI_rule,
  /*  379 */  rRegI_rule,
  /*  380 */  rRegI_rule,
  /*  381 */  rRegI_rule,
  /*  382 */  rRegI_rule,
  /*  383 */  rRegI_rule,
  /*  384 */  rRegI_rule,
  /*  385 */  rRegI_rule,
  /*  386 */  rRegI_rule,
  /*  387 */  rRegI_rule,
  /*  388 */  rRegI_rule,
  /*  389 */  xRegI_rule,
  /*  390 */  eRegL_rule,
  /*  391 */  xRegI_rule,
  /*  392 */  eRegL_rule,
  /*  393 */  eRegL_rule,
  /*  394 */  rRegI_rule,
  /*  395 */  rRegI_rule,
  /*  396 */  eRegL_rule,
  /*  397 */  rRegI_rule,
  /*  398 */  rRegI_rule,
  /*  399 */  eRegL_rule,
  /*  400 */  eRegL_rule,
  /*  401 */  eRegL_rule,
  /*  402 */  rRegI_rule,
  /*  403 */  rRegI_rule,
  /*  404 */  rRegI_rule,
  /*  405 */  rRegI_rule,
  /*  406 */  rRegI_rule,
  /*  407 */  eRegL_rule,
  /*  408 */  eRegL_rule,
  /*  409 */  eRegL_rule,
  /*  410 */  eRegL_rule,
  /*  411 */  eRegL_rule,
  /*  412 */  eRegL_rule,
  /*  413 */  stackSlotL_rule,
  /*  414 */  stackSlotL_rule,
  /*  415 */  eRegL_rule,
  /*  416 */  rRegI_rule,
  /*  417 */  eRegP_rule,
  /*  418 */  eRegP_rule,
  /*  419 */  regDPR_rule,
  /*  420 */  regD_rule,
  /*  421 */  regD_rule,
  /*  422 */  regF_rule,
  /*  423 */  regFPR_rule,
  /*  424 */  Universe_rule,
  /*  425 */  Universe_rule,
  /*  426 */  Universe_rule,
  /*  427 */  Universe_rule,
  /*  428 */  Universe_rule,
  /*  429 */  Universe_rule,
  /*  430 */  Universe_rule,
  /*  431 */  Universe_rule,
  /*  432 */  Universe_rule,
  /*  433 */  Universe_rule,
  /*  434 */  Universe_rule,
  /*  435 */  Universe_rule,
  /*  436 */  Universe_rule,
  /*  437 */  Universe_rule,
  /*  438 */  Universe_rule,
  /*  439 */  Universe_rule,
  /*  440 */  Universe_rule,
  /*  441 */  Universe_rule,
  /*  442 */  Universe_rule,
  /*  443 */  Universe_rule,
  /*  444 */  Universe_rule,
  /*  445 */  Universe_rule,
  /*  446 */  Universe_rule,
  /*  447 */  Universe_rule,
  /*  448 */  Universe_rule,
  /*  449 */  Universe_rule,
  /*  450 */  Universe_rule,
  /*  451 */  Universe_rule,
  /*  452 */  Universe_rule,
  /*  453 */  Universe_rule,
  /*  454 */  Universe_rule,
  /*  455 */  Universe_rule,
  /*  456 */  Universe_rule,
  /*  457 */  Universe_rule,
  /*  458 */  Universe_rule,
  /*  459 */  Universe_rule,
  /*  460 */  Universe_rule,
  /*  461 */  Universe_rule,
  /*  462 */  Universe_rule,
  /*  463 */  Universe_rule,
  /*  464 */  Universe_rule,
  /*  465 */  Universe_rule,
  /*  466 */  Universe_rule,
  /*  467 */  Universe_rule,
  /*  468 */  rRegI_rule,
  /*  469 */  rRegI_rule,
  /*  470 */  rRegI_rule,
  /*  471 */  rRegI_rule,
  /*  472 */  rRegI_rule,
  /*  473 */  rRegI_rule,
  /*  474 */  rRegI_rule,
  /*  475 */  rRegI_rule,
  /*  476 */  eRegP_rule,
  /*  477 */  eRegP_rule,
  /*  478 */  eRegP_rule,
  /*  479 */  eRegP_rule,
  /*  480 */  regDPR1_rule,
  /*  481 */  regFPR1_rule,
  /*  482 */  regDPR_rule,
  /*  483 */  regFPR_rule,
  /*  484 */  regF_rule,
  /*  485 */  regD_rule,
  /*  486 */  regF_rule,
  /*  487 */  regF_rule,
  /*  488 */  regD_rule,
  /*  489 */  regD_rule,
  /*  490 */  eRegL_rule,
  /*  491 */  eRegL_rule,
  /*  492 */  eRegL_rule,
  /*  493 */  rRegI_rule,
  /*  494 */  rRegI_rule,
  /*  495 */  rRegI_rule,
  /*  496 */  rRegI_rule,
  /*  497 */  eRegP_rule,
  /*  498 */  rRegI_rule,
  /*  499 */  eRegP_rule,
  /*  500 */  eRegP_rule,
  /*  501 */  rRegI_rule,
  /*  502 */  rRegI_rule,
  /*  503 */  Universe_rule,
  /*  504 */  Universe_rule,
  /*  505 */  Universe_rule,
  /*  506 */  Universe_rule,
  /*  507 */  Universe_rule,
  /*  508 */  eRegP_rule,
  /*  509 */  rRegI_rule,
  /*  510 */  rRegI_rule,
  /*  511 */  rRegI_rule,
  /*  512 */  Universe_rule,
  /*  513 */  rRegI_rule,
  /*  514 */  rRegI_rule,
  /*  515 */  pRegP_rule,
  /*  516 */  rRegI_rule,
  /*  517 */  rRegI_rule,
  /*  518 */  rRegI_rule,
  /*  519 */  Universe_rule,
  /*  520 */  eRegP_rule,
  /*  521 */  rRegI_rule,
  /*  522 */  rRegI_rule,
  /*  523 */  rRegI_rule,
  /*  524 */  eDXRegI_rule,
  /*  525 */  eDXRegI_rule,
  /*  526 */  eDXRegI_rule,
  /*  527 */  eDXRegI_rule,
  /*  528 */  rRegI_rule,
  /*  529 */  rRegI_rule,
  /*  530 */  rRegI_rule,
  /*  531 */  eADXRegL_rule,
  /*  532 */  eADXRegL_rule,
  /*  533 */  eADXRegL_rule,
  /*  534 */  eADXRegL_rule,
  /*  535 */  eADXRegL_rule,
  /*  536 */  eADXRegL_rule,
  /*  537 */  eADXRegL_rule,
  /*  538 */  eADXRegL_rule,
  /*  539 */  eADXRegL_rule,
  /*  540 */  eAXRegI_rule,
  /*  541 */  eADXRegL_rule,
  /*  542 */  Universe_rule,
  /*  543 */  eDXRegI_rule,
  /*  544 */  eADXRegL_rule,
  /*  545 */  eADXRegL_rule,
  /*  546 */  eADXRegL_rule,
  /*  547 */  rRegI_rule,
  /*  548 */  rRegI_rule,
  /*  549 */  rRegI_rule,
  /*  550 */  rRegI_rule,
  /*  551 */  Universe_rule,
  /*  552 */  rRegI_rule,
  /*  553 */  Universe_rule,
  /*  554 */  rRegI_rule,
  /*  555 */  rRegI_rule,
  /*  556 */  rRegI_rule,
  /*  557 */  rRegI_rule,
  /*  558 */  rRegI_rule,
  /*  559 */  rRegI_rule,
  /*  560 */  rRegI_rule,
  /*  561 */  rRegI_rule,
  /*  562 */  rRegI_rule,
  /*  563 */  rRegI_rule,
  /*  564 */  Universe_rule,
  /*  565 */  Universe_rule,
  /*  566 */  Universe_rule,
  /*  567 */  rRegI_rule,
  /*  568 */  rRegI_rule,
  /*  569 */  rRegI_rule,
  /*  570 */  rRegI_rule,
  /*  571 */  rRegI_rule,
  /*  572 */  rRegI_rule,
  /*  573 */  rRegI_rule,
  /*  574 */  rRegI_rule,
  /*  575 */  rRegI_rule,
  /*  576 */  rRegI_rule,
  /*  577 */  rRegI_rule,
  /*  578 */  rRegI_rule,
  /*  579 */  rRegI_rule,
  /*  580 */  rRegI_rule,
  /*  581 */  rRegI_rule,
  /*  582 */  rRegI_rule,
  /*  583 */  rRegI_rule,
  /*  584 */  rRegI_rule,
  /*  585 */  rRegI_rule,
  /*  586 */  rRegI_rule,
  /*  587 */  rRegI_rule,
  /*  588 */  rRegI_rule,
  /*  589 */  Universe_rule,
  /*  590 */  Universe_rule,
  /*  591 */  Universe_rule,
  /*  592 */  0,
  /*  593 */  0,
  /*  594 */  0,
  /*  595 */  rRegI_rule,
  /*  596 */  rRegI_rule,
  /*  597 */  rRegI_rule,
  /*  598 */  rRegI_rule,
  /*  599 */  ncxRegI_rule,
  /*  600 */  ncxRegI_rule,
  /*  601 */  ncxRegI_rule,
  /*  602 */  ncxRegI_rule,
  /*  603 */  0,
  /*  604 */  0,
  /*  605 */  0,
  /*  606 */  rRegI_rule,
  /*  607 */  rRegI_rule,
  /*  608 */  rRegI_rule,
  /*  609 */  rRegI_rule,
  /*  610 */  ncxRegI_rule,
  /*  611 */  ncxRegI_rule,
  /*  612 */  ncxRegI_rule,
  /*  613 */  ncxRegI_rule,
  /*  614 */  rRegI_rule,
  /*  615 */  rRegI_rule,
  /*  616 */  rRegI_rule,
  /*  617 */  rRegI_rule,
  /*  618 */  rRegI_rule,
  /*  619 */  Universe_rule,
  /*  620 */  Universe_rule,
  /*  621 */  Universe_rule,
  /*  622 */  0,
  /*  623 */  rRegI_rule,
  /*  624 */  0,
  /*  625 */  rRegI_rule,
  /*  626 */  eCXRegI_rule,
  /*  627 */  rRegI_rule,
  /*  628 */  rRegI_rule,
  /*  629 */  rRegI_rule,
  /*  630 */  rRegI_rule,
  /*  631 */  rRegI_rule,
  /*  632 */  rRegI_rule,
  /*  633 */  rRegI_rule,
  /*  634 */  eRegL_rule,
  /*  635 */  eRegL_rule,
  /*  636 */  eRegL_rule,
  /*  637 */  eRegL_rule,
  /*  638 */  eRegL_rule,
  /*  639 */  eRegL_rule,
  /*  640 */  eRegL_rule,
  /*  641 */  eRegL_rule,
  /*  642 */  eRegL_rule,
  /*  643 */  eRegL_rule,
  /*  644 */  eRegL_rule,
  /*  645 */  eRegL_rule,
  /*  646 */  eRegL_rule,
  /*  647 */  eRegL_rule,
  /*  648 */  eRegL_rule,
  /*  649 */  eRegL_rule,
  /*  650 */  eRegL_rule,
  /*  651 */  eRegL_rule,
  /*  652 */  eRegL_rule,
  /*  653 */  eRegL_rule,
  /*  654 */  eRegL_rule,
  /*  655 */  eRegL_rule,
  /*  656 */  eRegL_rule,
  /*  657 */  eRegL_rule,
  /*  658 */  eRegL_rule,
  /*  659 */  eRegL_rule,
  /*  660 */  eRegL_rule,
  /*  661 */  eRegL_rule,
  /*  662 */  eRegL_rule,
  /*  663 */  eRegL_rule,
  /*  664 */  eRegL_rule,
  /*  665 */  eRegL_rule,
  /*  666 */  eRegL_rule,
  /*  667 */  eRegL_rule,
  /*  668 */  eRegL_rule,
  /*  669 */  eRegL_rule,
  /*  670 */  eRegL_rule,
  /*  671 */  eRegL_rule,
  /*  672 */  eRegL_rule,
  /*  673 */  eRegL_rule,
  /*  674 */  eRegL_rule,
  /*  675 */  eRegL_rule,
  /*  676 */  eRegL_rule,
  /*  677 */  eRegL_rule,
  /*  678 */  eRegL_rule,
  /*  679 */  eRegL_rule,
  /*  680 */  eRegL_rule,
  /*  681 */  eRegL_rule,
  /*  682 */  eRegL_rule,
  /*  683 */  rRegI_rule,
  /*  684 */  rRegI_rule,
  /*  685 */  xRegI_rule,
  /*  686 */  xRegI_rule,
  /*  687 */  regDPR_rule,
  /*  688 */  stackSlotD_rule,
  /*  689 */  regDPR_rule,
  /*  690 */  regDPR_rule,
  /*  691 */  stackSlotD_rule,
  /*  692 */  regDPR_rule,
  /*  693 */  regDPR_rule,
  /*  694 */  Universe_rule,
  /*  695 */  Universe_rule,
  /*  696 */  regDPR_rule,
  /*  697 */  regDPR_rule,
  /*  698 */  stackSlotD_rule,
  /*  699 */  regDPR_rule,
  /*  700 */  regDPR1_rule,
  /*  701 */  regDPR_rule,
  /*  702 */  regDPR_rule,
  /*  703 */  regDPR_rule,
  /*  704 */  regDPR_rule,
  /*  705 */  regDPR_rule,
  /*  706 */  regDPR_rule,
  /*  707 */  regDPR_rule,
  /*  708 */  regDPR_rule,
  /*  709 */  regDPR_rule,
  /*  710 */  regDPR1_rule,
  /*  711 */  stackSlotD_rule,
  /*  712 */  regDPR_rule,
  /*  713 */  regD_rule,
  /*  714 */  regDPR1_rule,
  /*  715 */  regD_rule,
  /*  716 */  regDPR1_rule,
  /*  717 */  regD_rule,
  /*  718 */  regDPR1_rule,
  /*  719 */  regD_rule,
  /*  720 */  regDPR_rule,
  /*  721 */  regD_rule,
  /*  722 */  regDPR_rule,
  /*  723 */  regDPR1_rule,
  /*  724 */  regD_rule,
  /*  725 */  regDPR1_rule,
  /*  726 */  regD_rule,
  /*  727 */  regDPR1_rule,
  /*  728 */  regD_rule,
  /*  729 */  regDPR1_rule,
  /*  730 */  regD_rule,
  /*  731 */  rRegI_rule,
  /*  732 */  rRegI_rule,
  /*  733 */  xRegI_rule,
  /*  734 */  xRegI_rule,
  /*  735 */  stackSlotF_rule,
  /*  736 */  regFPR_rule,
  /*  737 */  stackSlotF_rule,
  /*  738 */  regFPR_rule,
  /*  739 */  stackSlotF_rule,
  /*  740 */  stackSlotF_rule,
  /*  741 */  regFPR_rule,
  /*  742 */  regFPR_rule,
  /*  743 */  stackSlotF_rule,
  /*  744 */  stackSlotF_rule,
  /*  745 */  stackSlotF_rule,
  /*  746 */  stackSlotF_rule,
  /*  747 */  stackSlotF_rule,
  /*  748 */  regFPR_rule,
  /*  749 */  stackSlotF_rule,
  /*  750 */  regFPR_rule,
  /*  751 */  stackSlotF_rule,
  /*  752 */  stackSlotF_rule,
  /*  753 */  regFPR_rule,
  /*  754 */  regFPR_rule,
  /*  755 */  stackSlotF_rule,
  /*  756 */  stackSlotF_rule,
  /*  757 */  regFPR_rule,
  /*  758 */  regFPR_rule,
  /*  759 */  regFPR_rule,
  /*  760 */  regFPR_rule,
  /*  761 */  regFPR_rule,
  /*  762 */  regFPR_rule,
  /*  763 */  regFPR_rule,
  /*  764 */  regFPR_rule,
  /*  765 */  regFPR_rule,
  /*  766 */  regFPR_rule,
  /*  767 */  stackSlotF_rule,
  /*  768 */  regFPR_rule,
  /*  769 */  stackSlotF_rule,
  /*  770 */  regFPR_rule,
  /*  771 */  regF_rule,
  /*  772 */  stackSlotF_rule,
  /*  773 */  stackSlotD_rule,
  /*  774 */  stackSlotF_rule,
  /*  775 */  regF_rule,
  /*  776 */  regF_rule,
  /*  777 */  regDPR_rule,
  /*  778 */  stackSlotD_rule,
  /*  779 */  regDPR_rule,
  /*  780 */  regD_rule,
  /*  781 */  eAXRegI_rule,
  /*  782 */  eAXRegI_rule,
  /*  783 */  eADXRegL_rule,
  /*  784 */  eADXRegL_rule,
  /*  785 */  eAXRegI_rule,
  /*  786 */  eAXRegI_rule,
  /*  787 */  eADXRegL_rule,
  /*  788 */  eADXRegL_rule,
  /*  789 */  regDPR_rule,
  /*  790 */  regD_rule,
  /*  791 */  regD_rule,
  /*  792 */  regD_rule,
  /*  793 */  regDPR_rule,
  /*  794 */  regFPR_rule,
  /*  795 */  stackSlotF_rule,
  /*  796 */  stackSlotF_rule,
  /*  797 */  regFPR_rule,
  /*  798 */  regFPR_rule,
  /*  799 */  regF_rule,
  /*  800 */  regF_rule,
  /*  801 */  eRegL_rule,
  /*  802 */  eRegL_rule,
  /*  803 */  eRegL_rule,
  /*  804 */  stackSlotD_rule,
  /*  805 */  regD_rule,
  /*  806 */  regF_rule,
  /*  807 */  stackSlotF_rule,
  /*  808 */  rRegI_rule,
  /*  809 */  stackSlotI_rule,
  /*  810 */  stackSlotI_rule,
  /*  811 */  stackSlotF_rule,
  /*  812 */  stackSlotL_rule,
  /*  813 */  stackSlotL_rule,
  /*  814 */  eRegL_rule,
  /*  815 */  stackSlotD_rule,
  /*  816 */  regD_rule,
  /*  817 */  Universe_rule,
  /*  818 */  Universe_rule,
  /*  819 */  eAXRegI_rule,
  /*  820 */  eAXRegI_rule,
  /*  821 */  eBXRegI_rule,
  /*  822 */  eBXRegI_rule,
  /*  823 */  eAXRegI_rule,
  /*  824 */  eAXRegI_rule,
  /*  825 */  rRegI_rule,
  /*  826 */  rRegI_rule,
  /*  827 */  eAXRegI_rule,
  /*  828 */  Universe_rule,
  /*  829 */  Universe_rule,
  /*  830 */  Universe_rule,
  /*  831 */  Universe_rule,
  /*  832 */  Universe_rule,
  /*  833 */  Universe_rule,
  /*  834 */  Universe_rule,
  /*  835 */  Universe_rule,
  /*  836 */  Universe_rule,
  /*  837 */  eDIRegP_rule,
  /*  838 */  Universe_rule,
  /*  839 */  Universe_rule,
  /*  840 */  Universe_rule,
  /*  841 */  Universe_rule,
  /*  842 */  Universe_rule,
  /*  843 */  Universe_rule,
  /*  844 */  Universe_rule,
  /*  845 */  Universe_rule,
  /*  846 */  eSIRegI_rule,
  /*  847 */  Universe_rule,
  /*  848 */  eRegL_rule,
  /*  849 */  eRegL_rule,
  /*  850 */  rRegI_rule,
  /*  851 */  rRegI_rule,
  /*  852 */  eRegP_rule,
  /*  853 */  regDPR_rule,
  /*  854 */  regD_rule,
  /*  855 */  regFPR_rule,
  /*  856 */  regF_rule,
  /*  857 */  Universe_rule,
  /*  858 */  eRegL_rule,
  /*  859 */  eRegL_rule,
  /*  860 */  rRegI_rule,
  /*  861 */  rRegI_rule,
  /*  862 */  eRegP_rule,
  /*  863 */  regDPR_rule,
  /*  864 */  regD_rule,
  /*  865 */  regFPR_rule,
  /*  866 */  regF_rule,
  /*  867 */  Universe_rule,
  /*  868 */  eRegL_rule,
  /*  869 */  eRegL_rule,
  /*  870 */  rRegI_rule,
  /*  871 */  rRegI_rule,
  /*  872 */  eRegP_rule,
  /*  873 */  regDPR_rule,
  /*  874 */  regD_rule,
  /*  875 */  regFPR_rule,
  /*  876 */  regF_rule,
  /*  877 */  Universe_rule,
  /*  878 */  Universe_rule,
  /*  879 */  Universe_rule,
  /*  880 */  Universe_rule,
  /*  881 */  Universe_rule,
  /*  882 */  Universe_rule,
  /*  883 */  Universe_rule,
  /*  884 */  Universe_rule,
  /*  885 */  Universe_rule,
  /*  886 */  eAXRegP_rule,
  /*  887 */  Universe_rule,
  /*  888 */  eRegP_rule,
  /*  889 */  Universe_rule,
  /*  890 */  regF_rule,
  /*  891 */  regF_rule,
  /*  892 */  regF_rule,
  /*  893 */  regF_rule,
  /*  894 */  regF_rule,
  /*  895 */  regF_rule,
  /*  896 */  regF_rule,
  /*  897 */  regF_rule,
  /*  898 */  regD_rule,
  /*  899 */  regD_rule,
  /*  900 */  regD_rule,
  /*  901 */  regD_rule,
  /*  902 */  regD_rule,
  /*  903 */  regD_rule,
  /*  904 */  regD_rule,
  /*  905 */  regD_rule,
  /*  906 */  regF_rule,
  /*  907 */  regF_rule,
  /*  908 */  regF_rule,
  /*  909 */  regF_rule,
  /*  910 */  regF_rule,
  /*  911 */  regF_rule,
  /*  912 */  regD_rule,
  /*  913 */  regD_rule,
  /*  914 */  regD_rule,
  /*  915 */  regD_rule,
  /*  916 */  regD_rule,
  /*  917 */  regD_rule,
  /*  918 */  regF_rule,
  /*  919 */  regF_rule,
  /*  920 */  regF_rule,
  /*  921 */  regF_rule,
  /*  922 */  regF_rule,
  /*  923 */  regF_rule,
  /*  924 */  regF_rule,
  /*  925 */  regF_rule,
  /*  926 */  regD_rule,
  /*  927 */  regD_rule,
  /*  928 */  regD_rule,
  /*  929 */  regD_rule,
  /*  930 */  regD_rule,
  /*  931 */  regD_rule,
  /*  932 */  regD_rule,
  /*  933 */  regD_rule,
  /*  934 */  regF_rule,
  /*  935 */  regF_rule,
  /*  936 */  regF_rule,
  /*  937 */  regF_rule,
  /*  938 */  regF_rule,
  /*  939 */  regF_rule,
  /*  940 */  regD_rule,
  /*  941 */  regD_rule,
  /*  942 */  regD_rule,
  /*  943 */  regD_rule,
  /*  944 */  regD_rule,
  /*  945 */  regD_rule,
  /*  946 */  regF_rule,
  /*  947 */  regF_rule,
  /*  948 */  regF_rule,
  /*  949 */  regD_rule,
  /*  950 */  regD_rule,
  /*  951 */  regD_rule,
  /*  952 */  vecS_rule,
  /*  953 */  vecD_rule,
  /*  954 */  vecX_rule,
  /*  955 */  vecY_rule,
  /*  956 */  Universe_rule,
  /*  957 */  Universe_rule,
  /*  958 */  Universe_rule,
  /*  959 */  Universe_rule,
  /*  960 */  vecS_rule,
  /*  961 */  vecD_rule,
  /*  962 */  vecX_rule,
  /*  963 */  vecY_rule,
  /*  964 */  vecS_rule,
  /*  965 */  vecD_rule,
  /*  966 */  vecX_rule,
  /*  967 */  vecY_rule,
  /*  968 */  vecS_rule,
  /*  969 */  vecD_rule,
  /*  970 */  vecX_rule,
  /*  971 */  vecY_rule,
  /*  972 */  vecS_rule,
  /*  973 */  vecD_rule,
  /*  974 */  vecX_rule,
  /*  975 */  vecY_rule,
  /*  976 */  vecS_rule,
  /*  977 */  vecD_rule,
  /*  978 */  vecX_rule,
  /*  979 */  vecY_rule,
  /*  980 */  vecS_rule,
  /*  981 */  vecD_rule,
  /*  982 */  vecX_rule,
  /*  983 */  vecY_rule,
  /*  984 */  vecD_rule,
  /*  985 */  vecX_rule,
  /*  986 */  vecY_rule,
  /*  987 */  vecD_rule,
  /*  988 */  vecX_rule,
  /*  989 */  vecY_rule,
  /*  990 */  vecD_rule,
  /*  991 */  vecX_rule,
  /*  992 */  vecY_rule,
  /*  993 */  vecD_rule,
  /*  994 */  vecX_rule,
  /*  995 */  vecY_rule,
  /*  996 */  vecX_rule,
  /*  997 */  vecY_rule,
  /*  998 */  vecX_rule,
  /*  999 */  vecY_rule,
  /* 1000 */  vecX_rule,
  /* 1001 */  vecY_rule,
  /* 1002 */  vecX_rule,
  /* 1003 */  vecY_rule,
  /* 1004 */  vecD_rule,
  /* 1005 */  vecX_rule,
  /* 1006 */  vecY_rule,
  /* 1007 */  vecD_rule,
  /* 1008 */  vecX_rule,
  /* 1009 */  vecY_rule,
  /* 1010 */  vecX_rule,
  /* 1011 */  vecY_rule,
  /* 1012 */  vecX_rule,
  /* 1013 */  vecY_rule,
  /* 1014 */  vecS_rule,
  /* 1015 */  vecS_rule,
  /* 1016 */  vecD_rule,
  /* 1017 */  vecD_rule,
  /* 1018 */  vecX_rule,
  /* 1019 */  vecX_rule,
  /* 1020 */  vecX_rule,
  /* 1021 */  vecY_rule,
  /* 1022 */  vecY_rule,
  /* 1023 */  vecS_rule,
  /* 1024 */  vecS_rule,
  /* 1025 */  vecD_rule,
  /* 1026 */  vecD_rule,
  /* 1027 */  vecX_rule,
  /* 1028 */  vecX_rule,
  /* 1029 */  vecX_rule,
  /* 1030 */  vecY_rule,
  /* 1031 */  vecY_rule,
  /* 1032 */  vecD_rule,
  /* 1033 */  vecD_rule,
  /* 1034 */  vecX_rule,
  /* 1035 */  vecX_rule,
  /* 1036 */  vecX_rule,
  /* 1037 */  vecY_rule,
  /* 1038 */  vecY_rule,
  /* 1039 */  vecX_rule,
  /* 1040 */  vecX_rule,
  /* 1041 */  vecX_rule,
  /* 1042 */  vecY_rule,
  /* 1043 */  vecY_rule,
  /* 1044 */  vecD_rule,
  /* 1045 */  vecD_rule,
  /* 1046 */  vecX_rule,
  /* 1047 */  vecX_rule,
  /* 1048 */  vecX_rule,
  /* 1049 */  vecY_rule,
  /* 1050 */  vecY_rule,
  /* 1051 */  vecX_rule,
  /* 1052 */  vecX_rule,
  /* 1053 */  vecX_rule,
  /* 1054 */  vecY_rule,
  /* 1055 */  vecY_rule,
  /* 1056 */  vecS_rule,
  /* 1057 */  vecS_rule,
  /* 1058 */  vecD_rule,
  /* 1059 */  vecD_rule,
  /* 1060 */  vecX_rule,
  /* 1061 */  vecX_rule,
  /* 1062 */  vecX_rule,
  /* 1063 */  vecY_rule,
  /* 1064 */  vecY_rule,
  /* 1065 */  vecS_rule,
  /* 1066 */  vecS_rule,
  /* 1067 */  vecD_rule,
  /* 1068 */  vecD_rule,
  /* 1069 */  vecX_rule,
  /* 1070 */  vecX_rule,
  /* 1071 */  vecX_rule,
  /* 1072 */  vecY_rule,
  /* 1073 */  vecY_rule,
  /* 1074 */  vecD_rule,
  /* 1075 */  vecD_rule,
  /* 1076 */  vecX_rule,
  /* 1077 */  vecX_rule,
  /* 1078 */  vecX_rule,
  /* 1079 */  vecY_rule,
  /* 1080 */  vecY_rule,
  /* 1081 */  vecX_rule,
  /* 1082 */  vecX_rule,
  /* 1083 */  vecX_rule,
  /* 1084 */  vecY_rule,
  /* 1085 */  vecY_rule,
  /* 1086 */  vecD_rule,
  /* 1087 */  vecD_rule,
  /* 1088 */  vecX_rule,
  /* 1089 */  vecX_rule,
  /* 1090 */  vecX_rule,
  /* 1091 */  vecY_rule,
  /* 1092 */  vecY_rule,
  /* 1093 */  vecX_rule,
  /* 1094 */  vecX_rule,
  /* 1095 */  vecX_rule,
  /* 1096 */  vecY_rule,
  /* 1097 */  vecY_rule,
  /* 1098 */  vecS_rule,
  /* 1099 */  vecS_rule,
  /* 1100 */  vecD_rule,
  /* 1101 */  vecD_rule,
  /* 1102 */  vecX_rule,
  /* 1103 */  vecX_rule,
  /* 1104 */  vecX_rule,
  /* 1105 */  vecY_rule,
  /* 1106 */  vecY_rule,
  /* 1107 */  vecD_rule,
  /* 1108 */  vecD_rule,
  /* 1109 */  vecX_rule,
  /* 1110 */  vecX_rule,
  /* 1111 */  vecX_rule,
  /* 1112 */  vecY_rule,
  /* 1113 */  vecY_rule,
  /* 1114 */  vecD_rule,
  /* 1115 */  vecD_rule,
  /* 1116 */  vecX_rule,
  /* 1117 */  vecX_rule,
  /* 1118 */  vecX_rule,
  /* 1119 */  vecY_rule,
  /* 1120 */  vecY_rule,
  /* 1121 */  vecX_rule,
  /* 1122 */  vecX_rule,
  /* 1123 */  vecX_rule,
  /* 1124 */  vecY_rule,
  /* 1125 */  vecY_rule,
  /* 1126 */  vecD_rule,
  /* 1127 */  vecD_rule,
  /* 1128 */  vecX_rule,
  /* 1129 */  vecX_rule,
  /* 1130 */  vecX_rule,
  /* 1131 */  vecY_rule,
  /* 1132 */  vecY_rule,
  /* 1133 */  vecX_rule,
  /* 1134 */  vecX_rule,
  /* 1135 */  vecX_rule,
  /* 1136 */  vecY_rule,
  /* 1137 */  vecY_rule,
  /* 1138 */  vecS_rule,
  /* 1139 */  vecS_rule,
  /* 1140 */  vecS_rule,
  /* 1141 */  vecS_rule,
  /* 1142 */  vecD_rule,
  /* 1143 */  vecD_rule,
  /* 1144 */  vecD_rule,
  /* 1145 */  vecD_rule,
  /* 1146 */  vecX_rule,
  /* 1147 */  vecX_rule,
  /* 1148 */  vecX_rule,
  /* 1149 */  vecX_rule,
  /* 1150 */  vecY_rule,
  /* 1151 */  vecY_rule,
  /* 1152 */  vecD_rule,
  /* 1153 */  vecD_rule,
  /* 1154 */  vecD_rule,
  /* 1155 */  vecD_rule,
  /* 1156 */  vecX_rule,
  /* 1157 */  vecX_rule,
  /* 1158 */  vecX_rule,
  /* 1159 */  vecX_rule,
  /* 1160 */  vecY_rule,
  /* 1161 */  vecY_rule,
  /* 1162 */  vecX_rule,
  /* 1163 */  vecX_rule,
  /* 1164 */  vecX_rule,
  /* 1165 */  vecX_rule,
  /* 1166 */  vecY_rule,
  /* 1167 */  vecY_rule,
  /* 1168 */  vecS_rule,
  /* 1169 */  vecS_rule,
  /* 1170 */  vecS_rule,
  /* 1171 */  vecS_rule,
  /* 1172 */  vecD_rule,
  /* 1173 */  vecD_rule,
  /* 1174 */  vecD_rule,
  /* 1175 */  vecD_rule,
  /* 1176 */  vecX_rule,
  /* 1177 */  vecX_rule,
  /* 1178 */  vecX_rule,
  /* 1179 */  vecX_rule,
  /* 1180 */  vecY_rule,
  /* 1181 */  vecY_rule,
  /* 1182 */  vecD_rule,
  /* 1183 */  vecD_rule,
  /* 1184 */  vecD_rule,
  /* 1185 */  vecD_rule,
  /* 1186 */  vecX_rule,
  /* 1187 */  vecX_rule,
  /* 1188 */  vecX_rule,
  /* 1189 */  vecX_rule,
  /* 1190 */  vecY_rule,
  /* 1191 */  vecY_rule,
  /* 1192 */  vecX_rule,
  /* 1193 */  vecX_rule,
  /* 1194 */  vecX_rule,
  /* 1195 */  vecX_rule,
  /* 1196 */  vecY_rule,
  /* 1197 */  vecY_rule,
  /* 1198 */  vecS_rule,
  /* 1199 */  vecS_rule,
  /* 1200 */  vecS_rule,
  /* 1201 */  vecS_rule,
  /* 1202 */  vecD_rule,
  /* 1203 */  vecD_rule,
  /* 1204 */  vecD_rule,
  /* 1205 */  vecD_rule,
  /* 1206 */  vecX_rule,
  /* 1207 */  vecX_rule,
  /* 1208 */  vecX_rule,
  /* 1209 */  vecX_rule,
  /* 1210 */  vecY_rule,
  /* 1211 */  vecY_rule,
  /* 1212 */  vecD_rule,
  /* 1213 */  vecD_rule,
  /* 1214 */  vecD_rule,
  /* 1215 */  vecD_rule,
  /* 1216 */  vecX_rule,
  /* 1217 */  vecX_rule,
  /* 1218 */  vecX_rule,
  /* 1219 */  vecX_rule,
  /* 1220 */  vecY_rule,
  /* 1221 */  vecY_rule,
  /* 1222 */  vecS_rule,
  /* 1223 */  vecS_rule,
  /* 1224 */  vecD_rule,
  /* 1225 */  vecD_rule,
  /* 1226 */  vecX_rule,
  /* 1227 */  vecX_rule,
  /* 1228 */  vecX_rule,
  /* 1229 */  vecY_rule,
  /* 1230 */  vecY_rule,
  /* 1231 */  vecS_rule,
  /* 1232 */  vecS_rule,
  /* 1233 */  vecD_rule,
  /* 1234 */  vecD_rule,
  /* 1235 */  vecX_rule,
  /* 1236 */  vecX_rule,
  /* 1237 */  vecX_rule,
  /* 1238 */  vecY_rule,
  /* 1239 */  vecY_rule,
  /* 1240 */  vecS_rule,
  /* 1241 */  vecS_rule,
  /* 1242 */  vecD_rule,
  /* 1243 */  vecD_rule,
  /* 1244 */  vecX_rule,
  /* 1245 */  vecX_rule,
  /* 1246 */  vecX_rule,
  /* 1247 */  vecY_rule,
  /* 1248 */  vecY_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  eRegP_rule,
  /*   88 */  eRegP_rule,
  /*   89 */  immP_rule,
  /*   90 */  _AddP_eRegP_rRegI_rule,
  /*   91 */  eRegP_rule,
  /*   92 */  eRegP_rule,
  /*   93 */  _AddP_eRegP__LShiftI_rRegI_immI2_rule,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  load_long_RegP_rule,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  eRegP_no_EBP_rule,
  /*  104 */  eRegP_no_EBP_rule,
  /*  105 */  _AddP_eRegP_no_EBP_rRegI_rule,
  /*  106 */  eRegP_no_EBP_rule,
  /*  107 */  _AddP_eRegP_no_EBP__LShiftI_rRegI_immI2_rule,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  // last operand
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  // last operand class
  /*  121 */  eRegP_rule,
  /*  122 */  rRegI_rule,
  /*  123 */  eRegP_rule,
  /*  124 */  eRegP_no_EBP_rule,
  /*  125 */  eRegP_no_EBP_rule,
  /*  126 */  memory_rule,
  /*  127 */  memory_rule,
  /*  128 */  memory_rule,
  /*  129 */  memory_rule,
  /*  130 */  _LoadUB_memory__rule,
  /*  131 */  memory_rule,
  /*  132 */  _LoadS_memory__rule,
  /*  133 */  memory_rule,
  /*  134 */  _LoadUS_memory__rule,
  /*  135 */  _LoadUS_memory__rule,
  /*  136 */  _LoadUS_memory__rule,
  /*  137 */  _LoadI_memory__rule,
  /*  138 */  _LoadI_memory__rule,
  /*  139 */  _LoadI_memory__rule,
  /*  140 */  _LoadI_memory__rule,
  /*  141 */  _LoadI_memory__rule,
  /*  142 */  _LoadI_memory__rule,
  /*  143 */  eRegL_rule,
  /*  144 */  regDPR1_rule,
  /*  145 */  regFPR1_rule,
  /*  146 */  regDPR1_rule,
  /*  147 */  cmpOp_rule,
  /*  148 */  rRegI_rule,
  /*  149 */  cmpOpU_rule,
  /*  150 */  cmpOpUCF_rule,
  /*  151 */  rRegI_rule,
  /*  152 */  eRegP_rule,
  /*  153 */  cmpOp_fcmov_rule,
  /*  154 */  regDPR1_rule,
  /*  155 */  regFPR1_rule,
  /*  156 */  regDPR_rule,
  /*  157 */  regFPR_rule,
  /*  158 */  regF_rule,
  /*  159 */  regD_rule,
  /*  160 */  eRegL_rule,
  /*  161 */  _LoadI_memory__rule,
  /*  162 */  rRegI_rule,
  /*  163 */  _LoadI_memory__rule,
  /*  164 */  _LoadI_memory__rule,
  /*  165 */  _LoadI_memory__rule,
  /*  166 */  eAXRegP_rule,
  /*  167 */  eAXRegI_rule,
  /*  168 */  eADXRegL_rule,
  /*  169 */  eAXRegP_rule,
  /*  170 */  eAXRegI_rule,
  /*  171 */  _LoadI_memory__rule,
  /*  172 */  immI0_rule,
  /*  173 */  nadxRegI_rule,
  /*  174 */  _ConvI2L_nadxRegI__rule,
  /*  175 */  _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule,
  /*  176 */  eADXRegL_low_only_rule,
  /*  177 */  _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule,
  /*  178 */  _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule,
  /*  179 */  _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule,
  /*  180 */  eAXRegI_rule,
  /*  181 */  _ConvI2L_eAXRegI__rule,
  /*  182 */  _ConvI2L_nadxRegI__rule,
  /*  183 */  _LoadI_memory__rule,
  /*  184 */  _LoadI_memory__rule,
  /*  185 */  xRegI_rule,
  /*  186 */  xRegI_rule,
  /*  187 */  _LoadI_memory__rule,
  /*  188 */  rRegI_rule,
  /*  189 */  _LoadI_memory__rule,
  /*  190 */  rRegI_rule,
  /*  191 */  immI0_rule,
  /*  192 */  rRegI_rule,
  /*  193 */  eRegP_rule,
  /*  194 */  _LoadI_memory__rule,
  /*  195 */  rRegI_rule,
  /*  196 */  _LoadI_memory__rule,
  /*  197 */  rRegI_rule,
  /*  198 */  rRegI_rule,
  /*  199 */  rRegI_rule,
  /*  200 */  rRegI_rule,
  /*  201 */  ncxRegI_rule,
  /*  202 */  immI0_rule,
  /*  203 */  ncxRegI_rule,
  /*  204 */  immI_32_rule,
  /*  205 */  ncxRegI_rule,
  /*  206 */  rRegI_rule,
  /*  207 */  rRegI_rule,
  /*  208 */  ncxRegI_rule,
  /*  209 */  ncxRegI_rule,
  /*  210 */  ncxRegI_rule,
  /*  211 */  _LoadI_memory__rule,
  /*  212 */  rRegI_rule,
  /*  213 */  _LoadI_memory__rule,
  /*  214 */  rRegI_rule,
  /*  215 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  216 */  rRegI_rule,
  /*  217 */  rRegI_rule,
  /*  218 */  load_long_memory_rule,
  /*  219 */  eRegL_rule,
  /*  220 */  immL0_rule,
  /*  221 */  immL0_rule,
  /*  222 */  eRegL_rule,
  /*  223 */  _LoadL_memory__rule,
  /*  224 */  memory_rule,
  /*  225 */  regDPR_rule,
  /*  226 */  regDPR_rule,
  /*  227 */  _LoadD_memory__rule,
  /*  228 */  _AddD__LoadD_memory__regDPR_rule,
  /*  229 */  regDPR_rule,
  /*  230 */  _AddD_regDPR__LoadD_memory__rule,
  /*  231 */  regDPR_rule,
  /*  232 */  regDPR_rule,
  /*  233 */  regDPR_rule,
  /*  234 */  memory_rule,
  /*  235 */  _LoadF_memory__rule,
  /*  236 */  regFPR_rule,
  /*  237 */  regFPR_rule,
  /*  238 */  regFPR_rule,
  /*  239 */  rRegI_rule,
  /*  240 */  eDIRegP_rule,
  /*  241 */  eSIRegP_rule,
  /*  242 */  eDIRegP_rule,
  /*  243 */  eDIRegP_rule,
  /*  244 */  eSIRegP_rule,
  /*  245 */  eSIRegP_rule,
  /*  246 */  rRegI_rule,
  /*  247 */  rRegI_rule,
  /*  248 */  memory_rule,
  /*  249 */  nadxRegI_rule,
  /*  250 */  eSIRegP_rule,
  /*  251 */  cmpOp_rule,
  /*  252 */  eRegL_rule,
  /*  253 */  cmpOp_rule,
  /*  254 */  cmpOp_commute_rule,
  /*  255 */  regF_rule,
  /*  256 */  _ConvF2D_regF__rule,
  /*  257 */  _LoadF_memory__rule,
  /*  258 */  _ConvF2D__LoadF_memory___rule,
  /*  259 */  immF_rule,
  /*  260 */  _ConvF2D_immF__rule,
  /*  261 */  memory_rule,
  // last internally defined operand
  /*  262 */  rRegI_rule,
  /*  263 */  eRegP_rule,
  /*  264 */  eRegL_rule,
  /*  265 */  indOffset8_rule,
  /*  266 */  indOffset32_rule,
  /*  267 */  indIndexOffset_rule,
  /*  268 */  indIndexScale_rule,
  /*  269 */  indIndexScaleOffset_rule,
  /*  270 */  immI_rule,
  /*  271 */  immI0_rule,
  /*  272 */  immP_rule,
  /*  273 */  immL_rule,
  /*  274 */  immL0_rule,
  /*  275 */  immFPR_rule,
  /*  276 */  immFPR0_rule,
  /*  277 */  immFPR1_rule,
  /*  278 */  immF_rule,
  /*  279 */  immF0_rule,
  /*  280 */  immDPR_rule,
  /*  281 */  immDPR0_rule,
  /*  282 */  immDPR1_rule,
  /*  283 */  immD_rule,
  /*  284 */  immD0_rule,
  /*  285 */  stackSlotI_rule,
  /*  286 */  stackSlotL_rule,
  /*  287 */  stackSlotP_rule,
  /*  288 */  stackSlotF_rule,
  /*  289 */  stackSlotD_rule,
  /*  290 */  immL32_rule,
  /*  291 */  0,
  /*  292 */  eAXRegI_rule,
  /*  293 */  eRegP_rule,
  /*  294 */  eRegP_rule,
  /*  295 */  eRegP_rule,
  /*  296 */  rRegI_rule,
  /*  297 */  memory_rule,
  /*  298 */  memory_rule,
  /*  299 */  memory_rule,
  /*  300 */  0,
  /*  301 */  0,
  /*  302 */  eAXRegI_rule,
  /*  303 */  eAXRegI_rule,
  /*  304 */  rRegI_rule,
  /*  305 */  rRegI_rule,
  /*  306 */  immI0_rule,
  /*  307 */  eAXRegI_rule,
  /*  308 */  rRegI_rule,
  /*  309 */  regDPR_rule,
  /*  310 */  regDPR_rule,
  /*  311 */  regDPR_rule,
  /*  312 */  regD_rule,
  /*  313 */  regD_rule,
  /*  314 */  regD_rule,
  /*  315 */  regD_rule,
  /*  316 */  regDPR1_rule,
  /*  317 */  regDPR1_rule,
  /*  318 */  regFPR_rule,
  /*  319 */  regFPR_rule,
  /*  320 */  regFPR_rule,
  /*  321 */  regF_rule,
  /*  322 */  regF_rule,
  /*  323 */  regF_rule,
  /*  324 */  regF_rule,
  /*  325 */  regFPR1_rule,
  /*  326 */  regFPR1_rule,
  /*  327 */  stackSlotF_rule,
  /*  328 */  regF_rule,
  /*  329 */  stackSlotI_rule,
  /*  330 */  stackSlotI_rule,
  /*  331 */  rRegI_rule,
  /*  332 */  stackSlotD_rule,
  /*  333 */  stackSlotL_rule,
  /*  334 */  stackSlotL_rule,
  /*  335 */  stackSlotL_rule,
  /*  336 */  rRegI_rule,
  /*  337 */  rRegI_rule,
  /*  338 */  rRegI_rule,
  /*  339 */  rRegI_rule,
  /*  340 */  _AndI_rRegI_immI_rule,
  /*  341 */  _AndI_rRegI_memory_rule,
  /*  342 */  rRegI_rule,
  /*  343 */  rRegI_rule,
  /*  344 */  rRegI_rule,
  /*  345 */  rRegI_rule,
  /*  346 */  eRegP_rule,
  /*  347 */  eRegP_rule,
  /*  348 */  eRegP_rule,
  /*  349 */  eRegP_rule,
  /*  350 */  eRegP_rule,
  /*  351 */  _LoadP_memory__rule,
  /*  352 */  _PartialSubtypeCheck_eSIRegP_eAXRegP_rule,
  /*  353 */  eRegL_rule,
  /*  354 */  eRegL_rule,
  /*  355 */  eRegL_rule,
  /*  356 */  eRegL_rule,
  /*  357 */  eRegL_rule,
  /*  358 */  eRegL_rule,
  /*  359 */  eRegP_rule,
  /*  360 */  eRegP_rule,
  /*  361 */  eRegP_rule,
  /*  362 */  0,
  /*  363 */  regF_rule,
  /*  364 */  regF_rule,
  /*  365 */  regD_rule,
  /*  366 */  regD_rule,
  /*  367 */  regF_rule,
  /*  368 */  regF_rule,
  /*  369 */  regD_rule,
  /*  370 */  regD_rule,
  /*  371 */  rRegI_rule,
  /*  372 */  rRegI_rule,
  /*  373 */  rRegI_rule,
  /*  374 */  eRegL_rule,
  /*  375 */  rRegI_rule,
  /*  376 */  rRegI_rule,
  /*  377 */  rRegI_rule,
  /*  378 */  rRegI_rule,
  /*  379 */  eRegL_rule,
  /*  380 */  eRegL_rule,
  /*  381 */  rRegI_rule,
  /*  382 */  rRegI_rule,
  /*  383 */  eRegL_rule,
  /*  384 */  eRegL_rule,
  /*  385 */  rRegI_rule,
  /*  386 */  _LoadI_memory__rule,
  /*  387 */  eRegL_rule,
  /*  388 */  _LoadL_memory__rule,
  /*  389 */  memory_rule,
  /*  390 */  _LoadB_memory__rule,
  /*  391 */  memory_rule,
  /*  392 */  _LoadUB_memory__rule,
  /*  393 */  _AndI__LoadUB_memory__immI8_rule,
  /*  394 */  memory_rule,
  /*  395 */  _LShiftI__LoadS_memory__immI_24_rule,
  /*  396 */  _LoadS_memory__rule,
  /*  397 */  memory_rule,
  /*  398 */  _LShiftI__LoadUS_memory__immI_24_rule,
  /*  399 */  _LoadUS_memory__rule,
  /*  400 */  _AndI__LoadUS_memory__immI_255_rule,
  /*  401 */  _AndI__LoadUS_memory__immI16_rule,
  /*  402 */  memory_rule,
  /*  403 */  _LShiftI__LoadI_memory__immI_24_rule,
  /*  404 */  _LoadI_memory__rule,
  /*  405 */  _LShiftI__LoadI_memory__immI_16_rule,
  /*  406 */  _LoadI_memory__rule,
  /*  407 */  _LoadI_memory__rule,
  /*  408 */  _AndI__LoadI_memory__immI_255_rule,
  /*  409 */  _AndI__LoadI_memory__immI_65535_rule,
  /*  410 */  _AndI__LoadI_memory__immU31_rule,
  /*  411 */  _ConvI2L__LoadI_memory___rule,
  /*  412 */  load_long_memory_rule,
  /*  413 */  memory_rule,
  /*  414 */  memory_rule,
  /*  415 */  memory_rule,
  /*  416 */  memory_rule,
  /*  417 */  memory_rule,
  /*  418 */  memory_rule,
  /*  419 */  memory_rule,
  /*  420 */  memory_rule,
  /*  421 */  memory_rule,
  /*  422 */  memory_rule,
  /*  423 */  memory_rule,
  /*  424 */  memory_rule,
  /*  425 */  memory_rule,
  /*  426 */  memory_rule,
  /*  427 */  memory_rule,
  /*  428 */  memory_rule,
  /*  429 */  memory_rule,
  /*  430 */  memory_rule,
  /*  431 */  memory_rule,
  /*  432 */  memory_rule,
  /*  433 */  memory_rule,
  /*  434 */  memory_rule,
  /*  435 */  memory_rule,
  /*  436 */  memory_rule,
  /*  437 */  memory_rule,
  /*  438 */  memory_rule,
  /*  439 */  memory_rule,
  /*  440 */  long_memory_rule,
  /*  441 */  memory_rule,
  /*  442 */  memory_rule,
  /*  443 */  memory_rule,
  /*  444 */  memory_rule,
  /*  445 */  memory_rule,
  /*  446 */  memory_rule,
  /*  447 */  memory_rule,
  /*  448 */  memory_rule,
  /*  449 */  memory_rule,
  /*  450 */  memory_rule,
  /*  451 */  memory_rule,
  /*  452 */  memory_rule,
  /*  453 */  memory_rule,
  /*  454 */  memory_rule,
  /*  455 */  memory_rule,
  /*  456 */  memory_rule,
  /*  457 */  memory_rule,
  /*  458 */  memory_rule,
  /*  459 */  memory_rule,
  /*  460 */  0,
  /*  461 */  0,
  /*  462 */  0,
  /*  463 */  0,
  /*  464 */  0,
  /*  465 */  0,
  /*  466 */  0,
  /*  467 */  0,
  /*  468 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  469 */  _Binary_cmpOpU_eFlagsRegU_rule,
  /*  470 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  471 */  _Binary_cmpOpU_eFlagsRegU_rule,
  /*  472 */  _Binary_cmpOpUCF_eFlagsRegUCF_rule,
  /*  473 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  474 */  _Binary_cmpOpU_eFlagsRegU_rule,
  /*  475 */  _Binary_cmpOpUCF_eFlagsRegUCF_rule,
  /*  476 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  477 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  478 */  _Binary_cmpOpU_eFlagsRegU_rule,
  /*  479 */  _Binary_cmpOpUCF_eFlagsRegUCF_rule,
  /*  480 */  _Binary_cmpOp_fcmov_eFlagsRegU_rule,
  /*  481 */  _Binary_cmpOp_fcmov_eFlagsRegU_rule,
  /*  482 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  483 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  484 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  485 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  486 */  _Binary_cmpOpU_eFlagsRegU_rule,
  /*  487 */  _Binary_cmpOpUCF_eFlagsRegUCF_rule,
  /*  488 */  _Binary_cmpOpU_eFlagsRegU_rule,
  /*  489 */  _Binary_cmpOpUCF_eFlagsRegUCF_rule,
  /*  490 */  _Binary_cmpOp_eFlagsReg_rule,
  /*  491 */  _Binary_cmpOpU_eFlagsRegU_rule,
  /*  492 */  _Binary_cmpOpUCF_eFlagsRegUCF_rule,
  /*  493 */  rRegI_rule,
  /*  494 */  rRegI_rule,
  /*  495 */  rRegI_rule,
  /*  496 */  rRegI_rule,
  /*  497 */  eRegP_rule,
  /*  498 */  rRegI_rule,
  /*  499 */  eRegP_rule,
  /*  500 */  eRegP_rule,
  /*  501 */  rRegI_rule,
  /*  502 */  _LoadI_memory__rule,
  /*  503 */  memory_rule,
  /*  504 */  memory_rule,
  /*  505 */  memory_rule,
  /*  506 */  memory_rule,
  /*  507 */  memory_rule,
  /*  508 */  memory_rule,
  /*  509 */  eSIRegP_rule,
  /*  510 */  pRegP_rule,
  /*  511 */  pRegP_rule,
  /*  512 */  memory_rule,
  /*  513 */  memory_rule,
  /*  514 */  memory_rule,
  /*  515 */  memory_rule,
  /*  516 */  rRegI_rule,
  /*  517 */  rRegI_rule,
  /*  518 */  rRegI_rule,
  /*  519 */  memory_rule,
  /*  520 */  eRegP_rule,
  /*  521 */  immI0_rule,
  /*  522 */  rRegI_rule,
  /*  523 */  rRegI_rule,
  /*  524 */  _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_rule,
  /*  525 */  _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_rule,
  /*  526 */  _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63_rule,
  /*  527 */  _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63_rule,
  /*  528 */  _LoadI_memory__rule,
  /*  529 */  rRegI_rule,
  /*  530 */  _LoadI_memory__rule,
  /*  531 */  _ConvI2L_eAXRegI__rule,
  /*  532 */  _ConvI2L_nadxRegI__rule,
  /*  533 */  _AndL__ConvI2L_eAXRegI__immL_32bits_rule,
  /*  534 */  _AndL__ConvI2L_nadxRegI__immL_32bits_rule,
  /*  535 */  eADXRegL_rule,
  /*  536 */  eADXRegL_rule,
  /*  537 */  eADXRegL_rule,
  /*  538 */  eADXRegL_rule,
  /*  539 */  eADXRegL_rule,
  /*  540 */  eAXRegI_rule,
  /*  541 */  eRegL_rule,
  /*  542 */  eAXRegI_rule,
  /*  543 */  eAXRegI_rule,
  /*  544 */  eRegL_rule,
  /*  545 */  eADXRegL_rule,
  /*  546 */  eADXRegL_rule,
  /*  547 */  rRegI_rule,
  /*  548 */  rRegI_rule,
  /*  549 */  rRegI_rule,
  /*  550 */  rRegI_rule,
  /*  551 */  memory_rule,
  /*  552 */  rRegI_rule,
  /*  553 */  memory_rule,
  /*  554 */  rRegI_rule,
  /*  555 */  rRegI_rule,
  /*  556 */  rRegI_rule,
  /*  557 */  _LShiftI_xRegI_immI_24_rule,
  /*  558 */  _LShiftI_xRegI_immI_16_rule,
  /*  559 */  rRegI_rule,
  /*  560 */  rRegI_rule,
  /*  561 */  rRegI_rule,
  /*  562 */  rRegI_rule,
  /*  563 */  _LoadI_memory__rule,
  /*  564 */  memory_rule,
  /*  565 */  memory_rule,
  /*  566 */  memory_rule,
  /*  567 */  _XorI_rRegI_immI_M1_rule,
  /*  568 */  rRegI_rule,
  /*  569 */  _XorI_rRegI_immI_M1_rule,
  /*  570 */  _LoadI_memory__rule,
  /*  571 */  _SubI_immI0_rRegI_rule,
  /*  572 */  rRegI_rule,
  /*  573 */  _SubI_immI0__LoadI_memory__rule,
  /*  574 */  _LoadI_memory__rule,
  /*  575 */  _AddI_rRegI_immI_M1_rule,
  /*  576 */  rRegI_rule,
  /*  577 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  578 */  _LoadI_memory__rule,
  /*  579 */  _AddI_rRegI_immI_M1_rule,
  /*  580 */  rRegI_rule,
  /*  581 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  582 */  _LoadI_memory__rule,
  /*  583 */  rRegI_rule,
  /*  584 */  rRegI_rule,
  /*  585 */  _CastP2X_eRegP__rule,
  /*  586 */  rRegI_rule,
  /*  587 */  rRegI_rule,
  /*  588 */  _LoadI_memory__rule,
  /*  589 */  memory_rule,
  /*  590 */  memory_rule,
  /*  591 */  memory_rule,
  /*  592 */  0,
  /*  593 */  0,
  /*  594 */  0,
  /*  595 */  _LShiftI_rRegI_immI1_rule,
  /*  596 */  _URShiftI_rRegI_immI_M1_rule,
  /*  597 */  _LShiftI_rRegI_immI8_rule,
  /*  598 */  _URShiftI_rRegI_immI8_rule,
  /*  599 */  _LShiftI_ncxRegI_eCXRegI_rule,
  /*  600 */  _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule,
  /*  601 */  _LShiftI_ncxRegI_eCXRegI_rule,
  /*  602 */  _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule,
  /*  603 */  0,
  /*  604 */  0,
  /*  605 */  0,
  /*  606 */  _URShiftI_rRegI_immI1_rule,
  /*  607 */  _LShiftI_rRegI_immI_M1_rule,
  /*  608 */  _URShiftI_rRegI_immI8_rule,
  /*  609 */  _LShiftI_rRegI_immI8_rule,
  /*  610 */  _URShiftI_ncxRegI_eCXRegI_rule,
  /*  611 */  _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule,
  /*  612 */  _URShiftI_ncxRegI_eCXRegI_rule,
  /*  613 */  _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule,
  /*  614 */  rRegI_rule,
  /*  615 */  rRegI_rule,
  /*  616 */  rRegI_rule,
  /*  617 */  rRegI_rule,
  /*  618 */  _LoadI_memory__rule,
  /*  619 */  memory_rule,
  /*  620 */  memory_rule,
  /*  621 */  memory_rule,
  /*  622 */  0,
  /*  623 */  rRegI_rule,
  /*  624 */  0,
  /*  625 */  eRegP_rule,
  /*  626 */  ncxRegI_rule,
  /*  627 */  rRegI_rule,
  /*  628 */  _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule,
  /*  629 */  _SubI_rRegI_rRegI_rule,
  /*  630 */  _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule,
  /*  631 */  _SubI_rRegI_rRegI_rule,
  /*  632 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  633 */  rRegI_rule,
  /*  634 */  eRegL_rule,
  /*  635 */  eRegL_rule,
  /*  636 */  eRegL_rule,
  /*  637 */  _LoadL_load_long_memory__rule,
  /*  638 */  eRegL_rule,
  /*  639 */  eRegL_rule,
  /*  640 */  eRegL_rule,
  /*  641 */  immL0_rule,
  /*  642 */  eRegL_rule,
  /*  643 */  eRegL_rule,
  /*  644 */  eRegL_rule,
  /*  645 */  _LoadL_load_long_memory__rule,
  /*  646 */  _XorL_eRegL_immL_M1_rule,
  /*  647 */  eRegL_rule,
  /*  648 */  _XorL_eRegL_immL_M1_rule,
  /*  649 */  _LoadL_memory__rule,
  /*  650 */  _SubL_immL0_eRegL_rule,
  /*  651 */  eRegL_rule,
  /*  652 */  _SubL_immL0__LoadL_memory__rule,
  /*  653 */  _LoadL_memory__rule,
  /*  654 */  _AddL_eRegL_immL_M1_rule,
  /*  655 */  eRegL_rule,
  /*  656 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  657 */  _LoadL_memory__rule,
  /*  658 */  _AddL_eRegL_immL_M1_rule,
  /*  659 */  eRegL_rule,
  /*  660 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  661 */  _LoadL_memory__rule,
  /*  662 */  eRegL_rule,
  /*  663 */  eRegL_rule,
  /*  664 */  eRegL_rule,
  /*  665 */  _LoadL_load_long_memory__rule,
  /*  666 */  eRegL_rule,
  /*  667 */  eRegL_rule,
  /*  668 */  eRegL_rule,
  /*  669 */  eRegL_rule,
  /*  670 */  _LoadL_load_long_memory__rule,
  /*  671 */  eRegL_rule,
  /*  672 */  eRegL_rule,
  /*  673 */  eRegL_rule,
  /*  674 */  eRegL_rule,
  /*  675 */  eRegL_rule,
  /*  676 */  eRegL_rule,
  /*  677 */  eRegL_rule,
  /*  678 */  eRegL_rule,
  /*  679 */  eRegL_rule,
  /*  680 */  eRegL_rule,
  /*  681 */  eRegL_rule,
  /*  682 */  eRegL_rule,
  /*  683 */  regDPR_rule,
  /*  684 */  regDPR_rule,
  /*  685 */  regD_rule,
  /*  686 */  regD_rule,
  /*  687 */  regDPR_rule,
  /*  688 */  _SubD_regDPR_regDPR_rule,
  /*  689 */  regDPR_rule,
  /*  690 */  regDPR_rule,
  /*  691 */  _AddD_regDPR_regDPR_rule,
  /*  692 */  regDPR_rule,
  /*  693 */  _LoadD_memory__rule,
  /*  694 */  memory_rule,
  /*  695 */  memory_rule,
  /*  696 */  regDPR_rule,
  /*  697 */  regDPR_rule,
  /*  698 */  _AddD_regDPR_immDPR_rule,
  /*  699 */  regDPR_rule,
  /*  700 */  regDPR1_rule,
  /*  701 */  regDPR_rule,
  /*  702 */  regDPR_rule,
  /*  703 */  _LoadD_memory__rule,
  /*  704 */  regDPR_rule,
  /*  705 */  _LoadD_memory__rule,
  /*  706 */  _MulD_regDPR_regDPR_rule,
  /*  707 */  regDPR_rule,
  /*  708 */  _MulD_regDPR_regDPR_rule,
  /*  709 */  regDPR_rule,
  /*  710 */  regDPR1_rule,
  /*  711 */  _DivD_regDPR_regDPR_rule,
  /*  712 */  regDPR_rule,
  /*  713 */  regD_rule,
  /*  714 */  regDPR1_rule,
  /*  715 */  regD_rule,
  /*  716 */  regDPR1_rule,
  /*  717 */  regD_rule,
  /*  718 */  regDPR1_rule,
  /*  719 */  regD_rule,
  /*  720 */  regDPR_rule,
  /*  721 */  regD_rule,
  /*  722 */  regDPR_rule,
  /*  723 */  regDPR_rule,
  /*  724 */  regD_rule,
  /*  725 */  regDPR1_rule,
  /*  726 */  regD_rule,
  /*  727 */  regDPR1_rule,
  /*  728 */  regD_rule,
  /*  729 */  regDPR1_rule,
  /*  730 */  regD_rule,
  /*  731 */  regFPR_rule,
  /*  732 */  regFPR_rule,
  /*  733 */  regF_rule,
  /*  734 */  regF_rule,
  /*  735 */  regFPR_rule,
  /*  736 */  regFPR_rule,
  /*  737 */  regFPR_rule,
  /*  738 */  regFPR_rule,
  /*  739 */  regFPR_rule,
  /*  740 */  _LoadF_memory__rule,
  /*  741 */  regFPR_rule,
  /*  742 */  _LoadF_memory__rule,
  /*  743 */  memory_rule,
  /*  744 */  memory_rule,
  /*  745 */  _LoadF_memory__rule,
  /*  746 */  memory_rule,
  /*  747 */  regFPR_rule,
  /*  748 */  regFPR_rule,
  /*  749 */  regFPR_rule,
  /*  750 */  regFPR_rule,
  /*  751 */  regFPR_rule,
  /*  752 */  _LoadF_memory__rule,
  /*  753 */  regFPR_rule,
  /*  754 */  _LoadF_memory__rule,
  /*  755 */  memory_rule,
  /*  756 */  regFPR_rule,
  /*  757 */  regFPR_rule,
  /*  758 */  _LoadF_memory__rule,
  /*  759 */  regFPR_rule,
  /*  760 */  _MulF__LoadF_memory__regFPR_rule,
  /*  761 */  regFPR_rule,
  /*  762 */  _MulF_regFPR__LoadF_memory__rule,
  /*  763 */  regFPR_rule,
  /*  764 */  _MulF_regFPR_regFPR_rule,
  /*  765 */  regFPR_rule,
  /*  766 */  _SubF_regFPR_regFPR_rule,
  /*  767 */  regFPR_rule,
  /*  768 */  regFPR_rule,
  /*  769 */  regFPR_rule,
  /*  770 */  regFPR_rule,
  /*  771 */  regF_rule,
  /*  772 */  regFPR_rule,
  /*  773 */  regDPR_rule,
  /*  774 */  regDPR_rule,
  /*  775 */  regDPR_rule,
  /*  776 */  regD_rule,
  /*  777 */  regFPR_rule,
  /*  778 */  regFPR_rule,
  /*  779 */  regF_rule,
  /*  780 */  regF_rule,
  /*  781 */  regDPR_rule,
  /*  782 */  regD_rule,
  /*  783 */  regDPR_rule,
  /*  784 */  regD_rule,
  /*  785 */  regFPR_rule,
  /*  786 */  regF_rule,
  /*  787 */  regFPR_rule,
  /*  788 */  regF_rule,
  /*  789 */  stackSlotI_rule,
  /*  790 */  rRegI_rule,
  /*  791 */  _LoadI_memory__rule,
  /*  792 */  rRegI_rule,
  /*  793 */  _LoadI_memory__rule,
  /*  794 */  stackSlotI_rule,
  /*  795 */  stackSlotI_rule,
  /*  796 */  _LoadI_memory__rule,
  /*  797 */  stackSlotI_rule,
  /*  798 */  _LoadI_memory__rule,
  /*  799 */  rRegI_rule,
  /*  800 */  rRegI_rule,
  /*  801 */  rRegI_rule,
  /*  802 */  _ConvI2L_rRegI__rule,
  /*  803 */  eRegL_rule,
  /*  804 */  eRegL_rule,
  /*  805 */  eRegL_rule,
  /*  806 */  eRegL_rule,
  /*  807 */  eRegL_rule,
  /*  808 */  eRegL_rule,
  /*  809 */  regFPR_rule,
  /*  810 */  regF_rule,
  /*  811 */  rRegI_rule,
  /*  812 */  regDPR_rule,
  /*  813 */  regD_rule,
  /*  814 */  regD_rule,
  /*  815 */  eRegL_rule,
  /*  816 */  eRegL_rule,
  /*  817 */  eCXRegI_rule,
  /*  818 */  eCXRegI_rule,
  /*  819 */  _Binary_eDIRegP_eCXRegI_rule,
  /*  820 */  _Binary_eDIRegP_eSIRegP_rule,
  /*  821 */  _Binary_eDIRegP_eDXRegI_rule,
  /*  822 */  _Binary_eDIRegP_eDXRegI_rule,
  /*  823 */  eDIRegP_rule,
  /*  824 */  eSIRegP_rule,
  /*  825 */  rRegI_rule,
  /*  826 */  rRegI_rule,
  /*  827 */  _Binary_nadxRegI_eAXRegI_rule,
  /*  828 */  rRegI_rule,
  /*  829 */  0,
  /*  830 */  cmpOp_rule,
  /*  831 */  cmpOp_rule,
  /*  832 */  cmpOpU_rule,
  /*  833 */  cmpOpUCF_rule,
  /*  834 */  cmpOpU_rule,
  /*  835 */  cmpOpUCF_rule,
  /*  836 */  cmpOpUCF2_rule,
  /*  837 */  eSIRegP_rule,
  /*  838 */  0,
  /*  839 */  cmpOp_rule,
  /*  840 */  cmpOp_rule,
  /*  841 */  cmpOpU_rule,
  /*  842 */  cmpOpUCF_rule,
  /*  843 */  cmpOpU_rule,
  /*  844 */  cmpOpUCF_rule,
  /*  845 */  cmpOpUCF2_rule,
  /*  846 */  eRegL_rule,
  /*  847 */  cmpOp_rule,
  /*  848 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  849 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  850 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  851 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  852 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  853 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  854 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  855 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  856 */  _Binary_cmpOp_flagsReg_long_LTGE_rule,
  /*  857 */  cmpOp_rule,
  /*  858 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  859 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  860 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  861 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  862 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  863 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  864 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  865 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  866 */  _Binary_cmpOp_flagsReg_long_EQNE_rule,
  /*  867 */  cmpOp_commute_rule,
  /*  868 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  869 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  870 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  871 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  872 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  873 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  874 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  875 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  876 */  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule,
  /*  877 */  0,
  /*  878 */  0,
  /*  879 */  0,
  /*  880 */  0,
  /*  881 */  0,
  /*  882 */  0,
  /*  883 */  0,
  /*  884 */  eRegP_no_EBP_rule,
  /*  885 */  eRegP_no_EBP_rule,
  /*  886 */  0,
  /*  887 */  0,
  /*  888 */  0,
  /*  889 */  0,
  /*  890 */  regF_rule,
  /*  891 */  regF_rule,
  /*  892 */  _LoadF_memory__rule,
  /*  893 */  regF_rule,
  /*  894 */  regF_rule,
  /*  895 */  regF_rule,
  /*  896 */  _LoadF_memory__rule,
  /*  897 */  regF_rule,
  /*  898 */  regD_rule,
  /*  899 */  regD_rule,
  /*  900 */  _LoadD_memory__rule,
  /*  901 */  regD_rule,
  /*  902 */  regD_rule,
  /*  903 */  regD_rule,
  /*  904 */  _LoadD_memory__rule,
  /*  905 */  regD_rule,
  /*  906 */  regF_rule,
  /*  907 */  regF_rule,
  /*  908 */  regF_rule,
  /*  909 */  regF_rule,
  /*  910 */  regF_rule,
  /*  911 */  regF_rule,
  /*  912 */  regD_rule,
  /*  913 */  regD_rule,
  /*  914 */  regD_rule,
  /*  915 */  regD_rule,
  /*  916 */  regD_rule,
  /*  917 */  regD_rule,
  /*  918 */  regF_rule,
  /*  919 */  regF_rule,
  /*  920 */  _LoadF_memory__rule,
  /*  921 */  regF_rule,
  /*  922 */  regF_rule,
  /*  923 */  regF_rule,
  /*  924 */  _LoadF_memory__rule,
  /*  925 */  regF_rule,
  /*  926 */  regD_rule,
  /*  927 */  regD_rule,
  /*  928 */  _LoadD_memory__rule,
  /*  929 */  regD_rule,
  /*  930 */  regD_rule,
  /*  931 */  regD_rule,
  /*  932 */  _LoadD_memory__rule,
  /*  933 */  regD_rule,
  /*  934 */  regF_rule,
  /*  935 */  regF_rule,
  /*  936 */  regF_rule,
  /*  937 */  regF_rule,
  /*  938 */  regF_rule,
  /*  939 */  regF_rule,
  /*  940 */  regD_rule,
  /*  941 */  regD_rule,
  /*  942 */  regD_rule,
  /*  943 */  regD_rule,
  /*  944 */  regD_rule,
  /*  945 */  regD_rule,
  /*  946 */  _SqrtD__ConvF2D_regF___rule,
  /*  947 */  _SqrtD__ConvF2D__LoadF_memory____rule,
  /*  948 */  _SqrtD__ConvF2D_immF___rule,
  /*  949 */  regD_rule,
  /*  950 */  _LoadD_memory__rule,
  /*  951 */  immD_rule,
  /*  952 */  memory_rule,
  /*  953 */  memory_rule,
  /*  954 */  memory_rule,
  /*  955 */  memory_rule,
  /*  956 */  memory_rule,
  /*  957 */  memory_rule,
  /*  958 */  memory_rule,
  /*  959 */  memory_rule,
  /*  960 */  rRegI_rule,
  /*  961 */  rRegI_rule,
  /*  962 */  rRegI_rule,
  /*  963 */  rRegI_rule,
  /*  964 */  immI_rule,
  /*  965 */  immI_rule,
  /*  966 */  immI_rule,
  /*  967 */  immI_rule,
  /*  968 */  immI0_rule,
  /*  969 */  immI0_rule,
  /*  970 */  immI0_rule,
  /*  971 */  immI0_rule,
  /*  972 */  rRegI_rule,
  /*  973 */  rRegI_rule,
  /*  974 */  rRegI_rule,
  /*  975 */  rRegI_rule,
  /*  976 */  immI_rule,
  /*  977 */  immI_rule,
  /*  978 */  immI_rule,
  /*  979 */  immI_rule,
  /*  980 */  immI0_rule,
  /*  981 */  immI0_rule,
  /*  982 */  immI0_rule,
  /*  983 */  immI0_rule,
  /*  984 */  rRegI_rule,
  /*  985 */  rRegI_rule,
  /*  986 */  rRegI_rule,
  /*  987 */  immI_rule,
  /*  988 */  immI_rule,
  /*  989 */  immI_rule,
  /*  990 */  _LoadI_memory__rule,
  /*  991 */  _LoadI_memory__rule,
  /*  992 */  _LoadI_memory__rule,
  /*  993 */  immI0_rule,
  /*  994 */  immI0_rule,
  /*  995 */  immI0_rule,
  /*  996 */  eRegL_rule,
  /*  997 */  eRegL_rule,
  /*  998 */  immL_rule,
  /*  999 */  immL_rule,
  /* 1000 */  _LoadL_memory__rule,
  /* 1001 */  _LoadL_memory__rule,
  /* 1002 */  immL0_rule,
  /* 1003 */  immL0_rule,
  /* 1004 */  regF_rule,
  /* 1005 */  regF_rule,
  /* 1006 */  regF_rule,
  /* 1007 */  immF0_rule,
  /* 1008 */  immF0_rule,
  /* 1009 */  immF0_rule,
  /* 1010 */  regD_rule,
  /* 1011 */  regD_rule,
  /* 1012 */  immD0_rule,
  /* 1013 */  immD0_rule,
  /* 1014 */  vecS_rule,
  /* 1015 */  vecS_rule,
  /* 1016 */  vecD_rule,
  /* 1017 */  vecD_rule,
  /* 1018 */  vecX_rule,
  /* 1019 */  vecX_rule,
  /* 1020 */  vecX_rule,
  /* 1021 */  vecY_rule,
  /* 1022 */  vecY_rule,
  /* 1023 */  vecS_rule,
  /* 1024 */  vecS_rule,
  /* 1025 */  vecD_rule,
  /* 1026 */  vecD_rule,
  /* 1027 */  vecX_rule,
  /* 1028 */  vecX_rule,
  /* 1029 */  vecX_rule,
  /* 1030 */  vecY_rule,
  /* 1031 */  vecY_rule,
  /* 1032 */  vecD_rule,
  /* 1033 */  vecD_rule,
  /* 1034 */  vecX_rule,
  /* 1035 */  vecX_rule,
  /* 1036 */  vecX_rule,
  /* 1037 */  vecY_rule,
  /* 1038 */  vecY_rule,
  /* 1039 */  vecX_rule,
  /* 1040 */  vecX_rule,
  /* 1041 */  vecX_rule,
  /* 1042 */  vecY_rule,
  /* 1043 */  vecY_rule,
  /* 1044 */  vecD_rule,
  /* 1045 */  vecD_rule,
  /* 1046 */  vecX_rule,
  /* 1047 */  vecX_rule,
  /* 1048 */  vecX_rule,
  /* 1049 */  vecY_rule,
  /* 1050 */  vecY_rule,
  /* 1051 */  vecX_rule,
  /* 1052 */  vecX_rule,
  /* 1053 */  vecX_rule,
  /* 1054 */  vecY_rule,
  /* 1055 */  vecY_rule,
  /* 1056 */  vecS_rule,
  /* 1057 */  vecS_rule,
  /* 1058 */  vecD_rule,
  /* 1059 */  vecD_rule,
  /* 1060 */  vecX_rule,
  /* 1061 */  vecX_rule,
  /* 1062 */  vecX_rule,
  /* 1063 */  vecY_rule,
  /* 1064 */  vecY_rule,
  /* 1065 */  vecS_rule,
  /* 1066 */  vecS_rule,
  /* 1067 */  vecD_rule,
  /* 1068 */  vecD_rule,
  /* 1069 */  vecX_rule,
  /* 1070 */  vecX_rule,
  /* 1071 */  vecX_rule,
  /* 1072 */  vecY_rule,
  /* 1073 */  vecY_rule,
  /* 1074 */  vecD_rule,
  /* 1075 */  vecD_rule,
  /* 1076 */  vecX_rule,
  /* 1077 */  vecX_rule,
  /* 1078 */  vecX_rule,
  /* 1079 */  vecY_rule,
  /* 1080 */  vecY_rule,
  /* 1081 */  vecX_rule,
  /* 1082 */  vecX_rule,
  /* 1083 */  vecX_rule,
  /* 1084 */  vecY_rule,
  /* 1085 */  vecY_rule,
  /* 1086 */  vecD_rule,
  /* 1087 */  vecD_rule,
  /* 1088 */  vecX_rule,
  /* 1089 */  vecX_rule,
  /* 1090 */  vecX_rule,
  /* 1091 */  vecY_rule,
  /* 1092 */  vecY_rule,
  /* 1093 */  vecX_rule,
  /* 1094 */  vecX_rule,
  /* 1095 */  vecX_rule,
  /* 1096 */  vecY_rule,
  /* 1097 */  vecY_rule,
  /* 1098 */  vecS_rule,
  /* 1099 */  vecS_rule,
  /* 1100 */  vecD_rule,
  /* 1101 */  vecD_rule,
  /* 1102 */  vecX_rule,
  /* 1103 */  vecX_rule,
  /* 1104 */  vecX_rule,
  /* 1105 */  vecY_rule,
  /* 1106 */  vecY_rule,
  /* 1107 */  vecD_rule,
  /* 1108 */  vecD_rule,
  /* 1109 */  vecX_rule,
  /* 1110 */  vecX_rule,
  /* 1111 */  vecX_rule,
  /* 1112 */  vecY_rule,
  /* 1113 */  vecY_rule,
  /* 1114 */  vecD_rule,
  /* 1115 */  vecD_rule,
  /* 1116 */  vecX_rule,
  /* 1117 */  vecX_rule,
  /* 1118 */  vecX_rule,
  /* 1119 */  vecY_rule,
  /* 1120 */  vecY_rule,
  /* 1121 */  vecX_rule,
  /* 1122 */  vecX_rule,
  /* 1123 */  vecX_rule,
  /* 1124 */  vecY_rule,
  /* 1125 */  vecY_rule,
  /* 1126 */  vecD_rule,
  /* 1127 */  vecD_rule,
  /* 1128 */  vecX_rule,
  /* 1129 */  vecX_rule,
  /* 1130 */  vecX_rule,
  /* 1131 */  vecY_rule,
  /* 1132 */  vecY_rule,
  /* 1133 */  vecX_rule,
  /* 1134 */  vecX_rule,
  /* 1135 */  vecX_rule,
  /* 1136 */  vecY_rule,
  /* 1137 */  vecY_rule,
  /* 1138 */  vecS_rule,
  /* 1139 */  vecS_rule,
  /* 1140 */  vecS_rule,
  /* 1141 */  vecS_rule,
  /* 1142 */  vecD_rule,
  /* 1143 */  vecD_rule,
  /* 1144 */  vecD_rule,
  /* 1145 */  vecD_rule,
  /* 1146 */  vecX_rule,
  /* 1147 */  vecX_rule,
  /* 1148 */  vecX_rule,
  /* 1149 */  vecX_rule,
  /* 1150 */  vecY_rule,
  /* 1151 */  vecY_rule,
  /* 1152 */  vecD_rule,
  /* 1153 */  vecD_rule,
  /* 1154 */  vecD_rule,
  /* 1155 */  vecD_rule,
  /* 1156 */  vecX_rule,
  /* 1157 */  vecX_rule,
  /* 1158 */  vecX_rule,
  /* 1159 */  vecX_rule,
  /* 1160 */  vecY_rule,
  /* 1161 */  vecY_rule,
  /* 1162 */  vecX_rule,
  /* 1163 */  vecX_rule,
  /* 1164 */  vecX_rule,
  /* 1165 */  vecX_rule,
  /* 1166 */  vecY_rule,
  /* 1167 */  vecY_rule,
  /* 1168 */  vecS_rule,
  /* 1169 */  vecS_rule,
  /* 1170 */  vecS_rule,
  /* 1171 */  vecS_rule,
  /* 1172 */  vecD_rule,
  /* 1173 */  vecD_rule,
  /* 1174 */  vecD_rule,
  /* 1175 */  vecD_rule,
  /* 1176 */  vecX_rule,
  /* 1177 */  vecX_rule,
  /* 1178 */  vecX_rule,
  /* 1179 */  vecX_rule,
  /* 1180 */  vecY_rule,
  /* 1181 */  vecY_rule,
  /* 1182 */  vecD_rule,
  /* 1183 */  vecD_rule,
  /* 1184 */  vecD_rule,
  /* 1185 */  vecD_rule,
  /* 1186 */  vecX_rule,
  /* 1187 */  vecX_rule,
  /* 1188 */  vecX_rule,
  /* 1189 */  vecX_rule,
  /* 1190 */  vecY_rule,
  /* 1191 */  vecY_rule,
  /* 1192 */  vecX_rule,
  /* 1193 */  vecX_rule,
  /* 1194 */  vecX_rule,
  /* 1195 */  vecX_rule,
  /* 1196 */  vecY_rule,
  /* 1197 */  vecY_rule,
  /* 1198 */  vecS_rule,
  /* 1199 */  vecS_rule,
  /* 1200 */  vecS_rule,
  /* 1201 */  vecS_rule,
  /* 1202 */  vecD_rule,
  /* 1203 */  vecD_rule,
  /* 1204 */  vecD_rule,
  /* 1205 */  vecD_rule,
  /* 1206 */  vecX_rule,
  /* 1207 */  vecX_rule,
  /* 1208 */  vecX_rule,
  /* 1209 */  vecX_rule,
  /* 1210 */  vecY_rule,
  /* 1211 */  vecY_rule,
  /* 1212 */  vecD_rule,
  /* 1213 */  vecD_rule,
  /* 1214 */  vecD_rule,
  /* 1215 */  vecD_rule,
  /* 1216 */  vecX_rule,
  /* 1217 */  vecX_rule,
  /* 1218 */  vecX_rule,
  /* 1219 */  vecX_rule,
  /* 1220 */  vecY_rule,
  /* 1221 */  vecY_rule,
  /* 1222 */  vecS_rule,
  /* 1223 */  vecS_rule,
  /* 1224 */  vecD_rule,
  /* 1225 */  vecD_rule,
  /* 1226 */  vecX_rule,
  /* 1227 */  vecX_rule,
  /* 1228 */  vecX_rule,
  /* 1229 */  vecY_rule,
  /* 1230 */  vecY_rule,
  /* 1231 */  vecS_rule,
  /* 1232 */  vecS_rule,
  /* 1233 */  vecD_rule,
  /* 1234 */  vecD_rule,
  /* 1235 */  vecX_rule,
  /* 1236 */  vecX_rule,
  /* 1237 */  vecX_rule,
  /* 1238 */  vecY_rule,
  /* 1239 */  vecY_rule,
  /* 1240 */  vecS_rule,
  /* 1241 */  vecS_rule,
  /* 1242 */  vecD_rule,
  /* 1243 */  vecD_rule,
  /* 1244 */  vecX_rule,
  /* 1245 */  vecX_rule,
  /* 1246 */  vecX_rule,
  /* 1247 */  vecY_rule,
  /* 1248 */  vecY_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  immI8_rule,
  /*   88 */  immI_rule,
  /*   89 */  rRegI_rule,
  /*   90 */  immI_rule,
  /*   91 */  rRegI_rule,
  /*   92 */  _LShiftI_rRegI_immI2_rule,
  /*   93 */  immI_rule,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  immI_rule,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  immI8_rule,
  /*  104 */  immI_rule,
  /*  105 */  immI_rule,
  /*  106 */  _LShiftI_rRegI_immI2_rule,
  /*  107 */  immI_rule,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  // last operand
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  // last operand class
  /*  121 */  rRegI_rule,
  /*  122 */  immI2_rule,
  /*  123 */  _LShiftI_rRegI_immI2_rule,
  /*  124 */  rRegI_rule,
  /*  125 */  _LShiftI_rRegI_immI2_rule,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  immI8_rule,
  /*  131 */  0,
  /*  132 */  immI_24_rule,
  /*  133 */  0,
  /*  134 */  immI_24_rule,
  /*  135 */  immI_255_rule,
  /*  136 */  immI16_rule,
  /*  137 */  immI_24_rule,
  /*  138 */  immI_16_rule,
  /*  139 */  immI_255_rule,
  /*  140 */  immI_65535_rule,
  /*  141 */  immU31_rule,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  eFlagsReg_rule,
  /*  148 */  rRegI_rule,
  /*  149 */  eFlagsRegU_rule,
  /*  150 */  eFlagsRegUCF_rule,
  /*  151 */  _LoadI_memory__rule,
  /*  152 */  eRegP_rule,
  /*  153 */  eFlagsRegU_rule,
  /*  154 */  regDPR_rule,
  /*  155 */  regFPR_rule,
  /*  156 */  regDPR_rule,
  /*  157 */  regFPR_rule,
  /*  158 */  regF_rule,
  /*  159 */  regD_rule,
  /*  160 */  eRegL_rule,
  /*  161 */  rRegI_rule,
  /*  162 */  _LoadI_memory__rule,
  /*  163 */  immI_rule,
  /*  164 */  immI1_rule,
  /*  165 */  immI_M1_rule,
  /*  166 */  eRegP_rule,
  /*  167 */  rRegI_rule,
  /*  168 */  eBCXRegL_rule,
  /*  169 */  eCXRegP_rule,
  /*  170 */  eCXRegI_rule,
  /*  171 */  rRegI_rule,
  /*  172 */  rRegI_rule,
  /*  173 */  0,
  /*  174 */  eADXRegL_low_only_rule,
  /*  175 */  immI_32_rule,
  /*  176 */  _ConvI2L_nadxRegI__rule,
  /*  177 */  immI_32_rule,
  /*  178 */  immI_32_63_rule,
  /*  179 */  immI_32_63_rule,
  /*  180 */  0,
  /*  181 */  immL_32bits_rule,
  /*  182 */  immL_32bits_rule,
  /*  183 */  immI1_rule,
  /*  184 */  immI8_rule,
  /*  185 */  immI_24_rule,
  /*  186 */  immI_16_rule,
  /*  187 */  rRegI_rule,
  /*  188 */  _LoadI_memory__rule,
  /*  189 */  immI_rule,
  /*  190 */  immI_M1_rule,
  /*  191 */  _LoadI_memory__rule,
  /*  192 */  immI_M1_rule,
  /*  193 */  0,
  /*  194 */  rRegI_rule,
  /*  195 */  _LoadI_memory__rule,
  /*  196 */  immI_rule,
  /*  197 */  immI1_rule,
  /*  198 */  immI_M1_rule,
  /*  199 */  immI8_rule,
  /*  200 */  immI8_rule,
  /*  201 */  eCXRegI_rule,
  /*  202 */  eCXRegI_rule,
  /*  203 */  _SubI_immI0_eCXRegI_rule,
  /*  204 */  eCXRegI_rule,
  /*  205 */  _SubI_immI_32_eCXRegI_rule,
  /*  206 */  immI1_rule,
  /*  207 */  immI_M1_rule,
  /*  208 */  eCXRegI_rule,
  /*  209 */  _SubI_immI0_eCXRegI_rule,
  /*  210 */  _SubI_immI_32_eCXRegI_rule,
  /*  211 */  rRegI_rule,
  /*  212 */  _LoadI_memory__rule,
  /*  213 */  immI_rule,
  /*  214 */  rRegI_rule,
  /*  215 */  rRegI_rule,
  /*  216 */  rRegI_rule,
  /*  217 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  218 */  0,
  /*  219 */  immL_M1_rule,
  /*  220 */  eRegL_rule,
  /*  221 */  _LoadL_memory__rule,
  /*  222 */  immL_M1_rule,
  /*  223 */  immL_M1_rule,
  /*  224 */  0,
  /*  225 */  regDPR_rule,
  /*  226 */  regDPR_rule,
  /*  227 */  regDPR_rule,
  /*  228 */  0,
  /*  229 */  _LoadD_memory__rule,
  /*  230 */  0,
  /*  231 */  immDPR_rule,
  /*  232 */  regDPR_rule,
  /*  233 */  regDPR_rule,
  /*  234 */  0,
  /*  235 */  regFPR_rule,
  /*  236 */  _LoadF_memory__rule,
  /*  237 */  regFPR_rule,
  /*  238 */  regFPR_rule,
  /*  239 */  0,
  /*  240 */  eCXRegI_rule,
  /*  241 */  eDXRegI_rule,
  /*  242 */  eSIRegP_rule,
  /*  243 */  eDXRegI_rule,
  /*  244 */  immI_rule,
  /*  245 */  eAXRegI_rule,
  /*  246 */  immI_rule,
  /*  247 */  memory_rule,
  /*  248 */  0,
  /*  249 */  eAXRegI_rule,
  /*  250 */  eAXRegP_rule,
  /*  251 */  flagsReg_long_LTGE_rule,
  /*  252 */  _LoadL_load_long_memory__rule,
  /*  253 */  flagsReg_long_EQNE_rule,
  /*  254 */  flagsReg_long_LEGT_rule,
  /*  255 */  0,
  /*  256 */  0,
  /*  257 */  0,
  /*  258 */  0,
  /*  259 */  0,
  /*  260 */  0,
  /*  261 */  0,
  // last internally defined operand
  /*  262 */  0,
  /*  263 */  0,
  /*  264 */  0,
  /*  265 */  0,
  /*  266 */  0,
  /*  267 */  0,
  /*  268 */  0,
  /*  269 */  0,
  /*  270 */  0,
  /*  271 */  0,
  /*  272 */  0,
  /*  273 */  0,
  /*  274 */  0,
  /*  275 */  0,
  /*  276 */  0,
  /*  277 */  0,
  /*  278 */  0,
  /*  279 */  0,
  /*  280 */  0,
  /*  281 */  0,
  /*  282 */  0,
  /*  283 */  0,
  /*  284 */  0,
  /*  285 */  0,
  /*  286 */  0,
  /*  287 */  0,
  /*  288 */  0,
  /*  289 */  0,
  /*  290 */  0,
  /*  291 */  0,
  /*  292 */  0,
  /*  293 */  0,
  /*  294 */  0,
  /*  295 */  0,
  /*  296 */  0,
  /*  297 */  _Binary_eAXRegP_eRegP_rule,
  /*  298 */  _Binary_eAXRegI_rRegI_rule,
  /*  299 */  _Binary_eADXRegL_eBCXRegL_rule,
  /*  300 */  0,
  /*  301 */  0,
  /*  302 */  rRegI_rule,
  /*  303 */  immI_rule,
  /*  304 */  rRegI_rule,
  /*  305 */  immI_rule,
  /*  306 */  eAXRegI_rule,
  /*  307 */  rRegI_rule,
  /*  308 */  immI_rule,
  /*  309 */  regDPR_rule,
  /*  310 */  regDPR_rule,
  /*  311 */  regDPR_rule,
  /*  312 */  regD_rule,
  /*  313 */  regD_rule,
  /*  314 */  _LoadD_memory__rule,
  /*  315 */  _LoadD_memory__rule,
  /*  316 */  0,
  /*  317 */  0,
  /*  318 */  regFPR_rule,
  /*  319 */  regFPR_rule,
  /*  320 */  regFPR_rule,
  /*  321 */  regF_rule,
  /*  322 */  regF_rule,
  /*  323 */  _LoadF_memory__rule,
  /*  324 */  _LoadF_memory__rule,
  /*  325 */  0,
  /*  326 */  0,
  /*  327 */  0,
  /*  328 */  0,
  /*  329 */  0,
  /*  330 */  0,
  /*  331 */  0,
  /*  332 */  0,
  /*  333 */  0,
  /*  334 */  0,
  /*  335 */  0,
  /*  336 */  rRegI_rule,
  /*  337 */  immI_rule,
  /*  338 */  _LoadI_memory__rule,
  /*  339 */  immI0_rule,
  /*  340 */  immI0_rule,
  /*  341 */  immI0_rule,
  /*  342 */  rRegI_rule,
  /*  343 */  immI_rule,
  /*  344 */  _LoadI_memory__rule,
  /*  345 */  immI0_rule,
  /*  346 */  eRegP_rule,
  /*  347 */  immP_rule,
  /*  348 */  _LoadP_memory__rule,
  /*  349 */  _LoadP_memory__rule,
  /*  350 */  immP0_rule,
  /*  351 */  immI0_rule,
  /*  352 */  immP0_rule,
  /*  353 */  immL0_rule,
  /*  354 */  eRegL_rule,
  /*  355 */  immL0_rule,
  /*  356 */  eRegL_rule,
  /*  357 */  immL0_rule,
  /*  358 */  eRegL_rule,
  /*  359 */  eBXRegP_rule,
  /*  360 */  eBXRegP_rule,
  /*  361 */  eAXRegP_rule,
  /*  362 */  0,
  /*  363 */  0,
  /*  364 */  0,
  /*  365 */  0,
  /*  366 */  0,
  /*  367 */  0,
  /*  368 */  0,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  0,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  0,
  /*  377 */  0,
  /*  378 */  0,
  /*  379 */  0,
  /*  380 */  0,
  /*  381 */  0,
  /*  382 */  0,
  /*  383 */  0,
  /*  384 */  0,
  /*  385 */  0,
  /*  386 */  0,
  /*  387 */  0,
  /*  388 */  0,
  /*  389 */  0,
  /*  390 */  0,
  /*  391 */  0,
  /*  392 */  0,
  /*  393 */  0,
  /*  394 */  0,
  /*  395 */  immI_24_rule,
  /*  396 */  0,
  /*  397 */  0,
  /*  398 */  immI_24_rule,
  /*  399 */  0,
  /*  400 */  0,
  /*  401 */  0,
  /*  402 */  0,
  /*  403 */  immI_24_rule,
  /*  404 */  immI_255_rule,
  /*  405 */  immI_16_rule,
  /*  406 */  immI_65535_rule,
  /*  407 */  0,
  /*  408 */  0,
  /*  409 */  0,
  /*  410 */  0,
  /*  411 */  immL_32bits_rule,
  /*  412 */  0,
  /*  413 */  0,
  /*  414 */  0,
  /*  415 */  0,
  /*  416 */  0,
  /*  417 */  0,
  /*  418 */  0,
  /*  419 */  0,
  /*  420 */  0,
  /*  421 */  0,
  /*  422 */  0,
  /*  423 */  0,
  /*  424 */  0,
  /*  425 */  0,
  /*  426 */  0,
  /*  427 */  0,
  /*  428 */  0,
  /*  429 */  0,
  /*  430 */  0,
  /*  431 */  0,
  /*  432 */  0,
  /*  433 */  0,
  /*  434 */  0,
  /*  435 */  0,
  /*  436 */  0,
  /*  437 */  xRegI_rule,
  /*  438 */  rRegI_rule,
  /*  439 */  rRegI_rule,
  /*  440 */  eRegL_rule,
  /*  441 */  _ConvL2I_eRegL__rule,
  /*  442 */  stackSlotL_rule,
  /*  443 */  stackSlotL_rule,
  /*  444 */  eRegL_rule,
  /*  445 */  anyRegP_rule,
  /*  446 */  immI_rule,
  /*  447 */  immI16_rule,
  /*  448 */  immP_rule,
  /*  449 */  immI8_rule,
  /*  450 */  immI8_rule,
  /*  451 */  regDPR1_rule,
  /*  452 */  _RoundDouble_regDPR1__rule,
  /*  453 */  regD_rule,
  /*  454 */  regF_rule,
  /*  455 */  regFPR1_rule,
  /*  456 */  _RoundFloat_regFPR1__rule,
  /*  457 */  _ConvD2F_regDPR1__rule,
  /*  458 */  immFPR_rule,
  /*  459 */  immF_rule,
  /*  460 */  0,
  /*  461 */  0,
  /*  462 */  0,
  /*  463 */  0,
  /*  464 */  0,
  /*  465 */  0,
  /*  466 */  0,
  /*  467 */  0,
  /*  468 */  _Binary_rRegI_rRegI_rule,
  /*  469 */  _Binary_rRegI_rRegI_rule,
  /*  470 */  _Binary_rRegI_rRegI_rule,
  /*  471 */  _Binary_rRegI_rRegI_rule,
  /*  472 */  _Binary_rRegI_rRegI_rule,
  /*  473 */  _Binary_rRegI__LoadI_memory__rule,
  /*  474 */  _Binary_rRegI__LoadI_memory__rule,
  /*  475 */  _Binary_rRegI__LoadI_memory__rule,
  /*  476 */  _Binary_eRegP_eRegP_rule,
  /*  477 */  _Binary_eRegP_eRegP_rule,
  /*  478 */  _Binary_eRegP_eRegP_rule,
  /*  479 */  _Binary_eRegP_eRegP_rule,
  /*  480 */  _Binary_regDPR1_regDPR_rule,
  /*  481 */  _Binary_regFPR1_regFPR_rule,
  /*  482 */  _Binary_regDPR_regDPR_rule,
  /*  483 */  _Binary_regFPR_regFPR_rule,
  /*  484 */  _Binary_regF_regF_rule,
  /*  485 */  _Binary_regD_regD_rule,
  /*  486 */  _Binary_regF_regF_rule,
  /*  487 */  _Binary_regF_regF_rule,
  /*  488 */  _Binary_regD_regD_rule,
  /*  489 */  _Binary_regD_regD_rule,
  /*  490 */  _Binary_eRegL_eRegL_rule,
  /*  491 */  _Binary_eRegL_eRegL_rule,
  /*  492 */  _Binary_eRegL_eRegL_rule,
  /*  493 */  rRegI_rule,
  /*  494 */  immI_rule,
  /*  495 */  immI1_rule,
  /*  496 */  immI_rule,
  /*  497 */  immI_rule,
  /*  498 */  immI_M1_rule,
  /*  499 */  rRegI_rule,
  /*  500 */  immI_rule,
  /*  501 */  _LoadI_memory__rule,
  /*  502 */  rRegI_rule,
  /*  503 */  _AddI__LoadI_memory__rRegI_rule,
  /*  504 */  _AddI_rRegI__LoadI_memory__rule,
  /*  505 */  _AddI__LoadI_memory__immI_rule,
  /*  506 */  _AddI__LoadI_memory__immI1_rule,
  /*  507 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  508 */  0,
  /*  509 */  _Binary_eADXRegL_eBCXRegL_rule,
  /*  510 */  _Binary_eAXRegP_eCXRegP_rule,
  /*  511 */  _Binary_eAXRegI_eCXRegI_rule,
  /*  512 */  immI_rule,
  /*  513 */  rRegI_rule,
  /*  514 */  rRegI_rule,
  /*  515 */  pRegP_rule,
  /*  516 */  rRegI_rule,
  /*  517 */  immI_rule,
  /*  518 */  _LoadI_memory__rule,
  /*  519 */  _SubI__LoadI_memory__rRegI_rule,
  /*  520 */  _SubI_immI0_rRegI_rule,
  /*  521 */  rRegI_rule,
  /*  522 */  rRegI_rule,
  /*  523 */  immI_rule,
  /*  524 */  0,
  /*  525 */  0,
  /*  526 */  0,
  /*  527 */  0,
  /*  528 */  immI_rule,
  /*  529 */  _LoadI_memory__rule,
  /*  530 */  rRegI_rule,
  /*  531 */  _ConvI2L_nadxRegI__rule,
  /*  532 */  _ConvI2L_eAXRegI__rule,
  /*  533 */  _AndL__ConvI2L_nadxRegI__immL_32bits_rule,
  /*  534 */  _AndL__ConvI2L_eAXRegI__immL_32bits_rule,
  /*  535 */  eRegL_rule,
  /*  536 */  eRegL_rule,
  /*  537 */  eRegL_rule,
  /*  538 */  eRegL_rule,
  /*  539 */  immL_127_rule,
  /*  540 */  eCXRegI_rule,
  /*  541 */  eRegL_rule,
  /*  542 */  eCXRegI_rule,
  /*  543 */  eCXRegI_rule,
  /*  544 */  eRegL_rule,
  /*  545 */  immL32_rule,
  /*  546 */  immL32_rule,
  /*  547 */  immI1_rule,
  /*  548 */  immI8_rule,
  /*  549 */  eCXRegI_rule,
  /*  550 */  immI1_rule,
  /*  551 */  _RShiftI__LoadI_memory__immI1_rule,
  /*  552 */  immI8_rule,
  /*  553 */  _RShiftI__LoadI_memory__immI8_rule,
  /*  554 */  eCXRegI_rule,
  /*  555 */  immI1_rule,
  /*  556 */  immI8_rule,
  /*  557 */  immI_24_rule,
  /*  558 */  immI_16_rule,
  /*  559 */  eCXRegI_rule,
  /*  560 */  rRegI_rule,
  /*  561 */  immI_rule,
  /*  562 */  _LoadI_memory__rule,
  /*  563 */  rRegI_rule,
  /*  564 */  _AndI__LoadI_memory__rRegI_rule,
  /*  565 */  _AndI_rRegI__LoadI_memory__rule,
  /*  566 */  _AndI__LoadI_memory__immI_rule,
  /*  567 */  rRegI_rule,
  /*  568 */  _XorI_rRegI_immI_M1_rule,
  /*  569 */  _LoadI_memory__rule,
  /*  570 */  _XorI_rRegI_immI_M1_rule,
  /*  571 */  rRegI_rule,
  /*  572 */  _SubI_immI0_rRegI_rule,
  /*  573 */  _LoadI_memory__rule,
  /*  574 */  _SubI_immI0__LoadI_memory__rule,
  /*  575 */  rRegI_rule,
  /*  576 */  _AddI_rRegI_immI_M1_rule,
  /*  577 */  _LoadI_memory__rule,
  /*  578 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  579 */  rRegI_rule,
  /*  580 */  _AddI_rRegI_immI_M1_rule,
  /*  581 */  _LoadI_memory__rule,
  /*  582 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  583 */  rRegI_rule,
  /*  584 */  _CastP2X_eRegP__rule,
  /*  585 */  rRegI_rule,
  /*  586 */  immI_rule,
  /*  587 */  _LoadI_memory__rule,
  /*  588 */  rRegI_rule,
  /*  589 */  _OrI__LoadI_memory__rRegI_rule,
  /*  590 */  _OrI_rRegI__LoadI_memory__rule,
  /*  591 */  _OrI__LoadI_memory__immI_rule,
  /*  592 */  0,
  /*  593 */  0,
  /*  594 */  0,
  /*  595 */  _URShiftI_rRegI_immI_M1_rule,
  /*  596 */  _LShiftI_rRegI_immI1_rule,
  /*  597 */  _URShiftI_rRegI_immI8_rule,
  /*  598 */  _LShiftI_rRegI_immI8_rule,
  /*  599 */  _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule,
  /*  600 */  _LShiftI_ncxRegI_eCXRegI_rule,
  /*  601 */  _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule,
  /*  602 */  _LShiftI_ncxRegI_eCXRegI_rule,
  /*  603 */  0,
  /*  604 */  0,
  /*  605 */  0,
  /*  606 */  _LShiftI_rRegI_immI_M1_rule,
  /*  607 */  _URShiftI_rRegI_immI1_rule,
  /*  608 */  _LShiftI_rRegI_immI8_rule,
  /*  609 */  _URShiftI_rRegI_immI8_rule,
  /*  610 */  _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule,
  /*  611 */  _URShiftI_ncxRegI_eCXRegI_rule,
  /*  612 */  _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule,
  /*  613 */  _URShiftI_ncxRegI_eCXRegI_rule,
  /*  614 */  rRegI_rule,
  /*  615 */  immI_M1_rule,
  /*  616 */  immI_rule,
  /*  617 */  _LoadI_memory__rule,
  /*  618 */  rRegI_rule,
  /*  619 */  _XorI__LoadI_memory__rRegI_rule,
  /*  620 */  _XorI_rRegI__LoadI_memory__rule,
  /*  621 */  _XorI__LoadI_memory__immI_rule,
  /*  622 */  0,
  /*  623 */  0,
  /*  624 */  0,
  /*  625 */  0,
  /*  626 */  ncxRegI_rule,
  /*  627 */  immI0_rule,
  /*  628 */  _SubI_rRegI_rRegI_rule,
  /*  629 */  _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule,
  /*  630 */  _SubI_rRegI_rRegI_rule,
  /*  631 */  _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule,
  /*  632 */  rRegI_rule,
  /*  633 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  634 */  eRegL_rule,
  /*  635 */  immL_rule,
  /*  636 */  _LoadL_load_long_memory__rule,
  /*  637 */  eRegL_rule,
  /*  638 */  eRegL_rule,
  /*  639 */  immL_rule,
  /*  640 */  _LoadL_load_long_memory__rule,
  /*  641 */  eRegL_rule,
  /*  642 */  eRegL_rule,
  /*  643 */  immL_rule,
  /*  644 */  _LoadL_load_long_memory__rule,
  /*  645 */  eRegL_rule,
  /*  646 */  eRegL_rule,
  /*  647 */  _XorL_eRegL_immL_M1_rule,
  /*  648 */  _LoadL_memory__rule,
  /*  649 */  _XorL_eRegL_immL_M1_rule,
  /*  650 */  eRegL_rule,
  /*  651 */  _SubL_immL0_eRegL_rule,
  /*  652 */  _LoadL_memory__rule,
  /*  653 */  _SubL_immL0__LoadL_memory__rule,
  /*  654 */  eRegL_rule,
  /*  655 */  _AddL_eRegL_immL_M1_rule,
  /*  656 */  _LoadL_memory__rule,
  /*  657 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  658 */  eRegL_rule,
  /*  659 */  _AddL_eRegL_immL_M1_rule,
  /*  660 */  _LoadL_memory__rule,
  /*  661 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  662 */  eRegL_rule,
  /*  663 */  immL_rule,
  /*  664 */  _LoadL_load_long_memory__rule,
  /*  665 */  eRegL_rule,
  /*  666 */  eRegL_rule,
  /*  667 */  immL_M1_rule,
  /*  668 */  immL_rule,
  /*  669 */  _LoadL_load_long_memory__rule,
  /*  670 */  eRegL_rule,
  /*  671 */  immI_1_rule,
  /*  672 */  immI_2_rule,
  /*  673 */  immI_3_rule,
  /*  674 */  immI_1_31_rule,
  /*  675 */  immI_32_63_rule,
  /*  676 */  eCXRegI_rule,
  /*  677 */  immI_1_31_rule,
  /*  678 */  immI_32_63_rule,
  /*  679 */  eCXRegI_rule,
  /*  680 */  immI_1_31_rule,
  /*  681 */  immI_32_63_rule,
  /*  682 */  eCXRegI_rule,
  /*  683 */  immDPR0_rule,
  /*  684 */  regDPR_rule,
  /*  685 */  regD_rule,
  /*  686 */  _LoadD_memory__rule,
  /*  687 */  regDPR_rule,
  /*  688 */  0,
  /*  689 */  _LoadD_memory__rule,
  /*  690 */  regDPR_rule,
  /*  691 */  0,
  /*  692 */  _LoadD_memory__rule,
  /*  693 */  regDPR_rule,
  /*  694 */  _RoundDouble__AddD__LoadD_memory__regDPR__rule,
  /*  695 */  _RoundDouble__AddD_regDPR__LoadD_memory___rule,
  /*  696 */  immDPR1_rule,
  /*  697 */  immDPR_rule,
  /*  698 */  0,
  /*  699 */  regDPR_rule,
  /*  700 */  regnotDPR1_rule,
  /*  701 */  immDPR_rule,
  /*  702 */  _LoadD_memory__rule,
  /*  703 */  regDPR_rule,
  /*  704 */  _LoadD_memory__rule,
  /*  705 */  regDPR_rule,
  /*  706 */  regDPR_rule,
  /*  707 */  _MulD_regDPR_regDPR_rule,
  /*  708 */  regDPR_rule,
  /*  709 */  regDPR_rule,
  /*  710 */  regnotDPR1_rule,
  /*  711 */  0,
  /*  712 */  regDPR_rule,
  /*  713 */  regD_rule,
  /*  714 */  0,
  /*  715 */  0,
  /*  716 */  0,
  /*  717 */  0,
  /*  718 */  0,
  /*  719 */  0,
  /*  720 */  regDPR_rule,
  /*  721 */  regD_rule,
  /*  722 */  0,
  /*  723 */  regDPR1_rule,
  /*  724 */  regD_rule,
  /*  725 */  0,
  /*  726 */  0,
  /*  727 */  0,
  /*  728 */  0,
  /*  729 */  0,
  /*  730 */  0,
  /*  731 */  immFPR0_rule,
  /*  732 */  regFPR_rule,
  /*  733 */  regF_rule,
  /*  734 */  _LoadF_memory__rule,
  /*  735 */  regFPR_rule,
  /*  736 */  regFPR_rule,
  /*  737 */  regFPR_rule,
  /*  738 */  regFPR_rule,
  /*  739 */  _LoadF_memory__rule,
  /*  740 */  regFPR_rule,
  /*  741 */  _LoadF_memory__rule,
  /*  742 */  regFPR_rule,
  /*  743 */  regFPR_rule,
  /*  744 */  _LoadF_memory__rule,
  /*  745 */  memory_rule,
  /*  746 */  memory_rule,
  /*  747 */  immFPR_rule,
  /*  748 */  immFPR_rule,
  /*  749 */  regFPR_rule,
  /*  750 */  regFPR_rule,
  /*  751 */  _LoadF_memory__rule,
  /*  752 */  regFPR_rule,
  /*  753 */  _LoadF_memory__rule,
  /*  754 */  regFPR_rule,
  /*  755 */  memory_rule,
  /*  756 */  immFPR_rule,
  /*  757 */  immFPR_rule,
  /*  758 */  regFPR_rule,
  /*  759 */  _LoadF_memory__rule,
  /*  760 */  regFPR_rule,
  /*  761 */  _MulF__LoadF_memory__regFPR_rule,
  /*  762 */  regFPR_rule,
  /*  763 */  _MulF_regFPR__LoadF_memory__rule,
  /*  764 */  regFPR_rule,
  /*  765 */  _MulF_regFPR_regFPR_rule,
  /*  766 */  regFPR_rule,
  /*  767 */  regFPR_rule,
  /*  768 */  regFPR_rule,
  /*  769 */  regFPR_rule,
  /*  770 */  regFPR_rule,
  /*  771 */  regF_rule,
  /*  772 */  0,
  /*  773 */  0,
  /*  774 */  0,
  /*  775 */  0,
  /*  776 */  0,
  /*  777 */  0,
  /*  778 */  0,
  /*  779 */  0,
  /*  780 */  0,
  /*  781 */  0,
  /*  782 */  0,
  /*  783 */  0,
  /*  784 */  0,
  /*  785 */  0,
  /*  786 */  0,
  /*  787 */  0,
  /*  788 */  0,
  /*  789 */  0,
  /*  790 */  0,
  /*  791 */  0,
  /*  792 */  0,
  /*  793 */  0,
  /*  794 */  0,
  /*  795 */  0,
  /*  796 */  0,
  /*  797 */  0,
  /*  798 */  0,
  /*  799 */  0,
  /*  800 */  0,
  /*  801 */  0,
  /*  802 */  immL_32bits_rule,
  /*  803 */  immL_32bits_rule,
  /*  804 */  0,
  /*  805 */  0,
  /*  806 */  0,
  /*  807 */  0,
  /*  808 */  0,
  /*  809 */  0,
  /*  810 */  0,
  /*  811 */  0,
  /*  812 */  0,
  /*  813 */  0,
  /*  814 */  0,
  /*  815 */  0,
  /*  816 */  0,
  /*  817 */  eDIRegP_rule,
  /*  818 */  eDIRegP_rule,
  /*  819 */  _Binary_eSIRegP_eDXRegI_rule,
  /*  820 */  eCXRegI_rule,
  /*  821 */  _Binary_eSIRegP_immI_rule,
  /*  822 */  _Binary_eSIRegP_eAXRegI_rule,
  /*  823 */  eSIRegP_rule,
  /*  824 */  _Binary_eDIRegP_eDXRegI_rule,
  /*  825 */  rRegI_rule,
  /*  826 */  rRegI_rule,
  /*  827 */  immI_rule,
  /*  828 */  0,
  /*  829 */  0,
  /*  830 */  eFlagsReg_rule,
  /*  831 */  eFlagsReg_rule,
  /*  832 */  eFlagsRegU_rule,
  /*  833 */  eFlagsRegUCF_rule,
  /*  834 */  eFlagsRegU_rule,
  /*  835 */  eFlagsRegUCF_rule,
  /*  836 */  eFlagsRegUCF_rule,
  /*  837 */  eAXRegP_rule,
  /*  838 */  0,
  /*  839 */  eFlagsReg_rule,
  /*  840 */  eFlagsReg_rule,
  /*  841 */  eFlagsRegU_rule,
  /*  842 */  eFlagsRegUCF_rule,
  /*  843 */  eFlagsRegU_rule,
  /*  844 */  eFlagsRegUCF_rule,
  /*  845 */  eFlagsRegUCF_rule,
  /*  846 */  eRegL_rule,
  /*  847 */  flagsReg_long_LTGE_rule,
  /*  848 */  _Binary_eRegL_eRegL_rule,
  /*  849 */  _Binary_eRegL__LoadL_load_long_memory__rule,
  /*  850 */  _Binary_rRegI_rRegI_rule,
  /*  851 */  _Binary_rRegI__LoadI_memory__rule,
  /*  852 */  _Binary_eRegP_eRegP_rule,
  /*  853 */  _Binary_regDPR_regDPR_rule,
  /*  854 */  _Binary_regD_regD_rule,
  /*  855 */  _Binary_regFPR_regFPR_rule,
  /*  856 */  _Binary_regF_regF_rule,
  /*  857 */  flagsReg_long_EQNE_rule,
  /*  858 */  _Binary_eRegL_eRegL_rule,
  /*  859 */  _Binary_eRegL__LoadL_load_long_memory__rule,
  /*  860 */  _Binary_rRegI_rRegI_rule,
  /*  861 */  _Binary_rRegI__LoadI_memory__rule,
  /*  862 */  _Binary_eRegP_eRegP_rule,
  /*  863 */  _Binary_regDPR_regDPR_rule,
  /*  864 */  _Binary_regD_regD_rule,
  /*  865 */  _Binary_regFPR_regFPR_rule,
  /*  866 */  _Binary_regF_regF_rule,
  /*  867 */  flagsReg_long_LEGT_rule,
  /*  868 */  _Binary_eRegL_eRegL_rule,
  /*  869 */  _Binary_eRegL__LoadL_load_long_memory__rule,
  /*  870 */  _Binary_rRegI_rRegI_rule,
  /*  871 */  _Binary_rRegI__LoadI_memory__rule,
  /*  872 */  _Binary_eRegP_eRegP_rule,
  /*  873 */  _Binary_regDPR_regDPR_rule,
  /*  874 */  _Binary_regD_regD_rule,
  /*  875 */  _Binary_regFPR_regFPR_rule,
  /*  876 */  _Binary_regF_regF_rule,
  /*  877 */  0,
  /*  878 */  0,
  /*  879 */  0,
  /*  880 */  0,
  /*  881 */  0,
  /*  882 */  0,
  /*  883 */  0,
  /*  884 */  eBXRegP_rule,
  /*  885 */  eAXRegP_rule,
  /*  886 */  0,
  /*  887 */  0,
  /*  888 */  0,
  /*  889 */  0,
  /*  890 */  regF_rule,
  /*  891 */  _LoadF_memory__rule,
  /*  892 */  regF_rule,
  /*  893 */  immF_rule,
  /*  894 */  regF_rule,
  /*  895 */  _LoadF_memory__rule,
  /*  896 */  regF_rule,
  /*  897 */  immF_rule,
  /*  898 */  regD_rule,
  /*  899 */  _LoadD_memory__rule,
  /*  900 */  regD_rule,
  /*  901 */  immD_rule,
  /*  902 */  regD_rule,
  /*  903 */  _LoadD_memory__rule,
  /*  904 */  regD_rule,
  /*  905 */  immD_rule,
  /*  906 */  regF_rule,
  /*  907 */  _LoadF_memory__rule,
  /*  908 */  immF_rule,
  /*  909 */  regF_rule,
  /*  910 */  _LoadF_memory__rule,
  /*  911 */  immF_rule,
  /*  912 */  regD_rule,
  /*  913 */  _LoadD_memory__rule,
  /*  914 */  immD_rule,
  /*  915 */  regD_rule,
  /*  916 */  _LoadD_memory__rule,
  /*  917 */  immD_rule,
  /*  918 */  regF_rule,
  /*  919 */  _LoadF_memory__rule,
  /*  920 */  regF_rule,
  /*  921 */  immF_rule,
  /*  922 */  regF_rule,
  /*  923 */  _LoadF_memory__rule,
  /*  924 */  regF_rule,
  /*  925 */  immF_rule,
  /*  926 */  regD_rule,
  /*  927 */  _LoadD_memory__rule,
  /*  928 */  regD_rule,
  /*  929 */  immD_rule,
  /*  930 */  regD_rule,
  /*  931 */  _LoadD_memory__rule,
  /*  932 */  regD_rule,
  /*  933 */  immD_rule,
  /*  934 */  regF_rule,
  /*  935 */  _LoadF_memory__rule,
  /*  936 */  immF_rule,
  /*  937 */  regF_rule,
  /*  938 */  _LoadF_memory__rule,
  /*  939 */  immF_rule,
  /*  940 */  regD_rule,
  /*  941 */  _LoadD_memory__rule,
  /*  942 */  immD_rule,
  /*  943 */  regD_rule,
  /*  944 */  _LoadD_memory__rule,
  /*  945 */  immD_rule,
  /*  946 */  0,
  /*  947 */  0,
  /*  948 */  0,
  /*  949 */  0,
  /*  950 */  0,
  /*  951 */  0,
  /*  952 */  0,
  /*  953 */  0,
  /*  954 */  0,
  /*  955 */  0,
  /*  956 */  vecS_rule,
  /*  957 */  vecD_rule,
  /*  958 */  vecX_rule,
  /*  959 */  vecY_rule,
  /*  960 */  0,
  /*  961 */  0,
  /*  962 */  0,
  /*  963 */  0,
  /*  964 */  0,
  /*  965 */  0,
  /*  966 */  0,
  /*  967 */  0,
  /*  968 */  0,
  /*  969 */  0,
  /*  970 */  0,
  /*  971 */  0,
  /*  972 */  0,
  /*  973 */  0,
  /*  974 */  0,
  /*  975 */  0,
  /*  976 */  0,
  /*  977 */  0,
  /*  978 */  0,
  /*  979 */  0,
  /*  980 */  0,
  /*  981 */  0,
  /*  982 */  0,
  /*  983 */  0,
  /*  984 */  0,
  /*  985 */  0,
  /*  986 */  0,
  /*  987 */  0,
  /*  988 */  0,
  /*  989 */  0,
  /*  990 */  0,
  /*  991 */  0,
  /*  992 */  0,
  /*  993 */  0,
  /*  994 */  0,
  /*  995 */  0,
  /*  996 */  0,
  /*  997 */  0,
  /*  998 */  0,
  /*  999 */  0,
  /* 1000 */  0,
  /* 1001 */  0,
  /* 1002 */  0,
  /* 1003 */  0,
  /* 1004 */  0,
  /* 1005 */  0,
  /* 1006 */  0,
  /* 1007 */  0,
  /* 1008 */  0,
  /* 1009 */  0,
  /* 1010 */  0,
  /* 1011 */  0,
  /* 1012 */  0,
  /* 1013 */  0,
  /* 1014 */  vecS_rule,
  /* 1015 */  vecS_rule,
  /* 1016 */  vecD_rule,
  /* 1017 */  vecD_rule,
  /* 1018 */  vecX_rule,
  /* 1019 */  vecX_rule,
  /* 1020 */  _LoadVector_memory__rule,
  /* 1021 */  vecY_rule,
  /* 1022 */  _LoadVector_memory__rule,
  /* 1023 */  vecS_rule,
  /* 1024 */  vecS_rule,
  /* 1025 */  vecD_rule,
  /* 1026 */  vecD_rule,
  /* 1027 */  vecX_rule,
  /* 1028 */  vecX_rule,
  /* 1029 */  _LoadVector_memory__rule,
  /* 1030 */  vecY_rule,
  /* 1031 */  _LoadVector_memory__rule,
  /* 1032 */  vecD_rule,
  /* 1033 */  vecD_rule,
  /* 1034 */  vecX_rule,
  /* 1035 */  vecX_rule,
  /* 1036 */  _LoadVector_memory__rule,
  /* 1037 */  vecY_rule,
  /* 1038 */  _LoadVector_memory__rule,
  /* 1039 */  vecX_rule,
  /* 1040 */  vecX_rule,
  /* 1041 */  _LoadVector_memory__rule,
  /* 1042 */  vecY_rule,
  /* 1043 */  _LoadVector_memory__rule,
  /* 1044 */  vecD_rule,
  /* 1045 */  vecD_rule,
  /* 1046 */  vecX_rule,
  /* 1047 */  vecX_rule,
  /* 1048 */  _LoadVector_memory__rule,
  /* 1049 */  vecY_rule,
  /* 1050 */  _LoadVector_memory__rule,
  /* 1051 */  vecX_rule,
  /* 1052 */  vecX_rule,
  /* 1053 */  _LoadVector_memory__rule,
  /* 1054 */  vecY_rule,
  /* 1055 */  _LoadVector_memory__rule,
  /* 1056 */  vecS_rule,
  /* 1057 */  vecS_rule,
  /* 1058 */  vecD_rule,
  /* 1059 */  vecD_rule,
  /* 1060 */  vecX_rule,
  /* 1061 */  vecX_rule,
  /* 1062 */  _LoadVector_memory__rule,
  /* 1063 */  vecY_rule,
  /* 1064 */  _LoadVector_memory__rule,
  /* 1065 */  vecS_rule,
  /* 1066 */  vecS_rule,
  /* 1067 */  vecD_rule,
  /* 1068 */  vecD_rule,
  /* 1069 */  vecX_rule,
  /* 1070 */  vecX_rule,
  /* 1071 */  _LoadVector_memory__rule,
  /* 1072 */  vecY_rule,
  /* 1073 */  _LoadVector_memory__rule,
  /* 1074 */  vecD_rule,
  /* 1075 */  vecD_rule,
  /* 1076 */  vecX_rule,
  /* 1077 */  vecX_rule,
  /* 1078 */  _LoadVector_memory__rule,
  /* 1079 */  vecY_rule,
  /* 1080 */  _LoadVector_memory__rule,
  /* 1081 */  vecX_rule,
  /* 1082 */  vecX_rule,
  /* 1083 */  _LoadVector_memory__rule,
  /* 1084 */  vecY_rule,
  /* 1085 */  _LoadVector_memory__rule,
  /* 1086 */  vecD_rule,
  /* 1087 */  vecD_rule,
  /* 1088 */  vecX_rule,
  /* 1089 */  vecX_rule,
  /* 1090 */  _LoadVector_memory__rule,
  /* 1091 */  vecY_rule,
  /* 1092 */  _LoadVector_memory__rule,
  /* 1093 */  vecX_rule,
  /* 1094 */  vecX_rule,
  /* 1095 */  _LoadVector_memory__rule,
  /* 1096 */  vecY_rule,
  /* 1097 */  _LoadVector_memory__rule,
  /* 1098 */  vecS_rule,
  /* 1099 */  vecS_rule,
  /* 1100 */  vecD_rule,
  /* 1101 */  vecD_rule,
  /* 1102 */  vecX_rule,
  /* 1103 */  vecX_rule,
  /* 1104 */  _LoadVector_memory__rule,
  /* 1105 */  vecY_rule,
  /* 1106 */  _LoadVector_memory__rule,
  /* 1107 */  vecD_rule,
  /* 1108 */  vecD_rule,
  /* 1109 */  vecX_rule,
  /* 1110 */  vecX_rule,
  /* 1111 */  _LoadVector_memory__rule,
  /* 1112 */  vecY_rule,
  /* 1113 */  _LoadVector_memory__rule,
  /* 1114 */  vecD_rule,
  /* 1115 */  vecD_rule,
  /* 1116 */  vecX_rule,
  /* 1117 */  vecX_rule,
  /* 1118 */  _LoadVector_memory__rule,
  /* 1119 */  vecY_rule,
  /* 1120 */  _LoadVector_memory__rule,
  /* 1121 */  vecX_rule,
  /* 1122 */  vecX_rule,
  /* 1123 */  _LoadVector_memory__rule,
  /* 1124 */  vecY_rule,
  /* 1125 */  _LoadVector_memory__rule,
  /* 1126 */  vecD_rule,
  /* 1127 */  vecD_rule,
  /* 1128 */  vecX_rule,
  /* 1129 */  vecX_rule,
  /* 1130 */  _LoadVector_memory__rule,
  /* 1131 */  vecY_rule,
  /* 1132 */  _LoadVector_memory__rule,
  /* 1133 */  vecX_rule,
  /* 1134 */  vecX_rule,
  /* 1135 */  _LoadVector_memory__rule,
  /* 1136 */  vecY_rule,
  /* 1137 */  _LoadVector_memory__rule,
  /* 1138 */  vecS_rule,
  /* 1139 */  immI8_rule,
  /* 1140 */  vecS_rule,
  /* 1141 */  immI8_rule,
  /* 1142 */  vecS_rule,
  /* 1143 */  immI8_rule,
  /* 1144 */  vecS_rule,
  /* 1145 */  immI8_rule,
  /* 1146 */  vecS_rule,
  /* 1147 */  immI8_rule,
  /* 1148 */  vecS_rule,
  /* 1149 */  immI8_rule,
  /* 1150 */  vecS_rule,
  /* 1151 */  immI8_rule,
  /* 1152 */  vecS_rule,
  /* 1153 */  immI8_rule,
  /* 1154 */  vecS_rule,
  /* 1155 */  immI8_rule,
  /* 1156 */  vecS_rule,
  /* 1157 */  immI8_rule,
  /* 1158 */  vecS_rule,
  /* 1159 */  immI8_rule,
  /* 1160 */  vecS_rule,
  /* 1161 */  immI8_rule,
  /* 1162 */  vecS_rule,
  /* 1163 */  immI8_rule,
  /* 1164 */  vecS_rule,
  /* 1165 */  immI8_rule,
  /* 1166 */  vecS_rule,
  /* 1167 */  immI8_rule,
  /* 1168 */  vecS_rule,
  /* 1169 */  immI8_rule,
  /* 1170 */  vecS_rule,
  /* 1171 */  immI8_rule,
  /* 1172 */  vecS_rule,
  /* 1173 */  immI8_rule,
  /* 1174 */  vecS_rule,
  /* 1175 */  immI8_rule,
  /* 1176 */  vecS_rule,
  /* 1177 */  immI8_rule,
  /* 1178 */  vecS_rule,
  /* 1179 */  immI8_rule,
  /* 1180 */  vecS_rule,
  /* 1181 */  immI8_rule,
  /* 1182 */  vecS_rule,
  /* 1183 */  immI8_rule,
  /* 1184 */  vecS_rule,
  /* 1185 */  immI8_rule,
  /* 1186 */  vecS_rule,
  /* 1187 */  immI8_rule,
  /* 1188 */  vecS_rule,
  /* 1189 */  immI8_rule,
  /* 1190 */  vecS_rule,
  /* 1191 */  immI8_rule,
  /* 1192 */  vecS_rule,
  /* 1193 */  immI8_rule,
  /* 1194 */  vecS_rule,
  /* 1195 */  immI8_rule,
  /* 1196 */  vecS_rule,
  /* 1197 */  immI8_rule,
  /* 1198 */  vecS_rule,
  /* 1199 */  immI8_rule,
  /* 1200 */  vecS_rule,
  /* 1201 */  immI8_rule,
  /* 1202 */  vecS_rule,
  /* 1203 */  immI8_rule,
  /* 1204 */  vecS_rule,
  /* 1205 */  immI8_rule,
  /* 1206 */  vecS_rule,
  /* 1207 */  immI8_rule,
  /* 1208 */  vecS_rule,
  /* 1209 */  immI8_rule,
  /* 1210 */  vecS_rule,
  /* 1211 */  immI8_rule,
  /* 1212 */  vecS_rule,
  /* 1213 */  immI8_rule,
  /* 1214 */  vecS_rule,
  /* 1215 */  immI8_rule,
  /* 1216 */  vecS_rule,
  /* 1217 */  immI8_rule,
  /* 1218 */  vecS_rule,
  /* 1219 */  immI8_rule,
  /* 1220 */  vecS_rule,
  /* 1221 */  immI8_rule,
  /* 1222 */  vecS_rule,
  /* 1223 */  vecS_rule,
  /* 1224 */  vecD_rule,
  /* 1225 */  vecD_rule,
  /* 1226 */  vecX_rule,
  /* 1227 */  vecX_rule,
  /* 1228 */  _LoadVector_memory__rule,
  /* 1229 */  vecY_rule,
  /* 1230 */  _LoadVector_memory__rule,
  /* 1231 */  vecS_rule,
  /* 1232 */  vecS_rule,
  /* 1233 */  vecD_rule,
  /* 1234 */  vecD_rule,
  /* 1235 */  vecX_rule,
  /* 1236 */  vecX_rule,
  /* 1237 */  _LoadVector_memory__rule,
  /* 1238 */  vecY_rule,
  /* 1239 */  _LoadVector_memory__rule,
  /* 1240 */  vecS_rule,
  /* 1241 */  vecS_rule,
  /* 1242 */  vecD_rule,
  /* 1243 */  vecD_rule,
  /* 1244 */  vecX_rule,
  /* 1245 */  vecX_rule,
  /* 1246 */  _LoadVector_memory__rule,
  /* 1247 */  vecY_rule,
  /* 1248 */  _LoadVector_memory__rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMI",
  /*    9 */  "IMMI0",
  /*   10 */  "IMMI1",
  /*   11 */  "IMMI_M1",
  /*   12 */  "IMMI2",
  /*   13 */  "IMMI8",
  /*   14 */  "IMMI16",
  /*   15 */  "IMMU31",
  /*   16 */  "IMMI_32",
  /*   17 */  "IMMI_1_31",
  /*   18 */  "IMMI_32_63",
  /*   19 */  "IMMI_1",
  /*   20 */  "IMMI_2",
  /*   21 */  "IMMI_3",
  /*   22 */  "IMMP",
  /*   23 */  "IMMP0",
  /*   24 */  "IMML",
  /*   25 */  "IMML0",
  /*   26 */  "IMML_M1",
  /*   27 */  "IMML_127",
  /*   28 */  "IMML_32BITS",
  /*   29 */  "IMML32",
  /*   30 */  "IMMDPR0",
  /*   31 */  "IMMDPR1",
  /*   32 */  "IMMDPR",
  /*   33 */  "IMMD",
  /*   34 */  "IMMD0",
  /*   35 */  "IMMFPR0",
  /*   36 */  "IMMFPR1",
  /*   37 */  "IMMFPR",
  /*   38 */  "IMMF",
  /*   39 */  "IMMF0",
  /*   40 */  "IMMI_16",
  /*   41 */  "IMMI_24",
  /*   42 */  "IMMI_255",
  /*   43 */  "IMMI_65535",
  /*   44 */  "RREGI",
  /*   45 */  "XREGI",
  /*   46 */  "EAXREGI",
  /*   47 */  "EBXREGI",
  /*   48 */  "ECXREGI",
  /*   49 */  "EDXREGI",
  /*   50 */  "EDIREGI",
  /*   51 */  "NAXREGI",
  /*   52 */  "NADXREGI",
  /*   53 */  "NCXREGI",
  /*   54 */  "ESIREGI",
  /*   55 */  "ANYREGP",
  /*   56 */  "EREGP",
  /*   57 */  "EREGP_NO_EBP",
  /*   58 */  "NAXREGP",
  /*   59 */  "NABXREGP",
  /*   60 */  "PREGP",
  /*   61 */  "EAXREGP",
  /*   62 */  "EBXREGP",
  /*   63 */  "ECXREGP",
  /*   64 */  "ESIREGP",
  /*   65 */  "EDIREGP",
  /*   66 */  "EBPREGP",
  /*   67 */  "EREGL",
  /*   68 */  "EADXREGL",
  /*   69 */  "EBCXREGL",
  /*   70 */  "EADXREGL_LOW_ONLY",
  /*   71 */  "EFLAGSREG",
  /*   72 */  "EFLAGSREGU",
  /*   73 */  "EFLAGSREGUCF",
  /*   74 */  "FLAGSREG_LONG_LTGE",
  /*   75 */  "FLAGSREG_LONG_EQNE",
  /*   76 */  "FLAGSREG_LONG_LEGT",
  /*   77 */  "REGDPR",
  /*   78 */  "REGDPR1",
  /*   79 */  "REGDPR2",
  /*   80 */  "REGNOTDPR1",
  /*   81 */  "REGFPR",
  /*   82 */  "REGFPR1",
  /*   83 */  "REGF",
  /*   84 */  "REGD",
  /*   85 */  "DIRECT",
  /*   86 */  "INDIRECT",
  /*   87 */  "INDOFFSET8",
  /*   88 */  "INDOFFSET32",
  /*   89 */  "INDOFFSET32X",
  /*   90 */  "INDINDEXOFFSET",
  /*   91 */  "INDINDEX",
  /*   92 */  "INDINDEXSCALE",
  /*   93 */  "INDINDEXSCALEOFFSET",
  /*   94 */  "LOAD_LONG_REGP",
  /*   95 */  "LOAD_LONG_INDIRECT",
  /*   96 */  "LOAD_LONG_INDOFFSET32",
  /*   97 */  "STACKSLOTP",
  /*   98 */  "STACKSLOTI",
  /*   99 */  "STACKSLOTF",
  /*  100 */  "STACKSLOTD",
  /*  101 */  "STACKSLOTL",
  /*  102 */  "INDIRECT_WIN95_SAFE",
  /*  103 */  "INDOFFSET8_WIN95_SAFE",
  /*  104 */  "INDOFFSET32_WIN95_SAFE",
  /*  105 */  "INDINDEXOFFSET_WIN95_SAFE",
  /*  106 */  "INDINDEXSCALE_WIN95_SAFE",
  /*  107 */  "INDINDEXSCALEOFFSET_WIN95_SAFE",
  /*  108 */  "CMPOP",
  /*  109 */  "CMPOPU",
  /*  110 */  "CMPOPUCF",
  /*  111 */  "CMPOPUCF2",
  /*  112 */  "CMPOP_FCMOV",
  /*  113 */  "CMPOP_COMMUTE",
  /*  114 */  "VECS",
  /*  115 */  "VECD",
  /*  116 */  "VECX",
  /*  117 */  "VECY",
  // last operand
  /*  118 */  "LOAD_LONG_MEMORY",
  /*  119 */  "MEMORY",
  /*  120 */  "LONG_MEMORY",
  // last operand class
  /*  121 */  "_AddP_eRegP_rRegI",
  /*  122 */  "_LShiftI_rRegI_immI2",
  /*  123 */  "_AddP_eRegP__LShiftI_rRegI_immI2",
  /*  124 */  "_AddP_eRegP_no_EBP_rRegI",
  /*  125 */  "_AddP_eRegP_no_EBP__LShiftI_rRegI_immI2",
  /*  126 */  "_LoadI_memory_",
  /*  127 */  "_LoadL_memory_",
  /*  128 */  "_LoadB_memory_",
  /*  129 */  "_LoadUB_memory_",
  /*  130 */  "_AndI__LoadUB_memory__immI8",
  /*  131 */  "_LoadS_memory_",
  /*  132 */  "_LShiftI__LoadS_memory__immI_24",
  /*  133 */  "_LoadUS_memory_",
  /*  134 */  "_LShiftI__LoadUS_memory__immI_24",
  /*  135 */  "_AndI__LoadUS_memory__immI_255",
  /*  136 */  "_AndI__LoadUS_memory__immI16",
  /*  137 */  "_LShiftI__LoadI_memory__immI_24",
  /*  138 */  "_LShiftI__LoadI_memory__immI_16",
  /*  139 */  "_AndI__LoadI_memory__immI_255",
  /*  140 */  "_AndI__LoadI_memory__immI_65535",
  /*  141 */  "_AndI__LoadI_memory__immU31",
  /*  142 */  "_ConvI2L__LoadI_memory__",
  /*  143 */  "_ConvL2I_eRegL_",
  /*  144 */  "_RoundDouble_regDPR1_",
  /*  145 */  "_RoundFloat_regFPR1_",
  /*  146 */  "_ConvD2F_regDPR1_",
  /*  147 */  "_Binary_cmpOp_eFlagsReg",
  /*  148 */  "_Binary_rRegI_rRegI",
  /*  149 */  "_Binary_cmpOpU_eFlagsRegU",
  /*  150 */  "_Binary_cmpOpUCF_eFlagsRegUCF",
  /*  151 */  "_Binary_rRegI__LoadI_memory_",
  /*  152 */  "_Binary_eRegP_eRegP",
  /*  153 */  "_Binary_cmpOp_fcmov_eFlagsRegU",
  /*  154 */  "_Binary_regDPR1_regDPR",
  /*  155 */  "_Binary_regFPR1_regFPR",
  /*  156 */  "_Binary_regDPR_regDPR",
  /*  157 */  "_Binary_regFPR_regFPR",
  /*  158 */  "_Binary_regF_regF",
  /*  159 */  "_Binary_regD_regD",
  /*  160 */  "_Binary_eRegL_eRegL",
  /*  161 */  "_AddI__LoadI_memory__rRegI",
  /*  162 */  "_AddI_rRegI__LoadI_memory_",
  /*  163 */  "_AddI__LoadI_memory__immI",
  /*  164 */  "_AddI__LoadI_memory__immI1",
  /*  165 */  "_AddI__LoadI_memory__immI_M1",
  /*  166 */  "_Binary_eAXRegP_eRegP",
  /*  167 */  "_Binary_eAXRegI_rRegI",
  /*  168 */  "_Binary_eADXRegL_eBCXRegL",
  /*  169 */  "_Binary_eAXRegP_eCXRegP",
  /*  170 */  "_Binary_eAXRegI_eCXRegI",
  /*  171 */  "_SubI__LoadI_memory__rRegI",
  /*  172 */  "_SubI_immI0_rRegI",
  /*  173 */  "_ConvI2L_nadxRegI_",
  /*  174 */  "_MulL__ConvI2L_nadxRegI__eADXRegL_low_only",
  /*  175 */  "_RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32",
  /*  176 */  "_MulL_eADXRegL_low_only__ConvI2L_nadxRegI_",
  /*  177 */  "_RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32",
  /*  178 */  "_RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63",
  /*  179 */  "_RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63",
  /*  180 */  "_ConvI2L_eAXRegI_",
  /*  181 */  "_AndL__ConvI2L_eAXRegI__immL_32bits",
  /*  182 */  "_AndL__ConvI2L_nadxRegI__immL_32bits",
  /*  183 */  "_RShiftI__LoadI_memory__immI1",
  /*  184 */  "_RShiftI__LoadI_memory__immI8",
  /*  185 */  "_LShiftI_xRegI_immI_24",
  /*  186 */  "_LShiftI_xRegI_immI_16",
  /*  187 */  "_AndI__LoadI_memory__rRegI",
  /*  188 */  "_AndI_rRegI__LoadI_memory_",
  /*  189 */  "_AndI__LoadI_memory__immI",
  /*  190 */  "_XorI_rRegI_immI_M1",
  /*  191 */  "_SubI_immI0__LoadI_memory_",
  /*  192 */  "_AddI_rRegI_immI_M1",
  /*  193 */  "_CastP2X_eRegP_",
  /*  194 */  "_OrI__LoadI_memory__rRegI",
  /*  195 */  "_OrI_rRegI__LoadI_memory_",
  /*  196 */  "_OrI__LoadI_memory__immI",
  /*  197 */  "_LShiftI_rRegI_immI1",
  /*  198 */  "_URShiftI_rRegI_immI_M1",
  /*  199 */  "_LShiftI_rRegI_immI8",
  /*  200 */  "_URShiftI_rRegI_immI8",
  /*  201 */  "_LShiftI_ncxRegI_eCXRegI",
  /*  202 */  "_SubI_immI0_eCXRegI",
  /*  203 */  "_URShiftI_ncxRegI__SubI_immI0_eCXRegI",
  /*  204 */  "_SubI_immI_32_eCXRegI",
  /*  205 */  "_URShiftI_ncxRegI__SubI_immI_32_eCXRegI",
  /*  206 */  "_URShiftI_rRegI_immI1",
  /*  207 */  "_LShiftI_rRegI_immI_M1",
  /*  208 */  "_URShiftI_ncxRegI_eCXRegI",
  /*  209 */  "_LShiftI_ncxRegI__SubI_immI0_eCXRegI",
  /*  210 */  "_LShiftI_ncxRegI__SubI_immI_32_eCXRegI",
  /*  211 */  "_XorI__LoadI_memory__rRegI",
  /*  212 */  "_XorI_rRegI__LoadI_memory_",
  /*  213 */  "_XorI__LoadI_memory__immI",
  /*  214 */  "_CmpLTMask_rRegI_rRegI",
  /*  215 */  "_AndI__CmpLTMask_rRegI_rRegI_rRegI",
  /*  216 */  "_SubI_rRegI_rRegI",
  /*  217 */  "_AndI_rRegI__CmpLTMask_rRegI_rRegI",
  /*  218 */  "_LoadL_load_long_memory_",
  /*  219 */  "_XorL_eRegL_immL_M1",
  /*  220 */  "_SubL_immL0_eRegL",
  /*  221 */  "_SubL_immL0__LoadL_memory_",
  /*  222 */  "_AddL_eRegL_immL_M1",
  /*  223 */  "_AddL__LoadL_memory__immL_M1",
  /*  224 */  "_LoadD_memory_",
  /*  225 */  "_SubD_regDPR_regDPR",
  /*  226 */  "_AddD_regDPR_regDPR",
  /*  227 */  "_AddD__LoadD_memory__regDPR",
  /*  228 */  "_RoundDouble__AddD__LoadD_memory__regDPR_",
  /*  229 */  "_AddD_regDPR__LoadD_memory_",
  /*  230 */  "_RoundDouble__AddD_regDPR__LoadD_memory__",
  /*  231 */  "_AddD_regDPR_immDPR",
  /*  232 */  "_MulD_regDPR_regDPR",
  /*  233 */  "_DivD_regDPR_regDPR",
  /*  234 */  "_LoadF_memory_",
  /*  235 */  "_MulF__LoadF_memory__regFPR",
  /*  236 */  "_MulF_regFPR__LoadF_memory_",
  /*  237 */  "_MulF_regFPR_regFPR",
  /*  238 */  "_SubF_regFPR_regFPR",
  /*  239 */  "_ConvI2L_rRegI_",
  /*  240 */  "_Binary_eDIRegP_eCXRegI",
  /*  241 */  "_Binary_eSIRegP_eDXRegI",
  /*  242 */  "_Binary_eDIRegP_eSIRegP",
  /*  243 */  "_Binary_eDIRegP_eDXRegI",
  /*  244 */  "_Binary_eSIRegP_immI",
  /*  245 */  "_Binary_eSIRegP_eAXRegI",
  /*  246 */  "_AndI_rRegI_immI",
  /*  247 */  "_AndI_rRegI_memory",
  /*  248 */  "_LoadP_memory_",
  /*  249 */  "_Binary_nadxRegI_eAXRegI",
  /*  250 */  "_PartialSubtypeCheck_eSIRegP_eAXRegP",
  /*  251 */  "_Binary_cmpOp_flagsReg_long_LTGE",
  /*  252 */  "_Binary_eRegL__LoadL_load_long_memory_",
  /*  253 */  "_Binary_cmpOp_flagsReg_long_EQNE",
  /*  254 */  "_Binary_cmpOp_commute_flagsReg_long_LEGT",
  /*  255 */  "_ConvF2D_regF_",
  /*  256 */  "_SqrtD__ConvF2D_regF__",
  /*  257 */  "_ConvF2D__LoadF_memory__",
  /*  258 */  "_SqrtD__ConvF2D__LoadF_memory___",
  /*  259 */  "_ConvF2D_immF_",
  /*  260 */  "_SqrtD__ConvF2D_immF__",
  /*  261 */  "_LoadVector_memory_",
  // last internally defined operand
  /*  262 */  "storeSSI",
  /*  263 */  "storeSSP",
  /*  264 */  "storeSSL",
  /*  265 */  "leaP8",
  /*  266 */  "leaP32",
  /*  267 */  "leaPIdxOff",
  /*  268 */  "leaPIdxScale",
  /*  269 */  "leaPIdxScaleOff",
  /*  270 */  "loadConI",
  /*  271 */  "loadConI0",
  /*  272 */  "loadConP",
  /*  273 */  "loadConL",
  /*  274 */  "loadConL0",
  /*  275 */  "loadConFPR",
  /*  276 */  "loadConFPR0",
  /*  277 */  "loadConFPR1",
  /*  278 */  "loadConF",
  /*  279 */  "loadConF0",
  /*  280 */  "loadConDPR",
  /*  281 */  "loadConDPR0",
  /*  282 */  "loadConDPR1",
  /*  283 */  "loadConD",
  /*  284 */  "loadConD0",
  /*  285 */  "loadSSI",
  /*  286 */  "loadSSL",
  /*  287 */  "loadSSP",
  /*  288 */  "loadSSF",
  /*  289 */  "loadSSD",
  /*  290 */  "loadConL_low_only",
  /*  291 */  "membar_volatile",
  /*  292 */  "castX2P",
  /*  293 */  "castP2X",
  /*  294 */  "checkCastPP",
  /*  295 */  "castPP",
  /*  296 */  "castII",
  /*  297 */  "storePConditional",
  /*  298 */  "storeIConditional",
  /*  299 */  "storeLConditional",
  /*  300 */  "movI_nocopy",
  /*  301 */  "movP_nocopy",
  /*  302 */  "overflowAddI_eReg",
  /*  303 */  "overflowAddI_rReg_imm",
  /*  304 */  "overflowSubI_rReg",
  /*  305 */  "overflowSubI_rReg_imm",
  /*  306 */  "overflowNegI_rReg",
  /*  307 */  "overflowMulI_rReg",
  /*  308 */  "overflowMulI_rReg_imm",
  /*  309 */  "cmpDPR_cc_P6",
  /*  310 */  "cmpDPR_cc_P6CF",
  /*  311 */  "cmpDPR_cc",
  /*  312 */  "cmpD_cc",
  /*  313 */  "cmpD_ccCF",
  /*  314 */  "cmpD_ccmem",
  /*  315 */  "cmpD_ccmemCF",
  /*  316 */  "absDPR_reg",
  /*  317 */  "negDPR_reg",
  /*  318 */  "cmpFPR_cc_P6",
  /*  319 */  "cmpFPR_cc_P6CF",
  /*  320 */  "cmpFPR_cc",
  /*  321 */  "cmpF_cc",
  /*  322 */  "cmpF_ccCF",
  /*  323 */  "cmpF_ccmem",
  /*  324 */  "cmpF_ccmemCF",
  /*  325 */  "absFPR_reg",
  /*  326 */  "negFPR_reg",
  /*  327 */  "MoveF2I_stack_reg",
  /*  328 */  "MoveF2I_reg_reg_sse",
  /*  329 */  "MoveI2FPR_stack_reg",
  /*  330 */  "MoveI2F_stack_reg_sse",
  /*  331 */  "MoveI2F_reg_reg_sse",
  /*  332 */  "MoveD2L_stack_reg",
  /*  333 */  "MoveL2DPR_stack_reg",
  /*  334 */  "MoveL2D_stack_reg_sse",
  /*  335 */  "MoveL2D_stack_reg_sse_partial",
  /*  336 */  "compI_eReg",
  /*  337 */  "compI_eReg_imm",
  /*  338 */  "compI_eReg_mem",
  /*  339 */  "testI_reg",
  /*  340 */  "testI_reg_imm",
  /*  341 */  "testI_reg_mem",
  /*  342 */  "compU_eReg",
  /*  343 */  "compU_eReg_imm",
  /*  344 */  "compU_eReg_mem",
  /*  345 */  "testU_reg",
  /*  346 */  "compP_eReg",
  /*  347 */  "compP_eReg_imm",
  /*  348 */  "compP_eReg_mem",
  /*  349 */  "compP_mem_eReg",
  /*  350 */  "testP_reg",
  /*  351 */  "testP_Reg_mem",
  /*  352 */  "partialSubtypeCheck_vs_Zero",
  /*  353 */  "cmpL_zero_flags_LTGE",
  /*  354 */  "cmpL_reg_flags_LTGE",
  /*  355 */  "cmpL_zero_flags_EQNE",
  /*  356 */  "cmpL_reg_flags_EQNE",
  /*  357 */  "cmpL_zero_flags_LEGT",
  /*  358 */  "cmpL_reg_flags_LEGT",
  /*  359 */  "cmpFastLockRTM",
  /*  360 */  "cmpFastLock",
  /*  361 */  "cmpFastUnlock",
  /*  362 */  "safePoint_poll",
  /*  363 */  "absF_reg",
  /*  364 */  "absF_reg_reg",
  /*  365 */  "absD_reg",
  /*  366 */  "absD_reg_reg",
  /*  367 */  "negF_reg",
  /*  368 */  "negF_reg_reg",
  /*  369 */  "negD_reg",
  /*  370 */  "negD_reg_reg",
  /*  371 */  "vshiftcnt",
  /*  372 */  "vshiftcnt_0",
  /*  373 */  "bytes_reverse_int",
  /*  374 */  "bytes_reverse_long",
  /*  375 */  "bytes_reverse_unsigned_short",
  /*  376 */  "bytes_reverse_short",
  /*  377 */  "countLeadingZerosI",
  /*  378 */  "countLeadingZerosI_bsr",
  /*  379 */  "countLeadingZerosL",
  /*  380 */  "countLeadingZerosL_bsr",
  /*  381 */  "countTrailingZerosI",
  /*  382 */  "countTrailingZerosI_bsf",
  /*  383 */  "countTrailingZerosL",
  /*  384 */  "countTrailingZerosL_bsf",
  /*  385 */  "popCountI",
  /*  386 */  "popCountI_mem",
  /*  387 */  "popCountL",
  /*  388 */  "popCountL_mem",
  /*  389 */  "loadB",
  /*  390 */  "loadB2L",
  /*  391 */  "loadUB",
  /*  392 */  "loadUB2L",
  /*  393 */  "loadUB2L_immI8",
  /*  394 */  "loadS",
  /*  395 */  "loadS2B",
  /*  396 */  "loadS2L",
  /*  397 */  "loadUS",
  /*  398 */  "loadUS2B",
  /*  399 */  "loadUS2L",
  /*  400 */  "loadUS2L_immI_255",
  /*  401 */  "loadUS2L_immI16",
  /*  402 */  "loadI",
  /*  403 */  "loadI2B",
  /*  404 */  "loadI2UB",
  /*  405 */  "loadI2S",
  /*  406 */  "loadI2US",
  /*  407 */  "loadI2L",
  /*  408 */  "loadI2L_immI_255",
  /*  409 */  "loadI2L_immI_65535",
  /*  410 */  "loadI2L_immU31",
  /*  411 */  "loadUI2L",
  /*  412 */  "loadL",
  /*  413 */  "loadL_volatile",
  /*  414 */  "loadLX_volatile",
  /*  415 */  "loadLX_reg_volatile",
  /*  416 */  "loadRange",
  /*  417 */  "loadP",
  /*  418 */  "loadKlass",
  /*  419 */  "loadDPR",
  /*  420 */  "loadD",
  /*  421 */  "loadD_partial",
  /*  422 */  "loadF",
  /*  423 */  "loadFPR",
  /*  424 */  "prefetchr0",
  /*  425 */  "prefetchr",
  /*  426 */  "prefetchrNTA",
  /*  427 */  "prefetchrT0",
  /*  428 */  "prefetchrT2",
  /*  429 */  "prefetchw0",
  /*  430 */  "prefetchw",
  /*  431 */  "prefetchwNTA",
  /*  432 */  "prefetchAlloc0",
  /*  433 */  "prefetchAlloc",
  /*  434 */  "prefetchAllocNTA",
  /*  435 */  "prefetchAllocT0",
  /*  436 */  "prefetchAllocT2",
  /*  437 */  "storeB",
  /*  438 */  "storeC",
  /*  439 */  "storeI",
  /*  440 */  "storeL",
  /*  441 */  "storeL2I",
  /*  442 */  "storeL_volatile",
  /*  443 */  "storeLX_volatile",
  /*  444 */  "storeLX_reg_volatile",
  /*  445 */  "storeP",
  /*  446 */  "storeImmI",
  /*  447 */  "storeImmI16",
  /*  448 */  "storeImmP",
  /*  449 */  "storeImmB",
  /*  450 */  "storeImmCM",
  /*  451 */  "storeDPR",
  /*  452 */  "storeDPR_rounded",
  /*  453 */  "storeD",
  /*  454 */  "storeF",
  /*  455 */  "storeFPR",
  /*  456 */  "storeFPR_rounded",
  /*  457 */  "storeFPR_Drounded",
  /*  458 */  "storeFPR_imm",
  /*  459 */  "storeF_imm",
  /*  460 */  "membar_acquire",
  /*  461 */  "membar_acquire_0",
  /*  462 */  "membar_acquire_lock",
  /*  463 */  "membar_release",
  /*  464 */  "membar_release_0",
  /*  465 */  "membar_release_lock",
  /*  466 */  "unnecessary_membar_volatile",
  /*  467 */  "membar_storestore",
  /*  468 */  "jmovI_reg",
  /*  469 */  "jmovI_regU",
  /*  470 */  "cmovI_reg",
  /*  471 */  "cmovI_regU",
  /*  472 */  "cmovI_regUCF",
  /*  473 */  "cmovI_mem",
  /*  474 */  "cmovI_memU",
  /*  475 */  "cmovI_memUCF",
  /*  476 */  "cmovP_reg",
  /*  477 */  "cmovP_reg_nonP6",
  /*  478 */  "cmovP_regU",
  /*  479 */  "cmovP_regUCF",
  /*  480 */  "fcmovDPR_regU",
  /*  481 */  "fcmovFPR_regU",
  /*  482 */  "fcmovDPR_regS",
  /*  483 */  "fcmovFPR_regS",
  /*  484 */  "fcmovF_regS",
  /*  485 */  "fcmovD_regS",
  /*  486 */  "fcmovF_regU",
  /*  487 */  "fcmovF_regUCF",
  /*  488 */  "fcmovD_regU",
  /*  489 */  "fcmovD_regUCF",
  /*  490 */  "cmovL_reg",
  /*  491 */  "cmovL_regU",
  /*  492 */  "cmovL_regUCF",
  /*  493 */  "addI_eReg",
  /*  494 */  "addI_eReg_imm",
  /*  495 */  "incI_eReg",
  /*  496 */  "leaI_eReg_immI",
  /*  497 */  "leaP_eReg_immI",
  /*  498 */  "decI_eReg",
  /*  499 */  "addP_eReg",
  /*  500 */  "addP_eReg_imm",
  /*  501 */  "addI_eReg_mem",
  /*  502 */  "addI_eReg_mem_0",
  /*  503 */  "addI_mem_eReg",
  /*  504 */  "addI_mem_eReg_0",
  /*  505 */  "addI_mem_imm",
  /*  506 */  "incI_mem",
  /*  507 */  "decI_mem",
  /*  508 */  "loadPLocked",
  /*  509 */  "compareAndSwapL",
  /*  510 */  "compareAndSwapP",
  /*  511 */  "compareAndSwapI",
  /*  512 */  "xaddI_no_res",
  /*  513 */  "xaddI",
  /*  514 */  "xchgI",
  /*  515 */  "xchgP",
  /*  516 */  "subI_eReg",
  /*  517 */  "subI_eReg_imm",
  /*  518 */  "subI_eReg_mem",
  /*  519 */  "subI_mem_eReg",
  /*  520 */  "subP_eReg",
  /*  521 */  "negI_eReg",
  /*  522 */  "mulI_eReg",
  /*  523 */  "mulI_eReg_imm",
  /*  524 */  "mulI_imm_high",
  /*  525 */  "mulI_imm_high_0",
  /*  526 */  "mulI_imm_RShift_high",
  /*  527 */  "mulI_imm_RShift_high_0",
  /*  528 */  "mulI_mem_imm",
  /*  529 */  "mulI",
  /*  530 */  "mulI_0",
  /*  531 */  "mulI2L",
  /*  532 */  "mulI2L_0",
  /*  533 */  "mulIS_eReg",
  /*  534 */  "mulIS_eReg_0",
  /*  535 */  "mulL_eReg",
  /*  536 */  "mulL_eReg_lhi0",
  /*  537 */  "mulL_eReg_rhi0",
  /*  538 */  "mulL_eReg_hi0",
  /*  539 */  "mulL_eReg_con",
  /*  540 */  "divI_eReg",
  /*  541 */  "divL_eReg",
  /*  542 */  "divModI_eReg_divmod",
  /*  543 */  "modI_eReg",
  /*  544 */  "modL_eReg",
  /*  545 */  "divL_eReg_imm32",
  /*  546 */  "modL_eReg_imm32",
  /*  547 */  "shlI_eReg_1",
  /*  548 */  "salI_eReg_imm",
  /*  549 */  "salI_eReg_CL",
  /*  550 */  "sarI_eReg_1",
  /*  551 */  "sarI_mem_1",
  /*  552 */  "sarI_eReg_imm",
  /*  553 */  "sarI_mem_imm",
  /*  554 */  "sarI_eReg_CL",
  /*  555 */  "shrI_eReg_1",
  /*  556 */  "shrI_eReg_imm",
  /*  557 */  "i2b",
  /*  558 */  "i2s",
  /*  559 */  "shrI_eReg_CL",
  /*  560 */  "andI_eReg",
  /*  561 */  "andI_eReg_imm",
  /*  562 */  "andI_eReg_mem",
  /*  563 */  "andI_eReg_mem_0",
  /*  564 */  "andI_mem_eReg",
  /*  565 */  "andI_mem_eReg_0",
  /*  566 */  "andI_mem_imm",
  /*  567 */  "andnI_rReg_rReg_rReg",
  /*  568 */  "andnI_rReg_rReg_rReg_0",
  /*  569 */  "andnI_rReg_rReg_mem",
  /*  570 */  "andnI_rReg_rReg_mem_0",
  /*  571 */  "blsiI_rReg_rReg",
  /*  572 */  "blsiI_rReg_rReg_0",
  /*  573 */  "blsiI_rReg_mem",
  /*  574 */  "blsiI_rReg_mem_0",
  /*  575 */  "blsmskI_rReg_rReg",
  /*  576 */  "blsmskI_rReg_rReg_0",
  /*  577 */  "blsmskI_rReg_mem",
  /*  578 */  "blsmskI_rReg_mem_0",
  /*  579 */  "blsrI_rReg_rReg",
  /*  580 */  "blsrI_rReg_rReg_0",
  /*  581 */  "blsrI_rReg_mem",
  /*  582 */  "blsrI_rReg_mem_0",
  /*  583 */  "orI_eReg",
  /*  584 */  "orI_eReg_castP2X",
  /*  585 */  "orI_eReg_castP2X_0",
  /*  586 */  "orI_eReg_imm",
  /*  587 */  "orI_eReg_mem",
  /*  588 */  "orI_eReg_mem_0",
  /*  589 */  "orI_mem_eReg",
  /*  590 */  "orI_mem_eReg_0",
  /*  591 */  "orI_mem_imm",
  /*  592 */  "rolI_eReg_imm1",
  /*  593 */  "rolI_eReg_imm8",
  /*  594 */  "rolI_eReg_CL",
  /*  595 */  "rolI_eReg_i1",
  /*  596 */  "rolI_eReg_i1_0",
  /*  597 */  "rolI_eReg_i8",
  /*  598 */  "rolI_eReg_i8_0",
  /*  599 */  "rolI_eReg_Var_C0",
  /*  600 */  "rolI_eReg_Var_C0_0",
  /*  601 */  "rolI_eReg_Var_C32",
  /*  602 */  "rolI_eReg_Var_C32_0",
  /*  603 */  "rorI_eReg_imm1",
  /*  604 */  "rorI_eReg_imm8",
  /*  605 */  "rorI_eReg_CL",
  /*  606 */  "rorI_eReg_i1",
  /*  607 */  "rorI_eReg_i1_0",
  /*  608 */  "rorI_eReg_i8",
  /*  609 */  "rorI_eReg_i8_0",
  /*  610 */  "rorI_eReg_Var_C0",
  /*  611 */  "rorI_eReg_Var_C0_0",
  /*  612 */  "rorI_eReg_Var_C32",
  /*  613 */  "rorI_eReg_Var_C32_0",
  /*  614 */  "xorI_eReg",
  /*  615 */  "xorI_eReg_im1",
  /*  616 */  "xorI_eReg_imm",
  /*  617 */  "xorI_eReg_mem",
  /*  618 */  "xorI_eReg_mem_0",
  /*  619 */  "xorI_mem_eReg",
  /*  620 */  "xorI_mem_eReg_0",
  /*  621 */  "xorI_mem_imm",
  /*  622 */  "ci2b",
  /*  623 */  "convI2B",
  /*  624 */  "cp2b",
  /*  625 */  "convP2B",
  /*  626 */  "cmpLTMask",
  /*  627 */  "cmpLTMask0",
  /*  628 */  "cadd_cmpLTMask",
  /*  629 */  "cadd_cmpLTMask_1",
  /*  630 */  "cadd_cmpLTMask_0",
  /*  631 */  "cadd_cmpLTMask_2",
  /*  632 */  "and_cmpLTMask",
  /*  633 */  "and_cmpLTMask_0",
  /*  634 */  "addL_eReg",
  /*  635 */  "addL_eReg_imm",
  /*  636 */  "addL_eReg_mem",
  /*  637 */  "addL_eReg_mem_0",
  /*  638 */  "subL_eReg",
  /*  639 */  "subL_eReg_imm",
  /*  640 */  "subL_eReg_mem",
  /*  641 */  "negL_eReg",
  /*  642 */  "andL_eReg",
  /*  643 */  "andL_eReg_imm",
  /*  644 */  "andL_eReg_mem",
  /*  645 */  "andL_eReg_mem_0",
  /*  646 */  "andnL_eReg_eReg_eReg",
  /*  647 */  "andnL_eReg_eReg_eReg_0",
  /*  648 */  "andnL_eReg_eReg_mem",
  /*  649 */  "andnL_eReg_eReg_mem_0",
  /*  650 */  "blsiL_eReg_eReg",
  /*  651 */  "blsiL_eReg_eReg_0",
  /*  652 */  "blsiL_eReg_mem",
  /*  653 */  "blsiL_eReg_mem_0",
  /*  654 */  "blsmskL_eReg_eReg",
  /*  655 */  "blsmskL_eReg_eReg_0",
  /*  656 */  "blsmskL_eReg_mem",
  /*  657 */  "blsmskL_eReg_mem_0",
  /*  658 */  "blsrL_eReg_eReg",
  /*  659 */  "blsrL_eReg_eReg_0",
  /*  660 */  "blsrL_eReg_mem",
  /*  661 */  "blsrL_eReg_mem_0",
  /*  662 */  "orl_eReg",
  /*  663 */  "orl_eReg_imm",
  /*  664 */  "orl_eReg_mem",
  /*  665 */  "orl_eReg_mem_0",
  /*  666 */  "xorl_eReg",
  /*  667 */  "xorl_eReg_im1",
  /*  668 */  "xorl_eReg_imm",
  /*  669 */  "xorl_eReg_mem",
  /*  670 */  "xorl_eReg_mem_0",
  /*  671 */  "shlL_eReg_1",
  /*  672 */  "shlL_eReg_2",
  /*  673 */  "shlL_eReg_3",
  /*  674 */  "shlL_eReg_1_31",
  /*  675 */  "shlL_eReg_32_63",
  /*  676 */  "salL_eReg_CL",
  /*  677 */  "shrL_eReg_1_31",
  /*  678 */  "shrL_eReg_32_63",
  /*  679 */  "shrL_eReg_CL",
  /*  680 */  "sarL_eReg_1_31",
  /*  681 */  "sarL_eReg_32_63",
  /*  682 */  "sarL_eReg_CL",
  /*  683 */  "cmpDPR_0",
  /*  684 */  "cmpDPR_reg",
  /*  685 */  "cmpD_reg",
  /*  686 */  "cmpD_regmem",
  /*  687 */  "subDPR_reg",
  /*  688 */  "subDPR_reg_round",
  /*  689 */  "subDPR_reg_mem",
  /*  690 */  "addDPR_reg",
  /*  691 */  "addDPR_reg_round",
  /*  692 */  "addDPR_reg_mem",
  /*  693 */  "addDPR_reg_mem_0",
  /*  694 */  "addDPR_mem_reg",
  /*  695 */  "addDPR_mem_reg_0",
  /*  696 */  "addDPR_reg_imm1",
  /*  697 */  "addDPR_reg_imm",
  /*  698 */  "addDPR_reg_imm_round",
  /*  699 */  "mulDPR_reg",
  /*  700 */  "strictfp_mulDPR_reg",
  /*  701 */  "mulDPR_reg_imm",
  /*  702 */  "mulDPR_reg_mem",
  /*  703 */  "mulDPR_reg_mem_0",
  /*  704 */  "mulDPR_reg_mem_cisc",
  /*  705 */  "mulDPR_reg_mem_cisc_0",
  /*  706 */  "addDPR_mulDPR_reg",
  /*  707 */  "addDPR_mulDPR_reg_0",
  /*  708 */  "subDPR_mulDPR_reg",
  /*  709 */  "divDPR_reg",
  /*  710 */  "strictfp_divDPR_reg",
  /*  711 */  "divDPR_reg_round",
  /*  712 */  "modDPR_reg",
  /*  713 */  "modD_reg",
  /*  714 */  "sinDPR_reg",
  /*  715 */  "sinD_reg",
  /*  716 */  "cosDPR_reg",
  /*  717 */  "cosD_reg",
  /*  718 */  "tanDPR_reg",
  /*  719 */  "tanD_reg",
  /*  720 */  "atanDPR_reg",
  /*  721 */  "atanD_reg",
  /*  722 */  "sqrtDPR_reg",
  /*  723 */  "powDPR_reg",
  /*  724 */  "powD_reg",
  /*  725 */  "expDPR_reg",
  /*  726 */  "expD_reg",
  /*  727 */  "log10DPR_reg",
  /*  728 */  "log10D_reg",
  /*  729 */  "logDPR_reg",
  /*  730 */  "logD_reg",
  /*  731 */  "cmpFPR_0",
  /*  732 */  "cmpFPR_reg",
  /*  733 */  "cmpF_reg",
  /*  734 */  "cmpF_regmem",
  /*  735 */  "subFPR24_reg",
  /*  736 */  "subFPR_reg",
  /*  737 */  "addFPR24_reg",
  /*  738 */  "addFPR_reg",
  /*  739 */  "addFPR24_reg_mem",
  /*  740 */  "addFPR24_reg_mem_0",
  /*  741 */  "addFPR_reg_mem",
  /*  742 */  "addFPR_reg_mem_0",
  /*  743 */  "addFPR24_mem_reg",
  /*  744 */  "addFPR24_mem_cisc",
  /*  745 */  "addFPR24_mem_cisc_0",
  /*  746 */  "addFPR24_mem_mem",
  /*  747 */  "addFPR24_reg_imm",
  /*  748 */  "addFPR_reg_imm",
  /*  749 */  "mulFPR24_reg",
  /*  750 */  "mulFPR_reg",
  /*  751 */  "mulFPR24_reg_mem",
  /*  752 */  "mulFPR24_reg_mem_0",
  /*  753 */  "mulFPR_reg_mem",
  /*  754 */  "mulFPR_reg_mem_0",
  /*  755 */  "mulFPR24_mem_mem",
  /*  756 */  "mulFPR24_reg_imm",
  /*  757 */  "mulFPR_reg_imm",
  /*  758 */  "mulFPR_reg_load1",
  /*  759 */  "mulFPR_reg_load1_0",
  /*  760 */  "addFPR_mulFPR_reg_load1",
  /*  761 */  "addFPR_mulFPR_reg_load1_1",
  /*  762 */  "addFPR_mulFPR_reg_load1_0",
  /*  763 */  "addFPR_mulFPR_reg_load1_2",
  /*  764 */  "addFPR_mulFPR_reg",
  /*  765 */  "addFPR_mulFPR_reg_0",
  /*  766 */  "subFPR_divFPR_reg",
  /*  767 */  "divFPR24_reg",
  /*  768 */  "divFPR_reg",
  /*  769 */  "modFPR24_reg",
  /*  770 */  "modFPR_reg",
  /*  771 */  "modF_reg",
  /*  772 */  "roundFloat_mem_reg",
  /*  773 */  "roundDouble_mem_reg",
  /*  774 */  "convDPR2FPR_reg",
  /*  775 */  "convDPR2F_reg",
  /*  776 */  "convD2F_reg",
  /*  777 */  "convFPR2DPR_reg_reg",
  /*  778 */  "convFPR2D_reg",
  /*  779 */  "convF2DPR_reg",
  /*  780 */  "convF2D_reg",
  /*  781 */  "convDPR2I_reg_reg",
  /*  782 */  "convD2I_reg_reg",
  /*  783 */  "convDPR2L_reg_reg",
  /*  784 */  "convD2L_reg_reg",
  /*  785 */  "convFPR2I_reg_reg",
  /*  786 */  "convF2I_reg",
  /*  787 */  "convFPR2L_reg_reg",
  /*  788 */  "convF2L_reg_reg",
  /*  789 */  "convI2DPR_reg",
  /*  790 */  "convI2D_reg",
  /*  791 */  "convI2D_mem",
  /*  792 */  "convXI2D_reg",
  /*  793 */  "convI2DPR_mem",
  /*  794 */  "conv24I2FPR_reg",
  /*  795 */  "convI2FPR_SSF",
  /*  796 */  "convI2FPR_SSF_mem",
  /*  797 */  "convI2FPR_reg",
  /*  798 */  "convI2FPR_mem",
  /*  799 */  "convI2F_reg",
  /*  800 */  "convXI2F_reg",
  /*  801 */  "convI2L_reg",
  /*  802 */  "convI2L_reg_zex",
  /*  803 */  "zerox_long",
  /*  804 */  "convL2DPR_reg",
  /*  805 */  "convL2D_reg",
  /*  806 */  "convL2F_reg",
  /*  807 */  "convL2FPR_reg",
  /*  808 */  "convL2I_reg",
  /*  809 */  "MoveFPR2I_reg_stack",
  /*  810 */  "MoveF2I_reg_stack_sse",
  /*  811 */  "MoveI2F_reg_stack",
  /*  812 */  "MoveDPR2L_reg_stack",
  /*  813 */  "MoveD2L_reg_stack_sse",
  /*  814 */  "MoveD2L_reg_reg_sse",
  /*  815 */  "MoveL2D_reg_stack",
  /*  816 */  "MoveL2D_reg_reg_sse",
  /*  817 */  "rep_stos",
  /*  818 */  "rep_fast_stosb",
  /*  819 */  "string_compare",
  /*  820 */  "string_equals",
  /*  821 */  "string_indexof_con",
  /*  822 */  "string_indexof",
  /*  823 */  "array_equals",
  /*  824 */  "encode_iso_array",
  /*  825 */  "minI_eReg",
  /*  826 */  "maxI_eReg",
  /*  827 */  "loopLimit_eReg",
  /*  828 */  "jumpXtnd",
  /*  829 */  "jmpDir",
  /*  830 */  "jmpCon",
  /*  831 */  "jmpLoopEnd",
  /*  832 */  "jmpLoopEndU",
  /*  833 */  "jmpLoopEndUCF",
  /*  834 */  "jmpConU",
  /*  835 */  "jmpConUCF",
  /*  836 */  "jmpConUCF2",
  /*  837 */  "partialSubtypeCheck",
  /*  838 */  "jmpDir_short",
  /*  839 */  "jmpCon_short",
  /*  840 */  "jmpLoopEnd_short",
  /*  841 */  "jmpLoopEndU_short",
  /*  842 */  "jmpLoopEndUCF_short",
  /*  843 */  "jmpConU_short",
  /*  844 */  "jmpConUCF_short",
  /*  845 */  "jmpConUCF2_short",
  /*  846 */  "cmpL3_reg_reg",
  /*  847 */  "cmpL_LTGE",
  /*  848 */  "cmovLL_reg_LTGE",
  /*  849 */  "cmovLL_mem_LTGE",
  /*  850 */  "cmovII_reg_LTGE",
  /*  851 */  "cmovII_mem_LTGE",
  /*  852 */  "cmovPP_reg_LTGE",
  /*  853 */  "cmovDDPR_reg_LTGE",
  /*  854 */  "cmovDD_reg_LTGE",
  /*  855 */  "cmovFFPR_reg_LTGE",
  /*  856 */  "cmovFF_reg_LTGE",
  /*  857 */  "cmpL_EQNE",
  /*  858 */  "cmovLL_reg_EQNE",
  /*  859 */  "cmovLL_mem_EQNE",
  /*  860 */  "cmovII_reg_EQNE",
  /*  861 */  "cmovII_mem_EQNE",
  /*  862 */  "cmovPP_reg_EQNE",
  /*  863 */  "cmovDDPR_reg_EQNE",
  /*  864 */  "cmovDD_reg_EQNE",
  /*  865 */  "cmovFFPR_reg_EQNE",
  /*  866 */  "cmovFF_reg_EQNE",
  /*  867 */  "cmpL_LEGT",
  /*  868 */  "cmovLL_reg_LEGT",
  /*  869 */  "cmovLL_mem_LEGT",
  /*  870 */  "cmovII_reg_LEGT",
  /*  871 */  "cmovII_mem_LEGT",
  /*  872 */  "cmovPP_reg_LEGT",
  /*  873 */  "cmovDDPR_reg_LEGT",
  /*  874 */  "cmovDD_reg_LEGT",
  /*  875 */  "cmovFFPR_reg_LEGT",
  /*  876 */  "cmovFF_reg_LEGT",
  /*  877 */  "CallStaticJavaDirect",
  /*  878 */  "CallStaticJavaHandle",
  /*  879 */  "CallDynamicJavaDirect",
  /*  880 */  "CallRuntimeDirect",
  /*  881 */  "CallLeafDirect",
  /*  882 */  "CallLeafNoFPDirect",
  /*  883 */  "Ret",
  /*  884 */  "TailCalljmpInd",
  /*  885 */  "tailjmpInd",
  /*  886 */  "CreateException",
  /*  887 */  "RethrowException",
  /*  888 */  "tlsLoadP",
  /*  889 */  "ShouldNotReachHere",
  /*  890 */  "addF_reg",
  /*  891 */  "addF_mem",
  /*  892 */  "addF_mem_0",
  /*  893 */  "addF_imm",
  /*  894 */  "addF_reg_reg",
  /*  895 */  "addF_reg_mem",
  /*  896 */  "addF_reg_mem_0",
  /*  897 */  "addF_reg_imm",
  /*  898 */  "addD_reg",
  /*  899 */  "addD_mem",
  /*  900 */  "addD_mem_0",
  /*  901 */  "addD_imm",
  /*  902 */  "addD_reg_reg",
  /*  903 */  "addD_reg_mem",
  /*  904 */  "addD_reg_mem_0",
  /*  905 */  "addD_reg_imm",
  /*  906 */  "subF_reg",
  /*  907 */  "subF_mem",
  /*  908 */  "subF_imm",
  /*  909 */  "subF_reg_reg",
  /*  910 */  "subF_reg_mem",
  /*  911 */  "subF_reg_imm",
  /*  912 */  "subD_reg",
  /*  913 */  "subD_mem",
  /*  914 */  "subD_imm",
  /*  915 */  "subD_reg_reg",
  /*  916 */  "subD_reg_mem",
  /*  917 */  "subD_reg_imm",
  /*  918 */  "mulF_reg",
  /*  919 */  "mulF_mem",
  /*  920 */  "mulF_mem_0",
  /*  921 */  "mulF_imm",
  /*  922 */  "mulF_reg_reg",
  /*  923 */  "mulF_reg_mem",
  /*  924 */  "mulF_reg_mem_0",
  /*  925 */  "mulF_reg_imm",
  /*  926 */  "mulD_reg",
  /*  927 */  "mulD_mem",
  /*  928 */  "mulD_mem_0",
  /*  929 */  "mulD_imm",
  /*  930 */  "mulD_reg_reg",
  /*  931 */  "mulD_reg_mem",
  /*  932 */  "mulD_reg_mem_0",
  /*  933 */  "mulD_reg_imm",
  /*  934 */  "divF_reg",
  /*  935 */  "divF_mem",
  /*  936 */  "divF_imm",
  /*  937 */  "divF_reg_reg",
  /*  938 */  "divF_reg_mem",
  /*  939 */  "divF_reg_imm",
  /*  940 */  "divD_reg",
  /*  941 */  "divD_mem",
  /*  942 */  "divD_imm",
  /*  943 */  "divD_reg_reg",
  /*  944 */  "divD_reg_mem",
  /*  945 */  "divD_reg_imm",
  /*  946 */  "sqrtF_reg",
  /*  947 */  "sqrtF_mem",
  /*  948 */  "sqrtF_imm",
  /*  949 */  "sqrtD_reg",
  /*  950 */  "sqrtD_mem",
  /*  951 */  "sqrtD_imm",
  /*  952 */  "loadV4",
  /*  953 */  "loadV8",
  /*  954 */  "loadV16",
  /*  955 */  "loadV32",
  /*  956 */  "storeV4",
  /*  957 */  "storeV8",
  /*  958 */  "storeV16",
  /*  959 */  "storeV32",
  /*  960 */  "Repl4B",
  /*  961 */  "Repl8B",
  /*  962 */  "Repl16B",
  /*  963 */  "Repl32B",
  /*  964 */  "Repl4B_imm",
  /*  965 */  "Repl8B_imm",
  /*  966 */  "Repl16B_imm",
  /*  967 */  "Repl32B_imm",
  /*  968 */  "Repl4B_zero",
  /*  969 */  "Repl8B_zero",
  /*  970 */  "Repl16B_zero",
  /*  971 */  "Repl32B_zero",
  /*  972 */  "Repl2S",
  /*  973 */  "Repl4S",
  /*  974 */  "Repl8S",
  /*  975 */  "Repl16S",
  /*  976 */  "Repl2S_imm",
  /*  977 */  "Repl4S_imm",
  /*  978 */  "Repl8S_imm",
  /*  979 */  "Repl16S_imm",
  /*  980 */  "Repl2S_zero",
  /*  981 */  "Repl4S_zero",
  /*  982 */  "Repl8S_zero",
  /*  983 */  "Repl16S_zero",
  /*  984 */  "Repl2I",
  /*  985 */  "Repl4I",
  /*  986 */  "Repl8I",
  /*  987 */  "Repl2I_imm",
  /*  988 */  "Repl4I_imm",
  /*  989 */  "Repl8I_imm",
  /*  990 */  "Repl2I_mem",
  /*  991 */  "Repl4I_mem",
  /*  992 */  "Repl8I_mem",
  /*  993 */  "Repl2I_zero",
  /*  994 */  "Repl4I_zero",
  /*  995 */  "Repl8I_zero",
  /*  996 */  "Repl2L",
  /*  997 */  "Repl4L",
  /*  998 */  "Repl2L_imm",
  /*  999 */  "Repl4L_imm",
  /* 1000 */  "Repl2L_mem",
  /* 1001 */  "Repl4L_mem",
  /* 1002 */  "Repl2L_zero",
  /* 1003 */  "Repl4L_zero",
  /* 1004 */  "Repl2F",
  /* 1005 */  "Repl4F",
  /* 1006 */  "Repl8F",
  /* 1007 */  "Repl2F_zero",
  /* 1008 */  "Repl4F_zero",
  /* 1009 */  "Repl8F_zero",
  /* 1010 */  "Repl2D",
  /* 1011 */  "Repl4D",
  /* 1012 */  "Repl2D_zero",
  /* 1013 */  "Repl4D_zero",
  /* 1014 */  "vadd4B",
  /* 1015 */  "vadd4B_reg",
  /* 1016 */  "vadd8B",
  /* 1017 */  "vadd8B_reg",
  /* 1018 */  "vadd16B",
  /* 1019 */  "vadd16B_reg",
  /* 1020 */  "vadd16B_mem",
  /* 1021 */  "vadd32B_reg",
  /* 1022 */  "vadd32B_mem",
  /* 1023 */  "vadd2S",
  /* 1024 */  "vadd2S_reg",
  /* 1025 */  "vadd4S",
  /* 1026 */  "vadd4S_reg",
  /* 1027 */  "vadd8S",
  /* 1028 */  "vadd8S_reg",
  /* 1029 */  "vadd8S_mem",
  /* 1030 */  "vadd16S_reg",
  /* 1031 */  "vadd16S_mem",
  /* 1032 */  "vadd2I",
  /* 1033 */  "vadd2I_reg",
  /* 1034 */  "vadd4I",
  /* 1035 */  "vadd4I_reg",
  /* 1036 */  "vadd4I_mem",
  /* 1037 */  "vadd8I_reg",
  /* 1038 */  "vadd8I_mem",
  /* 1039 */  "vadd2L",
  /* 1040 */  "vadd2L_reg",
  /* 1041 */  "vadd2L_mem",
  /* 1042 */  "vadd4L_reg",
  /* 1043 */  "vadd4L_mem",
  /* 1044 */  "vadd2F",
  /* 1045 */  "vadd2F_reg",
  /* 1046 */  "vadd4F",
  /* 1047 */  "vadd4F_reg",
  /* 1048 */  "vadd4F_mem",
  /* 1049 */  "vadd8F_reg",
  /* 1050 */  "vadd8F_mem",
  /* 1051 */  "vadd2D",
  /* 1052 */  "vadd2D_reg",
  /* 1053 */  "vadd2D_mem",
  /* 1054 */  "vadd4D_reg",
  /* 1055 */  "vadd4D_mem",
  /* 1056 */  "vsub4B",
  /* 1057 */  "vsub4B_reg",
  /* 1058 */  "vsub8B",
  /* 1059 */  "vsub8B_reg",
  /* 1060 */  "vsub16B",
  /* 1061 */  "vsub16B_reg",
  /* 1062 */  "vsub16B_mem",
  /* 1063 */  "vsub32B_reg",
  /* 1064 */  "vsub32B_mem",
  /* 1065 */  "vsub2S",
  /* 1066 */  "vsub2S_reg",
  /* 1067 */  "vsub4S",
  /* 1068 */  "vsub4S_reg",
  /* 1069 */  "vsub8S",
  /* 1070 */  "vsub8S_reg",
  /* 1071 */  "vsub8S_mem",
  /* 1072 */  "vsub16S_reg",
  /* 1073 */  "vsub16S_mem",
  /* 1074 */  "vsub2I",
  /* 1075 */  "vsub2I_reg",
  /* 1076 */  "vsub4I",
  /* 1077 */  "vsub4I_reg",
  /* 1078 */  "vsub4I_mem",
  /* 1079 */  "vsub8I_reg",
  /* 1080 */  "vsub8I_mem",
  /* 1081 */  "vsub2L",
  /* 1082 */  "vsub2L_reg",
  /* 1083 */  "vsub2L_mem",
  /* 1084 */  "vsub4L_reg",
  /* 1085 */  "vsub4L_mem",
  /* 1086 */  "vsub2F",
  /* 1087 */  "vsub2F_reg",
  /* 1088 */  "vsub4F",
  /* 1089 */  "vsub4F_reg",
  /* 1090 */  "vsub4F_mem",
  /* 1091 */  "vsub8F_reg",
  /* 1092 */  "vsub8F_mem",
  /* 1093 */  "vsub2D",
  /* 1094 */  "vsub2D_reg",
  /* 1095 */  "vsub2D_mem",
  /* 1096 */  "vsub4D_reg",
  /* 1097 */  "vsub4D_mem",
  /* 1098 */  "vmul2S",
  /* 1099 */  "vmul2S_reg",
  /* 1100 */  "vmul4S",
  /* 1101 */  "vmul4S_reg",
  /* 1102 */  "vmul8S",
  /* 1103 */  "vmul8S_reg",
  /* 1104 */  "vmul8S_mem",
  /* 1105 */  "vmul16S_reg",
  /* 1106 */  "vmul16S_mem",
  /* 1107 */  "vmul2I",
  /* 1108 */  "vmul2I_reg",
  /* 1109 */  "vmul4I",
  /* 1110 */  "vmul4I_reg",
  /* 1111 */  "vmul4I_mem",
  /* 1112 */  "vmul8I_reg",
  /* 1113 */  "vmul8I_mem",
  /* 1114 */  "vmul2F",
  /* 1115 */  "vmul2F_reg",
  /* 1116 */  "vmul4F",
  /* 1117 */  "vmul4F_reg",
  /* 1118 */  "vmul4F_mem",
  /* 1119 */  "vmul8F_reg",
  /* 1120 */  "vmul8F_mem",
  /* 1121 */  "vmul2D",
  /* 1122 */  "vmul2D_reg",
  /* 1123 */  "vmul2D_mem",
  /* 1124 */  "vmul4D_reg",
  /* 1125 */  "vmul4D_mem",
  /* 1126 */  "vdiv2F",
  /* 1127 */  "vdiv2F_reg",
  /* 1128 */  "vdiv4F",
  /* 1129 */  "vdiv4F_reg",
  /* 1130 */  "vdiv4F_mem",
  /* 1131 */  "vdiv8F_reg",
  /* 1132 */  "vdiv8F_mem",
  /* 1133 */  "vdiv2D",
  /* 1134 */  "vdiv2D_reg",
  /* 1135 */  "vdiv2D_mem",
  /* 1136 */  "vdiv4D_reg",
  /* 1137 */  "vdiv4D_mem",
  /* 1138 */  "vsll2S",
  /* 1139 */  "vsll2S_imm",
  /* 1140 */  "vsll2S_reg",
  /* 1141 */  "vsll2S_reg_imm",
  /* 1142 */  "vsll4S",
  /* 1143 */  "vsll4S_imm",
  /* 1144 */  "vsll4S_reg",
  /* 1145 */  "vsll4S_reg_imm",
  /* 1146 */  "vsll8S",
  /* 1147 */  "vsll8S_imm",
  /* 1148 */  "vsll8S_reg",
  /* 1149 */  "vsll8S_reg_imm",
  /* 1150 */  "vsll16S_reg",
  /* 1151 */  "vsll16S_reg_imm",
  /* 1152 */  "vsll2I",
  /* 1153 */  "vsll2I_imm",
  /* 1154 */  "vsll2I_reg",
  /* 1155 */  "vsll2I_reg_imm",
  /* 1156 */  "vsll4I",
  /* 1157 */  "vsll4I_imm",
  /* 1158 */  "vsll4I_reg",
  /* 1159 */  "vsll4I_reg_imm",
  /* 1160 */  "vsll8I_reg",
  /* 1161 */  "vsll8I_reg_imm",
  /* 1162 */  "vsll2L",
  /* 1163 */  "vsll2L_imm",
  /* 1164 */  "vsll2L_reg",
  /* 1165 */  "vsll2L_reg_imm",
  /* 1166 */  "vsll4L_reg",
  /* 1167 */  "vsll4L_reg_imm",
  /* 1168 */  "vsrl2S",
  /* 1169 */  "vsrl2S_imm",
  /* 1170 */  "vsrl2S_reg",
  /* 1171 */  "vsrl2S_reg_imm",
  /* 1172 */  "vsrl4S",
  /* 1173 */  "vsrl4S_imm",
  /* 1174 */  "vsrl4S_reg",
  /* 1175 */  "vsrl4S_reg_imm",
  /* 1176 */  "vsrl8S",
  /* 1177 */  "vsrl8S_imm",
  /* 1178 */  "vsrl8S_reg",
  /* 1179 */  "vsrl8S_reg_imm",
  /* 1180 */  "vsrl16S_reg",
  /* 1181 */  "vsrl16S_reg_imm",
  /* 1182 */  "vsrl2I",
  /* 1183 */  "vsrl2I_imm",
  /* 1184 */  "vsrl2I_reg",
  /* 1185 */  "vsrl2I_reg_imm",
  /* 1186 */  "vsrl4I",
  /* 1187 */  "vsrl4I_imm",
  /* 1188 */  "vsrl4I_reg",
  /* 1189 */  "vsrl4I_reg_imm",
  /* 1190 */  "vsrl8I_reg",
  /* 1191 */  "vsrl8I_reg_imm",
  /* 1192 */  "vsrl2L",
  /* 1193 */  "vsrl2L_imm",
  /* 1194 */  "vsrl2L_reg",
  /* 1195 */  "vsrl2L_reg_imm",
  /* 1196 */  "vsrl4L_reg",
  /* 1197 */  "vsrl4L_reg_imm",
  /* 1198 */  "vsra2S",
  /* 1199 */  "vsra2S_imm",
  /* 1200 */  "vsra2S_reg",
  /* 1201 */  "vsra2S_reg_imm",
  /* 1202 */  "vsra4S",
  /* 1203 */  "vsra4S_imm",
  /* 1204 */  "vsra4S_reg",
  /* 1205 */  "vsra4S_reg_imm",
  /* 1206 */  "vsra8S",
  /* 1207 */  "vsra8S_imm",
  /* 1208 */  "vsra8S_reg",
  /* 1209 */  "vsra8S_reg_imm",
  /* 1210 */  "vsra16S_reg",
  /* 1211 */  "vsra16S_reg_imm",
  /* 1212 */  "vsra2I",
  /* 1213 */  "vsra2I_imm",
  /* 1214 */  "vsra2I_reg",
  /* 1215 */  "vsra2I_reg_imm",
  /* 1216 */  "vsra4I",
  /* 1217 */  "vsra4I_imm",
  /* 1218 */  "vsra4I_reg",
  /* 1219 */  "vsra4I_reg_imm",
  /* 1220 */  "vsra8I_reg",
  /* 1221 */  "vsra8I_reg_imm",
  /* 1222 */  "vand4B",
  /* 1223 */  "vand4B_reg",
  /* 1224 */  "vand8B",
  /* 1225 */  "vand8B_reg",
  /* 1226 */  "vand16B",
  /* 1227 */  "vand16B_reg",
  /* 1228 */  "vand16B_mem",
  /* 1229 */  "vand32B_reg",
  /* 1230 */  "vand32B_mem",
  /* 1231 */  "vor4B",
  /* 1232 */  "vor4B_reg",
  /* 1233 */  "vor8B",
  /* 1234 */  "vor8B_reg",
  /* 1235 */  "vor16B",
  /* 1236 */  "vor16B_reg",
  /* 1237 */  "vor16B_mem",
  /* 1238 */  "vor32B_reg",
  /* 1239 */  "vor32B_mem",
  /* 1240 */  "vxor4B",
  /* 1241 */  "vxor4B_reg",
  /* 1242 */  "vxor8B",
  /* 1243 */  "vxor8B_reg",
  /* 1244 */  "vxor16B",
  /* 1245 */  "vxor16B_reg",
  /* 1246 */  "vxor16B_mem",
  /* 1247 */  "vxor32B_reg",
  /* 1248 */  "vxor32B_mem",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  false,
  /*   45 */  false,
  /*   46 */  false,
  /*   47 */  false,
  /*   48 */  false,
  /*   49 */  false,
  /*   50 */  false,
  /*   51 */  false,
  /*   52 */  false,
  /*   53 */  false,
  /*   54 */  false,
  /*   55 */  false,
  /*   56 */  false,
  /*   57 */  false,
  /*   58 */  false,
  /*   59 */  false,
  /*   60 */  false,
  /*   61 */  false,
  /*   62 */  false,
  /*   63 */  false,
  /*   64 */  false,
  /*   65 */  false,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  true,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  true,
  /*  109 */  true,
  /*  110 */  true,
  /*  111 */  true,
  /*  112 */  true,
  /*  113 */  true,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  // last operand
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  false,
  // last operand class
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  // last internally defined operand
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  /*  720 */  false,
  /*  721 */  false,
  /*  722 */  false,
  /*  723 */  false,
  /*  724 */  false,
  /*  725 */  false,
  /*  726 */  false,
  /*  727 */  false,
  /*  728 */  false,
  /*  729 */  false,
  /*  730 */  false,
  /*  731 */  false,
  /*  732 */  false,
  /*  733 */  false,
  /*  734 */  false,
  /*  735 */  false,
  /*  736 */  false,
  /*  737 */  false,
  /*  738 */  false,
  /*  739 */  false,
  /*  740 */  false,
  /*  741 */  false,
  /*  742 */  false,
  /*  743 */  false,
  /*  744 */  false,
  /*  745 */  false,
  /*  746 */  false,
  /*  747 */  false,
  /*  748 */  false,
  /*  749 */  false,
  /*  750 */  false,
  /*  751 */  false,
  /*  752 */  false,
  /*  753 */  false,
  /*  754 */  false,
  /*  755 */  false,
  /*  756 */  false,
  /*  757 */  false,
  /*  758 */  false,
  /*  759 */  false,
  /*  760 */  false,
  /*  761 */  false,
  /*  762 */  false,
  /*  763 */  false,
  /*  764 */  false,
  /*  765 */  false,
  /*  766 */  false,
  /*  767 */  false,
  /*  768 */  false,
  /*  769 */  false,
  /*  770 */  false,
  /*  771 */  false,
  /*  772 */  false,
  /*  773 */  false,
  /*  774 */  false,
  /*  775 */  false,
  /*  776 */  false,
  /*  777 */  false,
  /*  778 */  false,
  /*  779 */  false,
  /*  780 */  false,
  /*  781 */  false,
  /*  782 */  false,
  /*  783 */  false,
  /*  784 */  false,
  /*  785 */  false,
  /*  786 */  false,
  /*  787 */  false,
  /*  788 */  false,
  /*  789 */  false,
  /*  790 */  false,
  /*  791 */  false,
  /*  792 */  false,
  /*  793 */  false,
  /*  794 */  false,
  /*  795 */  false,
  /*  796 */  false,
  /*  797 */  false,
  /*  798 */  false,
  /*  799 */  false,
  /*  800 */  false,
  /*  801 */  false,
  /*  802 */  false,
  /*  803 */  false,
  /*  804 */  false,
  /*  805 */  false,
  /*  806 */  false,
  /*  807 */  false,
  /*  808 */  false,
  /*  809 */  false,
  /*  810 */  false,
  /*  811 */  false,
  /*  812 */  false,
  /*  813 */  false,
  /*  814 */  false,
  /*  815 */  false,
  /*  816 */  false,
  /*  817 */  false,
  /*  818 */  false,
  /*  819 */  false,
  /*  820 */  false,
  /*  821 */  false,
  /*  822 */  false,
  /*  823 */  false,
  /*  824 */  false,
  /*  825 */  false,
  /*  826 */  false,
  /*  827 */  false,
  /*  828 */  false,
  /*  829 */  false,
  /*  830 */  false,
  /*  831 */  false,
  /*  832 */  false,
  /*  833 */  false,
  /*  834 */  false,
  /*  835 */  false,
  /*  836 */  false,
  /*  837 */  false,
  /*  838 */  false,
  /*  839 */  false,
  /*  840 */  false,
  /*  841 */  false,
  /*  842 */  false,
  /*  843 */  false,
  /*  844 */  false,
  /*  845 */  false,
  /*  846 */  false,
  /*  847 */  false,
  /*  848 */  false,
  /*  849 */  false,
  /*  850 */  false,
  /*  851 */  false,
  /*  852 */  false,
  /*  853 */  false,
  /*  854 */  false,
  /*  855 */  false,
  /*  856 */  false,
  /*  857 */  false,
  /*  858 */  false,
  /*  859 */  false,
  /*  860 */  false,
  /*  861 */  false,
  /*  862 */  false,
  /*  863 */  false,
  /*  864 */  false,
  /*  865 */  false,
  /*  866 */  false,
  /*  867 */  false,
  /*  868 */  false,
  /*  869 */  false,
  /*  870 */  false,
  /*  871 */  false,
  /*  872 */  false,
  /*  873 */  false,
  /*  874 */  false,
  /*  875 */  false,
  /*  876 */  false,
  /*  877 */  false,
  /*  878 */  false,
  /*  879 */  false,
  /*  880 */  false,
  /*  881 */  false,
  /*  882 */  false,
  /*  883 */  false,
  /*  884 */  false,
  /*  885 */  false,
  /*  886 */  false,
  /*  887 */  false,
  /*  888 */  false,
  /*  889 */  false,
  /*  890 */  false,
  /*  891 */  false,
  /*  892 */  false,
  /*  893 */  false,
  /*  894 */  false,
  /*  895 */  false,
  /*  896 */  false,
  /*  897 */  false,
  /*  898 */  false,
  /*  899 */  false,
  /*  900 */  false,
  /*  901 */  false,
  /*  902 */  false,
  /*  903 */  false,
  /*  904 */  false,
  /*  905 */  false,
  /*  906 */  false,
  /*  907 */  false,
  /*  908 */  false,
  /*  909 */  false,
  /*  910 */  false,
  /*  911 */  false,
  /*  912 */  false,
  /*  913 */  false,
  /*  914 */  false,
  /*  915 */  false,
  /*  916 */  false,
  /*  917 */  false,
  /*  918 */  false,
  /*  919 */  false,
  /*  920 */  false,
  /*  921 */  false,
  /*  922 */  false,
  /*  923 */  false,
  /*  924 */  false,
  /*  925 */  false,
  /*  926 */  false,
  /*  927 */  false,
  /*  928 */  false,
  /*  929 */  false,
  /*  930 */  false,
  /*  931 */  false,
  /*  932 */  false,
  /*  933 */  false,
  /*  934 */  false,
  /*  935 */  false,
  /*  936 */  false,
  /*  937 */  false,
  /*  938 */  false,
  /*  939 */  false,
  /*  940 */  false,
  /*  941 */  false,
  /*  942 */  false,
  /*  943 */  false,
  /*  944 */  false,
  /*  945 */  false,
  /*  946 */  false,
  /*  947 */  false,
  /*  948 */  false,
  /*  949 */  false,
  /*  950 */  false,
  /*  951 */  false,
  /*  952 */  false,
  /*  953 */  false,
  /*  954 */  false,
  /*  955 */  false,
  /*  956 */  false,
  /*  957 */  false,
  /*  958 */  false,
  /*  959 */  false,
  /*  960 */  false,
  /*  961 */  false,
  /*  962 */  false,
  /*  963 */  false,
  /*  964 */  false,
  /*  965 */  false,
  /*  966 */  false,
  /*  967 */  false,
  /*  968 */  false,
  /*  969 */  false,
  /*  970 */  false,
  /*  971 */  false,
  /*  972 */  false,
  /*  973 */  false,
  /*  974 */  false,
  /*  975 */  false,
  /*  976 */  false,
  /*  977 */  false,
  /*  978 */  false,
  /*  979 */  false,
  /*  980 */  false,
  /*  981 */  false,
  /*  982 */  false,
  /*  983 */  false,
  /*  984 */  false,
  /*  985 */  false,
  /*  986 */  false,
  /*  987 */  false,
  /*  988 */  false,
  /*  989 */  false,
  /*  990 */  false,
  /*  991 */  false,
  /*  992 */  false,
  /*  993 */  false,
  /*  994 */  false,
  /*  995 */  false,
  /*  996 */  false,
  /*  997 */  false,
  /*  998 */  false,
  /*  999 */  false,
  /* 1000 */  false,
  /* 1001 */  false,
  /* 1002 */  false,
  /* 1003 */  false,
  /* 1004 */  false,
  /* 1005 */  false,
  /* 1006 */  false,
  /* 1007 */  false,
  /* 1008 */  false,
  /* 1009 */  false,
  /* 1010 */  false,
  /* 1011 */  false,
  /* 1012 */  false,
  /* 1013 */  false,
  /* 1014 */  false,
  /* 1015 */  false,
  /* 1016 */  false,
  /* 1017 */  false,
  /* 1018 */  false,
  /* 1019 */  false,
  /* 1020 */  false,
  /* 1021 */  false,
  /* 1022 */  false,
  /* 1023 */  false,
  /* 1024 */  false,
  /* 1025 */  false,
  /* 1026 */  false,
  /* 1027 */  false,
  /* 1028 */  false,
  /* 1029 */  false,
  /* 1030 */  false,
  /* 1031 */  false,
  /* 1032 */  false,
  /* 1033 */  false,
  /* 1034 */  false,
  /* 1035 */  false,
  /* 1036 */  false,
  /* 1037 */  false,
  /* 1038 */  false,
  /* 1039 */  false,
  /* 1040 */  false,
  /* 1041 */  false,
  /* 1042 */  false,
  /* 1043 */  false,
  /* 1044 */  false,
  /* 1045 */  false,
  /* 1046 */  false,
  /* 1047 */  false,
  /* 1048 */  false,
  /* 1049 */  false,
  /* 1050 */  false,
  /* 1051 */  false,
  /* 1052 */  false,
  /* 1053 */  false,
  /* 1054 */  false,
  /* 1055 */  false,
  /* 1056 */  false,
  /* 1057 */  false,
  /* 1058 */  false,
  /* 1059 */  false,
  /* 1060 */  false,
  /* 1061 */  false,
  /* 1062 */  false,
  /* 1063 */  false,
  /* 1064 */  false,
  /* 1065 */  false,
  /* 1066 */  false,
  /* 1067 */  false,
  /* 1068 */  false,
  /* 1069 */  false,
  /* 1070 */  false,
  /* 1071 */  false,
  /* 1072 */  false,
  /* 1073 */  false,
  /* 1074 */  false,
  /* 1075 */  false,
  /* 1076 */  false,
  /* 1077 */  false,
  /* 1078 */  false,
  /* 1079 */  false,
  /* 1080 */  false,
  /* 1081 */  false,
  /* 1082 */  false,
  /* 1083 */  false,
  /* 1084 */  false,
  /* 1085 */  false,
  /* 1086 */  false,
  /* 1087 */  false,
  /* 1088 */  false,
  /* 1089 */  false,
  /* 1090 */  false,
  /* 1091 */  false,
  /* 1092 */  false,
  /* 1093 */  false,
  /* 1094 */  false,
  /* 1095 */  false,
  /* 1096 */  false,
  /* 1097 */  false,
  /* 1098 */  false,
  /* 1099 */  false,
  /* 1100 */  false,
  /* 1101 */  false,
  /* 1102 */  false,
  /* 1103 */  false,
  /* 1104 */  false,
  /* 1105 */  false,
  /* 1106 */  false,
  /* 1107 */  false,
  /* 1108 */  false,
  /* 1109 */  false,
  /* 1110 */  false,
  /* 1111 */  false,
  /* 1112 */  false,
  /* 1113 */  false,
  /* 1114 */  false,
  /* 1115 */  false,
  /* 1116 */  false,
  /* 1117 */  false,
  /* 1118 */  false,
  /* 1119 */  false,
  /* 1120 */  false,
  /* 1121 */  false,
  /* 1122 */  false,
  /* 1123 */  false,
  /* 1124 */  false,
  /* 1125 */  false,
  /* 1126 */  false,
  /* 1127 */  false,
  /* 1128 */  false,
  /* 1129 */  false,
  /* 1130 */  false,
  /* 1131 */  false,
  /* 1132 */  false,
  /* 1133 */  false,
  /* 1134 */  false,
  /* 1135 */  false,
  /* 1136 */  false,
  /* 1137 */  false,
  /* 1138 */  false,
  /* 1139 */  false,
  /* 1140 */  false,
  /* 1141 */  false,
  /* 1142 */  false,
  /* 1143 */  false,
  /* 1144 */  false,
  /* 1145 */  false,
  /* 1146 */  false,
  /* 1147 */  false,
  /* 1148 */  false,
  /* 1149 */  false,
  /* 1150 */  false,
  /* 1151 */  false,
  /* 1152 */  false,
  /* 1153 */  false,
  /* 1154 */  false,
  /* 1155 */  false,
  /* 1156 */  false,
  /* 1157 */  false,
  /* 1158 */  false,
  /* 1159 */  false,
  /* 1160 */  false,
  /* 1161 */  false,
  /* 1162 */  false,
  /* 1163 */  false,
  /* 1164 */  false,
  /* 1165 */  false,
  /* 1166 */  false,
  /* 1167 */  false,
  /* 1168 */  false,
  /* 1169 */  false,
  /* 1170 */  false,
  /* 1171 */  false,
  /* 1172 */  false,
  /* 1173 */  false,
  /* 1174 */  false,
  /* 1175 */  false,
  /* 1176 */  false,
  /* 1177 */  false,
  /* 1178 */  false,
  /* 1179 */  false,
  /* 1180 */  false,
  /* 1181 */  false,
  /* 1182 */  false,
  /* 1183 */  false,
  /* 1184 */  false,
  /* 1185 */  false,
  /* 1186 */  false,
  /* 1187 */  false,
  /* 1188 */  false,
  /* 1189 */  false,
  /* 1190 */  false,
  /* 1191 */  false,
  /* 1192 */  false,
  /* 1193 */  false,
  /* 1194 */  false,
  /* 1195 */  false,
  /* 1196 */  false,
  /* 1197 */  false,
  /* 1198 */  false,
  /* 1199 */  false,
  /* 1200 */  false,
  /* 1201 */  false,
  /* 1202 */  false,
  /* 1203 */  false,
  /* 1204 */  false,
  /* 1205 */  false,
  /* 1206 */  false,
  /* 1207 */  false,
  /* 1208 */  false,
  /* 1209 */  false,
  /* 1210 */  false,
  /* 1211 */  false,
  /* 1212 */  false,
  /* 1213 */  false,
  /* 1214 */  false,
  /* 1215 */  false,
  /* 1216 */  false,
  /* 1217 */  false,
  /* 1218 */  false,
  /* 1219 */  false,
  /* 1220 */  false,
  /* 1221 */  false,
  /* 1222 */  false,
  /* 1223 */  false,
  /* 1224 */  false,
  /* 1225 */  false,
  /* 1226 */  false,
  /* 1227 */  false,
  /* 1228 */  false,
  /* 1229 */  false,
  /* 1230 */  false,
  /* 1231 */  false,
  /* 1232 */  false,
  /* 1233 */  false,
  /* 1234 */  false,
  /* 1235 */  false,
  /* 1236 */  false,
  /* 1237 */  false,
  /* 1238 */  false,
  /* 1239 */  false,
  /* 1240 */  false,
  /* 1241 */  false,
  /* 1242 */  false,
  /* 1243 */  false,
  /* 1244 */  false,
  /* 1245 */  false,
  /* 1246 */  false,
  /* 1247 */  false,
  /* 1248 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // RegFlags: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // _last_machine_leaf: 13
  0, // AbsD: 14
  0, // AbsF: 15
  0, // AbsI: 16
  0, // AddD: 17
  0, // AddF: 18
  0, // AddI: 19
  0, // AddL: 20
  0, // AddP: 21
  0, // Allocate: 22
  0, // AllocateArray: 23
  0, // AndI: 24
  0, // AndL: 25
  0, // AryEq: 26
  0, // AtanD: 27
  1, // Binary: 28
  1, // Bool: 29
  0, // BoxLock: 30
  0, // ReverseBytesI: 31
  0, // ReverseBytesL: 32
  0, // ReverseBytesUS: 33
  0, // ReverseBytesS: 34
  0, // CProj: 35
  0, // CallDynamicJava: 36
  0, // CallJava: 37
  0, // CallLeaf: 38
  0, // CallLeafNoFP: 39
  0, // CallRuntime: 40
  0, // CallStaticJava: 41
  0, // CastII: 42
  0, // CastX2P: 43
  0, // CastP2X: 44
  0, // CastPP: 45
  0, // Catch: 46
  0, // CatchProj: 47
  0, // CheckCastPP: 48
  0, // ClearArray: 49
  0, // ConstraintCast: 50
  0, // CMoveD: 51
  0, // CMoveF: 52
  0, // CMoveI: 53
  0, // CMoveL: 54
  0, // CMoveP: 55
  0, // CMoveN: 56
  1, // CmpN: 57
  1, // CmpD: 58
  0, // CmpD3: 59
  1, // CmpF: 60
  0, // CmpF3: 61
  1, // CmpI: 62
  1, // CmpL: 63
  0, // CmpL3: 64
  0, // CmpLTMask: 65
  1, // CmpP: 66
  1, // CmpU: 67
  0, // CompareAndSwapI: 68
  0, // CompareAndSwapL: 69
  0, // CompareAndSwapP: 70
  0, // CompareAndSwapN: 71
  0, // GetAndAddI: 72
  0, // GetAndAddL: 73
  0, // GetAndSetI: 74
  0, // GetAndSetL: 75
  0, // GetAndSetP: 76
  0, // GetAndSetN: 77
  0, // Con: 78
  0, // ConN: 79
  0, // ConNKlass: 80
  0, // ConD: 81
  0, // ConF: 82
  0, // ConI: 83
  0, // ConL: 84
  0, // ConP: 85
  0, // Conv2B: 86
  0, // ConvD2F: 87
  0, // ConvD2I: 88
  0, // ConvD2L: 89
  0, // ConvF2D: 90
  0, // ConvF2I: 91
  0, // ConvF2L: 92
  0, // ConvI2D: 93
  0, // ConvI2F: 94
  0, // ConvI2L: 95
  0, // ConvL2D: 96
  0, // ConvL2F: 97
  0, // ConvL2I: 98
  0, // CosD: 99
  0, // CountedLoop: 100
  0, // CountedLoopEnd: 101
  0, // CountLeadingZerosI: 102
  0, // CountLeadingZerosL: 103
  0, // CountTrailingZerosI: 104
  0, // CountTrailingZerosL: 105
  0, // CreateEx: 106
  0, // DecodeN: 107
  0, // DecodeNKlass: 108
  0, // DivD: 109
  0, // DivF: 110
  0, // DivI: 111
  0, // DivL: 112
  0, // DivMod: 113
  0, // DivModI: 114
  0, // DivModL: 115
  0, // EncodeISOArray: 116
  0, // EncodeP: 117
  0, // EncodePKlass: 118
  0, // ExpD: 119
  1, // FastLock: 120
  1, // FastUnlock: 121
  0, // Goto: 122
  0, // Halt: 123
  0, // If: 124
  0, // IfFalse: 125
  0, // IfTrue: 126
  0, // Initialize: 127
  0, // JProj: 128
  0, // Jump: 129
  0, // JumpProj: 130
  0, // LShiftI: 131
  0, // LShiftL: 132
  0, // LoadB: 133
  0, // LoadUB: 134
  0, // LoadUS: 135
  0, // LoadD: 136
  0, // LoadD_unaligned: 137
  0, // LoadF: 138
  0, // LoadI: 139
  0, // LoadKlass: 140
  0, // LoadNKlass: 141
  0, // LoadL: 142
  0, // LoadL_unaligned: 143
  0, // LoadPLocked: 144
  0, // LoadP: 145
  0, // LoadN: 146
  0, // LoadRange: 147
  0, // LoadS: 148
  0, // Lock: 149
  0, // LogD: 150
  0, // Log10D: 151
  0, // Loop: 152
  0, // LoopLimit: 153
  0, // Mach: 154
  0, // MachProj: 155
  0, // MaxI: 156
  0, // MemBarAcquire: 157
  0, // LoadFence: 158
  0, // MemBarAcquireLock: 159
  0, // MemBarCPUOrder: 160
  0, // MemBarRelease: 161
  0, // StoreFence: 162
  0, // MemBarReleaseLock: 163
  0, // MemBarVolatile: 164
  0, // MemBarStoreStore: 165
  0, // MergeMem: 166
  0, // MinI: 167
  0, // ModD: 168
  0, // ModF: 169
  0, // ModI: 170
  0, // ModL: 171
  0, // MoveI2F: 172
  0, // MoveF2I: 173
  0, // MoveL2D: 174
  0, // MoveD2L: 175
  0, // MulD: 176
  0, // MulF: 177
  0, // MulHiL: 178
  0, // MulI: 179
  0, // MulL: 180
  0, // Multi: 181
  0, // NegD: 182
  0, // NegF: 183
  0, // NeverBranch: 184
  0, // Opaque1: 185
  0, // Opaque2: 186
  0, // Opaque3: 187
  0, // OrI: 188
  0, // OrL: 189
  1, // OverflowAddI: 190
  1, // OverflowSubI: 191
  1, // OverflowMulI: 192
  1, // OverflowAddL: 193
  1, // OverflowSubL: 194
  1, // OverflowMulL: 195
  0, // PCTable: 196
  0, // Parm: 197
  0, // PartialSubtypeCheck: 198
  0, // Phi: 199
  0, // PopCountI: 200
  0, // PopCountL: 201
  0, // PowD: 202
  0, // PrefetchAllocation: 203
  0, // PrefetchRead: 204
  0, // PrefetchWrite: 205
  0, // Proj: 206
  0, // RShiftI: 207
  0, // RShiftL: 208
  0, // Region: 209
  0, // Rethrow: 210
  0, // Return: 211
  0, // Root: 212
  0, // RoundDouble: 213
  0, // RoundFloat: 214
  0, // SafePoint: 215
  0, // SafePointScalarObject: 216
  0, // SCMemProj: 217
  0, // SinD: 218
  0, // SqrtD: 219
  0, // Start: 220
  0, // StartOSR: 221
  0, // StoreB: 222
  0, // StoreC: 223
  0, // StoreCM: 224
  0, // StorePConditional: 225
  0, // StoreIConditional: 226
  0, // StoreLConditional: 227
  0, // StoreD: 228
  0, // StoreF: 229
  0, // StoreI: 230
  0, // StoreL: 231
  0, // StoreP: 232
  0, // StoreN: 233
  0, // StoreNKlass: 234
  0, // StrComp: 235
  0, // StrEquals: 236
  0, // StrIndexOf: 237
  0, // SubD: 238
  0, // SubF: 239
  0, // SubI: 240
  0, // SubL: 241
  0, // TailCall: 242
  0, // TailJump: 243
  0, // TanD: 244
  0, // ThreadLocal: 245
  0, // Unlock: 246
  0, // URShiftI: 247
  0, // URShiftL: 248
  0, // XorI: 249
  0, // XorL: 250
  0, // Vector: 251
  0, // AddVB: 252
  0, // AddVS: 253
  0, // AddVI: 254
  0, // AddVL: 255
  0, // AddVF: 256
  0, // AddVD: 257
  0, // SubVB: 258
  0, // SubVS: 259
  0, // SubVI: 260
  0, // SubVL: 261
  0, // SubVF: 262
  0, // SubVD: 263
  0, // MulVS: 264
  0, // MulVI: 265
  0, // MulVF: 266
  0, // MulVD: 267
  0, // DivVF: 268
  0, // DivVD: 269
  0, // LShiftCntV: 270
  0, // RShiftCntV: 271
  0, // LShiftVB: 272
  0, // LShiftVS: 273
  0, // LShiftVI: 274
  0, // LShiftVL: 275
  0, // RShiftVB: 276
  0, // RShiftVS: 277
  0, // RShiftVI: 278
  0, // RShiftVL: 279
  0, // URShiftVB: 280
  0, // URShiftVS: 281
  0, // URShiftVI: 282
  0, // URShiftVL: 283
  0, // AndV: 284
  0, // OrV: 285
  0, // XorV: 286
  0, // LoadVector: 287
  0, // StoreVector: 288
  0, // Pack: 289
  0, // PackB: 290
  0, // PackS: 291
  0, // PackI: 292
  0, // PackL: 293
  0, // PackF: 294
  0, // PackD: 295
  0, // Pack2L: 296
  0, // Pack2D: 297
  0, // ReplicateB: 298
  0, // ReplicateS: 299
  0, // ReplicateI: 300
  0, // ReplicateL: 301
  0, // ReplicateF: 302
  0, // ReplicateD: 303
  0, // Extract: 304
  0, // ExtractB: 305
  0, // ExtractUB: 306
  0, // ExtractC: 307
  0, // ExtractS: 308
  0, // ExtractI: 309
  0, // ExtractL: 310
  0, // ExtractF: 311
  0 // no trailing comma // ExtractD: 312
};
//  The following instructions can cisc-spill
//  popCountI can cisc-spill operand 1 to popCountI_mem
//  popCountL can cisc-spill operand 1 to popCountL_mem
//  cmovI_reg can cisc-spill operand 4 to cmovI_mem
//  cmovI_regU can cisc-spill operand 4 to cmovI_memU
//  cmovI_regUCF can cisc-spill operand 4 to cmovI_memUCF
//  addI_eReg can cisc-spill operand 2 to addI_eReg_mem
//  subI_eReg can cisc-spill operand 2 to subI_eReg_mem
//  mulI_eReg can cisc-spill operand 2 to mulI
//  mulI_eReg_imm can cisc-spill operand 1 to mulI_mem_imm
//  i2b can cisc-spill operand 1 to loadI2B
//  i2s can cisc-spill operand 1 to loadI2S
//  andI_eReg can cisc-spill operand 2 to andI_eReg_mem
//  andnI_rReg_rReg_rReg can cisc-spill operand 3 to andnI_rReg_rReg_mem
//  andnI_rReg_rReg_rReg_0 can cisc-spill operand 1 to andnI_rReg_rReg_mem_0
//  orI_eReg can cisc-spill operand 2 to orI_eReg_mem
//  xorI_eReg can cisc-spill operand 2 to xorI_eReg_mem
//  addL_eReg can cisc-spill operand 2 to addL_eReg_mem
//  subL_eReg can cisc-spill operand 2 to subL_eReg_mem
//  andL_eReg can cisc-spill operand 2 to andL_eReg_mem
//  andnL_eReg_eReg_eReg can cisc-spill operand 3 to andnL_eReg_eReg_mem
//  andnL_eReg_eReg_eReg_0 can cisc-spill operand 1 to andnL_eReg_eReg_mem_0
//  orl_eReg can cisc-spill operand 2 to orl_eReg_mem
//  xorl_eReg can cisc-spill operand 2 to xorl_eReg_mem
//  cmpD_cc can cisc-spill operand 2 to cmpD_ccmem
//  cmpD_ccCF can cisc-spill operand 2 to cmpD_ccmemCF
//  cmpD_reg can cisc-spill operand 2 to cmpD_regmem
//  subDPR_reg can cisc-spill operand 2 to subDPR_reg_mem
//  addDPR_reg can cisc-spill operand 2 to addDPR_reg_mem
//  mulDPR_reg can cisc-spill operand 2 to mulDPR_reg_mem
//  cmpF_cc can cisc-spill operand 2 to cmpF_ccmem
//  cmpF_ccCF can cisc-spill operand 2 to cmpF_ccmemCF
//  cmpF_reg can cisc-spill operand 2 to cmpF_regmem
//  addFPR24_reg can cisc-spill operand 2 to addFPR24_reg_mem
//  addFPR_reg can cisc-spill operand 2 to addFPR_reg_mem
//  addFPR24_reg_mem can cisc-spill operand 1 to addFPR24_mem_cisc
//  addFPR24_reg_mem_0 can cisc-spill operand 2 to addFPR24_mem_cisc_0
//  addFPR24_mem_reg can cisc-spill operand 2 to addFPR24_mem_cisc
//  mulFPR24_reg can cisc-spill operand 2 to mulFPR24_reg_mem
//  mulFPR_reg can cisc-spill operand 2 to mulFPR_reg_mem
//  addFPR_mulFPR_reg can cisc-spill operand 1 to addFPR_mulFPR_reg_load1
//  addFPR_mulFPR_reg_0 can cisc-spill operand 2 to addFPR_mulFPR_reg_load1_1
//  convI2L_reg can cisc-spill operand 1 to loadI2L
//  convI2L_reg_zex can cisc-spill operand 1 to loadUI2L
//  compI_eReg can cisc-spill operand 2 to compI_eReg_mem
//  compU_eReg can cisc-spill operand 2 to compU_eReg_mem
//  compP_eReg can cisc-spill operand 2 to compP_eReg_mem
//  cmovLL_reg_LTGE can cisc-spill operand 4 to cmovLL_mem_LTGE
//  cmovII_reg_LTGE can cisc-spill operand 4 to cmovII_mem_LTGE
//  cmovLL_reg_EQNE can cisc-spill operand 4 to cmovLL_mem_EQNE
//  cmovII_reg_EQNE can cisc-spill operand 4 to cmovII_mem_EQNE
//  cmovLL_reg_LEGT can cisc-spill operand 4 to cmovLL_mem_LEGT
//  cmovII_reg_LEGT can cisc-spill operand 4 to cmovII_mem_LEGT
//  addF_reg can cisc-spill operand 2 to addF_mem
//  addF_reg_reg can cisc-spill operand 2 to addF_reg_mem
//  addD_reg can cisc-spill operand 2 to addD_mem
//  addD_reg_reg can cisc-spill operand 2 to addD_reg_mem
//  subF_reg can cisc-spill operand 2 to subF_mem
//  subF_reg_reg can cisc-spill operand 2 to subF_reg_mem
//  subD_reg can cisc-spill operand 2 to subD_mem
//  subD_reg_reg can cisc-spill operand 2 to subD_reg_mem
//  mulF_reg can cisc-spill operand 2 to mulF_mem
//  mulF_reg_reg can cisc-spill operand 2 to mulF_reg_mem
//  mulD_reg can cisc-spill operand 2 to mulD_mem
//  mulD_reg_reg can cisc-spill operand 2 to mulD_reg_mem
//  divF_reg can cisc-spill operand 2 to divF_mem
//  divF_reg_reg can cisc-spill operand 2 to divF_reg_mem
//  divD_reg can cisc-spill operand 2 to divD_mem
//  divD_reg_reg can cisc-spill operand 2 to divD_reg_mem
//  sqrtF_reg can cisc-spill operand 1 to sqrtF_mem
//  sqrtD_reg can cisc-spill operand 1 to sqrtD_mem
//  Repl2I can cisc-spill operand 1 to Repl2I_mem
//  Repl4I can cisc-spill operand 1 to Repl4I_mem
//  Repl8I can cisc-spill operand 1 to Repl8I_mem



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "ECX",
  "EBX",
  "EBP",
  "EDI",
  "EAX",
  "EDX",
  "ESI",
  "ESP",
  "FPR0L",
  "FPR0H",
  "FPR1L",
  "FPR1H",
  "FPR2L",
  "FPR2H",
  "FPR3L",
  "FPR3H",
  "FPR4L",
  "FPR4H",
  "FPR5L",
  "FPR5H",
  "FPR6L",
  "FPR6H",
  "FPR7L",
  "FPR7H",
  "XMM0",
  "XMM0b",
  "XMM0c",
  "XMM0d",
  "XMM0e",
  "XMM0f",
  "XMM0g",
  "XMM0h",
  "XMM1",
  "XMM1b",
  "XMM1c",
  "XMM1d",
  "XMM1e",
  "XMM1f",
  "XMM1g",
  "XMM1h",
  "XMM2",
  "XMM2b",
  "XMM2c",
  "XMM2d",
  "XMM2e",
  "XMM2f",
  "XMM2g",
  "XMM2h",
  "XMM3",
  "XMM3b",
  "XMM3c",
  "XMM3d",
  "XMM3e",
  "XMM3f",
  "XMM3g",
  "XMM3h",
  "XMM4",
  "XMM4b",
  "XMM4c",
  "XMM4d",
  "XMM4e",
  "XMM4f",
  "XMM4g",
  "XMM4h",
  "XMM5",
  "XMM5b",
  "XMM5c",
  "XMM5d",
  "XMM5e",
  "XMM5f",
  "XMM5g",
  "XMM5h",
  "XMM6",
  "XMM6b",
  "XMM6c",
  "XMM6d",
  "XMM6e",
  "XMM6f",
  "XMM6g",
  "XMM6h",
  "XMM7",
  "XMM7b",
  "XMM7c",
  "XMM7d",
  "XMM7e",
  "XMM7f",
  "XMM7g",
  "XMM7h",
  "RFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	rcx->as_VMReg(),
	rbx->as_VMReg(),
	rbp->as_VMReg(),
	rdi->as_VMReg(),
	rax->as_VMReg(),
	rdx->as_VMReg(),
	rsi->as_VMReg(),
	rsp->as_VMReg(),
	VMRegImpl::Bad(),
	VMRegImpl::Bad(),
	as_FloatRegister(0)->as_VMReg(),
	as_FloatRegister(0)->as_VMReg()->next(),
	as_FloatRegister(1)->as_VMReg(),
	as_FloatRegister(1)->as_VMReg()->next(),
	as_FloatRegister(2)->as_VMReg(),
	as_FloatRegister(2)->as_VMReg()->next(),
	as_FloatRegister(3)->as_VMReg(),
	as_FloatRegister(3)->as_VMReg()->next(),
	as_FloatRegister(4)->as_VMReg(),
	as_FloatRegister(4)->as_VMReg()->next(),
	as_FloatRegister(5)->as_VMReg(),
	as_FloatRegister(5)->as_VMReg()->next(),
	as_FloatRegister(6)->as_VMReg(),
	as_FloatRegister(6)->as_VMReg()->next(),
	xmm0->as_VMReg(),
	xmm0->as_VMReg()->next(1),
	xmm0->as_VMReg()->next(2),
	xmm0->as_VMReg()->next(3),
	xmm0->as_VMReg()->next(4),
	xmm0->as_VMReg()->next(5),
	xmm0->as_VMReg()->next(6),
	xmm0->as_VMReg()->next(7),
	xmm1->as_VMReg(),
	xmm1->as_VMReg()->next(1),
	xmm1->as_VMReg()->next(2),
	xmm1->as_VMReg()->next(3),
	xmm1->as_VMReg()->next(4),
	xmm1->as_VMReg()->next(5),
	xmm1->as_VMReg()->next(6),
	xmm1->as_VMReg()->next(7),
	xmm2->as_VMReg(),
	xmm2->as_VMReg()->next(1),
	xmm2->as_VMReg()->next(2),
	xmm2->as_VMReg()->next(3),
	xmm2->as_VMReg()->next(4),
	xmm2->as_VMReg()->next(5),
	xmm2->as_VMReg()->next(6),
	xmm2->as_VMReg()->next(7),
	xmm3->as_VMReg(),
	xmm3->as_VMReg()->next(1),
	xmm3->as_VMReg()->next(2),
	xmm3->as_VMReg()->next(3),
	xmm3->as_VMReg()->next(4),
	xmm3->as_VMReg()->next(5),
	xmm3->as_VMReg()->next(6),
	xmm3->as_VMReg()->next(7),
	xmm4->as_VMReg(),
	xmm4->as_VMReg()->next(1),
	xmm4->as_VMReg()->next(2),
	xmm4->as_VMReg()->next(3),
	xmm4->as_VMReg()->next(4),
	xmm4->as_VMReg()->next(5),
	xmm4->as_VMReg()->next(6),
	xmm4->as_VMReg()->next(7),
	xmm5->as_VMReg(),
	xmm5->as_VMReg()->next(1),
	xmm5->as_VMReg()->next(2),
	xmm5->as_VMReg()->next(3),
	xmm5->as_VMReg()->next(4),
	xmm5->as_VMReg()->next(5),
	xmm5->as_VMReg()->next(6),
	xmm5->as_VMReg()->next(7),
	xmm6->as_VMReg(),
	xmm6->as_VMReg()->next(1),
	xmm6->as_VMReg()->next(2),
	xmm6->as_VMReg()->next(3),
	xmm6->as_VMReg()->next(4),
	xmm6->as_VMReg()->next(5),
	xmm6->as_VMReg()->next(6),
	xmm6->as_VMReg()->next(7),
	xmm7->as_VMReg(),
	xmm7->as_VMReg()->next(1),
	xmm7->as_VMReg()->next(2),
	xmm7->as_VMReg()->next(3),
	xmm7->as_VMReg()->next(4),
	xmm7->as_VMReg()->next(5),
	xmm7->as_VMReg()->next(6),
	xmm7->as_VMReg()->next(7),
	VMRegImpl::Bad() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\x1',  // ECX
  (unsigned char)'\x3',  // EBX
  (unsigned char)'\x5',  // EBP
  (unsigned char)'\x7',  // EDI
  (unsigned char)'\x0',  // EAX
  (unsigned char)'\x2',  // EDX
  (unsigned char)'\x6',  // ESI
  (unsigned char)'\x4',  // ESP
  (unsigned char)'\x0',  // FPR0L
  (unsigned char)'\x0',  // FPR0H
  (unsigned char)'\x1',  // FPR1L
  (unsigned char)'\x1',  // FPR1H
  (unsigned char)'\x2',  // FPR2L
  (unsigned char)'\x2',  // FPR2H
  (unsigned char)'\x3',  // FPR3L
  (unsigned char)'\x3',  // FPR3H
  (unsigned char)'\x4',  // FPR4L
  (unsigned char)'\x4',  // FPR4H
  (unsigned char)'\x5',  // FPR5L
  (unsigned char)'\x5',  // FPR5H
  (unsigned char)'\x6',  // FPR6L
  (unsigned char)'\x6',  // FPR6H
  (unsigned char)'\x7',  // FPR7L
  (unsigned char)'\x7',  // FPR7H
  (unsigned char)'\x0',  // XMM0
  (unsigned char)'\x0',  // XMM0b
  (unsigned char)'\x0',  // XMM0c
  (unsigned char)'\x0',  // XMM0d
  (unsigned char)'\x0',  // XMM0e
  (unsigned char)'\x0',  // XMM0f
  (unsigned char)'\x0',  // XMM0g
  (unsigned char)'\x0',  // XMM0h
  (unsigned char)'\x1',  // XMM1
  (unsigned char)'\x1',  // XMM1b
  (unsigned char)'\x1',  // XMM1c
  (unsigned char)'\x1',  // XMM1d
  (unsigned char)'\x1',  // XMM1e
  (unsigned char)'\x1',  // XMM1f
  (unsigned char)'\x1',  // XMM1g
  (unsigned char)'\x1',  // XMM1h
  (unsigned char)'\x2',  // XMM2
  (unsigned char)'\x2',  // XMM2b
  (unsigned char)'\x2',  // XMM2c
  (unsigned char)'\x2',  // XMM2d
  (unsigned char)'\x2',  // XMM2e
  (unsigned char)'\x2',  // XMM2f
  (unsigned char)'\x2',  // XMM2g
  (unsigned char)'\x2',  // XMM2h
  (unsigned char)'\x3',  // XMM3
  (unsigned char)'\x3',  // XMM3b
  (unsigned char)'\x3',  // XMM3c
  (unsigned char)'\x3',  // XMM3d
  (unsigned char)'\x3',  // XMM3e
  (unsigned char)'\x3',  // XMM3f
  (unsigned char)'\x3',  // XMM3g
  (unsigned char)'\x3',  // XMM3h
  (unsigned char)'\x4',  // XMM4
  (unsigned char)'\x4',  // XMM4b
  (unsigned char)'\x4',  // XMM4c
  (unsigned char)'\x4',  // XMM4d
  (unsigned char)'\x4',  // XMM4e
  (unsigned char)'\x4',  // XMM4f
  (unsigned char)'\x4',  // XMM4g
  (unsigned char)'\x4',  // XMM4h
  (unsigned char)'\x5',  // XMM5
  (unsigned char)'\x5',  // XMM5b
  (unsigned char)'\x5',  // XMM5c
  (unsigned char)'\x5',  // XMM5d
  (unsigned char)'\x5',  // XMM5e
  (unsigned char)'\x5',  // XMM5f
  (unsigned char)'\x5',  // XMM5g
  (unsigned char)'\x5',  // XMM5h
  (unsigned char)'\x6',  // XMM6
  (unsigned char)'\x6',  // XMM6b
  (unsigned char)'\x6',  // XMM6c
  (unsigned char)'\x6',  // XMM6d
  (unsigned char)'\x6',  // XMM6e
  (unsigned char)'\x6',  // XMM6f
  (unsigned char)'\x6',  // XMM6g
  (unsigned char)'\x6',  // XMM6h
  (unsigned char)'\x7',  // XMM7
  (unsigned char)'\x7',  // XMM7b
  (unsigned char)'\x7',  // XMM7c
  (unsigned char)'\x7',  // XMM7d
  (unsigned char)'\x7',  // XMM7e
  (unsigned char)'\x7',  // XMM7f
  (unsigned char)'\x7',  // XMM7g
  (unsigned char)'\x7',  // XMM7h
  (unsigned char)'\x8' // no trailing comma  // RFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone(Compile* C) const {
  return  new (C) labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone(Compile* C) const {
  return  new (C) methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *rRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *xRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_X_REG_mask();
}

const RegMask *eAXRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EAX_REG_mask();
}

const RegMask *eBXRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EBX_REG_mask();
}

const RegMask *eCXRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ECX_REG_mask();
}

const RegMask *eDXRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EDX_REG_mask();
}

const RegMask *eDIRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EDI_REG_mask();
}

const RegMask *naxRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NAX_REG_mask();
}

const RegMask *nadxRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NADX_REG_mask();
}

const RegMask *ncxRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NCX_REG_mask();
}

const RegMask *eSIRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask();
}

const RegMask *anyRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *eRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *eRegP_no_EBPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_NO_RBP_mask();
}

const RegMask *naxRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NAX_REG_mask();
}

const RegMask *nabxRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NABX_REG_mask();
}

const RegMask *pRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *eAXRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EAX_REG_mask();
}

const RegMask *eBXRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EBX_REG_mask();
}

const RegMask *eCXRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ECX_REG_mask();
}

const RegMask *eSIRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask();
}

const RegMask *eDIRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EDI_REG_mask();
}

const RegMask *eBPRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EBP_REG_mask();
}

const RegMask *eRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_REG_mask();
}

const RegMask *eADXRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EADX_REG_mask();
}

const RegMask *eBCXRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EBCX_REG_mask();
}

const RegMask *eADXRegL_low_onlyOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EADX_REG_mask();
}

const RegMask *eFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *eFlagsRegUOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *eFlagsRegUCFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *flagsReg_long_LTGEOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *flagsReg_long_EQNEOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *flagsReg_long_LEGTOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *regDPROper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_DBL_REG_mask();
}

const RegMask *regDPR1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_DBL_REG0_mask();
}

const RegMask *regDPR2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_DBL_REG1_mask();
}

const RegMask *regnotDPR1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_DBL_NOTREG0_mask();
}

const RegMask *regFPROper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_FLT_REG_mask();
}

const RegMask *regFPR1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_FLT_REG0_mask();
}

const RegMask *regFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_mask();
}

const RegMask *regDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset32Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset32XOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indIndexOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indIndexScaleOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indIndexScaleOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &INT_REG_mask();
}

const RegMask *load_long_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask();
}

const RegMask *load_long_indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask();
}

const RegMask *load_long_indOffset32Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *indirect_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset8_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_NO_RBP_mask();
}

const RegMask *indOffset32_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_NO_RBP_mask();
}

const RegMask *indIndexOffset_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_NO_RBP_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScale_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_NO_RBP_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaleOffset_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_NO_RBP_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *vecSOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORS_REG_mask();
}

const RegMask *vecDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORD_REG_mask();
}

const RegMask *vecXOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORX_REG_mask();
}

const RegMask *vecYOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORY_REG_mask();
}

//------------------Define members for classes derived from MachNode----------

void popCountINode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *popCountINode::cisc_version( int offset, Compile* C ) {
  popCountI_memNode *node = new (C) popCountI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void popCountLNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *popCountLNode::cisc_version( int offset, Compile* C ) {
  popCountL_memNode *node = new (C) popCountL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovI_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovI_regNode::cisc_version( int offset, Compile* C ) {
  cmovI_memNode *node = new (C) cmovI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovI_regUNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovI_regUNode::cisc_version( int offset, Compile* C ) {
  cmovI_memUNode *node = new (C) cmovI_memUNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovI_regUCFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovI_regUCFNode::cisc_version( int offset, Compile* C ) {
  cmovI_memUCFNode *node = new (C) cmovI_memUCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addI_eRegNode::cisc_version( int offset, Compile* C ) {
  addI_eReg_memNode *node = new (C) addI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subI_eRegNode::cisc_version( int offset, Compile* C ) {
  subI_eReg_memNode *node = new (C) subI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulI_eRegNode::cisc_version( int offset, Compile* C ) {
  mulINode *node = new (C) mulINode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulI_eReg_immNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulI_eReg_immNode::cisc_version( int offset, Compile* C ) {
  mulI_mem_immNode *node = new (C) mulI_mem_immNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void i2bNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_X_REG_mask();
}

// Build CISC version of this instruction
MachNode *i2bNode::cisc_version( int offset, Compile* C ) {
  loadI2BNode *node = new (C) loadI2BNode();
  node->_num_opnds = 3;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void i2sNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_X_REG_mask();
}

// Build CISC version of this instruction
MachNode *i2sNode::cisc_version( int offset, Compile* C ) {
  loadI2SNode *node = new (C) loadI2SNode();
  node->_num_opnds = 3;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void andI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andI_eRegNode::cisc_version( int offset, Compile* C ) {
  andI_eReg_memNode *node = new (C) andI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void andnI_rReg_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andnI_rReg_rReg_rRegNode::cisc_version( int offset, Compile* C ) {
  andnI_rReg_rReg_memNode *node = new (C) andnI_rReg_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void andnI_rReg_rReg_rReg_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andnI_rReg_rReg_rReg_0Node::cisc_version( int offset, Compile* C ) {
  andnI_rReg_rReg_mem_0Node *node = new (C) andnI_rReg_rReg_mem_0Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void orI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *orI_eRegNode::cisc_version( int offset, Compile* C ) {
  orI_eReg_memNode *node = new (C) orI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void xorI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *xorI_eRegNode::cisc_version( int offset, Compile* C ) {
  xorI_eReg_memNode *node = new (C) xorI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addL_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *addL_eRegNode::cisc_version( int offset, Compile* C ) {
  addL_eReg_memNode *node = new (C) addL_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subL_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *subL_eRegNode::cisc_version( int offset, Compile* C ) {
  subL_eReg_memNode *node = new (C) subL_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void andL_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *andL_eRegNode::cisc_version( int offset, Compile* C ) {
  andL_eReg_memNode *node = new (C) andL_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void andnL_eReg_eReg_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *andnL_eReg_eReg_eRegNode::cisc_version( int offset, Compile* C ) {
  andnL_eReg_eReg_memNode *node = new (C) andnL_eReg_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void andnL_eReg_eReg_eReg_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *andnL_eReg_eReg_eReg_0Node::cisc_version( int offset, Compile* C ) {
  andnL_eReg_eReg_mem_0Node *node = new (C) andnL_eReg_eReg_mem_0Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void orl_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *orl_eRegNode::cisc_version( int offset, Compile* C ) {
  orl_eReg_memNode *node = new (C) orl_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void xorl_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *xorl_eRegNode::cisc_version( int offset, Compile* C ) {
  xorl_eReg_memNode *node = new (C) xorl_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpD_ccNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpD_ccNode::cisc_version( int offset, Compile* C ) {
  cmpD_ccmemNode *node = new (C) cmpD_ccmemNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpD_ccCFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpD_ccCFNode::cisc_version( int offset, Compile* C ) {
  cmpD_ccmemCFNode *node = new (C) cmpD_ccmemCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpD_regNode::cisc_version( int offset, Compile* C ) {
  cmpD_regmemNode *node = new (C) cmpD_regmemNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subDPR_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *subDPR_regNode::cisc_version( int offset, Compile* C ) {
  subDPR_reg_memNode *node = new (C) subDPR_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addDPR_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *addDPR_regNode::cisc_version( int offset, Compile* C ) {
  addDPR_reg_memNode *node = new (C) addDPR_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulDPR_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulDPR_regNode::cisc_version( int offset, Compile* C ) {
  mulDPR_reg_memNode *node = new (C) mulDPR_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpF_ccNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpF_ccNode::cisc_version( int offset, Compile* C ) {
  cmpF_ccmemNode *node = new (C) cmpF_ccmemNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpF_ccCFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpF_ccCFNode::cisc_version( int offset, Compile* C ) {
  cmpF_ccmemCFNode *node = new (C) cmpF_ccmemCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpF_regNode::cisc_version( int offset, Compile* C ) {
  cmpF_regmemNode *node = new (C) cmpF_regmemNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addFPR24_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addFPR24_regNode::cisc_version( int offset, Compile* C ) {
  addFPR24_reg_memNode *node = new (C) addFPR24_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addFPR_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addFPR_regNode::cisc_version( int offset, Compile* C ) {
  addFPR_reg_memNode *node = new (C) addFPR_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addFPR24_reg_memNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addFPR24_reg_memNode::cisc_version( int offset, Compile* C ) {
  addFPR24_mem_ciscNode *node = new (C) addFPR24_mem_ciscNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addFPR24_reg_mem_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addFPR24_reg_mem_0Node::cisc_version( int offset, Compile* C ) {
  addFPR24_mem_cisc_0Node *node = new (C) addFPR24_mem_cisc_0Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addFPR24_mem_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addFPR24_mem_regNode::cisc_version( int offset, Compile* C ) {
  addFPR24_mem_ciscNode *node = new (C) addFPR24_mem_ciscNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulFPR24_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulFPR24_regNode::cisc_version( int offset, Compile* C ) {
  mulFPR24_reg_memNode *node = new (C) mulFPR24_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulFPR_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulFPR_regNode::cisc_version( int offset, Compile* C ) {
  mulFPR_reg_memNode *node = new (C) mulFPR_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addFPR_mulFPR_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addFPR_mulFPR_regNode::cisc_version( int offset, Compile* C ) {
  addFPR_mulFPR_reg_load1Node *node = new (C) addFPR_mulFPR_reg_load1Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addFPR_mulFPR_reg_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FP_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addFPR_mulFPR_reg_0Node::cisc_version( int offset, Compile* C ) {
  addFPR_mulFPR_reg_load1_1Node *node = new (C) addFPR_mulFPR_reg_load1_1Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void convI2L_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convI2L_regNode::cisc_version( int offset, Compile* C ) {
  loadI2LNode *node = new (C) loadI2LNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void convI2L_reg_zexNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convI2L_reg_zexNode::cisc_version( int offset, Compile* C ) {
  loadUI2LNode *node = new (C) loadUI2LNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void compI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compI_eRegNode::cisc_version( int offset, Compile* C ) {
  compI_eReg_memNode *node = new (C) compI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void compU_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compU_eRegNode::cisc_version( int offset, Compile* C ) {
  compU_eReg_memNode *node = new (C) compU_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void compP_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compP_eRegNode::cisc_version( int offset, Compile* C ) {
  compP_eReg_memNode *node = new (C) compP_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}

// Build short branch version of this instruction
MachNode *jmpDirNode::short_branch_version(Compile* C) {
  jmpDir_shortNode *node = new (C) jmpDir_shortNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConNode::short_branch_version(Compile* C) {
  jmpCon_shortNode *node = new (C) jmpCon_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEndNode::short_branch_version(Compile* C) {
  jmpLoopEnd_shortNode *node = new (C) jmpLoopEnd_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEndUNode::short_branch_version(Compile* C) {
  jmpLoopEndU_shortNode *node = new (C) jmpLoopEndU_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEndUCFNode::short_branch_version(Compile* C) {
  jmpLoopEndUCF_shortNode *node = new (C) jmpLoopEndUCF_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUNode::short_branch_version(Compile* C) {
  jmpConU_shortNode *node = new (C) jmpConU_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUCFNode::short_branch_version(Compile* C) {
  jmpConUCF_shortNode *node = new (C) jmpConUCF_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUCF2Node::short_branch_version(Compile* C) {
  jmpConUCF2_shortNode *node = new (C) jmpConUCF2_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}


void cmovLL_reg_LTGENode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovLL_reg_LTGENode::cisc_version( int offset, Compile* C ) {
  cmovLL_mem_LTGENode *node = new (C) cmovLL_mem_LTGENode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovII_reg_LTGENode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovII_reg_LTGENode::cisc_version( int offset, Compile* C ) {
  cmovII_mem_LTGENode *node = new (C) cmovII_mem_LTGENode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovLL_reg_EQNENode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovLL_reg_EQNENode::cisc_version( int offset, Compile* C ) {
  cmovLL_mem_EQNENode *node = new (C) cmovLL_mem_EQNENode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovII_reg_EQNENode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovII_reg_EQNENode::cisc_version( int offset, Compile* C ) {
  cmovII_mem_EQNENode *node = new (C) cmovII_mem_EQNENode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovLL_reg_LEGTNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovLL_reg_LEGTNode::cisc_version( int offset, Compile* C ) {
  cmovLL_mem_LEGTNode *node = new (C) cmovLL_mem_LEGTNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovII_reg_LEGTNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovII_reg_LEGTNode::cisc_version( int offset, Compile* C ) {
  cmovII_mem_LEGTNode *node = new (C) cmovII_mem_LEGTNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addF_regNode::cisc_version( int offset, Compile* C ) {
  addF_memNode *node = new (C) addF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addF_reg_regNode::cisc_version( int offset, Compile* C ) {
  addF_reg_memNode *node = new (C) addF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *addD_regNode::cisc_version( int offset, Compile* C ) {
  addD_memNode *node = new (C) addD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *addD_reg_regNode::cisc_version( int offset, Compile* C ) {
  addD_reg_memNode *node = new (C) addD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subF_regNode::cisc_version( int offset, Compile* C ) {
  subF_memNode *node = new (C) subF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subF_reg_regNode::cisc_version( int offset, Compile* C ) {
  subF_reg_memNode *node = new (C) subF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *subD_regNode::cisc_version( int offset, Compile* C ) {
  subD_memNode *node = new (C) subD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *subD_reg_regNode::cisc_version( int offset, Compile* C ) {
  subD_reg_memNode *node = new (C) subD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulF_regNode::cisc_version( int offset, Compile* C ) {
  mulF_memNode *node = new (C) mulF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulF_reg_regNode::cisc_version( int offset, Compile* C ) {
  mulF_reg_memNode *node = new (C) mulF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulD_regNode::cisc_version( int offset, Compile* C ) {
  mulD_memNode *node = new (C) mulD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulD_reg_regNode::cisc_version( int offset, Compile* C ) {
  mulD_reg_memNode *node = new (C) mulD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void divF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *divF_regNode::cisc_version( int offset, Compile* C ) {
  divF_memNode *node = new (C) divF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void divF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *divF_reg_regNode::cisc_version( int offset, Compile* C ) {
  divF_reg_memNode *node = new (C) divF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void divD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *divD_regNode::cisc_version( int offset, Compile* C ) {
  divD_memNode *node = new (C) divD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void divD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *divD_reg_regNode::cisc_version( int offset, Compile* C ) {
  divD_reg_memNode *node = new (C) divD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void sqrtF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *sqrtF_regNode::cisc_version( int offset, Compile* C ) {
  sqrtF_memNode *node = new (C) sqrtF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void sqrtD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *sqrtD_regNode::cisc_version( int offset, Compile* C ) {
  sqrtD_memNode *node = new (C) sqrtD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void Repl2INode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *Repl2INode::cisc_version( int offset, Compile* C ) {
  Repl2I_memNode *node = new (C) Repl2I_memNode();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void Repl4INode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *Repl4INode::cisc_version( int offset, Compile* C ) {
  Repl4I_memNode *node = new (C) Repl4I_memNode();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void Repl8INode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *Repl8INode::cisc_version( int offset, Compile* C ) {
  Repl8I_memNode *node = new (C) Repl8I_memNode();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


// Copy _idx, inputs and operands to new node
void MachNode::fill_new_machnode( MachNode* node, Compile* C) const {
  // New node must use same node index
  node->set_idx( _idx );
  // Copy machine-independent inputs
  for( uint j = 0; j < req(); j++ ) {
    node->add_req(in(j));
  }
  // Copy my operands, except for cisc position
  int nopnds = num_opnds();
  assert( node->num_opnds() == (uint)nopnds, "Must have same number of operands");
  MachOper **to = node->_opnds;
  for( int i = 0; i < nopnds; i++ ) {
    if( i != cisc_operand() ) 
      to[i] = _opnds[i]->clone(C);
  }
}

void jmpDirNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpDirNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEndNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEndNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEndUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEndUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEndUCFNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEndUCFNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUCFNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUCFNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUCF2Node::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUCF2Node::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpDir_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpDir_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpCon_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpCon_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEndU_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEndU_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEndUCF_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEndUCF_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConU_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConU_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUCF_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUCF_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUCF2_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUCF2_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_LTGENode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_LTGENode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_EQNENode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_EQNENode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_LEGTNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_LEGTNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallStaticJavaHandleNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int popCountI_memNode::reloc() const {
  return 1;
}

int popCountL_memNode::reloc() const {
  return 1;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadUB2L_immI8Node::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2BNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2BNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadUS2L_immI_255Node::reloc() const {
  return 1;
}

int loadUS2L_immI16Node::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2BNode::reloc() const {
  return 1;
}

int loadI2UBNode::reloc() const {
  return 1;
}

int loadI2SNode::reloc() const {
  return 1;
}

int loadI2USNode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadI2L_immI_255Node::reloc() const {
  return 1;
}

int loadI2L_immI_65535Node::reloc() const {
  return 1;
}

int loadI2L_immU31Node::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadL_volatileNode::reloc() const {
  return 1;
}

int loadLX_volatileNode::reloc() const {
  return 1;
}

int loadLX_reg_volatileNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadDPRNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadD_partialNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadFPRNode::reloc() const {
  return 1;
}

int loadConPNode::reloc() const {
  return 1;
}

int loadConFPRNode::reloc() const {
  return 2;
}

int loadConFPR0Node::reloc() const {
  return 2;
}

int loadConFPR1Node::reloc() const {
  return 2;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConF0Node::reloc() const {
  return 2;
}

int loadConDPRNode::reloc() const {
  return 2;
}

int loadConDPR0Node::reloc() const {
  return 2;
}

int loadConDPR1Node::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int loadConD0Node::reloc() const {
  return 2;
}

int prefetchr0Node::reloc() const {
  return 1;
}

int prefetchrNode::reloc() const {
  return 1;
}

int prefetchrNTANode::reloc() const {
  return 1;
}

int prefetchrT0Node::reloc() const {
  return 1;
}

int prefetchrT2Node::reloc() const {
  return 1;
}

int prefetchw0Node::reloc() const {
  return 1;
}

int prefetchwNode::reloc() const {
  return 1;
}

int prefetchwNTANode::reloc() const {
  return 1;
}

int prefetchAlloc0Node::reloc() const {
  return 1;
}

int prefetchAllocNode::reloc() const {
  return 1;
}

int prefetchAllocNTANode::reloc() const {
  return 1;
}

int prefetchAllocT0Node::reloc() const {
  return 1;
}

int prefetchAllocT2Node::reloc() const {
  return 1;
}

int storeBNode::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storeL2INode::reloc() const {
  return 2;
}

int storeL_volatileNode::reloc() const {
  return 2;
}

int storeLX_volatileNode::reloc() const {
  return 2;
}

int storeLX_reg_volatileNode::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeImmINode::reloc() const {
  return 2;
}

int storeImmI16Node::reloc() const {
  return 2;
}

int storeImmPNode::reloc() const {
  return 3;
}

int storeImmBNode::reloc() const {
  return 2;
}

int storeImmCMNode::reloc() const {
  return 2;
}

int storeDPRNode::reloc() const {
  return 2;
}

int storeDPR_roundedNode::reloc() const {
  return 2;
}

int storeDNode::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeFPRNode::reloc() const {
  return 2;
}

int storeFPR_roundedNode::reloc() const {
  return 2;
}

int storeFPR_DroundedNode::reloc() const {
  return 2;
}

int storeFPR_immNode::reloc() const {
  return 3;
}

int storeF_immNode::reloc() const {
  return 3;
}

int cmovI_memNode::reloc() const {
  return 1;
}

int cmovI_memUNode::reloc() const {
  return 1;
}

int cmovI_memUCFNode::reloc() const {
  return 1;
}

int addI_eReg_memNode::reloc() const {
  return 1;
}

int addI_eReg_mem_0Node::reloc() const {
  return 1;
}

int addI_mem_eRegNode::reloc() const {
  return 3;
}

int addI_mem_eReg_0Node::reloc() const {
  return 3;
}

int addI_mem_immNode::reloc() const {
  return 3;
}

int incI_memNode::reloc() const {
  return 3;
}

int decI_memNode::reloc() const {
  return 3;
}

int loadPLockedNode::reloc() const {
  return 1;
}

int storePConditionalNode::reloc() const {
  return 1;
}

int storeIConditionalNode::reloc() const {
  return 1;
}

int storeLConditionalNode::reloc() const {
  return 1;
}

int xaddI_no_resNode::reloc() const {
  return 1;
}

int xaddINode::reloc() const {
  return 1;
}

int xchgINode::reloc() const {
  return 1;
}

int xchgPNode::reloc() const {
  return 1;
}

int subI_eReg_memNode::reloc() const {
  return 1;
}

int subI_mem_eRegNode::reloc() const {
  return 3;
}

int mulI_mem_immNode::reloc() const {
  return 1;
}

int mulINode::reloc() const {
  return 1;
}

int mulI_0Node::reloc() const {
  return 1;
}

int sarI_mem_1Node::reloc() const {
  return 3;
}

int sarI_mem_immNode::reloc() const {
  return 3;
}

int andI_eReg_memNode::reloc() const {
  return 1;
}

int andI_eReg_mem_0Node::reloc() const {
  return 1;
}

int andI_mem_eRegNode::reloc() const {
  return 3;
}

int andI_mem_eReg_0Node::reloc() const {
  return 3;
}

int andI_mem_immNode::reloc() const {
  return 3;
}

int andnI_rReg_rReg_memNode::reloc() const {
  return 1;
}

int andnI_rReg_rReg_mem_0Node::reloc() const {
  return 1;
}

int blsiI_rReg_memNode::reloc() const {
  return 2;
}

int blsiI_rReg_mem_0Node::reloc() const {
  return 2;
}

int blsmskI_rReg_memNode::reloc() const {
  return 2;
}

int blsmskI_rReg_mem_0Node::reloc() const {
  return 2;
}

int blsrI_rReg_memNode::reloc() const {
  return 2;
}

int blsrI_rReg_mem_0Node::reloc() const {
  return 2;
}

int orI_eReg_memNode::reloc() const {
  return 1;
}

int orI_eReg_mem_0Node::reloc() const {
  return 1;
}

int orI_mem_eRegNode::reloc() const {
  return 3;
}

int orI_mem_eReg_0Node::reloc() const {
  return 3;
}

int orI_mem_immNode::reloc() const {
  return 3;
}

int xorI_eReg_memNode::reloc() const {
  return 1;
}

int xorI_eReg_mem_0Node::reloc() const {
  return 1;
}

int xorI_mem_eRegNode::reloc() const {
  return 3;
}

int xorI_mem_eReg_0Node::reloc() const {
  return 3;
}

int xorI_mem_immNode::reloc() const {
  return 3;
}

int addL_eReg_memNode::reloc() const {
  return 1;
}

int addL_eReg_mem_0Node::reloc() const {
  return 1;
}

int subL_eReg_memNode::reloc() const {
  return 1;
}

int andL_eReg_memNode::reloc() const {
  return 1;
}

int andL_eReg_mem_0Node::reloc() const {
  return 1;
}

int andnL_eReg_eReg_memNode::reloc() const {
  return 1;
}

int andnL_eReg_eReg_mem_0Node::reloc() const {
  return 1;
}

int blsiL_eReg_memNode::reloc() const {
  return 2;
}

int blsiL_eReg_mem_0Node::reloc() const {
  return 2;
}

int blsmskL_eReg_memNode::reloc() const {
  return 2;
}

int blsmskL_eReg_mem_0Node::reloc() const {
  return 2;
}

int blsrL_eReg_memNode::reloc() const {
  return 2;
}

int blsrL_eReg_mem_0Node::reloc() const {
  return 2;
}

int orl_eReg_memNode::reloc() const {
  return 1;
}

int orl_eReg_mem_0Node::reloc() const {
  return 1;
}

int xorl_eReg_memNode::reloc() const {
  return 1;
}

int xorl_eReg_mem_0Node::reloc() const {
  return 1;
}

int cmpDPR_0Node::reloc() const {
  return 1;
}

int cmpD_ccmemNode::reloc() const {
  return 1;
}

int cmpD_ccmemCFNode::reloc() const {
  return 1;
}

int cmpD_regmemNode::reloc() const {
  return 1;
}

int subDPR_reg_memNode::reloc() const {
  return 1;
}

int addDPR_reg_memNode::reloc() const {
  return 1;
}

int addDPR_reg_mem_0Node::reloc() const {
  return 1;
}

int addDPR_mem_regNode::reloc() const {
  return 3;
}

int addDPR_mem_reg_0Node::reloc() const {
  return 3;
}

int addDPR_reg_imm1Node::reloc() const {
  return 1;
}

int addDPR_reg_immNode::reloc() const {
  return 1;
}

int addDPR_reg_imm_roundNode::reloc() const {
  return 1;
}

int mulDPR_reg_immNode::reloc() const {
  return 1;
}

int mulDPR_reg_memNode::reloc() const {
  return 1;
}

int mulDPR_reg_mem_0Node::reloc() const {
  return 1;
}

int mulDPR_reg_mem_ciscNode::reloc() const {
  return 1;
}

int mulDPR_reg_mem_cisc_0Node::reloc() const {
  return 1;
}

int cmpFPR_0Node::reloc() const {
  return 1;
}

int cmpF_ccmemNode::reloc() const {
  return 1;
}

int cmpF_ccmemCFNode::reloc() const {
  return 1;
}

int cmpF_regmemNode::reloc() const {
  return 1;
}

int addFPR24_reg_memNode::reloc() const {
  return 1;
}

int addFPR24_reg_mem_0Node::reloc() const {
  return 1;
}

int addFPR_reg_memNode::reloc() const {
  return 1;
}

int addFPR_reg_mem_0Node::reloc() const {
  return 1;
}

int addFPR24_mem_regNode::reloc() const {
  return 1;
}

int addFPR24_mem_ciscNode::reloc() const {
  return 2;
}

int addFPR24_mem_cisc_0Node::reloc() const {
  return 2;
}

int addFPR24_mem_memNode::reloc() const {
  return 2;
}

int addFPR24_reg_immNode::reloc() const {
  return 1;
}

int addFPR_reg_immNode::reloc() const {
  return 1;
}

int mulFPR24_reg_memNode::reloc() const {
  return 1;
}

int mulFPR24_reg_mem_0Node::reloc() const {
  return 1;
}

int mulFPR_reg_memNode::reloc() const {
  return 1;
}

int mulFPR_reg_mem_0Node::reloc() const {
  return 1;
}

int mulFPR24_mem_memNode::reloc() const {
  return 2;
}

int mulFPR24_reg_immNode::reloc() const {
  return 1;
}

int mulFPR_reg_immNode::reloc() const {
  return 1;
}

int mulFPR_reg_load1Node::reloc() const {
  return 1;
}

int mulFPR_reg_load1_0Node::reloc() const {
  return 1;
}

int addFPR_mulFPR_reg_load1Node::reloc() const {
  return 1;
}

int addFPR_mulFPR_reg_load1_1Node::reloc() const {
  return 1;
}

int addFPR_mulFPR_reg_load1_0Node::reloc() const {
  return 1;
}

int addFPR_mulFPR_reg_load1_2Node::reloc() const {
  return 1;
}

int convI2D_memNode::reloc() const {
  return 1;
}

int convI2DPR_memNode::reloc() const {
  return 1;
}

int convI2FPR_SSF_memNode::reloc() const {
  return 1;
}

int convI2FPR_memNode::reloc() const {
  return 1;
}

int compI_eReg_memNode::reloc() const {
  return 1;
}

int testI_reg_memNode::reloc() const {
  return 1;
}

int compU_eReg_memNode::reloc() const {
  return 1;
}

int compP_eReg_immNode::reloc() const {
  return 1;
}

int compP_eReg_memNode::reloc() const {
  return 1;
}

int compP_mem_eRegNode::reloc() const {
  return 1;
}

int testP_regNode::reloc() const {
  return 1;
}

int testP_Reg_memNode::reloc() const {
  return 1;
}

int partialSubtypeCheck_vs_ZeroNode::reloc() const {
  return 1;
}

int cmovLL_mem_LTGENode::reloc() const {
  return 1;
}

int cmovII_mem_LTGENode::reloc() const {
  return 1;
}

int cmovLL_mem_EQNENode::reloc() const {
  return 1;
}

int cmovII_mem_EQNENode::reloc() const {
  return 1;
}

int cmovLL_mem_LEGTNode::reloc() const {
  return 1;
}

int cmovII_mem_LEGTNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallStaticJavaHandleNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int tailjmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int safePoint_pollNode::reloc() const {
  return 1;
}

int addF_memNode::reloc() const {
  return 1;
}

int addF_mem_0Node::reloc() const {
  return 1;
}

int addF_immNode::reloc() const {
  return 1;
}

int addF_reg_memNode::reloc() const {
  return 1;
}

int addF_reg_mem_0Node::reloc() const {
  return 1;
}

int addF_reg_immNode::reloc() const {
  return 1;
}

int addD_memNode::reloc() const {
  return 1;
}

int addD_mem_0Node::reloc() const {
  return 1;
}

int addD_immNode::reloc() const {
  return 1;
}

int addD_reg_memNode::reloc() const {
  return 1;
}

int addD_reg_mem_0Node::reloc() const {
  return 1;
}

int addD_reg_immNode::reloc() const {
  return 1;
}

int subF_memNode::reloc() const {
  return 1;
}

int subF_immNode::reloc() const {
  return 1;
}

int subF_reg_memNode::reloc() const {
  return 1;
}

int subF_reg_immNode::reloc() const {
  return 1;
}

int subD_memNode::reloc() const {
  return 1;
}

int subD_immNode::reloc() const {
  return 1;
}

int subD_reg_memNode::reloc() const {
  return 1;
}

int subD_reg_immNode::reloc() const {
  return 1;
}

int mulF_memNode::reloc() const {
  return 1;
}

int mulF_mem_0Node::reloc() const {
  return 1;
}

int mulF_immNode::reloc() const {
  return 1;
}

int mulF_reg_memNode::reloc() const {
  return 1;
}

int mulF_reg_mem_0Node::reloc() const {
  return 1;
}

int mulF_reg_immNode::reloc() const {
  return 1;
}

int mulD_memNode::reloc() const {
  return 1;
}

int mulD_mem_0Node::reloc() const {
  return 1;
}

int mulD_immNode::reloc() const {
  return 1;
}

int mulD_reg_memNode::reloc() const {
  return 1;
}

int mulD_reg_mem_0Node::reloc() const {
  return 1;
}

int mulD_reg_immNode::reloc() const {
  return 1;
}

int divF_memNode::reloc() const {
  return 1;
}

int divF_immNode::reloc() const {
  return 1;
}

int divF_reg_memNode::reloc() const {
  return 1;
}

int divF_reg_immNode::reloc() const {
  return 1;
}

int divD_memNode::reloc() const {
  return 1;
}

int divD_immNode::reloc() const {
  return 1;
}

int divD_reg_memNode::reloc() const {
  return 1;
}

int divD_reg_immNode::reloc() const {
  return 1;
}

int sqrtF_memNode::reloc() const {
  return 1;
}

int sqrtF_immNode::reloc() const {
  return 1;
}

int sqrtD_memNode::reloc() const {
  return 1;
}

int sqrtD_immNode::reloc() const {
  return 1;
}

int loadV4Node::reloc() const {
  return 1;
}

int loadV8Node::reloc() const {
  return 1;
}

int loadV16Node::reloc() const {
  return 1;
}

int loadV32Node::reloc() const {
  return 1;
}

int storeV4Node::reloc() const {
  return 2;
}

int storeV8Node::reloc() const {
  return 2;
}

int storeV16Node::reloc() const {
  return 2;
}

int storeV32Node::reloc() const {
  return 2;
}

int Repl2I_memNode::reloc() const {
  return 1;
}

int Repl4I_memNode::reloc() const {
  return 1;
}

int Repl8I_memNode::reloc() const {
  return 1;
}

int Repl2L_memNode::reloc() const {
  return 1;
}

int Repl4L_memNode::reloc() const {
  return 1;
}

int Repl2F_zeroNode::reloc() const {
  return 1;
}

int Repl4F_zeroNode::reloc() const {
  return 1;
}

int Repl8F_zeroNode::reloc() const {
  return 1;
}

int Repl2D_zeroNode::reloc() const {
  return 1;
}

int Repl4D_zeroNode::reloc() const {
  return 1;
}

int vadd16B_memNode::reloc() const {
  return 1;
}

int vadd32B_memNode::reloc() const {
  return 1;
}

int vadd8S_memNode::reloc() const {
  return 1;
}

int vadd16S_memNode::reloc() const {
  return 1;
}

int vadd4I_memNode::reloc() const {
  return 1;
}

int vadd8I_memNode::reloc() const {
  return 1;
}

int vadd2L_memNode::reloc() const {
  return 1;
}

int vadd4L_memNode::reloc() const {
  return 1;
}

int vadd4F_memNode::reloc() const {
  return 1;
}

int vadd8F_memNode::reloc() const {
  return 1;
}

int vadd2D_memNode::reloc() const {
  return 1;
}

int vadd4D_memNode::reloc() const {
  return 1;
}

int vsub16B_memNode::reloc() const {
  return 1;
}

int vsub32B_memNode::reloc() const {
  return 1;
}

int vsub8S_memNode::reloc() const {
  return 1;
}

int vsub16S_memNode::reloc() const {
  return 1;
}

int vsub4I_memNode::reloc() const {
  return 1;
}

int vsub8I_memNode::reloc() const {
  return 1;
}

int vsub2L_memNode::reloc() const {
  return 1;
}

int vsub4L_memNode::reloc() const {
  return 1;
}

int vsub4F_memNode::reloc() const {
  return 1;
}

int vsub8F_memNode::reloc() const {
  return 1;
}

int vsub2D_memNode::reloc() const {
  return 1;
}

int vsub4D_memNode::reloc() const {
  return 1;
}

int vmul8S_memNode::reloc() const {
  return 1;
}

int vmul16S_memNode::reloc() const {
  return 1;
}

int vmul4I_memNode::reloc() const {
  return 1;
}

int vmul8I_memNode::reloc() const {
  return 1;
}

int vmul4F_memNode::reloc() const {
  return 1;
}

int vmul8F_memNode::reloc() const {
  return 1;
}

int vmul2D_memNode::reloc() const {
  return 1;
}

int vmul4D_memNode::reloc() const {
  return 1;
}

int vdiv4F_memNode::reloc() const {
  return 1;
}

int vdiv8F_memNode::reloc() const {
  return 1;
}

int vdiv2D_memNode::reloc() const {
  return 1;
}

int vdiv4D_memNode::reloc() const {
  return 1;
}

int vand16B_memNode::reloc() const {
  return 1;
}

int vand32B_memNode::reloc() const {
  return 1;
}

int vor16B_memNode::reloc() const {
  return 1;
}

int vor32B_memNode::reloc() const {
  return 1;
}

int vxor16B_memNode::reloc() const {
  return 1;
}

int vxor32B_memNode::reloc() const {
  return 1;
}


void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 12267 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1676 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_cc(cbuf, (0xC8 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 12275 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 1680 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int destlo = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int desthi = HIGH_FROM_LOW(destlo);
    // bswap lo
    emit_opcode(cbuf, 0x0F);
    emit_cc(cbuf, 0xC8, destlo);
    // bswap hi
    emit_opcode(cbuf, 0x0F);
    emit_cc(cbuf, 0xC8, desthi);
    // xchg lo and hi
    emit_opcode(cbuf, 0x87);
    emit_rm(cbuf, 0x3, destlo, desthi);
  
#line 12300 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 4995 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ bswapl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ shrl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 16); 
  
#line 12317 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 5008 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ bswapl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ sarl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 16); 
  
#line 12334 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5024 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ lzcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 12350 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void countLeadingZerosI_bsrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5041 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Label skip;
    __ bsrl(Rdst, Rsrc);
    __ jccb(Assembler::notZero, skip);
    __ movl(Rdst, -1);
    __ bind(skip);
    __ negl(Rdst);
    __ addl(Rdst, BitsPerInt - 1);
  
#line 12374 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 5065 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Label done;
    __ lzcntl(Rdst, HIGH_FROM_LOW(Rsrc));
    __ jccb(Assembler::carryClear, done);
    __ lzcntl(Rdst, Rsrc);
    __ addl(Rdst, BitsPerInt);
    __ bind(done);
  
#line 12398 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void countLeadingZerosL_bsrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 5094 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Label msw_is_zero;
    Label not_zero;
    __ bsrl(Rdst, HIGH_FROM_LOW(Rsrc));
    __ jccb(Assembler::zero, msw_is_zero);
    __ addl(Rdst, BitsPerInt);
    __ jmpb(not_zero);
    __ bind(msw_is_zero);
    __ bsrl(Rdst, Rsrc);
    __ jccb(Assembler::notZero, not_zero);
    __ movl(Rdst, -1);
    __ bind(not_zero);
    __ negl(Rdst);
    __ addl(Rdst, BitsPerLong - 1);
  
#line 12429 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5120 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ tzcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 12445 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void countTrailingZerosI_bsfNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5135 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Label done;
    __ bsfl(Rdst, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ jccb(Assembler::notZero, done);
    __ movl(Rdst, BitsPerInt);
    __ bind(done);
  
#line 12466 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 5156 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Label done;
    __ tzcntl(Rdst, Rsrc);
    __ jccb(Assembler::carryClear, done);
    __ tzcntl(Rdst, HIGH_FROM_LOW(Rsrc));
    __ addl(Rdst, BitsPerInt);
    __ bind(done);
  
#line 12490 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void countTrailingZerosL_bsfNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 5182 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Label msw_not_zero;
    Label done;
    __ bsfl(Rdst, Rsrc);
    __ jccb(Assembler::notZero, done);
    __ bsfl(Rdst, HIGH_FROM_LOW(Rsrc));
    __ jccb(Assembler::notZero, msw_not_zero);
    __ movl(Rdst, BitsPerInt);
    __ bind(msw_not_zero);
    __ addl(Rdst, BitsPerInt);
    __ bind(done);
  
#line 12518 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void popCountINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5208 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ popcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 12534 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void popCountI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5220 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ popcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12550 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void popCountLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 5235 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ popcntl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ popcntl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* src */));
    __ addl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 12570 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void popCountL_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 5252 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    //__ popcntl($dst$$Register, $mem$$Address$$first);
    //__ popcntl($tmp$$Register, $mem$$Address$$second);
    __ popcntl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), relocInfo::none));
    __ popcntl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, relocInfo::none));
    __ addl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 12592 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5272 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12608 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5289 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), opnd_array(0)->as_Register(ra_,this)/* dst */); // This is always a different register.
    __ sarl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), 7); // 24+1 MSB are already signed extended.
  
#line 12626 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5305 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12642 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5321 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movzbl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
  
#line 12660 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUB2L_immI8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5338 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movzbl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
    __ andl(Rdst, opnd_array(2)->constant());
  
#line 12680 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5354 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12696 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadS2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {
    MacroAssembler _masm(&cbuf);

#line 5367 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12713 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), opnd_array(0)->as_Register(ra_,this)/* dst */); // This is always a different register.
    __ sarl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), 15); // 16+1 MSB are already signed extended.
  
#line 12731 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5399 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12747 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUS2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {
    MacroAssembler _masm(&cbuf);

#line 5412 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12764 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5427 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */));
  
#line 12781 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUS2L_immI_255Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5442 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movzbl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
  
#line 12800 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUS2L_immI16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5458 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movzwl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
    __ andl(Rdst, opnd_array(2)->constant());
  
#line 12820 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12836 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {
    MacroAssembler _masm(&cbuf);

#line 5487 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12853 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadI2UBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5499 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12870 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadI2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// sixteen
  {
    MacroAssembler _masm(&cbuf);

#line 5511 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12887 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadI2USNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5523 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 12904 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5539 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), opnd_array(0)->as_Register(ra_,this)/* dst */); // This is always a different register.
    __ sarl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), 31);
  
#line 12922 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadI2L_immI_255Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5555 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movzbl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
  
#line 12941 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadI2L_immI_65535Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5570 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movzwl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
  
#line 12960 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadI2L_immU31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5586 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
    __ andl(Rdst, opnd_array(2)->constant());
  
#line 12980 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadUI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 5604 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xorl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */));
  
#line 12998 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5622 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Address Amemlo = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), relocInfo::none);
    Address Amemhi = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, relocInfo::none);
    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Amemlo);
    __ movl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), Amemhi);
  
#line 13017 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3014 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xDF);
    int rm_byte_opcode = 0x05;
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
    store_to_stackslot( cbuf, 0x0DF, 0x07, opnd_array(0)->disp(ra_,this,0) );
  
#line 13040 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadLX_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 5653 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movdbl(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */);
  
#line 13058 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadLX_reg_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 5669 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movdl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */);
    __ psrlq(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */, 32);
    __ movdl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */);
  
#line 13078 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 13093 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13107 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 13122 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13136 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 13151 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13165 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadDPRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*primary()*/));
  
#line 13180 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 13194 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 13203 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5732 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 13219 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadD_partialNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5743 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 13235 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5756 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movflt (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 13251 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadFPRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 13266 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 13280 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 13289 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void leaP8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 13304 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13318 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void leaP32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 13333 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13347 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void leaPIdxOffNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 13362 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13376 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void leaPIdxScaleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 13391 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13405 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void leaPIdxScaleOffNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 13420 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13434 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1886 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    emit_opcode(cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32(cbuf, opnd_array(1)->constant());
  
#line 13452 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 13467 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 13475 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1893 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    emit_opcode(cbuf, (0xB8 /*primary()*/) + opnd_array(0)->reg(ra_,this)/* dst */);
    
if ( opnd_array(1)->constant_reloc() != relocInfo::none ) {
  emit_d32_reloc(cbuf, opnd_array(1)->constant(), opnd_array(1)->constant_reloc(), 0);
} else {
  emit_d32(cbuf, opnd_array(1)->constant());
};
  
#line 13498 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1900 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    int dst_enc = opnd_array(0)->reg(ra_,this)/* dst */;
    int src_con = opnd_array(1)->constantL() & 0x0FFFFFFFFL;
    if (src_con == 0) {
      // xor dst, dst
      emit_opcode(cbuf, 0x33);
      emit_rm(cbuf, 0x3, dst_enc, dst_enc);
    } else {
      emit_opcode(cbuf, (0xB8 /*primary()*/) + dst_enc);
      emit_d32(cbuf, src_con);
    }
  
#line 13524 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1915 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    int dst_enc = opnd_array(0)->reg(ra_,this)/* dst */ + 2;
    int src_con = ((julong)(opnd_array(1)->constantL())) >> 32;
    if (src_con == 0) {
      // xor dst, dst
      emit_opcode(cbuf, 0x33);
      emit_rm(cbuf, 0x3, dst_enc, dst_enc);
    } else {
      emit_opcode(cbuf, (0xB8 /*primary()*/) + dst_enc);
      emit_d32(cbuf, src_con);
    }
  
#line 13543 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1944 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x33 /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 13559 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1949 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x33 /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)/* dst */), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 13568 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConFPRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5885 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 13585 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConFPRNode::eval_constant(Compile* C) {
  {

#line 5886 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 13594 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConFPR0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5898 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fldz();
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 13610 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConFPR1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5911 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld1();
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 13627 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5923 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 13643 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 5924 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 13652 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5934 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ xorps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 13667 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConDPRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5947 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_d(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 13684 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConDPRNode::eval_constant(Compile* C) {
  {

#line 5948 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 13693 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConDPR0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5961 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fldz();
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 13709 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConDPR1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5975 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld1();
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 13726 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5987 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 13742 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 5988 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 13751 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5998 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ xorpd (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 13766 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadSSINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 13781 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13795 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadSSLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 13810 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13824 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*secondary()*/));
  
#line 13832 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 13846 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadSSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 13861 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 13875 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadSSFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 13890 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "No oops here because no reloc info allowed" );
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, relocInfo::none);
  
#line 13904 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 13913 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadSSDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*primary()*/));
  
#line 13928 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "No oops here because no reloc info allowed" );
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, relocInfo::none);
  
#line 13942 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 13951 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchr0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  // User did not define which encode class to use.
}

uint prefetchr0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void prefetchrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6082 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetchr(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 13980 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchrNTANode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6094 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetchnta(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 13996 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchrT0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6106 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetcht0(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 14012 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchrT2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6118 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetcht2(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 14028 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchw0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  // User did not define which encode class to use.
}

uint prefetchw0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void prefetchwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6140 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetchw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 14057 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchwNTANode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6152 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetchnta(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 14073 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchAlloc0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  // User did not define which encode class to use.
}

uint prefetchAlloc0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void prefetchAllocNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6176 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetchw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 14102 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchAllocNTANode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6188 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetchnta(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 14118 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchAllocT0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6200 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetcht0(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 14134 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void prefetchAllocT2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6212 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ prefetcht2(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 14150 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x88 /*primary()*/));
  
#line 14166 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14180 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66 /*secondary()*/));
  
#line 14196 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 14204 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14218 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 14234 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14248 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 14264 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14278 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*secondary()*/));
  
#line 14286 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src */);  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 14300 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeL2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6271 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 14317 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 14333 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = (EAX_enc);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14347 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3030 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0x0DF, 0x05, opnd_array(2)->disp(ra_,this,idx2) );
    cbuf.set_insts_mark();            // Mark start of FIST in case $mem has an oop
    emit_opcode(cbuf,0xDF);
    int rm_byte_opcode = 0x07;
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 14364 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeLX_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 6302 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cmpl(rax, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, Address(rsp, opnd_array(2)->disp(ra_,this,idx2)));
    __ movdbl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */);
  
#line 14384 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeLX_reg_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 6320 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cmpl(rax, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movdl(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    __ movdl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp2 */, HIGH_FROM_LOW(opnd_array(2)->as_Register(ra_,this,idx2)/* src */));
    __ punpckldq(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp2 */);
    __ movdbl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
  
#line 14407 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 14423 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14437 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 14453 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 14467 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output immediate
    emit_d32(cbuf, opnd_array(2)->constant());
  
#line 14476 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeImmI16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1555 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x66);
  
#line 14492 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 14500 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 14514 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1985 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output immediate
    emit_d16(cbuf, opnd_array(2)->constant());
  
#line 14523 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeImmPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 14539 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 14553 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output immediate
    
if ( opnd_array(2)->constant_reloc() != relocInfo::none ) {
  emit_d32_reloc(cbuf, opnd_array(2)->constant(), opnd_array(2)->constant_reloc(), 0);
} else {
  emit_d32(cbuf, opnd_array(2)->constant());
};
  
#line 14567 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC6 /*primary()*/));
  
#line 14583 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 14597 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 14612 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeImmCMNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC6 /*primary()*/));
  
#line 14628 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 14642 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 14657 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeDPRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2191 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xDD /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14688 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeDPR_roundedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2191 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xDD /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14719 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6429 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 14736 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6442 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movflt(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 14753 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeFPRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2191 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xD9 /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14784 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeFPR_roundedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2191 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xD9 /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14815 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeFPR_DroundedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2191 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xD9 /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14846 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeFPR_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 14862 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 14876 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1971 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output Float immediate bits
    jfloat jf = opnd_array(2)->constantF();
    int    jf_as_bits = jint_cast( jf );
    emit_d32(cbuf, jf_as_bits);
  
#line 14887 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeF_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 14903 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 14917 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1978 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output Float immediate bits
    jfloat jf = opnd_array(2)->constantF();
    int    jf_as_bits = jint_cast( jf );
    emit_d32(cbuf, jf_as_bits);
  
#line 14928 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeSSINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2355 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0x89 /*primary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src */, opnd_array(0)->disp(ra_,this,0) );
  
#line 14943 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeSSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2355 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0x89 /*primary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src */, opnd_array(0)->disp(ra_,this,0) );
  
#line 14958 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeSSLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 14973 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* src */;
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0);
    relocInfo::relocType disp_reloc = opnd_array(0)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 14987 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*secondary()*/));
  
#line 14995 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */);  // Hi register of pair, computed from lo
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0) + 4;      // Offset is 4 further in memory
    assert( opnd_array(0)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 15009 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquireNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_acquire_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquire_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquire_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_releaseNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_release_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_release_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_release_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6600 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ membar(Assembler::StoreLoad);
  
#line 15103 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void unnecessary_membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint unnecessary_membar_volatileNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_storestoreNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  // User did not define which encode class to use.
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 15152 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void jmovI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6653 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label Lskip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), Lskip);
    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
    __ bind(Lskip);
  
#line 15175 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void jmovI_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6670 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label Lskip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), Lskip);
    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
    __ bind(Lskip);
  
#line 15198 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15217 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 15225 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovI_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15244 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 15252 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15271 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* dst */;
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    relocInfo::relocType disp_reloc = opnd_array(4)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 15285 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovI_memUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15304 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* dst */;
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    relocInfo::relocType disp_reloc = opnd_array(4)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 15318 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15337 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 15345 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovP_reg_nonP6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1710 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Invert sense of branch from sense of CMOV
    emit_cc( cbuf, 0x70, (opnd_array(1)->ccode()^1) );
    emit_d8( cbuf, (0x2) );
  
#line 15365 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8b /*primary()*/));
  
#line 15373 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 15381 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovP_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15400 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 15408 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void fcmovDPR_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1703 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int op = 0xDA00 + opnd_array(1)->ccode() + (opnd_array(4)->reg(ra_,this,idx4)/* src */-1);
    emit_d8(cbuf, op >> 8 );
    emit_d8(cbuf, op & 255);
  
#line 15428 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void fcmovFPR_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1703 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int op = 0xDA00 + opnd_array(1)->ccode() + (opnd_array(4)->reg(ra_,this,idx4)/* src */-1);
    emit_d8(cbuf, op >> 8 );
    emit_d8(cbuf, op & 255);
  
#line 15448 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void fcmovDPR_regSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1710 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Invert sense of branch from sense of CMOV
    emit_cc( cbuf, 0x70, (opnd_array(1)->ccode()^1) );
    emit_d8( cbuf, (0x4) );
  
#line 15468 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(4)->reg(ra_,this,idx4)/* src */ );   // FLD ST(i-1)
  
#line 15477 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xdd /*primary()*/));
  
#line 15485 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(3)->reg(ra_,this,idx3)/* dst */ );
  
#line 15493 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void fcmovFPR_regSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1710 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Invert sense of branch from sense of CMOV
    emit_cc( cbuf, 0x70, (opnd_array(1)->ccode()^1) );
    emit_d8( cbuf, (0x4) );
  
#line 15513 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(4)->reg(ra_,this,idx4)/* src */ );
  
#line 15522 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xdd /*primary()*/));
  
#line 15530 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(3)->reg(ra_,this,idx3)/* dst */ );
  
#line 15538 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void fcmovF_regSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label skip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), skip);
    __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* src */);
    __ bind(skip);
  
#line 15561 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void fcmovD_regSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6887 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label skip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), skip);
    __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* src */);
    __ bind(skip);
  
#line 15584 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void fcmovF_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6905 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label skip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), skip);
    __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* src */);
    __ bind(skip);
  
#line 15607 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void fcmovD_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label skip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), skip);
    __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* src */);
    __ bind(skip);
  
#line 15630 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15649 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1954 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 15657 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15666 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)/* dst */), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)/* src */));
  
#line 15674 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovL_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15693 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1954 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 15701 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 15710 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)/* dst */), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)/* src */));
  
#line 15718 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 15734 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 15742 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint addI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void addI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x00 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 15771 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 15786 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void incI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1615 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x40 /*primary()*/) + opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 15802 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint incI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 1, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 1);
}

void leaI_eReg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 15823 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2157 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base         = opnd_array(1)->reg(ra_,this,idx1)/* src0 */;      // 0xFFFFFFFF indicates no base
    int index        = 0x04;            // 0x04 indicates no index
    int scale        = 0x00;            // 0x00 indicates no scale
    int displace     = opnd_array(2)->constant(); // 0x00 indicates no displacement
    relocInfo::relocType disp_reloc = relocInfo::none;
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 15837 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void leaP_eReg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 15853 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2157 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base         = opnd_array(1)->reg(ra_,this,idx1)/* src0 */;      // 0xFFFFFFFF indicates no base
    int index        = 0x04;            // 0x04 indicates no index
    int scale        = 0x00;            // 0x00 indicates no scale
    int displace     = opnd_array(2)->constant(); // 0x00 indicates no displacement
    relocInfo::relocType disp_reloc = relocInfo::none;
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 15867 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void decI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1615 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x48 /*primary()*/) + opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 15883 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint decI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 1, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 1);
}

void addP_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 15904 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 15912 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint addP_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void addP_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x00 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 15941 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 15956 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 15972 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 15986 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addI_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 16002 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 16016 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x01 /*primary()*/));
  
#line 16032 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 16046 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addI_mem_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x01 /*primary()*/));
  
#line 16062 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 16076 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1621 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
  
#line 16098 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 16112 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 16127 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void incI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*primary()*/));
  
#line 16143 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 16157 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void decI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*primary()*/));
  
#line 16173 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x01);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 16187 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void loadPLockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 16231 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 16245 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storePConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// heap_top_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2000 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);         // [Lock]
  
#line 16263 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 16271 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xB1));
  
#line 16279 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* newval */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 16293 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeIConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2000 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);         // [Lock]
  
#line 16311 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 16319 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xB1));
  
#line 16327 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* newval */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 16341 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeLConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 7197 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Note: we need to swap rbx, and rcx before and after the
    //       cmpxchg8 instruction because the instruction uses
    //       rcx as the high order word of the new value to store but
    //       our register encoding uses rbx.
    __ xchgl(as_Register(EBX_enc), as_Register(ECX_enc));
    if( os::is_MP() )
      __ lock();
    __ cmpxchg8(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ xchgl(as_Register(EBX_enc), as_Register(ECX_enc));
  
#line 16367 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2010 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"


    // XCHG  rbx,ecx
    emit_opcode(cbuf,0x87);
    emit_opcode(cbuf,0xD9);
    // [Lock]
    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);
    // CMPXCHG8 [Eptr]
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xC7);
    emit_rm( cbuf, 0x0, 1, opnd_array(1)->reg(ra_,this,idx1)/* mem_ptr */ );
    // XCHG  rbx,ecx
    emit_opcode(cbuf,0x87);
    emit_opcode(cbuf,0xD9);
  
#line 16397 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2038 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int res_encoding = opnd_array(0)->reg(ra_,this)/* res */;

    // MOV  res,0
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 0 );
    // JNE,s  fail
    emit_opcode(cbuf,0x75);
    emit_d8(cbuf, 5 );
    // MOV  res,1
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 1 );
    // fail:
  
#line 16416 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2027 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // [Lock]
    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);

    // CMPXCHG [Eptr]
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xB1);
    emit_rm( cbuf, 0x0, 1, opnd_array(1)->reg(ra_,this,idx1)/* mem_ptr */ );
  
#line 16440 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2038 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int res_encoding = opnd_array(0)->reg(ra_,this)/* res */;

    // MOV  res,0
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 0 );
    // JNE,s  fail
    emit_opcode(cbuf,0x75);
    emit_d8(cbuf, 5 );
    // MOV  res,1
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 1 );
    // fail:
  
#line 16459 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2027 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // [Lock]
    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);

    // CMPXCHG [Eptr]
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xB1);
    emit_rm( cbuf, 0x0, 1, opnd_array(1)->reg(ra_,this,idx1)/* mem_ptr */ );
  
#line 16483 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2038 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int res_encoding = opnd_array(0)->reg(ra_,this)/* res */;

    // MOV  res,0
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 0 );
    // JNE,s  fail
    emit_opcode(cbuf,0x75);
    emit_d8(cbuf, 5 );
    // MOV  res,1
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 1 );
    // fail:
  
#line 16502 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xaddI_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {
    MacroAssembler _masm(&cbuf);

#line 7256 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    if (os::is_MP()) { __ lock(); }
    __ addl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 16520 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xaddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 7267 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    if (os::is_MP()) { __ lock(); }
    __ xaddl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
  
#line 16538 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xchgINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 7277 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ xchgl(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 16555 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xchgPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 7286 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ xchgl(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 16572 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2B /*primary()*/));
  
#line 16588 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 16596 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint subI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void subI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 16625 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 16640 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2B /*primary()*/));
  
#line 16656 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 16670 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x29 /*primary()*/));
  
#line 16686 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 16700 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subP_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2B /*primary()*/));
  
#line 16717 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(3)->reg(ra_,this,idx3)/* src */);
  
#line 16725 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint subP_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void negI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 16746 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x03 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* dst */ );
  
#line 16754 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint negI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void mulI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 16775 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xAF /*primary()*/));
  
#line 16783 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 16791 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint mulI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 3);
}

void mulI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 1621 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x69 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x69 /*primary()*/));
    }
  
#line 16818 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* src */);
  
#line 16826 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 16841 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadConL_low_onlyNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1900 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    int dst_enc = opnd_array(0)->reg(ra_,this)/* dst */;
    int src_con = opnd_array(1)->constantL() & 0x0FFFFFFFFL;
    if (src_con == 0) {
      // xor dst, dst
      emit_opcode(cbuf, 0x33);
      emit_rm(cbuf, 0x3, dst_enc, dst_enc);
    } else {
      emit_opcode(cbuf, (0xB8 /*primary()*/) + dst_enc);
      emit_d32(cbuf, src_con);
    }
  
#line 16867 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulI_imm_highNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {

#line 2679 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // IMUL   EDX:EAX,$src1
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
    // SAR    EDX,$cnt-32
    int shift_count = ((int)opnd_array(3)->constant()) - 32;
    if (shift_count > 0) {
      emit_opcode(cbuf, 0xC1);
      emit_rm(cbuf, 0x3, 7, opnd_array(0)->reg(ra_,this)/* dst */ );
      emit_d8(cbuf, shift_count);
    }
  
#line 16893 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulI_imm_high_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {

#line 2679 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // IMUL   EDX:EAX,$src1
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(2)->reg(ra_,this,idx2)/* src1 */ );
    // SAR    EDX,$cnt-32
    int shift_count = ((int)opnd_array(3)->constant()) - 32;
    if (shift_count > 0) {
      emit_opcode(cbuf, 0xC1);
      emit_rm(cbuf, 0x3, 7, opnd_array(0)->reg(ra_,this)/* dst */ );
      emit_d8(cbuf, shift_count);
    }
  
#line 16919 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulI_imm_RShift_highNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {

#line 2679 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // IMUL   EDX:EAX,$src1
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
    // SAR    EDX,$cnt-32
    int shift_count = ((int)opnd_array(3)->constant()) - 32;
    if (shift_count > 0) {
      emit_opcode(cbuf, 0xC1);
      emit_rm(cbuf, 0x3, 7, opnd_array(0)->reg(ra_,this)/* dst */ );
      emit_d8(cbuf, shift_count);
    }
  
#line 16945 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulI_imm_RShift_high_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {

#line 2679 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // IMUL   EDX:EAX,$src1
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(2)->reg(ra_,this,idx2)/* src1 */ );
    // SAR    EDX,$cnt-32
    int shift_count = ((int)opnd_array(3)->constant()) - 32;
    if (shift_count > 0) {
      emit_opcode(cbuf, 0xC1);
      emit_rm(cbuf, 0x3, 7, opnd_array(0)->reg(ra_,this)/* dst */ );
      emit_d8(cbuf, shift_count);
    }
  
#line 16971 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 1621 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x69 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x69 /*primary()*/));
    }
  
#line 16993 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 17007 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 17022 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 17038 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xAF /*primary()*/));
  
#line 17046 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 17060 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 17076 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xAF /*primary()*/));
  
#line 17084 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 17098 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 2705 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic idea: long = (long)int * (long)int
    // IMUL EDX:EAX, src
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
  
#line 17117 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulI2L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2705 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic idea: long = (long)int * (long)int
    // IMUL EDX:EAX, src
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
  
#line 17136 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulIS_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {

#line 2712 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic Idea:  long = (int & 0xffffffffL) * (int & 0xffffffffL)
    // MUL EDX:EAX, src
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x4, opnd_array(3)->reg(ra_,this,idx3)/* src1 */);
  
#line 17156 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulIS_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  {

#line 2712 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic Idea:  long = (int & 0xffffffffL) * (int & 0xffffffffL)
    // MUL EDX:EAX, src
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x4, opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
  
#line 17176 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2719 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic idea: lo(result) = lo(x_lo * y_lo)
    //             hi(result) = hi(x_lo * y_lo) + lo(x_hi * y_lo) + lo(x_lo * y_hi)
    // MOV    $tmp,$src.lo
    encode_Copy( cbuf, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, opnd_array(2)->reg(ra_,this,idx2)/* src */ );
    // IMUL   $tmp,EDX
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0xAF );
    emit_rm( cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */) );
    // MOV    EDX,$src.hi
    encode_Copy( cbuf, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src */) );
    // IMUL   EDX,EAX
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0xAF );
    emit_rm( cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
    // ADD    $tmp,EDX
    emit_opcode( cbuf, 0x03 );
    emit_rm( cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */) );
    // MUL   EDX:EAX,$src.lo
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x4, opnd_array(2)->reg(ra_,this,idx2)/* src */ );
    // ADD    EDX,ESI
    emit_opcode( cbuf, 0x03 );
    emit_rm( cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), opnd_array(3)->reg(ra_,this,idx3)/* tmp */ );
  
#line 17215 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulL_eReg_lhi0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 7512 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(2)->as_Register(ra_,this,idx2)/* src */));
    __ imull(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, rax);
    __ mull(opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    __ addl(rdx, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 17236 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulL_eReg_rhi0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 7533 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    __ imull(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, rdx);
    __ mull(opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    __ addl(rdx, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 17257 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulL_eReg_hi0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ mull(opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 17274 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulL_eReg_conNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2745 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic idea: lo(result) = lo(src * y_lo)
    //             hi(result) = hi(src * y_lo) + lo(src * y_hi)
    // IMUL   $tmp,EDX,$src
    emit_opcode( cbuf, 0x6B );
    emit_rm( cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */) );
    emit_d8( cbuf, (int)opnd_array(2)->constantL() );
    // MOV    EDX,$src
    emit_opcode(cbuf, 0xB8 + EDX_enc);
    emit_d32( cbuf, (int)opnd_array(2)->constantL() );
    // MUL   EDX:EAX,EDX
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x4, EDX_enc );
    // ADD    EDX,ESI
    emit_opcode( cbuf, 0x03 );
    emit_rm( cbuf, 0x3, EDX_enc, opnd_array(3)->reg(ra_,this,idx3)/* tmp */ );
  
#line 17305 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint mulL_eReg_conNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 12, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 12);
}

void divI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 1573 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax,: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax,: quotient  (= rax, idiv reg)       min_int
    //         rdx: remainder (= rax, irem reg)       0
    //
    //  Code sequnce:
    //
    //  81 F8 00 00 00 80    cmp         rax,80000000h
    //  0F 85 0B 00 00 00    jne         normal_case
    //  33 D2                xor         rdx,edx
    //  83 F9 FF             cmp         rcx,0FFh
    //  0F 84 03 00 00 00    je          done
    //                  normal_case:
    //  99                   cdq
    //  F7 F9                idiv        rax,ecx
    //                  done:
    //
    emit_opcode(cbuf,0x81); emit_d8(cbuf,0xF8);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x80);                     // cmp rax,80000000h
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x85);
    emit_opcode(cbuf,0x0B); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // jne normal_case
    emit_opcode(cbuf,0x33); emit_d8(cbuf,0xD2);                     // xor rdx,edx
    emit_opcode(cbuf,0x83); emit_d8(cbuf,0xF9); emit_d8(cbuf,0xFF); // cmp rcx,0FFh
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x84);
    emit_opcode(cbuf,0x03); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // je done
    // normal_case:
    emit_opcode(cbuf,0x99);                                         // cdq
    // idiv (note: must be emitted by the user of this rule)
    // normal:
  
#line 17363 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 17371 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* div */ );
  
#line 17379 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint divI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 26, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 26);
}

void divL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2763 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // PUSH src1.hi
    emit_opcode(cbuf, HIGH_FROM_LOW(0x50+opnd_array(1)->reg(ra_,this,idx1)/* src1 */) );
    // PUSH src1.lo
    emit_opcode(cbuf,               0x50+opnd_array(1)->reg(ra_,this,idx1)/* src1 */  );
    // PUSH src2.hi
    emit_opcode(cbuf, HIGH_FROM_LOW(0x50+opnd_array(2)->reg(ra_,this,idx2)/* src2 */) );
    // PUSH src2.lo
    emit_opcode(cbuf,               0x50+opnd_array(2)->reg(ra_,this,idx2)/* src2 */  );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (CAST_FROM_FN_PTR(address, SharedRuntime::ldiv) - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Restore stack
    emit_opcode(cbuf, 0x83); // add  SP, #framesize
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, 4*4);
  
#line 17415 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divModI_eReg_divmodNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// div
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rdx
  {

#line 1573 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax,: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax,: quotient  (= rax, idiv reg)       min_int
    //         rdx: remainder (= rax, irem reg)       0
    //
    //  Code sequnce:
    //
    //  81 F8 00 00 00 80    cmp         rax,80000000h
    //  0F 85 0B 00 00 00    jne         normal_case
    //  33 D2                xor         rdx,edx
    //  83 F9 FF             cmp         rcx,0FFh
    //  0F 84 03 00 00 00    je          done
    //                  normal_case:
    //  99                   cdq
    //  F7 F9                idiv        rax,ecx
    //                  done:
    //
    emit_opcode(cbuf,0x81); emit_d8(cbuf,0xF8);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x80);                     // cmp rax,80000000h
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x85);
    emit_opcode(cbuf,0x0B); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // jne normal_case
    emit_opcode(cbuf,0x33); emit_d8(cbuf,0xD2);                     // xor rdx,edx
    emit_opcode(cbuf,0x83); emit_d8(cbuf,0xF9); emit_d8(cbuf,0xFF); // cmp rcx,0FFh
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x84);
    emit_opcode(cbuf,0x03); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // je done
    // normal_case:
    emit_opcode(cbuf,0x99);                                         // cdq
    // idiv (note: must be emitted by the user of this rule)
    // normal:
  
#line 17468 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 17476 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* div */ );
  
#line 17484 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint divModI_eReg_divmodNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 26, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 26);
}

void modI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 1573 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax,: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax,: quotient  (= rax, idiv reg)       min_int
    //         rdx: remainder (= rax, irem reg)       0
    //
    //  Code sequnce:
    //
    //  81 F8 00 00 00 80    cmp         rax,80000000h
    //  0F 85 0B 00 00 00    jne         normal_case
    //  33 D2                xor         rdx,edx
    //  83 F9 FF             cmp         rcx,0FFh
    //  0F 84 03 00 00 00    je          done
    //                  normal_case:
    //  99                   cdq
    //  F7 F9                idiv        rax,ecx
    //                  done:
    //
    emit_opcode(cbuf,0x81); emit_d8(cbuf,0xF8);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x80);                     // cmp rax,80000000h
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x85);
    emit_opcode(cbuf,0x0B); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // jne normal_case
    emit_opcode(cbuf,0x33); emit_d8(cbuf,0xD2);                     // xor rdx,edx
    emit_opcode(cbuf,0x83); emit_d8(cbuf,0xF9); emit_d8(cbuf,0xFF); // cmp rcx,0FFh
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x84);
    emit_opcode(cbuf,0x03); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // je done
    // normal_case:
    emit_opcode(cbuf,0x99);                                         // cdq
    // idiv (note: must be emitted by the user of this rule)
    // normal:
  
#line 17542 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 17550 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* div */ );
  
#line 17558 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint modI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 26, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 26);
}

void modL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2782 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // PUSH src1.hi
    emit_opcode(cbuf, HIGH_FROM_LOW(0x50+opnd_array(1)->reg(ra_,this,idx1)/* src1 */) );
    // PUSH src1.lo
    emit_opcode(cbuf,               0x50+opnd_array(1)->reg(ra_,this,idx1)/* src1 */  );
    // PUSH src2.hi
    emit_opcode(cbuf, HIGH_FROM_LOW(0x50+opnd_array(2)->reg(ra_,this,idx2)/* src2 */) );
    // PUSH src2.lo
    emit_opcode(cbuf,               0x50+opnd_array(2)->reg(ra_,this,idx2)/* src2 */  );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (CAST_FROM_FN_PTR(address, SharedRuntime::lrem ) - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Restore stack
    emit_opcode(cbuf, 0x83); // add  SP, #framesize
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, 4*4);
  
#line 17594 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divL_eReg_imm32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    MacroAssembler _masm(&cbuf);

#line 7682 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int con = (int)opnd_array(2)->constantL();
    assert(con != 0 && con != -1 && con != min_jint, "wrong divisor");
    int pcon = (con > 0) ? con : -con;
    Label Lfast, Lpos, Ldone;

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, pcon);
    __ xorl(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    __ cmpl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ jccb(Assembler::above, Lfast); // result fits into 32 bit

    __ movl(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* dst */); // save
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ movl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),0); // preserve flags
    __ jccb(Assembler::lessEqual, Lpos); // result is positive

    // Negative dividend.
    // convert value to positive to use unsigned division
    __ lneg(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
    __ xchgl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
    // revert result back to negative
    __ lneg(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ jmpb(Ldone);

    __ bind(Lpos);
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */); // Use unsigned division
    __ xchgl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    // Fallthrow for final divide, tmp2 has 32 bit hi result

    __ bind(Lfast);
    // fast path: src is positive
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */); // Use unsigned division

    __ bind(Ldone);
    __ movl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    if (con < 0) {
      __ lneg(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    }
  
#line 17651 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void modL_eReg_imm32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    MacroAssembler _masm(&cbuf);

#line 7752 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int con = (int)opnd_array(2)->constantL();
    assert(con != 0 && con != -1 && con != min_jint, "wrong divisor");
    int pcon = (con > 0) ? con : -con;
    Label  Lfast, Lpos, Ldone;

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, pcon);
    __ cmpl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ jccb(Assembler::above, Lfast); // src is positive and result fits into 32 bit

    __ movl(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* dst */); // save
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ movl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),0); // preserve flags
    __ jccb(Assembler::lessEqual, Lpos); // result is positive

    // Negative dividend.
    // convert value to positive to use unsigned division
    __ lneg(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
    // revert remainder back to negative
    __ negl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ jmpb(Ldone);

    __ bind(Lpos);
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);

    __ bind(Lfast);
    // fast path: src is positive
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);

    __ bind(Ldone);
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ sarl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */), 31); // result sign

  
#line 17705 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void shlI_eReg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 17721 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 17729 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint shlI_eReg_1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void salI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 17752 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint salI_eReg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 3);
}

void salI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 17773 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 17781 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint salI_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void sarI_eReg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 17802 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 17810 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint sarI_eReg_1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void sarI_mem_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 17831 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x7 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 17845 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sarI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 17863 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint sarI_eReg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 3);
}

void sarI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC1 /*primary()*/));
  
#line 17884 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x7 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 17898 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 17913 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sarI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 17929 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 17937 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint sarI_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void shrI_eReg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 17958 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 17966 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint shrI_eReg_1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void shrI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 17989 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint shrI_eReg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 3);
}

void i2bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {
    MacroAssembler _masm(&cbuf);

#line 7919 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18011 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint i2bNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 3);
}

void i2sNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// sixteen
  {
    MacroAssembler _masm(&cbuf);

#line 7932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18033 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint i2sNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 3);
}

void shrI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 18054 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 18062 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint shrI_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void andI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 18083 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 18091 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint andI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void andI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x04 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 18120 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 18135 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 18151 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 18165 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andI_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 18181 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 18195 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x21 /*primary()*/));
  
#line 18211 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 18225 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andI_mem_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x21 /*primary()*/));
  
#line 18241 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 18255 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1621 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
  
#line 18277 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x4 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 18291 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 18306 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andnI_rReg_rReg_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8024 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ andnl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
  
#line 18324 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andnI_rReg_rReg_rReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8024 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ andnl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */);
  
#line 18342 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andnI_rReg_rReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8038 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ andnl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()));
  
#line 18360 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andnI_rReg_rReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8038 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ andnl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 18378 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsiI_rReg_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm_zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8051 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsil(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 18395 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsiI_rReg_rReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm_zero
  {
    MacroAssembler _masm(&cbuf);

#line 8051 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsil(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18412 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsiI_rReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// imm_zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8065 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsil(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 18429 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsiI_rReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm_zero
  {
    MacroAssembler _masm(&cbuf);

#line 8065 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsil(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 18446 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsmskI_rReg_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8079 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsmskl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18463 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsmskI_rReg_rReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8079 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsmskl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18480 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsmskI_rReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8095 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsmskl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 18497 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsmskI_rReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8095 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsmskl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 18514 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsrI_rReg_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8110 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsrl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18531 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsrI_rReg_rReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8110 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsrl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18548 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsrI_rReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8126 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsrl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 18565 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsrI_rReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {
    MacroAssembler _masm(&cbuf);

#line 8126 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ blsrl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 18582 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 18598 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 18606 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint orI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void orI_eReg_castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 18627 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 18635 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint orI_eReg_castP2XNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void orI_eReg_castP2X_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 18656 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* src */);
  
#line 18664 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint orI_eReg_castP2X_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void orI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x01 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 18693 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 18708 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 18724 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 18738 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orI_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 18754 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 18768 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x09 /*primary()*/));
  
#line 18784 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 18798 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orI_mem_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x09 /*primary()*/));
  
#line 18814 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 18828 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1621 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
  
#line 18850 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x1 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 18864 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 18879 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void rolI_eReg_imm1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// shift
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 18895 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 18903 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void rolI_eReg_imm8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// shift
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {

#line 1880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 18921 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void rolI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// shift
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 18937 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 18945 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void rorI_eReg_imm1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// shift
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 18961 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 18969 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void rorI_eReg_imm8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// shift
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {

#line 1880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 18987 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void rorI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// shift
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 19003 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 19011 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 19027 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 19035 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint xorI_eRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void xorI_eReg_im1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    MacroAssembler _masm(&cbuf);

#line 8359 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

     __ notl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 19057 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint xorI_eReg_im1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void xorI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x06 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 19086 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 19101 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 19117 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 19131 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorI_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 19147 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 19161 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x31 /*primary()*/));
  
#line 19177 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 19191 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorI_mem_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x31 /*primary()*/));
  
#line 19207 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 19221 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1621 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
  
#line 19243 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x6 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 19257 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 19272 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void movI_nocopyNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 19287 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void ci2bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {

#line 2210 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // NEG $dst
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0x03, opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 19305 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1563 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,(0x13));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 19314 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint ci2bNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void movP_nocopyNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 19334 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cp2bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {

#line 2210 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // NEG $dst
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0x03, opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 19352 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1563 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,(0x13));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 19361 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpLTMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    MacroAssembler _masm(&cbuf);

#line 8477 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Rd = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Label done;
    __ xorl(Rd, Rd);
    __ cmpl(Rp, Rq);
    __ setb(Assembler::less, Rd);
    __ negl(Rd);
  
#line 19385 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpLTMask0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 8497 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

  __ sarl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 31);
  
#line 19402 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cadd_cmpLTMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// y
  {
    MacroAssembler _masm(&cbuf);

#line 8512 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Ry = opnd_array(3)->as_Register(ra_,this,idx3)/* y */;
    Label done;
    __ subl(Rp, Rq);
    __ jccb(Assembler::greaterEqual, done);
    __ addl(Rp, Ry);
    __ bind(done);
  
#line 19427 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cadd_cmpLTMask_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// y
  {
    MacroAssembler _masm(&cbuf);

#line 8512 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Ry = opnd_array(3)->as_Register(ra_,this,idx3)/* y */;
    Label done;
    __ subl(Rp, Rq);
    __ jccb(Assembler::greaterEqual, done);
    __ addl(Rp, Ry);
    __ bind(done);
  
#line 19452 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cadd_cmpLTMask_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// y
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// p
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// q
  {
    MacroAssembler _masm(&cbuf);

#line 8512 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rp = opnd_array(2)->as_Register(ra_,this,idx2)/* p */;
    Register Rq = opnd_array(3)->as_Register(ra_,this,idx3)/* q */;
    Register Ry = opnd_array(1)->as_Register(ra_,this,idx1)/* y */;
    Label done;
    __ subl(Rp, Rq);
    __ jccb(Assembler::greaterEqual, done);
    __ addl(Rp, Ry);
    __ bind(done);
  
#line 19477 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cadd_cmpLTMask_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// y
  {
    MacroAssembler _masm(&cbuf);

#line 8512 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Ry = opnd_array(3)->as_Register(ra_,this,idx3)/* y */;
    Label done;
    __ subl(Rp, Rq);
    __ jccb(Assembler::greaterEqual, done);
    __ addl(Rp, Ry);
    __ bind(done);
  
#line 19502 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void and_cmpLTMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// y
  {
    MacroAssembler _masm(&cbuf);

#line 8537 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Ry = opnd_array(3)->as_Register(ra_,this,idx3)/* y */;
    Label done;
    __ cmpl(Rp, Rq);
    __ jccb(Assembler::less, done);
    __ xorl(Ry, Ry);
    __ bind(done);
  
#line 19527 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void and_cmpLTMask_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// y
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// p
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// q
  {
    MacroAssembler _masm(&cbuf);

#line 8537 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rp = opnd_array(2)->as_Register(ra_,this,idx2)/* p */;
    Register Rq = opnd_array(3)->as_Register(ra_,this,idx3)/* q */;
    Register Ry = opnd_array(1)->as_Register(ra_,this,idx1)/* y */;
    Label done;
    __ cmpl(Rp, Rq);
    __ jccb(Assembler::less, done);
    __ xorl(Ry, Ry);
    __ bind(done);
  
#line 19552 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void overflowAddI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 8564 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 19569 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void overflowAddI_rReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 8577 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 19586 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void overflowSubI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 8588 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 19603 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void overflowSubI_rReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 8599 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 19620 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void overflowNegI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 8611 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ negl(opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 19637 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void overflowMulI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 8623 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ imull(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 19654 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void overflowMulI_rReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 8635 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ imull(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 19672 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1944 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x03 /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 19689 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1949 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x13 /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 19698 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addL_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1654 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x00 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 19721 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1665 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x02 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 19736 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 19752 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 19766 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x13 /*secondary()*/));
  
#line 19774 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( opnd_array(2)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 19788 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addL_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 19804 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 19818 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x13 /*secondary()*/));
  
#line 19826 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 19840 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1944 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x2B /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 19857 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1949 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x1B /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 19866 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subL_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1654 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 19889 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1665 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x03 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 19904 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2B /*primary()*/));
  
#line 19920 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 19934 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x1B /*secondary()*/));
  
#line 19942 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( opnd_array(2)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 19956 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void negL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 2847 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xF7);    // NEG hi
    emit_rm    (cbuf,0x3, 0x3, HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* dst */));
    emit_opcode(cbuf,0xF7);    // NEG lo
    emit_rm    (cbuf,0x3, 0x3,               opnd_array(2)->reg(ra_,this,idx2)/* dst */ );
    emit_opcode(cbuf,0x83);    // SBB hi,0
    emit_rm    (cbuf,0x3, 0x3, HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* dst */));
    emit_d8    (cbuf,0 );
  
#line 19978 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1944 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x23 /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 19995 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1949 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x23 /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 20004 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andL_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1654 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x04 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 20027 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1665 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x04 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 20042 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 20058 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 20072 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*secondary()*/));
  
#line 20080 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( opnd_array(2)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 20094 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andL_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 20110 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 20124 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*secondary()*/));
  
#line 20132 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 20146 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andnL_eReg_eReg_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8765 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register Rsrc2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    __ andnl(Rdst, Rsrc1, Rsrc2);
    __ andnl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc1), HIGH_FROM_LOW(Rsrc2));
  
#line 20169 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andnL_eReg_eReg_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// minus_1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8765 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register Rsrc1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register Rsrc2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;
    __ andnl(Rdst, Rsrc1, Rsrc2);
    __ andnl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc1), HIGH_FROM_LOW(Rsrc2));
  
#line 20192 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andnL_eReg_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8785 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Address src2_hi = Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3)+ 4, relocInfo::none);

    __ andnl(Rdst, Rsrc1, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()));
    __ andnl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc1), src2_hi);
  
#line 20216 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void andnL_eReg_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// minus_1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8785 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register Rsrc1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Address src2_hi = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, relocInfo::none);

    __ andnl(Rdst, Rsrc1, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ andnl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc1), src2_hi);
  
#line 20240 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsiL_eReg_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm_zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8808 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rsrc = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;
    __ movl(HIGH_FROM_LOW(Rdst), 0);
    __ blsil(Rdst, Rsrc);
    __ jccb(Assembler::notZero, done);
    __ blsil(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc));
    __ bind(done);
  
#line 20265 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsiL_eReg_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm_zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8808 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    __ movl(HIGH_FROM_LOW(Rdst), 0);
    __ blsil(Rdst, Rsrc);
    __ jccb(Assembler::notZero, done);
    __ blsil(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc));
    __ bind(done);
  
#line 20290 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsiL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// imm_zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8834 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Address src_hi = Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2)+ 4, relocInfo::none);

    __ movl(HIGH_FROM_LOW(Rdst), 0);
    __ blsil(Rdst, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
    __ jccb(Assembler::notZero, done);
    __ blsil(HIGH_FROM_LOW(Rdst), src_hi);
    __ bind(done);
  
#line 20316 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsiL_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm_zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8834 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Address src_hi = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, relocInfo::none);

    __ movl(HIGH_FROM_LOW(Rdst), 0);
    __ blsil(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ jccb(Assembler::notZero, done);
    __ blsil(HIGH_FROM_LOW(Rdst), src_hi);
    __ bind(done);
  
#line 20342 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsmskL_eReg_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8861 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    __ movl(HIGH_FROM_LOW(Rdst), 0);
    __ blsmskl(Rdst, Rsrc);
    __ jccb(Assembler::carryClear, done);
    __ blsmskl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc));
    __ bind(done);
  
#line 20367 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsmskL_eReg_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8861 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    __ movl(HIGH_FROM_LOW(Rdst), 0);
    __ blsmskl(Rdst, Rsrc);
    __ jccb(Assembler::carryClear, done);
    __ blsmskl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc));
    __ bind(done);
  
#line 20392 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsmskL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8889 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Address src_hi = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, relocInfo::none);

    __ movl(HIGH_FROM_LOW(Rdst), 0);
    __ blsmskl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ jccb(Assembler::carryClear, done);
    __ blsmskl(HIGH_FROM_LOW(Rdst), src_hi);
    __ bind(done);
  
#line 20418 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsmskL_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8889 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Address src_hi = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, relocInfo::none);

    __ movl(HIGH_FROM_LOW(Rdst), 0);
    __ blsmskl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ jccb(Assembler::carryClear, done);
    __ blsmskl(HIGH_FROM_LOW(Rdst), src_hi);
    __ bind(done);
  
#line 20444 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsrL_eReg_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8917 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    __ movl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc));
    __ blsrl(Rdst, Rsrc);
    __ jccb(Assembler::carryClear, done);
    __ blsrl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc));
    __ bind(done);
  
#line 20469 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsrL_eReg_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8917 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    __ movl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc));
    __ blsrl(Rdst, Rsrc);
    __ jccb(Assembler::carryClear, done);
    __ blsrl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rsrc));
    __ bind(done);
  
#line 20494 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsrL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8945 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Address src_hi = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, relocInfo::none);
    __ movl(HIGH_FROM_LOW(Rdst), src_hi);
    __ blsrl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ jccb(Assembler::carryClear, done);
    __ blsrl(HIGH_FROM_LOW(Rdst), src_hi);
    __ bind(done);
  
#line 20519 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void blsrL_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 8945 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label done;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Address src_hi = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, relocInfo::none);
    __ movl(HIGH_FROM_LOW(Rdst), src_hi);
    __ blsrl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ jccb(Assembler::carryClear, done);
    __ blsrl(HIGH_FROM_LOW(Rdst), src_hi);
    __ bind(done);
  
#line 20544 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orl_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1944 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0B /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 20561 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1949 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0B /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 20570 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orl_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1654 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x01 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 20593 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1665 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x01 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 20608 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orl_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 20624 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 20638 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*secondary()*/));
  
#line 20646 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( opnd_array(2)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 20660 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void orl_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 20676 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 20690 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*secondary()*/));
  
#line 20698 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 20712 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorl_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1944 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x33 /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 20729 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1949 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x33 /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 20738 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorl_eReg_im1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    MacroAssembler _masm(&cbuf);

#line 9009 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

     __ notl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
     __ notl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
  
#line 20756 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorl_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1654 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x06 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 20779 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1665 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x06 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 20794 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorl_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 20810 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* dst */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 20824 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*secondary()*/));
  
#line 20832 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( opnd_array(2)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 20846 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void xorl_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 20862 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 20876 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*secondary()*/));
  
#line 20884 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 20898 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void shlL_eReg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 9047 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */,opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
  
#line 20916 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void shlL_eReg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 9064 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */,opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */,opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
  
#line 20936 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void shlL_eReg_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 9085 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */,opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */,opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */,opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */));
  
#line 20958 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void shlL_eReg_1_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {

#line 2077 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0xA4 /*tertiary()*/) == 0xA4 ) { r1 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,(0xA4 /*tertiary()*/));
    emit_rm(cbuf, 0x3, r1, r2);
    emit_d8(cbuf,opnd_array(2)->constant());
    emit_d8(cbuf,(0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), r1);
    emit_d8(cbuf,opnd_array(2)->constant());
  
#line 20983 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void shlL_eReg_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {

#line 2103 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0x4 /*secondary()*/) == 0x5 ) { r1 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }

    emit_opcode( cbuf, 0x8B ); // Move r1,r2
    emit_rm(cbuf, 0x3, r1, r2);
    if( opnd_array(2)->constant() > 32 ) { // Shift, if not by zero
      emit_opcode(cbuf,(0xC1 /*primary()*/));
      emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), r1);
      emit_d8(cbuf,opnd_array(2)->constant()-32);
    }
    emit_opcode(cbuf,0x33);  // XOR r2,r2
    emit_rm(cbuf, 0x3, r2, r2);
  
#line 21011 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void salL_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 2240 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // TEST shift,32
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0, ECX_enc);
    emit_d32(cbuf,0x20);
    // JEQ,s small
    emit_opcode(cbuf, 0x74);
    emit_d8(cbuf, 0x04);
    // MOV    $dst.hi,$dst.lo
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
    // CLR    $dst.lo
    emit_opcode(cbuf, 0x33);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* dst */);
// small:
    // SHLD   $dst.hi,$dst.lo,$shift
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xA5);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
    // SHL    $dst.lo,$shift"
    emit_opcode(cbuf,0xD3);
    emit_rm(cbuf, 0x3, 0x4, opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 21047 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint salL_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 17, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 17);
}

void shrL_eReg_1_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {

#line 2077 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0xAC /*tertiary()*/) == 0xA4 ) { r1 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,(0xAC /*tertiary()*/));
    emit_rm(cbuf, 0x3, r1, r2);
    emit_d8(cbuf,opnd_array(2)->constant());
    emit_d8(cbuf,(0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), r1);
    emit_d8(cbuf,opnd_array(2)->constant());
  
#line 21077 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void shrL_eReg_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {

#line 2103 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0x5 /*secondary()*/) == 0x5 ) { r1 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }

    emit_opcode( cbuf, 0x8B ); // Move r1,r2
    emit_rm(cbuf, 0x3, r1, r2);
    if( opnd_array(2)->constant() > 32 ) { // Shift, if not by zero
      emit_opcode(cbuf,(0xC1 /*primary()*/));
      emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), r1);
      emit_d8(cbuf,opnd_array(2)->constant()-32);
    }
    emit_opcode(cbuf,0x33);  // XOR r2,r2
    emit_rm(cbuf, 0x3, r2, r2);
  
#line 21105 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void shrL_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 2264 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // TEST shift,32
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0, ECX_enc);
    emit_d32(cbuf,0x20);
    // JEQ,s small
    emit_opcode(cbuf, 0x74);
    emit_d8(cbuf, 0x04);
    // MOV    $dst.lo,$dst.hi
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */) );
    // CLR    $dst.hi
    emit_opcode(cbuf, 0x33);
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
// small:
    // SHRD   $dst.lo,$dst.hi,$shift
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xAD);
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    // SHR    $dst.hi,$shift"
    emit_opcode(cbuf,0xD3);
    emit_rm(cbuf, 0x3, 0x5, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */) );
  
#line 21141 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint shrL_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 17, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 17);
}

void sarL_eReg_1_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {

#line 2077 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0xAC /*tertiary()*/) == 0xA4 ) { r1 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1)/* dst */;  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */); }
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,(0xAC /*tertiary()*/));
    emit_rm(cbuf, 0x3, r1, r2);
    emit_d8(cbuf,opnd_array(2)->constant());
    emit_d8(cbuf,(0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), r1);
    emit_d8(cbuf,opnd_array(2)->constant());
  
#line 21171 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sarL_eReg_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {

#line 2090 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0x8B ); // Move
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
    if( opnd_array(2)->constant() > 32 ) { // Shift, if not by zero
      emit_d8(cbuf,(0xC1 /*primary()*/));
      emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
      emit_d8(cbuf,opnd_array(2)->constant()-32);
    }
    emit_d8(cbuf,(0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */));
    emit_d8(cbuf,31);
  
#line 21196 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sarL_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 2288 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // TEST shift,32
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0, ECX_enc);
    emit_d32(cbuf,0x20);
    // JEQ,s small
    emit_opcode(cbuf, 0x74);
    emit_d8(cbuf, 0x05);
    // MOV    $dst.lo,$dst.hi
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */) );
    // SAR    $dst.hi,31
    emit_opcode(cbuf, 0xC1);
    emit_rm(cbuf, 0x3, 7, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */) );
    emit_d8(cbuf, 0x1F );
// small:
    // SHRD   $dst.lo,$dst.hi,$shift
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xAD);
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */), opnd_array(1)->reg(ra_,this,idx1)/* dst */);
    // SAR    $dst.hi,$shift"
    emit_opcode(cbuf,0xD3);
    emit_rm(cbuf, 0x3, 0x7, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* dst */) );
  
#line 21233 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint sarL_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 18, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 18);
}

void cmpDPR_cc_P6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 21255 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDF /*primary()*/));
  
#line 21263 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 21271 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2575 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Fixup the integer flags in case comparison involved a NaN
    //
    // JNP exit (no unordered comparison, P-flag is set by NaN)
    emit_opcode( cbuf, 0x7B );
    emit_d8    ( cbuf, 0x03 );
    // MOV AH,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // SAHF
    emit_opcode( cbuf, 0x9E);
    // NOP     // target for branch to avoid branch to branch
    emit_opcode( cbuf, 0x90);
  
#line 21290 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpDPR_cc_P6CFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 21307 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDF /*primary()*/));
  
#line 21315 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 21323 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpDPR_ccNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 21340 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 21348 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 21356 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2552 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // test ax,0x0400
    emit_opcode( cbuf, 0x66 );   // operand-size prefix for 16-bit immediate
    emit_opcode( cbuf, 0xA9 );
    emit_d16   ( cbuf, 0x0400 );
    // // // This sequence works, but stalls for 12-16 cycles on PPro
    // // test rax,0x0400
    // emit_opcode( cbuf, 0xA9 );
    // emit_d32   ( cbuf, 0x00000400 );
    //
    // jz exit (no unordered comparison)
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x02 );
    // mov ah,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // sahf
    emit_opcode( cbuf, 0x9E);
  
#line 21383 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpDPR_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 21400 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 21408 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE4 /*primary()*/));
  
#line 21416 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2322 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, 0xD8 );
  
#line 21425 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax();
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // sahf
    emit_opcode( cbuf, 0x9E);
    // movl(dst, nan_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, -1 );
    // jcc(Assembler::parity, exit);
    emit_opcode( cbuf, 0x7A );
    emit_d8    ( cbuf, 0x13 );
    // movl(dst, less_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, -1 );
    // jcc(Assembler::below, exit);
    emit_opcode( cbuf, 0x72 );
    emit_d8    ( cbuf, 0x0C );
    // movl(dst, equal_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, 0 );
    // jcc(Assembler::equal, exit);
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x05 );
    // movl(dst, greater_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, 1 );
  
#line 21458 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 21475 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 21483 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 21491 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax();
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // sahf
    emit_opcode( cbuf, 0x9E);
    // movl(dst, nan_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, -1 );
    // jcc(Assembler::parity, exit);
    emit_opcode( cbuf, 0x7A );
    emit_d8    ( cbuf, 0x13 );
    // movl(dst, less_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, -1 );
    // jcc(Assembler::below, exit);
    emit_opcode( cbuf, 0x72 );
    emit_d8    ( cbuf, 0x0C );
    // movl(dst, equal_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, 0 );
    // jcc(Assembler::equal, exit);
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x05 );
    // movl(dst, greater_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, 1 );
  
#line 21524 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpD_ccNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9315 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    emit_cmpfp_fixup(_masm);
  
#line 21542 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpD_ccCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9327 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 21559 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpD_ccmemNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9344 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
    emit_cmpfp_fixup(_masm);
  
#line 21577 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpD_ccmemCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9356 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 21594 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9375 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    emit_cmpfp3(_masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 21612 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpD_regmemNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9395 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
    emit_cmpfp3(_masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 21630 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );   // FLD ST(i-1)
  
#line 21647 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 21655 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 21663 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subDPR_reg_roundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );   // FLD ST(i-1)
  
#line 21680 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 21688 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 21696 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2379 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 21704 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subDPR_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 21720 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 21734 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 21742 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 21750 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void absDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 21765 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE1 /*primary()*/));
  
#line 21773 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void negDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 21788 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE0 /*primary()*/));
  
#line 21796 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );   // FLD ST(i-1)
  
#line 21813 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 21821 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 21829 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint addDPR_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addDPR_reg_roundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );   // FLD ST(i-1)
  
#line 21851 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 21859 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 21867 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2379 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 21875 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 21891 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 21905 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 21913 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 21921 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 21937 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 21951 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 21959 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* dst */ );
  
#line 21967 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_mem_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 21983 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 21997 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8));
  
#line 22005 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src */ );
  
#line 22013 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2053 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 22021 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 22029 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x03);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 22043 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_mem_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 22059 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 22073 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8));
  
#line 22081 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src */ );
  
#line 22089 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2053 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 22097 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 22105 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x03);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 22119 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_reg_imm1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 9529 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld1();
    __ faddp(opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 22137 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 9542 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_d(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ faddp(opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 22155 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_reg_immNode::eval_constant(Compile* C) {
  {

#line 9543 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 22164 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addDPR_reg_imm_roundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 9556 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_d(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fadd(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    __ fstp_d(Address(rsp, opnd_array(0)->disp(ra_,this,0)));
  
#line 22182 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_reg_imm_roundNode::eval_constant(Compile* C) {
  {

#line 9557 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 22191 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );   // FLD ST(i-1)
  
#line 22207 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 22215 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22223 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void strictfp_mulDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2338 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDB );           // FLD m80real
    emit_opcode( cbuf, 0x2D );
    emit_d32( cbuf, (int)StubRoutines::addr_fpu_subnormal_bias1() );
    emit_opcode( cbuf, 0xDE );           // FMULP ST(dst), ST0
    emit_opcode( cbuf, 0xC8+opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22243 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );   // FLD ST(i-1)
  
#line 22252 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 22260 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22268 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2346 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDB );           // FLD m80real
    emit_opcode( cbuf, 0x2D );
    emit_d32( cbuf, (int)StubRoutines::addr_fpu_subnormal_bias2() );
    emit_opcode( cbuf, 0xDE );           // FMULP ST(dst), ST0
    emit_opcode( cbuf, 0xC8+opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22280 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulDPR_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 9609 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_d(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fmulp(opnd_array(1)->reg(ra_,this,idx1)/* dst */);
  
#line 22298 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulDPR_reg_immNode::eval_constant(Compile* C) {
  {

#line 9610 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 22307 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulDPR_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 22322 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 22336 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 22344 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22352 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulDPR_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 22368 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 22382 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 22390 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* dst */ );
  
#line 22398 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulDPR_reg_mem_ciscNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22414 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 22428 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 22437 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 22446 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulDPR_reg_mem_cisc_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22462 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 22476 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src */ );
  
#line 22485 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 22494 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_mulDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src0 */ );
  
#line 22512 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
  
#line 22523 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  src2,ST  /* DE C0+i */
    emit_opcode(cbuf, 0xDE);
    emit_opcode(cbuf, 0xC0 + opnd_array(3)->reg(ra_,this,idx3)/* src2 */);
  
#line 22533 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addDPR_mulDPR_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src0
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src0 */ );
  
#line 22551 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(3)->reg(ra_,this,idx3)/* src1 */);
  
#line 22562 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  src2,ST  /* DE C0+i */
    emit_opcode(cbuf, 0xDE);
    emit_opcode(cbuf, 0xC0 + opnd_array(1)->reg(ra_,this,idx1)/* src2 */);
  
#line 22572 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subDPR_mulDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src0 */ );
  
#line 22590 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
  
#line 22601 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE));
  
#line 22609 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1615 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE0) + opnd_array(3)->reg(ra_,this,idx3)/* src2 */);
  
#line 22617 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );   // FLD ST(i-1)
  
#line 22634 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 22642 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22650 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void strictfp_divDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2338 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDB );           // FLD m80real
    emit_opcode( cbuf, 0x2D );
    emit_d32( cbuf, (int)StubRoutines::addr_fpu_subnormal_bias1() );
    emit_opcode( cbuf, 0xDE );           // FMULP ST(dst), ST0
    emit_opcode( cbuf, 0xC8+opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22670 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );   // FLD ST(i-1)
  
#line 22679 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 22687 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22695 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2346 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDB );           // FLD m80real
    emit_opcode( cbuf, 0x2D );
    emit_d32( cbuf, (int)StubRoutines::addr_fpu_subnormal_bias2() );
    emit_opcode( cbuf, 0xDE );           // FMULP ST(dst), ST0
    emit_opcode( cbuf, 0xC8+opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22707 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divDPR_reg_roundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 22724 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 22732 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x6 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 22740 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2379 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22748 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void modDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2428 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // load dst in FPR0
    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
    if (opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // swap src with FPR1:
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
  
#line 22778 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2530 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 22804 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2501 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    if (opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
    // // following asm replaced with Pop_Reg_F or Pop_Mem_F
    // // FSTP   FPR$dst$$reg
    // emit_opcode( cbuf, 0xDD );
    // emit_d8( cbuf, 0xD8+$dst$$reg );
  
#line 22826 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 22835 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void modD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 2446 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */);
    __ fld_d(Address(rsp, 0));
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src0 */);
    __ fld_d(Address(rsp, 0));
  
#line 22856 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2530 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 22882 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2464 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 22893 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2322 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, 0xD8 );
  
#line 22902 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sinDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 22917 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFE /*secondary()*/));
  
#line 22925 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sinD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */);
    __ fld_d(Address(rsp, 0));
  
#line 22943 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 22951 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFE /*secondary()*/));
  
#line 22959 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2464 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 22970 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cosDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 22985 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*secondary()*/));
  
#line 22993 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cosD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */);
    __ fld_d(Address(rsp, 0));
  
#line 23011 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 23019 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*secondary()*/));
  
#line 23027 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2464 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 23038 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void tanDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23053 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 23061 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 23069 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8));
  
#line 23077 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void tanD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */);
    __ fld_d(Address(rsp, 0));
  
#line 23095 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23103 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 23111 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 23119 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8));
  
#line 23127 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2464 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 23138 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void atanDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );   // FLD ST(i-1)
  
#line 23155 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 23163 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3 /*secondary()*/));
  
#line 23171 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0xF3 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 23179 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void atanD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
    __ fld_d(Address(rsp, 0));
  
#line 23198 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 23206 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3 /*secondary()*/));
  
#line 23214 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2464 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 23225 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sqrtDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );   // FLD ST(i-1)
  
#line 23241 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 23249 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFA /*primary()*/));
  
#line 23257 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 23266 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void powDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// X
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// Y
  {
    MacroAssembler _masm(&cbuf);

#line 9873 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ subptr(rsp, 8);
    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)/* X */- 1);
    __ fast_pow();
    __ addptr(rsp, 8);
  
#line 23286 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void powD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9887 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */);
    __ fld_d(Address(rsp, 0));
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src0 */);
    __ fld_d(Address(rsp, 0));
    __ fast_pow();
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 23311 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void expDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dpr1
  {
    MacroAssembler _masm(&cbuf);

#line 9907 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fast_exp();
  
#line 23327 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void expD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9918 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_d(Address(rsp, 0));
    __ fast_exp();
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 23349 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void log10DPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23364 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xEC));
  
#line 23372 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23380 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC9));
  
#line 23388 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23396 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 23404 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void log10D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23419 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xEC));
  
#line 23427 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_d(Address(rsp, 0));
  
#line 23438 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23446 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 23454 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2464 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 23465 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void logDPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23480 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xED));
  
#line 23488 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23496 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC9));
  
#line 23504 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23512 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 23520 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void logD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23535 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xED));
  
#line 23543 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_d(Address(rsp, 0));
  
#line 23554 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 23562 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 23570 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2464 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 23581 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpFPR_cc_P6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 23598 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDF /*primary()*/));
  
#line 23606 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 23614 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2575 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Fixup the integer flags in case comparison involved a NaN
    //
    // JNP exit (no unordered comparison, P-flag is set by NaN)
    emit_opcode( cbuf, 0x7B );
    emit_d8    ( cbuf, 0x03 );
    // MOV AH,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // SAHF
    emit_opcode( cbuf, 0x9E);
    // NOP     // target for branch to avoid branch to branch
    emit_opcode( cbuf, 0x90);
  
#line 23633 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpFPR_cc_P6CFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 23650 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDF /*primary()*/));
  
#line 23658 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 23666 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpFPR_ccNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 23683 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 23691 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 23699 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2552 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // test ax,0x0400
    emit_opcode( cbuf, 0x66 );   // operand-size prefix for 16-bit immediate
    emit_opcode( cbuf, 0xA9 );
    emit_d16   ( cbuf, 0x0400 );
    // // // This sequence works, but stalls for 12-16 cycles on PPro
    // // test rax,0x0400
    // emit_opcode( cbuf, 0xA9 );
    // emit_d32   ( cbuf, 0x00000400 );
    //
    // jz exit (no unordered comparison)
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x02 );
    // mov ah,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // sahf
    emit_opcode( cbuf, 0x9E);
  
#line 23726 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpFPR_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 23743 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 23751 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE4 /*primary()*/));
  
#line 23759 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2322 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, 0xD8 );
  
#line 23768 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax();
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // sahf
    emit_opcode( cbuf, 0x9E);
    // movl(dst, nan_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, -1 );
    // jcc(Assembler::parity, exit);
    emit_opcode( cbuf, 0x7A );
    emit_d8    ( cbuf, 0x13 );
    // movl(dst, less_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, -1 );
    // jcc(Assembler::below, exit);
    emit_opcode( cbuf, 0x72 );
    emit_d8    ( cbuf, 0x0C );
    // movl(dst, equal_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, 0 );
    // jcc(Assembler::equal, exit);
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x05 );
    // movl(dst, greater_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, 1 );
  
#line 23801 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );   // FLD ST(i-1)
  
#line 23818 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 23826 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 23834 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax();
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // sahf
    emit_opcode( cbuf, 0x9E);
    // movl(dst, nan_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, -1 );
    // jcc(Assembler::parity, exit);
    emit_opcode( cbuf, 0x7A );
    emit_d8    ( cbuf, 0x13 );
    // movl(dst, less_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, -1 );
    // jcc(Assembler::below, exit);
    emit_opcode( cbuf, 0x72 );
    emit_d8    ( cbuf, 0x0C );
    // movl(dst, equal_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, 0 );
    // jcc(Assembler::equal, exit);
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x05 );
    // movl(dst, greater_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this)/* dst */);
    emit_d32( cbuf, 1 );
  
#line 23867 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpF_ccNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10107 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    emit_cmpfp_fixup(_masm);
  
#line 23885 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpF_ccCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10119 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 23902 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpF_ccmemNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10136 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
    emit_cmpfp_fixup(_masm);
  
#line 23920 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpF_ccmemCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10148 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 23937 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10167 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    emit_cmpfp3(_masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 23955 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpF_regmemNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10187 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
    emit_cmpfp3(_masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 23973 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subFPR24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 23990 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 23999 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24007 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
  
#line 24024 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 24032 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 24040 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 24057 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 24066 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24074 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
  
#line 24091 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 24099 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 24107 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void absFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 24122 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE1 /*primary()*/));
  
#line 24130 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void negFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 24145 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE0 /*primary()*/));
  
#line 24153 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24169 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24183 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 24192 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24200 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24216 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24230 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src1 */ );
  
#line 24239 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24247 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24263 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24277 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 24285 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 24293 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24309 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24323 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 24331 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* dst */ );
  
#line 24339 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_mem_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24355 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24369 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 24378 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24386 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_mem_ciscNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24402 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24416 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2053 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 24424 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 24432 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x0 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24446 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24454 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_mem_cisc_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24470 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24484 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2053 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 24492 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 24500 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x0 /*secondary()*/);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24514 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24522 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_mem_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24538 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24552 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2053 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 24560 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 24568 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x0 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24582 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24590 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 10345 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)/* src */- 1);  // FLD ST(i-1)
    __ fadd_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_s(Address(rsp, opnd_array(0)->disp(ra_,this,0)));
  
#line 24609 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR24_reg_immNode::eval_constant(Compile* C) {
  {

#line 10347 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 24618 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addFPR_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 10360 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)/* src */- 1);  // FLD ST(i-1)
    __ fadd_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 24636 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_reg_immNode::eval_constant(Compile* C) {
  {

#line 10362 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 24645 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulFPR24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 24661 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 24670 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24678 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 24695 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 24704 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 24713 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR24_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24729 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24743 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 24752 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24760 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR24_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24776 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24790 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src1 */ );
  
#line 24799 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24807 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24823 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24837 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 24846 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 24855 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24871 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24885 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src1 */ );
  
#line 24894 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 24903 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR24_mem_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 24919 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24933 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2053 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 24941 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 24949 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x1 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 24963 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24971 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR24_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 10451 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)/* src */- 1);  // FLD ST(i-1)
    __ fmul_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_s(Address(rsp, opnd_array(0)->disp(ra_,this,0)));
  
#line 24990 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR24_reg_immNode::eval_constant(Compile* C) {
  {

#line 10453 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 24999 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulFPR_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 10467 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)/* src */- 1);  // FLD ST(i-1)
    __ fmul_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 25017 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR_reg_immNode::eval_constant(Compile* C) {
  {

#line 10469 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 25026 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulFPR_reg_load1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 25041 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 25055 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src */ );
  
#line 25064 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 25073 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulFPR_reg_load1_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem1
  {

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 25089 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 25103 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 25112 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 25121 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_mulFPR_reg_load1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 25138 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 25152 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
  
#line 25163 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  ST,src2  /* D8 C0+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC0 + opnd_array(3)->reg(ra_,this,idx3)/* src2 */);
    //could use FADDP  src2,fpST  /* DE C0+i */
  
#line 25174 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 25183 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_mulFPR_reg_load1_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 25200 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 25214 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(3)->reg(ra_,this,idx3)/* src1 */);
  
#line 25225 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  ST,src2  /* D8 C0+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC0 + opnd_array(1)->reg(ra_,this,idx1)/* src2 */);
    //could use FADDP  src2,fpST  /* DE C0+i */
  
#line 25236 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 25245 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_mulFPR_reg_load1_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 25262 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 25276 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
  
#line 25287 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  ST,src2  /* D8 C0+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC0 + opnd_array(3)->reg(ra_,this,idx3)/* src2 */);
    //could use FADDP  src2,fpST  /* DE C0+i */
  
#line 25298 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 25307 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_mulFPR_reg_load1_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mem1
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 25324 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(3)->base(ra_,this,idx3);
    int index    = opnd_array(3)->index(ra_,this,idx3);
    int scale    = opnd_array(3)->scale();
    int displace = opnd_array(3)->disp(ra_,this,idx3);
    relocInfo::relocType disp_reloc = opnd_array(3)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 25338 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
  
#line 25349 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  ST,src2  /* D8 C0+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC0 + opnd_array(1)->reg(ra_,this,idx1)/* src2 */);
    //could use FADDP  src2,fpST  /* DE C0+i */
  
#line 25360 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 25369 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_mulFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src0 */ );
  
#line 25387 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
  
#line 25398 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  src2,ST  /* DE C0+i */
    emit_opcode(cbuf, 0xDE);
    emit_opcode(cbuf, 0xC0 + opnd_array(3)->reg(ra_,this,idx3)/* src2 */);
  
#line 25408 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addFPR_mulFPR_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src0
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src0 */ );
  
#line 25426 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(3)->reg(ra_,this,idx3)/* src1 */);
  
#line 25437 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  src2,ST  /* DE C0+i */
    emit_opcode(cbuf, 0xDE);
    emit_opcode(cbuf, 0xC0 + opnd_array(1)->reg(ra_,this,idx1)/* src2 */);
  
#line 25447 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subFPR_divFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src2 */ );
  
#line 25465 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2979 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand has been loaded into fp ST (stack top)
      // FSUB   ST,$src1
      emit_opcode(cbuf, 0xD8);
      emit_opcode(cbuf, 0xE0 + opnd_array(2)->reg(ra_,this,idx2)/* src1 */);

      // FDIV
      emit_opcode(cbuf, 0xD8);
      emit_opcode(cbuf, 0xF0 + opnd_array(3)->reg(ra_,this,idx3)/* src3 */);
  
#line 25480 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 25489 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divFPR24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
  
#line 25506 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x6 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
  
#line 25515 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 25523 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
  
#line 25540 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 25548 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 25556 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void modFPR24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2428 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // load dst in FPR0
    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
    if (opnd_array(2)->reg(ra_,this,idx2)/* src2 */ != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // swap src with FPR1:
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
  
#line 25586 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2530 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 25612 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2501 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    if (opnd_array(2)->reg(ra_,this,idx2)/* src2 */ != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
    // // following asm replaced with Pop_Reg_F or Pop_Mem_F
    // // FSTP   FPR$dst$$reg
    // emit_opcode( cbuf, 0xDD );
    // emit_d8( cbuf, 0xD8+$dst$$reg );
  
#line 25634 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 25642 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void modFPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2428 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // load dst in FPR0
    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
    if (opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // swap src with FPR1:
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
  
#line 25672 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2530 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 25698 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2501 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    if (opnd_array(2)->reg(ra_,this,idx2)/* src */ != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2)/* src */ );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
    // // following asm replaced with Pop_Reg_F or Pop_Mem_F
    // // FSTP   FPR$dst$$reg
    // emit_opcode( cbuf, 0xDD );
    // emit_d8( cbuf, 0xD8+$dst$$reg );
  
#line 25720 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(1)->reg(ra_,this,idx1)/* dst */ );
  
#line 25729 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void modF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 2455 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ subptr(rsp, 4);
    __ movflt(Address(rsp, 0), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */);
    __ fld_s(Address(rsp, 0));
    __ movflt(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src0 */);
    __ fld_s(Address(rsp, 0));
  
#line 25750 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2530 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 25776 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2471 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_s(Address(rsp, 0));
    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, (0x4));
  
#line 25787 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2322 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, 0xD8 );
  
#line 25796 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void roundFloat_mem_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2394 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1)/* src */ != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xD9, pop, opnd_array(0)->disp(ra_,this,0) ); // FST<P>_S  [ESP+dst]
  
#line 25817 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void roundDouble_mem_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1)/* src */ != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xDD, pop, opnd_array(0)->disp(ra_,this,0) ); // FST<P>_D  [ESP+dst]
  
#line 25838 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convDPR2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10667 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ subptr(rsp, 4);
    if (opnd_array(1)->reg(ra_,this,idx1)/* src */!= FPR1L_enc) {
      __ fld_s(opnd_array(1)->reg(ra_,this,idx1)/* src */-1);
      __ fstp_s(Address(rsp, 0));
    } else {
      __ fst_s(Address(rsp, 0));
    }
    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 4);
  
#line 25862 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convD2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10686 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cvtsd2ss (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 25878 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convFPR2DPR_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2416 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0xD0 - 1; // -1 since we skip FLD
    if (opnd_array(1)->reg(ra_,this,idx1)/* src */ != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(src-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
      pop = 0xD8;
    }
    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, pop+opnd_array(0)->reg(ra_,this)/* dst */ );      // FST<P> ST(i)
  
#line 25900 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convF2DPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10718 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ subptr(rsp, 4);
    __ movflt(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_s(Address(rsp, 0));
    __ addptr(rsp, 4);
    __ fstp_d(opnd_array(0)->reg(ra_,this)/* dst */);
  
#line 25920 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convF2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10732 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cvtss2sd (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 25936 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convDPR2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );   // FLD ST(i-1)
  
#line 25952 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2874 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Flip to round-to-zero mode.  We attempted to allow invalid-op
    // exceptions here, so that a NAN or other corner-case value will
    // thrown an exception (but normal values get converted at full speed).
    // However, I2C adapters and other float-stack manglers leave pending
    // invalid-op exceptions hanging.  We would have to clear them before
    // enabling them and that is more expensive than just testing for the
    // invalid value Intel stores down in the corner cases.
    emit_opcode(cbuf,0xD9);            // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());
    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x04);
    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as an int, popping the FPU stack
    emit_opcode(cbuf,0xDB);            // FISTP [ESP]
    emit_opcode(cbuf,0x1C);
    emit_d8(cbuf,0x24);
    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);            // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
        ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
        : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);       // POP EAX
    emit_opcode(cbuf,0x3D);       // CMP EAX,imm
    emit_d32   (cbuf,0x80000000); //         0x80000000
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07);       // Size of slow_call
    // Push src onto stack slow-path
    emit_opcode(cbuf,0xD9 );      // FLD     ST(i)
    emit_d8    (cbuf,0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2i_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 25999 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10772 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label fast;
    __ cvttsd2sil(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ cmpl(opnd_array(0)->as_Register(ra_,this)/* dst */, 0x80000000);
    __ jccb(Assembler::notEqual, fast);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_d(Address(rsp, 0));
    __ addptr(rsp, 8);
    __ call(RuntimeAddress(CAST_FROM_FN_PTR(address, StubRoutines::d2i_wrapper())));
    __ bind(fast);
  
#line 26024 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convDPR2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );   // FLD ST(i-1)
  
#line 26040 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2917 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xD9);            // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());
    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);
    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as a long, popping the FPU stack
    emit_opcode(cbuf,0xDF);            // FISTP [ESP]
    emit_opcode(cbuf,0x3C);
    emit_d8(cbuf,0x24);
    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);            // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
        ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
        : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);       // POP EAX
    emit_opcode(cbuf,0x5A);       // POP EDX
    emit_opcode(cbuf,0x81);       // CMP EDX,imm
    emit_d8    (cbuf,0xFA);       // rdx
    emit_d32   (cbuf,0x80000000); //         0x80000000
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07+4);     // Size of slow_call
    emit_opcode(cbuf,0x85);       // TEST EAX,EAX
    emit_opcode(cbuf,0xC0);       // 2/rax,/rax,
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07);       // Size of slow_call
    // Push src onto stack slow-path
    emit_opcode(cbuf,0xD9 );      // FLD     ST(i)
    emit_d8    (cbuf,0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2l_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 26086 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10832 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label fast;
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_d(Address(rsp, 0));
    __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_trunc()));
    __ fistp_d(Address(rsp, 0));
    // Restore the rounding mode, mask the exception
    if (Compile::current()->in_24_bit_fp_mode()) {
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    } else {
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    // Load the converted long, adjust CPU stack
    __ pop(rax);
    __ pop(rdx);
    __ cmpl(rdx, 0x80000000);
    __ jccb(Assembler::notEqual, fast);
    __ testl(rax, rax);
    __ jccb(Assembler::notEqual, fast);
    __ subptr(rsp, 8);
    __ movdbl(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_d(Address(rsp, 0));
    __ addptr(rsp, 8);
    __ call(RuntimeAddress(CAST_FROM_FN_PTR(address, StubRoutines::d2l_wrapper())));
    __ bind(fast);
  
#line 26126 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convFPR2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 26142 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2874 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Flip to round-to-zero mode.  We attempted to allow invalid-op
    // exceptions here, so that a NAN or other corner-case value will
    // thrown an exception (but normal values get converted at full speed).
    // However, I2C adapters and other float-stack manglers leave pending
    // invalid-op exceptions hanging.  We would have to clear them before
    // enabling them and that is more expensive than just testing for the
    // invalid value Intel stores down in the corner cases.
    emit_opcode(cbuf,0xD9);            // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());
    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x04);
    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as an int, popping the FPU stack
    emit_opcode(cbuf,0xDB);            // FISTP [ESP]
    emit_opcode(cbuf,0x1C);
    emit_d8(cbuf,0x24);
    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);            // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
        ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
        : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);       // POP EAX
    emit_opcode(cbuf,0x3D);       // CMP EAX,imm
    emit_d32   (cbuf,0x80000000); //         0x80000000
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07);       // Size of slow_call
    // Push src onto stack slow-path
    emit_opcode(cbuf,0xD9 );      // FLD     ST(i)
    emit_d8    (cbuf,0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2i_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 26189 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convF2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10902 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label fast;
    __ cvttss2sil(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ cmpl(opnd_array(0)->as_Register(ra_,this)/* dst */, 0x80000000);
    __ jccb(Assembler::notEqual, fast);
    __ subptr(rsp, 4);
    __ movflt(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_s(Address(rsp, 0));
    __ addptr(rsp, 4);
    __ call(RuntimeAddress(CAST_FROM_FN_PTR(address, StubRoutines::d2i_wrapper())));
    __ bind(fast);
  
#line 26214 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convFPR2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2388 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 26230 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2917 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xD9);            // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());
    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);
    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as a long, popping the FPU stack
    emit_opcode(cbuf,0xDF);            // FISTP [ESP]
    emit_opcode(cbuf,0x3C);
    emit_d8(cbuf,0x24);
    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);            // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
        ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
        : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);       // POP EAX
    emit_opcode(cbuf,0x5A);       // POP EDX
    emit_opcode(cbuf,0x81);       // CMP EDX,imm
    emit_d8    (cbuf,0xFA);       // rdx
    emit_d32   (cbuf,0x80000000); //         0x80000000
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07+4);     // Size of slow_call
    emit_opcode(cbuf,0x85);       // TEST EAX,EAX
    emit_opcode(cbuf,0xC0);       // 2/rax,/rax,
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07);       // Size of slow_call
    // Push src onto stack slow-path
    emit_opcode(cbuf,0xD9 );      // FLD     ST(i)
    emit_d8    (cbuf,0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2l_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 26276 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10963 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label fast;
    __ subptr(rsp, 8);
    __ movflt(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_s(Address(rsp, 0));
    __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_trunc()));
    __ fistp_d(Address(rsp, 0));
    // Restore the rounding mode, mask the exception
    if (Compile::current()->in_24_bit_fp_mode()) {
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    } else {
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    // Load the converted long, adjust CPU stack
    __ pop(rax);
    __ pop(rdx);
    __ cmpl(rdx, 0x80000000);
    __ jccb(Assembler::notEqual, fast);
    __ testl(rax, rax);
    __ jccb(Assembler::notEqual, fast);
    __ subptr(rsp, 4);
    __ movflt(Address(rsp, 0), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ fld_s(Address(rsp, 0));
    __ addptr(rsp, 4);
    __ call(RuntimeAddress(CAST_FROM_FN_PTR(address, StubRoutines::d2l_wrapper())));
    __ bind(fast);
  
#line 26316 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2DPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2368 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0xDB /*primary()*/), (0x0 /*secondary()*/), opnd_array(1)->disp(ra_,this,idx1) );
  
#line 26331 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 26340 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11007 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cvtsi2sdl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26356 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 11017 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cvtsi2sdl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26372 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convXI2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11030 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cvtdq2pd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 26389 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2DPR_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDB /*primary()*/));
  
#line 26404 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 26418 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 26427 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void conv24I2FPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2368 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0xDB /*primary()*/), (0x0 /*secondary()*/), opnd_array(1)->disp(ra_,this,idx1) );
  
#line 26442 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 26451 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2FPR_SSFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2368 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0xDB /*primary()*/), (0x0 /*secondary()*/), opnd_array(1)->disp(ra_,this,idx1) );
  
#line 26466 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 26474 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2FPR_SSF_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDB /*primary()*/));
  
#line 26489 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 26503 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 26511 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2FPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2368 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0xDB /*primary()*/), (0x0 /*secondary()*/), opnd_array(1)->disp(ra_,this,idx1) );
  
#line 26526 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 26535 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2FPR_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDB /*primary()*/));
  
#line 26550 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 26564 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 26573 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ cvtsi2ssl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26589 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convXI2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11128 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cvtdq2ps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 26606 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2650 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // mov $dst.lo,$src
    int dst_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int src_encoding = opnd_array(1)->reg(ra_,this,idx1)/* src */;
    encode_Copy( cbuf, dst_encoding  , src_encoding );
    // mov $dst.hi,$src
    encode_Copy( cbuf, HIGH_FROM_LOW(dst_encoding), src_encoding );
    // sar $dst.hi,31
    emit_opcode( cbuf, 0xC1 );
    emit_rm(cbuf, 0x3, 7, HIGH_FROM_LOW(dst_encoding) );
    emit_d8(cbuf, 0x1F );
  
#line 26630 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convI2L_reg_zexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 26646 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 26654 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)/* dst */), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 26662 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void zerox_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 26678 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 26686 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)/* dst */), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 26694 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convL2DPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2663 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // push $src.hi
    emit_opcode(cbuf, 0x50+HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    // push $src.lo
    emit_opcode(cbuf, 0x50+opnd_array(1)->reg(ra_,this,idx1)/* src */  );
    // fild 64-bits at [SP]
    emit_opcode(cbuf,0xdf);
    emit_d8(cbuf, 0x6C);
    emit_d8(cbuf, 0x24);
    emit_d8(cbuf, 0x00);
    // pop stack
    emit_opcode(cbuf, 0x83); // add  SP, #8
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, 0x8);
  
#line 26721 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2379 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 26729 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convL2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2693 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // push $src.hi
    emit_opcode(cbuf, 0x50+HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    // push $src.lo
    emit_opcode(cbuf, 0x50+opnd_array(1)->reg(ra_,this,idx1)/* src */  );
    // fild 64-bits at [SP]
    emit_opcode(cbuf,0xdf);
    emit_d8(cbuf, 0x6C);
    emit_d8(cbuf, 0x24);
    emit_d8(cbuf, 0x00);
  
#line 26752 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2464 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_d(Address(rsp, 0));
    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, 8);
  
#line 26763 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convL2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2693 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // push $src.hi
    emit_opcode(cbuf, 0x50+HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    // push $src.lo
    emit_opcode(cbuf, 0x50+opnd_array(1)->reg(ra_,this,idx1)/* src */  );
    // fild 64-bits at [SP]
    emit_opcode(cbuf,0xdf);
    emit_d8(cbuf, 0x6C);
    emit_d8(cbuf, 0x24);
    emit_d8(cbuf, 0x00);
  
#line 26786 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2471 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ fstp_s(Address(rsp, 0));
    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, 0));
    __ addptr(rsp, (0x8));
  
#line 26797 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convL2FPR_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2663 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // push $src.hi
    emit_opcode(cbuf, 0x50+HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    // push $src.lo
    emit_opcode(cbuf, 0x50+opnd_array(1)->reg(ra_,this,idx1)/* src */  );
    // fild 64-bits at [SP]
    emit_opcode(cbuf,0xdf);
    emit_d8(cbuf, 0x6C);
    emit_d8(cbuf, 0x24);
    emit_d8(cbuf, 0x00);
    // pop stack
    emit_opcode(cbuf, 0x83); // add  SP, #8
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, 0x8);
  
#line 26824 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2373 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 26832 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1936 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this)/* dst */, opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 26847 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveF2I_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11241 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 26863 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveFPR2I_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2394 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1)/* src */ != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xD9, pop, opnd_array(0)->disp(ra_,this,0) ); // FST<P>_S  [ESP+dst]
  
#line 26884 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveF2I_reg_stack_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11265 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movflt(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 26900 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveF2I_reg_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11277 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 26916 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveI2F_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11289 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26932 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveI2FPR_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 26947 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "No oops here because no reloc info allowed" );
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, relocInfo::none);
  
#line 26961 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 26970 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveI2F_stack_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 26986 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveI2F_reg_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11330 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27002 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveD2L_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 27017 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this)/* dst */;
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 27031 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*secondary()*/));
  
#line 27039 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 27053 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveDPR2L_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1)/* src */ != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1)/* src */ );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xDD, pop, opnd_array(0)->disp(ra_,this,0) ); // FST<P>_D  [ESP+dst]
  
#line 27074 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveD2L_reg_stack_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11365 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 27090 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveD2L_reg_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 11379 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ pshuflw(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x4e);
    __ movdl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)/* dst */), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */);
  
#line 27109 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveL2D_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 27124 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* src */;
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0);
    relocInfo::relocType disp_reloc = opnd_array(0)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 27138 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*secondary()*/));
  
#line 27146 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */);  // Hi register of pair, computed from lo
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0) + 4;      // Offset is 4 further in memory
    assert( opnd_array(0)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 27160 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveL2DPR_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*primary()*/));
  
#line 27175 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    assert( opnd_array(1)->disp_reloc() == relocInfo::none, "No oops here because no reloc info allowed" );
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, relocInfo::none);
  
#line 27189 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this)/* dst */ );
  
#line 27198 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveL2D_stack_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11422 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27214 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveL2D_stack_reg_sse_partialNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11435 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27230 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void MoveL2D_reg_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 11449 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdl(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ movdl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* src */));
    __ punpckldq(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */);
  
#line 27250 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void rep_stosNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {
    MacroAssembler _masm(&cbuf);

#line 11467 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ clear_mem(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */, as_Register(EAX_enc));
  
#line 27267 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void rep_fast_stosbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {
    MacroAssembler _masm(&cbuf);

#line 11480 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ clear_mem(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */, as_Register(EAX_enc));
  
#line 27284 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void string_compareNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  {
    MacroAssembler _masm(&cbuf);

#line 11492 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */);
  
#line 27306 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void string_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    MacroAssembler _masm(&cbuf);

#line 11507 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ char_arrays_equals(false, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                          opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(EBX_enc),
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */);
  
#line 27328 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void string_indexof_conNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vec
  {
    MacroAssembler _masm(&cbuf);

#line 11523 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    if (icnt2 >= 8) {
      // IndexOf for constant substrings with size >= 8 elements
      // which don't need to be loaded through stack.
      __ string_indexofC8(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                          opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, as_Register(EAX_enc),
                          icnt2, opnd_array(0)->as_Register(ra_,this)/* result */,
                          opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vec */, as_Register(ECX_enc));
    } else {
      // Small strings are loaded through stack if they cross page boundary.
      __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                        opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, as_Register(EAX_enc),
                        icnt2, opnd_array(0)->as_Register(ra_,this)/* result */,
                        opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vec */, as_Register(ECX_enc));
    }
  
#line 27362 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void string_indexofNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vec
  {
    MacroAssembler _masm(&cbuf);

#line 11550 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      (-1), opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vec */, as_Register(ECX_enc));
  
#line 27385 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void array_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    MacroAssembler _masm(&cbuf);

#line 11568 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ char_arrays_equals(true, opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                          as_Register(ECX_enc), opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(EBX_enc),
                          opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */);
  
#line 27406 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void encode_iso_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 11584 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */,
                        opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */, as_Register(ECX_enc), opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 27430 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 27446 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* op1 */, opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
  
#line 27454 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x07 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
  
#line 27478 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 27493 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 27509 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* op1 */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 27523 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void testI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 27539 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* src */, opnd_array(1)->reg(ra_,this,idx1)/* src */);
  
#line 27547 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void testI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 27564 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x00 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* src */ );
  
#line 27572 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output immediate
    emit_d32(cbuf, opnd_array(2)->constant());
  
#line 27581 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void testI_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 27598 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* src */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 27612 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compU_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 27628 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* op1 */, opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
  
#line 27636 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compU_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x07 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
  
#line 27660 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 27675 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compU_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 27691 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* op1 */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 27705 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void testU_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 27721 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* src */, opnd_array(1)->reg(ra_,this,idx1)/* src */);
  
#line 27729 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compP_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 27745 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* op1 */, opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
  
#line 27753 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compP_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x07 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
  
#line 27777 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      
if ( opnd_array(2)->constant_reloc() != relocInfo::none ) {
  emit_d32_reloc(cbuf, opnd_array(2)->constant(), opnd_array(2)->constant_reloc(), 0);
} else {
  emit_d32(cbuf, opnd_array(2)->constant());
};
    }
  
#line 27797 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compP_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 27813 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* op1 */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 27827 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void compP_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 27843 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1)/* op1 */;
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 27857 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void testP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 27873 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* src */, opnd_array(1)->reg(ra_,this,idx1)/* src */);
  
#line 27881 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void testP_Reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 27897 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2147 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_reloc);
  
#line 27911 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1990 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d32(cbuf,(0xFFFFFFFF));
  
#line 27919 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void minI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2167 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Compare dst,src
    emit_opcode(cbuf,0x3B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // jmp dst < src around move
    emit_opcode(cbuf,0x7C);
    emit_d8(cbuf,2);
    // move dst,src
    emit_opcode(cbuf,0x8B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 27943 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void maxI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2179 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Compare dst,src
    emit_opcode(cbuf,0x3B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // jmp dst > src around move
    emit_opcode(cbuf,0x7F);
    emit_d8(cbuf,2);
    // move dst,src
    emit_opcode(cbuf,0x8B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* dst */, opnd_array(2)->reg(ra_,this,idx2)/* src */);
  
#line 27967 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loopLimit_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// init
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// limit
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// stride
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// limit_hi
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 11868 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int strd = (int)opnd_array(3)->constant();
    assert(strd != 1 && strd != -1, "sanity");
    int m1 = (strd > 0) ? 1 : -1;
    // Convert limit to long (EAX:EDX)
    __ cdql();
    // Convert init to long (init:tmp)
    __ movl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* init */);
    __ sarl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, 31);
    // $limit - $init
    __ subl(opnd_array(2)->as_Register(ra_,this,idx2)/* limit */, opnd_array(1)->as_Register(ra_,this,idx1)/* init */);
    __ sbbl(opnd_array(4)->as_Register(ra_,this,idx4)/* limit_hi */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */);
    // + ($stride - 1)
    if (strd > 0) {
      __ addl(opnd_array(2)->as_Register(ra_,this,idx2)/* limit */, (strd - 1));
      __ adcl(opnd_array(4)->as_Register(ra_,this,idx4)/* limit_hi */, 0);
      __ movl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, strd);
    } else {
      __ addl(opnd_array(2)->as_Register(ra_,this,idx2)/* limit */, (strd + 1));
      __ adcl(opnd_array(4)->as_Register(ra_,this,idx4)/* limit_hi */, -1);
      __ lneg(opnd_array(4)->as_Register(ra_,this,idx4)/* limit_hi */, opnd_array(2)->as_Register(ra_,this,idx2)/* limit */);
      __ movl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, -strd);
    }
    // signed devision: (EAX:EDX) / pos_stride
    __ idivl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */);
    if (strd < 0) {
      // restore sign
      __ negl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */);
    }
    // (EAX) * stride
    __ mull(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */);
    // + init (ignore upper bits)
    __ addl(opnd_array(2)->as_Register(ra_,this,idx2)/* limit */, opnd_array(1)->as_Register(ra_,this,idx1)/* init */);
  
#line 28018 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void jumpXtndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  ra_->C->constant_table().fill_jump_table(cbuf, (MachConstantNode*) this, _index2label);
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11912 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Jump to Address(table_base + switch_reg)
    Address index(noreg, opnd_array(1)->as_Register(ra_,this,idx1)/* switch_val */, Address::times_1);
    __ jump(ArrayAddress(InternalAddress(__ code()->consts()->start() + constant_offset()), index));
  
#line 28037 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void jumpXtndNode::eval_constant(Compile* C) {
  _constant = C->constant_table().add_jump_table(this);
  // User did not define an encode section.
}
void jmpDirNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11928 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(1)->label();
    __ jmp(*L, false); // Always long jump
  
#line 28058 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpDirNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 5, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 5);
}

void jmpConNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 28082 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpConNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpLoopEndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 28106 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpLoopEndNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpLoopEndUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 28130 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpLoopEndUNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpLoopEndUCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11987 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 28154 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpLoopEndUCFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpConUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12002 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 28178 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpConUNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpConUCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12016 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 28202 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpConUCFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpConUCF2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12038 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* l = opnd_array(3)->label();
    if (opnd_array(1)->ccode()== Assembler::notEqual) {
      __ jcc(Assembler::parity, *l, false);
      __ jcc(Assembler::notEqual, *l, false);
    } else if (opnd_array(1)->ccode()== Assembler::equal) {
      Label done;
      __ jccb(Assembler::parity, done);
      __ jcc(Assembler::equal, *l, false);
      __ bind(done);
    } else {
       ShouldNotReachHere();
    }
  
#line 28236 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 1716 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Redi = as_Register(EDI_enc); // result register
    Register Reax = as_Register(EAX_enc); // super class
    Register Recx = as_Register(ECX_enc); // killed
    Register Resi = as_Register(ESI_enc); // sub class
    Label miss;

    MacroAssembler _masm(&cbuf);
    __ check_klass_subtype_slow_path(Resi, Reax, Recx, Redi,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
    if ((0x1 /*primary()*/)) {
      __ xorptr(Redi, Redi);
    }
    __ bind(miss);
  
#line 28265 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void partialSubtypeCheck_vs_ZeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 1716 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Redi = as_Register(EDI_enc); // result register
    Register Reax = as_Register(EAX_enc); // super class
    Register Recx = as_Register(ECX_enc); // killed
    Register Resi = as_Register(ESI_enc); // sub class
    Label miss;

    MacroAssembler _masm(&cbuf);
    __ check_klass_subtype_slow_path(Resi, Reax, Recx, Redi,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
    if ((0x0 /*primary()*/)) {
      __ xorptr(Redi, Redi);
    }
    __ bind(miss);
  
#line 28295 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void jmpDir_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12117 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(1)->label();
    __ jmpb(*L);
  
#line 28312 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpDir_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpCon_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12133 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 28336 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpCon_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpLoopEnd_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12149 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 28360 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpLoopEnd_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpLoopEndU_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12165 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 28384 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpLoopEndU_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpLoopEndUCF_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12180 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 28408 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpLoopEndUCF_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpConU_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12196 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 28432 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpConU_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpConUCF_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12211 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 28456 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpConUCF_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpConUCF2_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12235 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* l = opnd_array(3)->label();
    if (opnd_array(1)->ccode()== Assembler::notEqual) {
      __ jccb(Assembler::parity, *l);
      __ jccb(Assembler::notEqual, *l);
    } else if (opnd_array(1)->ccode()== Assembler::equal) {
      Label done;
      __ jccb(Assembler::parity, done);
      __ jccb(Assembler::equal, *l);
      __ bind(done);
    } else {
       ShouldNotReachHere();
    }
  
#line 28490 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint jmpConUCF2_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12291 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label p_one, m_one, done;
    __ xorptr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ cmpl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */), HIGH_FROM_LOW(opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */));
    __ jccb(Assembler::less,    m_one);
    __ jccb(Assembler::greater, p_one);
    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ jccb(Assembler::below,   m_one);
    __ jccb(Assembler::equal,   done);
    __ bind(p_one);
    __ incrementl(opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ jmpb(done);
    __ bind(m_one);
    __ decrementl(opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ bind(done);
  
#line 28525 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpL_zero_flags_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 28541 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 28549 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpL_reg_flags_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2822 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CMP    $src1.lo,$src2.lo\t! Long compare; set flags for low bits
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* src1 */, opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
    // MOV    $tmp,$src1.hi
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src1 */) );
    // SBB   $tmp,$src2.hi\t! Compute flags for long compare
    emit_opcode( cbuf, 0x1B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src2 */) );
  
#line 28574 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovLL_reg_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28593 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1954 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 28601 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28610 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)/* dst */), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)/* src */));
  
#line 28618 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovLL_mem_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28637 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* dst */;
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    relocInfo::relocType disp_reloc = opnd_array(4)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 28651 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28660 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4) + 4;      // Offset is 4 further in memory
    assert( opnd_array(4)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 28674 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovII_reg_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28693 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 28701 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovII_mem_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28720 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* dst */;
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    relocInfo::relocType disp_reloc = opnd_array(4)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 28734 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovPP_reg_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28753 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 28761 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpL_zero_flags_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2801 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // MOV   $tmp,$src.lo
    emit_opcode(cbuf, 0x8B);
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, opnd_array(1)->reg(ra_,this,idx1)/* src */);
    // OR    $tmp,$src.hi
    emit_opcode(cbuf, 0x0B);
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 28783 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpL_reg_flags_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2810 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CMP    $src1.lo,$src2.lo
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1)/* src1 */, opnd_array(2)->reg(ra_,this,idx2)/* src2 */ );
    // JNE,s  skip
    emit_cc(cbuf, 0x70, 0x5);
    emit_d8(cbuf,2);
    // CMP    $src1.hi,$src2.hi
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src2 */) );
  
#line 28807 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovLL_reg_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28826 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1954 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 28834 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28843 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)/* dst */), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)/* src */));
  
#line 28851 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovLL_mem_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28870 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* dst */;
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    relocInfo::relocType disp_reloc = opnd_array(4)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 28884 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28893 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4) + 4;      // Offset is 4 further in memory
    assert( opnd_array(4)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 28907 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovII_reg_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28926 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 28934 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovII_mem_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28953 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* dst */;
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    relocInfo::relocType disp_reloc = opnd_array(4)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 28967 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovPP_reg_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28986 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 28994 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpL_zero_flags_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2834 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // XOR    $tmp,$tmp
    emit_opcode(cbuf,0x33);  // XOR
    emit_rm(cbuf,0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    // CMP    $tmp,$src.lo
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, opnd_array(1)->reg(ra_,this,idx1)/* src */ );
    // SBB    $tmp,$src.hi
    emit_opcode( cbuf, 0x1B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src */) );
  
#line 29019 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpL_reg_flags_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2822 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CMP    $src1.lo,$src2.lo\t! Long compare; set flags for low bits
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2)/* src2 */, opnd_array(1)->reg(ra_,this,idx1)/* src1 */ );
    // MOV    $tmp,$src1.hi
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)/* src2 */) );
    // SBB   $tmp,$src2.hi\t! Compute flags for long compare
    emit_opcode( cbuf, 0x1B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)/* src1 */) );
  
#line 29044 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovLL_reg_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 29063 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1954 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 29071 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 29080 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1958 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)/* dst */), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)/* src */));
  
#line 29088 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovLL_mem_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 29107 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* dst */;
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    relocInfo::relocType disp_reloc = opnd_array(4)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 29121 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 29130 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)/* dst */);  // Hi register of pair, computed from lo
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4) + 4;      // Offset is 4 further in memory
    assert( opnd_array(4)->disp_reloc() == relocInfo::none, "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, relocInfo::none);
  
#line 29144 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovII_reg_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 29163 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 29171 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovII_mem_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 29190 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3)/* dst */;
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    relocInfo::relocType disp_reloc = opnd_array(4)->disp_reloc();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_reloc);
  
#line 29204 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmovPP_reg_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// flags
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 29223 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3)/* dst */, opnd_array(4)->reg(ra_,this,idx4)/* src */);
  
#line 29231 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1792 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if (ra_->C->in_24_bit_fp_mode()) {
      MacroAssembler _masm(&cbuf);
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    if (ra_->C->max_vector_size() > 16) {
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      MacroAssembler _masm(&cbuf);
      __ vzeroupper();
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_resets_size(), "correct size prediction");
  
#line 29259 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1817 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CALL to fixup routine.  Fixup routine uses ScopeDesc info to determine
    // who we intended to call.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    if (!_method) {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     runtime_call_Relocation::spec(), RELOC_IMM32 );
    } else if (_optimized_virtual) {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     opt_virtual_call_Relocation::spec(), RELOC_IMM32 );
    } else {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     static_call_Relocation::spec(), RELOC_IMM32 );
    }
    if (_method) {  // Emit stub for static call.
      CompiledStaticCall::emit_to_interp_stub(cbuf);
    }
  
#line 29283 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 930 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      int framesize = ra_->reg2offset_unchecked(OptoReg::add(ra_->_matcher._old_SP, -3*VMRegImpl::slots_per_word));
      MacroAssembler _masm(&cbuf);
      Label L;
      __ cmpptr(Address(rsp, framesize), (int32_t)0xbadb100d);
      __ jccb(Assembler::equal, L);
      // Die if stack mismatch
      __ int3();
      __ bind(L);
    }
  
#line 29301 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1809 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if (Compile::current()->in_24_bit_fp_mode()) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 29313 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void CallStaticJavaHandleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// ebp_mh_SP_save
  {

#line 1792 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if (ra_->C->in_24_bit_fp_mode()) {
      MacroAssembler _masm(&cbuf);
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    if (ra_->C->max_vector_size() > 16) {
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      MacroAssembler _masm(&cbuf);
      __ vzeroupper();
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_resets_size(), "correct size prediction");
  
#line 29341 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 915 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    debug_only(int off0 = cbuf.insts_size());
    MacroAssembler _masm(&cbuf);
    // RBP is preserved across all calls, even compiled calls.
    // Use it to preserve RSP in places where the callee might change the SP.
    __ movptr(rbp_mh_SP_save, rsp);
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == preserve_SP_size(), "correct size prediction");
  
#line 29355 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1817 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CALL to fixup routine.  Fixup routine uses ScopeDesc info to determine
    // who we intended to call.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    if (!_method) {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     runtime_call_Relocation::spec(), RELOC_IMM32 );
    } else if (_optimized_virtual) {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     opt_virtual_call_Relocation::spec(), RELOC_IMM32 );
    } else {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     static_call_Relocation::spec(), RELOC_IMM32 );
    }
    if (_method) {  // Emit stub for static call.
      CompiledStaticCall::emit_to_interp_stub(cbuf);
    }
  
#line 29379 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 925 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    MacroAssembler _masm(&cbuf);
    __ movptr(rsp, rbp_mh_SP_save);
  
#line 29388 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 930 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      int framesize = ra_->reg2offset_unchecked(OptoReg::add(ra_->_matcher._old_SP, -3*VMRegImpl::slots_per_word));
      MacroAssembler _masm(&cbuf);
      Label L;
      __ cmpptr(Address(rsp, framesize), (int32_t)0xbadb100d);
      __ jccb(Assembler::equal, L);
      // Die if stack mismatch
      __ int3();
      __ bind(L);
    }
  
#line 29406 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1809 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if (Compile::current()->in_24_bit_fp_mode()) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 29418 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1792 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if (ra_->C->in_24_bit_fp_mode()) {
      MacroAssembler _masm(&cbuf);
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    if (ra_->C->max_vector_size() > 16) {
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      MacroAssembler _masm(&cbuf);
      __ vzeroupper();
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_resets_size(), "correct size prediction");
  
#line 29446 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1837 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ ic_call((address)opnd_array(1)->method());
  
#line 29455 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 930 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      int framesize = ra_->reg2offset_unchecked(OptoReg::add(ra_->_matcher._old_SP, -3*VMRegImpl::slots_per_word));
      MacroAssembler _masm(&cbuf);
      Label L;
      __ cmpptr(Address(rsp, framesize), (int32_t)0xbadb100d);
      __ jccb(Assembler::equal, L);
      // Die if stack mismatch
      __ int3();
      __ bind(L);
    }
  
#line 29473 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1809 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if (Compile::current()->in_24_bit_fp_mode()) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 29485 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1792 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if (ra_->C->in_24_bit_fp_mode()) {
      MacroAssembler _masm(&cbuf);
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    if (ra_->C->max_vector_size() > 16) {
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      MacroAssembler _masm(&cbuf);
      __ vzeroupper();
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_resets_size(), "correct size prediction");
  
#line 29513 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1733 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler masm(&cbuf);
    int start = masm.offset();
    if (UseSSE >= 2) {
      if (VerifyFPU) {
        masm.verify_FPU(0, "must be empty in SSE2+ mode");
      }
    } else {
      // External c_calling_convention expects the FPU stack to be 'clean'.
      // Compiled code leaves it dirty.  Do cleanup now.
      masm.empty_FPU_stack();
    }
    if (sizeof_FFree_Float_Stack_All == -1) {
      sizeof_FFree_Float_Stack_All = masm.offset() - start;
    } else {
      assert(masm.offset() - start == sizeof_FFree_Float_Stack_All, "wrong size");
    }
  
#line 29536 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1759 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // This is the instruction starting address for relocation info.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    // CALL directly to the runtime
    emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                runtime_call_Relocation::spec(), RELOC_IMM32 );

    if (UseSSE >= 2) {
      MacroAssembler _masm(&cbuf);
      BasicType rt = tf()->return_type();

      if ((rt == T_FLOAT || rt == T_DOUBLE) && !return_value_is_used()) {
        // A C runtime call where the return value is unused.  In SSE2+
        // mode the result needs to be removed from the FPU stack.  It's
        // likely that this function call could be removed by the
        // optimizer if the C function is a pure function.
        __ ffree(0);
      } else if (rt == T_FLOAT) {
        __ lea(rsp, Address(rsp, -4));
        __ fstp_s(Address(rsp, 0));
        __ movflt(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  4));
      } else if (rt == T_DOUBLE) {
        __ lea(rsp, Address(rsp, -8));
        __ fstp_d(Address(rsp, 0));
        __ movdbl(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  8));
      }
    }
  
#line 29572 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1809 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if (Compile::current()->in_24_bit_fp_mode()) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 29584 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1792 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if (ra_->C->in_24_bit_fp_mode()) {
      MacroAssembler _masm(&cbuf);
      __ fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    if (ra_->C->max_vector_size() > 16) {
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      MacroAssembler _masm(&cbuf);
      __ vzeroupper();
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_resets_size(), "correct size prediction");
  
#line 29612 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1733 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler masm(&cbuf);
    int start = masm.offset();
    if (UseSSE >= 2) {
      if (VerifyFPU) {
        masm.verify_FPU(0, "must be empty in SSE2+ mode");
      }
    } else {
      // External c_calling_convention expects the FPU stack to be 'clean'.
      // Compiled code leaves it dirty.  Do cleanup now.
      masm.empty_FPU_stack();
    }
    if (sizeof_FFree_Float_Stack_All == -1) {
      sizeof_FFree_Float_Stack_All = masm.offset() - start;
    } else {
      assert(masm.offset() - start == sizeof_FFree_Float_Stack_All, "wrong size");
    }
  
#line 29635 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1759 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // This is the instruction starting address for relocation info.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    // CALL directly to the runtime
    emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                runtime_call_Relocation::spec(), RELOC_IMM32 );

    if (UseSSE >= 2) {
      MacroAssembler _masm(&cbuf);
      BasicType rt = tf()->return_type();

      if ((rt == T_FLOAT || rt == T_DOUBLE) && !return_value_is_used()) {
        // A C runtime call where the return value is unused.  In SSE2+
        // mode the result needs to be removed from the FPU stack.  It's
        // likely that this function call could be removed by the
        // optimizer if the C function is a pure function.
        __ ffree(0);
      } else if (rt == T_FLOAT) {
        __ lea(rsp, Address(rsp, -4));
        __ fstp_s(Address(rsp, 0));
        __ movflt(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  4));
      } else if (rt == T_DOUBLE) {
        __ lea(rsp, Address(rsp, -8));
        __ fstp_d(Address(rsp, 0));
        __ movdbl(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  8));
      }
    }
  
#line 29671 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1752 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    if( VerifyFPU ) {
      MacroAssembler masm(&cbuf);
      masm.verify_FPU( -3, "Returning from Runtime Leaf call");
    }
  
#line 29682 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1809 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if (Compile::current()->in_24_bit_fp_mode()) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 29694 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1759 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // This is the instruction starting address for relocation info.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    // CALL directly to the runtime
    emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                runtime_call_Relocation::spec(), RELOC_IMM32 );

    if (UseSSE >= 2) {
      MacroAssembler _masm(&cbuf);
      BasicType rt = tf()->return_type();

      if ((rt == T_FLOAT || rt == T_DOUBLE) && !return_value_is_used()) {
        // A C runtime call where the return value is unused.  In SSE2+
        // mode the result needs to be removed from the FPU stack.  It's
        // likely that this function call could be removed by the
        // optimizer if the C function is a pure function.
        __ ffree(0);
      } else if (rt == T_FLOAT) {
        __ lea(rsp, Address(rsp, -4));
        __ fstp_s(Address(rsp, 0));
        __ movflt(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  4));
      } else if (rt == T_DOUBLE) {
        __ lea(rsp, Address(rsp, -8));
        __ fstp_d(Address(rsp, 0));
        __ movdbl(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  8));
      }
    }
  
#line 29737 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC3 /*primary()*/));
  
#line 29752 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*primary()*/));
  
#line 29768 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* jump_target */ );
  
#line 29776 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void tailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2857 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x5A);
  
#line 29792 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*primary()*/));
  
#line 29800 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1)/* jump_target */ );
  
#line 29808 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2861 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();
    emit_opcode(cbuf, 0xE9);        // jmp    entry
    emit_d32_reloc(cbuf, (int)OptoRuntime::rethrow_stub() - ((int)cbuf.insts_end())-4,
                   runtime_call_Relocation::spec(), RELOC_IMM32 );
  
#line 29839 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpFastLockRTMNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// scr
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// cx1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// cx2
  {
    MacroAssembler _masm(&cbuf);

#line 12883 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fast_lock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */,
                 opnd_array(4)->as_Register(ra_,this,idx4)/* scr */, opnd_array(5)->as_Register(ra_,this,idx5)/* cx1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* cx2 */,
                 _counters, _rtm_counters, _stack_rtm_counters,
                 ((Method*)(ra_->C->method()->constant_encoding()))->method_data(),
                 true, ra_->C->profile_rtm());
  
#line 29864 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// scr
  {
    MacroAssembler _masm(&cbuf);

#line 12899 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fast_lock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */,
                 opnd_array(4)->as_Register(ra_,this,idx4)/* scr */, noreg, noreg, _counters, NULL, NULL, NULL, false, false);
  
#line 29884 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 12911 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fast_unlock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, ra_->C->use_rtm());
  
#line 29902 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void safePoint_pollNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 3049 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.relocate(cbuf.insts_mark(), relocInfo::poll_type, 0);
    emit_opcode(cbuf,0x85);
    emit_rm (cbuf, 0x0, 0x7, 0x5);
    emit_d32(cbuf, (intptr_t)os::get_polling_page());
  
#line 29920 "../generated/adfiles/ad_x86_32.cpp"
  }
}

uint safePoint_pollNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 12950 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register dstReg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ get_thread(dstReg);
  
#line 29942 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 993 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ int3();
  
#line 29958 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1007 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 29975 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1019 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29992 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 1019 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addss(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30009 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1030 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30026 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_immNode::eval_constant(Compile* C) {
  {

#line 1031 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30035 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1042 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vaddss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 30051 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1054 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vaddss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30068 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 1054 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vaddss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30085 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1066 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vaddss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30102 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addF_reg_immNode::eval_constant(Compile* C) {
  {

#line 1067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30111 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1078 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 30127 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1090 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30144 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addD_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 1090 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addsd(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30161 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1101 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30178 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addD_immNode::eval_constant(Compile* C) {
  {

#line 1102 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30187 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1113 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vaddsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 30203 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addD_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1125 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vaddsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30220 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addD_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 1125 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vaddsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30237 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addD_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vaddsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30254 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void addD_reg_immNode::eval_constant(Compile* C) {
  {

#line 1138 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30263 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1149 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 30279 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subF_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1161 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30296 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subF_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1172 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30313 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subF_immNode::eval_constant(Compile* C) {
  {

#line 1173 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30322 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1184 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vsubss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 30338 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subF_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1196 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vsubss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30355 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subF_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1208 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vsubss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30372 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subF_reg_immNode::eval_constant(Compile* C) {
  {

#line 1209 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30381 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1220 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 30397 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1232 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30414 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1243 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30431 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subD_immNode::eval_constant(Compile* C) {
  {

#line 1244 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30440 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1255 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vsubsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 30456 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subD_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1267 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vsubsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30473 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subD_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1279 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vsubsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30490 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void subD_reg_immNode::eval_constant(Compile* C) {
  {

#line 1280 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30499 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1291 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 30515 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulF_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1303 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30532 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulF_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 1303 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulss(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30549 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulF_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1314 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30566 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulF_immNode::eval_constant(Compile* C) {
  {

#line 1315 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30575 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1326 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmulss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 30591 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulF_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1338 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmulss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30608 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulF_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 1338 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmulss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30625 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulF_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1350 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmulss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30642 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulF_reg_immNode::eval_constant(Compile* C) {
  {

#line 1351 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30651 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1362 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 30667 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1374 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30684 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulD_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 1374 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulsd(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30701 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1385 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30718 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulD_immNode::eval_constant(Compile* C) {
  {

#line 1386 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30727 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1397 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmulsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 30743 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulD_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1409 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmulsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30760 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulD_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 1409 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmulsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30777 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulD_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1421 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmulsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30794 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void mulD_reg_immNode::eval_constant(Compile* C) {
  {

#line 1422 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30803 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1433 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 30819 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divF_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1445 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30836 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divF_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1456 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30853 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divF_immNode::eval_constant(Compile* C) {
  {

#line 1457 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30862 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1468 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vdivss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 30878 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divF_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1480 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vdivss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30895 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divF_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1492 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vdivss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30912 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divF_reg_immNode::eval_constant(Compile* C) {
  {

#line 1493 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30921 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1504 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 30937 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1516 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30954 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1527 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 30971 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divD_immNode::eval_constant(Compile* C) {
  {

#line 1528 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 30980 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1539 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vdivsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 30996 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divD_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 1551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vdivsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31013 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divD_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1563 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vdivsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31030 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void divD_reg_immNode::eval_constant(Compile* C) {
  {

#line 1564 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(2));
#line 31039 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 1574 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ andps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, ExternalAddress(float_signmask()));
  
#line 31054 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void absF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1585 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vandps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
              ExternalAddress(float_signmask()), vector256);
  
#line 31072 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 1599 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ andpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, ExternalAddress(double_signmask()));
  
#line 31088 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void absD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1611 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vandpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
              ExternalAddress(double_signmask()), vector256);
  
#line 31106 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void negF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 1624 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ xorps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, ExternalAddress(float_signflip()));
  
#line 31122 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void negF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1635 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vxorps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
              ExternalAddress(float_signflip()), vector256);
  
#line 31140 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void negD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    MacroAssembler _masm(&cbuf);

#line 1649 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ xorpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, ExternalAddress(double_signflip()));
  
#line 31156 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void negD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1661 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vxorpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
              ExternalAddress(double_signflip()), vector256);
  
#line 31174 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1675 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ sqrtss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 31190 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sqrtF_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1687 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ sqrtss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31206 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sqrtF_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ sqrtss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31222 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sqrtF_immNode::eval_constant(Compile* C) {
  {

#line 1699 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 31231 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1710 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ sqrtsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 31246 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sqrtD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1722 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ sqrtsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31262 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sqrtD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1733 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ sqrtsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31278 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void sqrtD_immNode::eval_constant(Compile* C) {
  {

#line 1734 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 31287 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadV4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 1748 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31302 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 1760 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31318 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 1772 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31334 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void loadV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 1784 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmovdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31350 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeV4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1796 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31367 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1807 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31384 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1818 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdqu(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31401 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void storeV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1829 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ vmovdqu(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31418 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1842 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ punpcklbw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
  
#line 31436 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1856 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ punpcklbw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
  
#line 31454 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1871 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ punpcklbw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31473 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1888 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ punpcklbw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31493 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1903 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31509 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4B_immNode::eval_constant(Compile* C) {
  {

#line 1904 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate4_imm(opnd_array(1)->constant(), 1));
#line 31518 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl8B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1913 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31533 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8B_immNode::eval_constant(Compile* C) {
  {

#line 1914 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 1));
#line 31542 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1924 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31558 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl16B_immNode::eval_constant(Compile* C) {
  {

#line 1925 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 1));
#line 31567 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 1937 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31584 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl32B_immNode::eval_constant(Compile* C) {
  {

#line 1938 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 1));
#line 31593 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4B_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 1950 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31608 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8B_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 1960 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31624 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl16B_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 1970 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31640 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl32B_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 1980 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    // Use vxorpd since AVX does not have vpxor for 256-bit (AVX2 will have it).
    bool vector256 = true;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vector256);
  
#line 31658 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 1994 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
  
#line 31675 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2006 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
  
#line 31692 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2019 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31710 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2034 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31729 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2048 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31745 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2S_immNode::eval_constant(Compile* C) {
  {

#line 2049 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate4_imm(opnd_array(1)->constant(), 2));
#line 31754 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2058 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31769 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4S_immNode::eval_constant(Compile* C) {
  {

#line 2059 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 2));
#line 31778 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2069 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31794 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8S_immNode::eval_constant(Compile* C) {
  {

#line 2070 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 2));
#line 31803 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl16S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2082 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31820 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl16S_immNode::eval_constant(Compile* C) {
  {

#line 2083 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 2));
#line 31829 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2S_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2095 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31844 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4S_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31860 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8S_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31876 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl16S_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2125 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    // Use vxorpd since AVX does not have vpxor for 256-bit (AVX2 will have it).
    bool vector256 = true;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vector256);
  
#line 31894 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2139 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
  
#line 31911 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2151 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
  
#line 31928 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2164 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31946 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2177 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31962 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2I_immNode::eval_constant(Compile* C) {
  {

#line 2178 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 4));
#line 31971 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2188 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 31987 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4I_immNode::eval_constant(Compile* C) {
  {

#line 2189 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 4));
#line 31996 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2201 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32013 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8I_immNode::eval_constant(Compile* C) {
  {

#line 2202 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, replicate8_imm(opnd_array(1)->constant(), 4));
#line 32022 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2215 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
  
#line 32038 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2227 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
  
#line 32055 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2240 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32073 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2I_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2253 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32089 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4I_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2263 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32105 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8I_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2273 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    // Use vxorpd since AVX does not have vpxor for 256-bit (AVX2 will have it).
    bool vector256 = true;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vector256);
  
#line 32123 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 2317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ movdl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* src */));
    __ punpckldq(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */);
    __ punpcklqdq(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */);
  
#line 32144 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 2335 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ movdl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)/* src */));
    __ punpckldq(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */);
    __ punpcklqdq(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */);
    __ vinserti128h(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */);
  
#line 32166 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2352 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32183 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2L_immNode::eval_constant(Compile* C) {
  {

#line 2353 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 32192 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 2365 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32209 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4L_immNode::eval_constant(Compile* C) {
  {

#line 2366 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 32218 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2L_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2379 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32234 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4L_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2392 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    __ vinserti128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32252 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2L_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32268 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4L_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2415 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    // Use vxorpd since AVX does not have vpxor for 256-bit (AVX2 will have it).
    bool vector256 = true;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vector256);
  
#line 32286 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2428 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x00);
  
#line 32302 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x00);
  
#line 32318 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2449 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x00);
    __ vinsertf128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32335 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2F_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2461 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ xorps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32351 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4F_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2471 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ xorps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32367 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl8F_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2481 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vxorps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vector256);
  
#line 32384 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2493 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x44);
  
#line 32400 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2504 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x44);
    __ vinsertf128h(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32417 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl2D_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2516 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ xorpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 32433 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void Repl4D_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 2526 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vxorpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vector256);
  
#line 32450 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2542 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32467 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2552 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32485 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2563 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32502 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2573 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32520 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2584 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32537 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd16B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2594 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32555 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd16B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 32573 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd32B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2616 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32591 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd32B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2627 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 32609 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2639 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32626 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2649 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32644 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2660 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32661 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2670 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32679 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2681 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32696 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2691 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32714 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8S_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2702 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 32732 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd16S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2713 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32750 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd16S_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2724 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 32768 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2736 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32785 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2746 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32803 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2757 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32820 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2767 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32838 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2778 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 32856 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2789 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpaddd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32874 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2800 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpaddd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 32892 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2812 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ paddq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32909 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2822 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32927 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2L_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2833 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpaddq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 32945 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2844 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpaddq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 32963 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4L_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2855 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpaddq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 32981 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2867 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32998 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2877 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vaddps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33016 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2888 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33033 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2898 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vaddps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33051 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2909 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vaddps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33069 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2920 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vaddps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33087 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd8F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2931 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vaddps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33105 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 2943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ addpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33122 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2953 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vaddpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33140 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd2D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2964 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vaddpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33158 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 2975 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vaddpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33176 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vadd4D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 2986 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vaddpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33194 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3000 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33211 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3010 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33229 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3021 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33246 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3031 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33264 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3042 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33281 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub16B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3052 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33299 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub16B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3063 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33317 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub32B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3074 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsubb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33335 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub32B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3085 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsubb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33353 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3097 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33370 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3107 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33388 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3118 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33405 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3128 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33423 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3139 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33440 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3149 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33458 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8S_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3160 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33476 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub16S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3171 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsubw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33494 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub16S_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3182 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsubw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33512 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3194 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33529 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3204 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33547 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3215 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33564 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3225 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33582 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3236 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33600 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3247 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsubd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33618 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3258 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsubd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33636 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3270 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psubq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33653 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3280 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33671 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2L_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3291 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsubq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33689 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3302 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsubq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33707 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4L_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3313 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsubq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33725 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3325 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33742 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3335 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vsubps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33760 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3346 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33777 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3356 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vsubps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33795 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3367 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vsubps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33813 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3378 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vsubps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33831 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub8F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3389 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vsubps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33849 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3401 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ subpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33866 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3411 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vsubpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33884 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub2D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3422 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vsubpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33902 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3433 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vsubpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33920 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsub4D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3444 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vsubpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 33938 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3458 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pmullw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33955 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3468 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 33973 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pmullw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 33990 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3489 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34008 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3500 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pmullw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34025 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul8S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3510 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34043 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul8S_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3521 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34061 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul16S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3532 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34079 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul16S_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3543 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34097 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3555 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pmulld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34114 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3565 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpmulld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34132 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3576 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pmulld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34149 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3586 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpmulld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34167 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3597 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpmulld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34185 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul8I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3608 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpmulld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34203 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul8I_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3619 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpmulld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34221 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34238 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3641 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vmulps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34256 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3652 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34273 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3662 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vmulps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34291 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3673 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vmulps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34309 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul8F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3684 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vmulps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34327 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul8F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3695 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vmulps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34345 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3707 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ mulpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34362 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3717 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vmulpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34380 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul2D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3728 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vmulpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34398 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3739 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vmulpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34416 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vmul4D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3750 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vmulpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34434 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3764 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34451 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3774 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vdivps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34469 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3785 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34486 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv4F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3795 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vdivps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34504 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv4F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3806 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vdivps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34522 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv8F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3817 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vdivps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34540 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv8F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3828 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vdivps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34558 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 3840 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ divpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 34575 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3850 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vdivpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34593 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv2D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3861 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vdivpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34611 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv4D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 3872 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vdivpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 34629 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vdiv4D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 3883 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vdivpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 34647 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vshiftcntNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 3898 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 34663 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vshiftcnt_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 3898 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 34679 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3911 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psllw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 34696 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3921 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psllw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 34713 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3931 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsllw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 34731 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3942 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsllw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 34749 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3953 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psllw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 34766 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3963 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psllw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 34783 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsllw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 34801 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3984 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsllw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 34819 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 3995 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psllw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 34836 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4005 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psllw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 34853 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll8S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4015 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsllw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 34871 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll8S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4026 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsllw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 34889 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll16S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4037 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsllw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 34907 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll16S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4048 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsllw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 34925 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4060 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pslld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 34942 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4070 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pslld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 34959 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4080 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpslld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 34977 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4091 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpslld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 34995 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4102 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pslld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35012 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4112 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pslld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35029 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4122 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpslld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35047 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4133 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpslld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35065 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll8I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4144 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpslld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35083 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll8I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4155 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpslld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35101 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4167 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psllq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35118 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4177 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psllq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35135 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4187 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsllq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35153 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll2L_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4198 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsllq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35171 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4209 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsllq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35189 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsll4L_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4220 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsllq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35207 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4238 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrlw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35224 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4248 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrlw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35241 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4258 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrlw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35259 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4269 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrlw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35277 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4280 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrlw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35294 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4290 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrlw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35311 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4300 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrlw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35329 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4311 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrlw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35347 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4322 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrlw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35364 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4332 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrlw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35381 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl8S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4342 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrlw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35399 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl8S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4353 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrlw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35417 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl16S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4364 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsrlw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35435 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl16S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4375 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsrlw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35453 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4387 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35470 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4397 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35487 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4407 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35505 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4418 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35523 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4429 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35540 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4439 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35557 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4449 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35575 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4460 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35593 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl8I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4471 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsrld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35611 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl8I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4482 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsrld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35629 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4494 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrlq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35646 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4504 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrlq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35663 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4514 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrlq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35681 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl2L_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4525 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrlq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35699 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4536 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsrlq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35717 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsrl4L_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4547 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsrlq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35735 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4561 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psraw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35752 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra2S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4571 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psraw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35769 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra2S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4581 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsraw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35787 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra2S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4592 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsraw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35805 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4603 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psraw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35822 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4613 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psraw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35839 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra4S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4623 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsraw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35857 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra4S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4634 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsraw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35875 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4645 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psraw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35892 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4655 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psraw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 35909 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra8S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4665 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsraw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35927 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra8S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4676 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsraw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35945 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra16S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4687 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsraw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 35963 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra16S_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsraw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 35981 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4710 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrad(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 35998 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4720 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrad(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 36015 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4730 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrad(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 36033 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra2I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4741 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrad(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 36051 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4752 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrad(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
  
#line 36068 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4762 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ psrad(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, (int)opnd_array(2)->constant());
  
#line 36085 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra4I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4772 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrad(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 36103 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra4I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4783 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpsrad(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 36121 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra8I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4794 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsrad(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector256);
  
#line 36139 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vsra8I_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 4805 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpsrad(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant(), vector256);
  
#line 36157 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand4BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 4821 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pand(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36174 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand4B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 4831 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36192 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 4842 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pand(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36209 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand8B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 4852 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36227 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 4863 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pand(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36244 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand16B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 4873 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36262 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand16B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 4884 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 36280 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand32B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 4895 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36298 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vand32B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 4906 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 36316 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor4BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 4919 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ por(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36333 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor4B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 4929 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36351 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 4940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ por(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36368 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor8B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 4950 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36386 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 4961 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ por(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36403 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor16B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 4971 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36421 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor16B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 4982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 36439 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor32B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 4993 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36457 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vor32B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5004 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 36475 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor4BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5017 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36492 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor4B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 5027 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36510 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5038 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36527 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor8B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 5048 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36545 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5059 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    __ pxor(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36562 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor16B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 5069 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36580 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor16B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5080 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = false;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 36598 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor32B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 5091 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vector256);
  
#line 36616 "../generated/adfiles/ad_x86_32.cpp"
  }
}

void vxor32B_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 5102 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86.ad"

    bool vector256 = true;
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vector256);
  
#line 36634 "../generated/adfiles/ad_x86_32.cpp"
  }
}

const MachOper* popCountI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2L_immI8Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_immI_255Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_immI16Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2UBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2SNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2USNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immI_255Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immI_65535Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immU31Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLX_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLX_reg_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDPRNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadD_partialNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFPRNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchr0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrNTANode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrT0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrT2Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchw0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwNTANode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAlloc0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocNTANode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocT0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocT2Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL2INode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLX_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLX_reg_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmI16Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmPNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmCMNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDPRNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDPR_roundedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeFPRNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeFPR_roundedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeFPR_DroundedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeFPR_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_immNode::memory_operand() const { return _opnds[1]; }
const TypePtr *membar_acquireNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquireNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquire_0Node::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquire_0Node::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquire_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquire_lockNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_releaseNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_releaseNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_release_0Node::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_release_0Node::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_release_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_release_lockNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_storestoreNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_storestoreNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* cmovI_memNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovI_memUNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovI_memUCFNode::memory_operand() const { return _opnds[4]; }
const MachOper* addI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addI_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_eReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* incI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* decI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPLockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeIConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddI_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddINode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgINode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgPNode::memory_operand() const { return _opnds[1]; }
const MachOper* subI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* mulI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* mulINode::memory_operand() const { return _opnds[2]; }
const MachOper* mulI_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* sarI_mem_1Node::memory_operand() const { return _opnds[1]; }
const MachOper* sarI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* andI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andI_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_eReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* andnI_rReg_rReg_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* andnI_rReg_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsiI_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* blsiI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsmskI_rReg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* blsmskI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsrI_rReg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* blsrI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* orI_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_eReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* xorI_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_eReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addL_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* subL_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andL_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andL_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andnL_eReg_eReg_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* andnL_eReg_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsiL_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* blsiL_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsmskL_eReg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* blsmskL_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsrL_eReg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* blsrL_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orl_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* orl_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorl_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* xorl_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* cmpD_ccmemNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpD_ccmemCFNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpD_regmemNode::memory_operand() const { return _opnds[2]; }
const MachOper* subDPR_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addDPR_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addDPR_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addDPR_mem_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* addDPR_mem_reg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulDPR_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulDPR_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulDPR_reg_mem_ciscNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulDPR_reg_mem_cisc_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* cmpF_ccmemNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpF_ccmemCFNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpF_regmemNode::memory_operand() const { return _opnds[2]; }
const MachOper* addFPR24_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addFPR24_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addFPR_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addFPR_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addFPR24_mem_regNode::memory_operand() const { return _opnds[1]; }
const TypePtr *addFPR24_mem_ciscNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* addFPR24_mem_ciscNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *addFPR24_mem_cisc_0Node::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* addFPR24_mem_cisc_0Node::memory_operand() const { return (MachOper*)-1; }
const TypePtr *addFPR24_mem_memNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* addFPR24_mem_memNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* mulFPR24_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulFPR24_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulFPR_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulFPR_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const TypePtr *mulFPR24_mem_memNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* mulFPR24_mem_memNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* mulFPR_reg_load1Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulFPR_reg_load1_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* addFPR_mulFPR_reg_load1Node::memory_operand() const { return _opnds[1]; }
const MachOper* addFPR_mulFPR_reg_load1_1Node::memory_operand() const { return _opnds[2]; }
const MachOper* addFPR_mulFPR_reg_load1_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* addFPR_mulFPR_reg_load1_2Node::memory_operand() const { return _opnds[3]; }
const MachOper* convI2D_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2DPR_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2FPR_SSF_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2FPR_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* compI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* testI_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compU_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compP_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compP_mem_eRegNode::memory_operand() const { return _opnds[2]; }
const MachOper* testP_Reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* cmovLL_mem_LTGENode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovII_mem_LTGENode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovLL_mem_EQNENode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovII_mem_EQNENode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovLL_mem_LEGTNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovII_mem_LEGTNode::memory_operand() const { return _opnds[4]; }
const MachOper* addF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addF_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addF_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addD_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addD_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* subF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulD_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulD_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* divF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* divF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* divD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* divD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* sqrtF_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* sqrtD_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV4Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV32Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV4Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV32Node::memory_operand() const { return _opnds[1]; }
const MachOper* Repl2I_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* Repl4I_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* Repl8I_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* Repl2L_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* Repl4L_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* vadd16B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd32B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd8S_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd16S_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd4I_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd8I_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd2L_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd4L_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd4F_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd8F_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd2D_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd4D_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub16B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub32B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub8S_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub16S_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub4I_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub8I_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub2L_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub4L_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub4F_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub8F_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub2D_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub4D_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul8S_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul16S_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul4I_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul8I_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul4F_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul8F_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul2D_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul4D_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vdiv4F_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vdiv8F_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vdiv2D_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vdiv4D_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vand16B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vand32B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vor16B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vor32B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vxor16B_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vxor32B_memNode::memory_operand() const { return _opnds[2]; }


const bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // RegFlags
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    false,  // AbsI
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    true ,  // AryEq
    true ,  // AtanD
    true ,  // Binary
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    false,  // CProj
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastII
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    false,  // CMoveN
    false,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    false,  // CompareAndSwapN
    true ,  // GetAndAddI
    false,  // GetAndAddL
    true ,  // GetAndSetI
    false,  // GetAndSetL
    true ,  // GetAndSetP
    false,  // GetAndSetN
    false,  // Con
    false,  // ConN
    false,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    true ,  // CosD
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CreateEx
    false,  // DecodeN
    false,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    false,  // DivMod
    true ,  // DivModI
    false,  // DivModL
    true ,  // EncodeISOArray
    false,  // EncodeP
    false,  // EncodePKlass
    true ,  // ExpD
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // Goto
    true ,  // Halt
    true ,  // If
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    true ,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    false,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadPLocked
    true ,  // LoadP
    false,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    true ,  // LogD
    true ,  // Log10D
    false,  // Loop
    true ,  // LoopLimit
    false,  // Mach
    false,  // MachProj
    true ,  // MaxI
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    true ,  // ModD
    true ,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // MulD
    true ,  // MulF
    false,  // MulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    false,  // Opaque1
    false,  // Opaque2
    false,  // Opaque3
    true ,  // OrI
    true ,  // OrL
    true ,  // OverflowAddI
    true ,  // OverflowSubI
    true ,  // OverflowMulI
    false,  // OverflowAddL
    false,  // OverflowSubL
    false,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    true ,  // PartialSubtypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    true ,  // PowD
    true ,  // PrefetchAllocation
    true ,  // PrefetchRead
    true ,  // PrefetchWrite
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // Root
    true ,  // RoundDouble
    true ,  // RoundFloat
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SCMemProj
    true ,  // SinD
    true ,  // SqrtD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StorePConditional
    true ,  // StoreIConditional
    true ,  // StoreLConditional
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    false,  // StoreN
    false,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    true ,  // TanD
    true ,  // ThreadLocal
    false,  // Unlock
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    true ,  // AddVB
    true ,  // AddVS
    true ,  // AddVI
    true ,  // AddVL
    true ,  // AddVF
    true ,  // AddVD
    true ,  // SubVB
    true ,  // SubVS
    true ,  // SubVI
    true ,  // SubVL
    true ,  // SubVF
    true ,  // SubVD
    true ,  // MulVS
    true ,  // MulVI
    true ,  // MulVF
    true ,  // MulVD
    true ,  // DivVF
    true ,  // DivVD
    true ,  // LShiftCntV
    true ,  // RShiftCntV
    false,  // LShiftVB
    true ,  // LShiftVS
    true ,  // LShiftVI
    true ,  // LShiftVL
    false,  // RShiftVB
    true ,  // RShiftVS
    true ,  // RShiftVI
    false,  // RShiftVL
    false,  // URShiftVB
    true ,  // URShiftVS
    true ,  // URShiftVI
    true ,  // URShiftVL
    true ,  // AndV
    true ,  // OrV
    true ,  // XorV
    true ,  // LoadVector
    true ,  // StoreVector
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // ReplicateB
    true ,  // ReplicateS
    true ,  // ReplicateI
    true ,  // ReplicateL
    true ,  // ReplicateF
    true ,  // ReplicateD
    false,  // Extract
    false,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    false,  // ExtractS
    false,  // ExtractI
    false,  // ExtractL
    false,  // ExtractF
    false   // ExtractD
};


bool Matcher::stack_direction() const { return false; }

int Compile::sync_stack_slots() const { return 1; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 1 +
              round_to((Compile::current()->in_preserve_stack_slots() +
                        Compile::current()->fixed_slots()),
                       stack_alignment_in_slots())); }

uint Compile::in_preserve_stack_slots() { return 2+VerifyStackAtCalls; }

uint Compile::out_preserve_stack_slots() { return SharedRuntime::out_preserve_stack_slots(); }

uint Compile::varargs_C_out_slots_killed() const { return 0; }

void Matcher::calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length, bool is_outgoing) {

#line 3165 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // No difference between ingoing/outgoing just pass false
    SharedRuntime::java_calling_convention(sig_bt, regs, length, false);
  
#line 37273 "../generated/adfiles/ad_x86_32.cpp"

}

void Matcher::c_calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length) {

#line 3177 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    // This is obviously always outgoing
    (void) SharedRuntime::c_calling_convention(sig_bt, regs, /*regs2=*/NULL, length);
  
#line 37284 "../generated/adfiles/ad_x86_32.cpp"

}

OptoRegPair Matcher::return_value(int ideal_reg, bool is_outgoing) {

#line 3199 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    assert( ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values" );
    static int lo[Op_RegL+1] = { 0, 0, OptoReg::Bad, EAX_num,      EAX_num,      FPR1L_num,    FPR1L_num, EAX_num };
    static int hi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, OptoReg::Bad, OptoReg::Bad, FPR1H_num, EDX_num };
    if( ideal_reg == Op_RegD && UseSSE>=2 )
      return OptoRegPair(XMM0b_num,XMM0_num);
    if( ideal_reg == Op_RegF && UseSSE>=1 )
      return OptoRegPair(OptoReg::Bad,XMM0_num);
    return OptoRegPair(hi[ideal_reg],lo[ideal_reg]);
  
#line 37301 "../generated/adfiles/ad_x86_32.cpp"

}

OptoRegPair Matcher::c_return_value(int ideal_reg, bool is_outgoing) {

#line 3183 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.40-14.b02.fc22.i386/jdk8/hotspot/src/cpu/x86/vm/x86_32.ad"

    assert( ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values" );
    static int lo[Op_RegL+1] = { 0, 0, OptoReg::Bad, EAX_num,      EAX_num,      FPR1L_num,    FPR1L_num, EAX_num };
    static int hi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, OptoReg::Bad, OptoReg::Bad, FPR1H_num, EDX_num };

    // in SSE2+ mode we want to keep the FPU stack clean so pretend
    // that C functions return float and double results in XMM0.
    if( ideal_reg == Op_RegD && UseSSE>=2 )
      return OptoRegPair(XMM0b_num,XMM0_num);
    if( ideal_reg == Op_RegF && UseSSE>=2 )
      return OptoRegPair(OptoReg::Bad,XMM0_num);

    return OptoRegPair(hi[ideal_reg],lo[ideal_reg]);
  
#line 37322 "../generated/adfiles/ad_x86_32.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(EAX_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_method_oop_reg() { return OptoReg::Name(EBX_num); }

int Matcher::interpreter_method_oop_reg_encode() { return _regEncode[interpreter_method_oop_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(EBP_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(ESP_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DIA32=1
#ifndef IA32
#  error "IA32 must be defined"
#endif // IA32
// Check adlc -U_LP64
#ifdef _LP64
#  error "_LP64 must not be defined"
#endif // _LP64
